/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
/*-----------------------------------------------------------------------------
 *
 * $Author: dtvbm11 $
 * $Date: 2016/06/23 $
 * $RCSfile: drv_tcon.c,v $
 * $Revision: #1 $
 *
 *---------------------------------------------------------------------------*/
#include "sv_const.h"
#include "feature.h"

#include "hw_tg.h"

#include "sif_if.h"

#include "drv_tcon.h"

#ifdef DEFINE_IS_LOG
#undef DEFINE_IS_LOG
#endif
#ifdef CC_MTK_LOADER
#define DEFINE_IS_LOG(level, fmt...)   Printf(fmt)
#else /* CC_MTK_LOADER */
#define DEFINE_IS_LOG   IR_IsLog
#endif /* CC_MTK_LOADER */

// for V12 gamma IC
//#define GAMMAIC_BUS 0
//#define GAMMAIC_CLK_RATE 0x100
#define GAMMAIC_ID_V12 0x40
#define GAMMAIC_DATA_CNT_V12 1


// Gamma
struct sTCONREGTABLE sRegCustGamma_V12[] = {
  // Gamma voltage
  {0x0000, 0x2A, 0xffffffff},
  {0x0001, 0x09, 0xffffffff},
  {0x0002, 0x03, 0xffffffff},
  {0x0003, 0x03, 0xffffffff},
  {0x0004, 0x0B, 0xffffffff},
  {0x0005, 0x0B, 0xffffffff},
  {0x0006, 0x20, 0xffffffff},
  {0x0007, 0x01, 0xffffffff},
  {0x0008, 0x03, 0xffffffff},
  {0x0009, 0x03, 0xffffffff},
  {0x000A, 0x1, 0xffffffff},
  {0x000B, 0x3D, 0xffffffff},
  {0x000C, 0x0, 0xffffffff},
  {0x000D, 0xFD, 0xffffffff},
  {0x000E, 0x0, 0xffffffff},
  {0x000F, 0x88, 0xffffffff},
  {0x0010, 0x1, 0xffffffff},
  {0x0011, 0x74, 0xffffffff},
  {0x0012, 0x0, 0xffffffff},
  {0x0013, 0xFD, 0xffffffff},
  {0x0014, 0x0, 0xffffffff},
  {0x0015, 0xBD, 0xffffffff},
  {0x0016, 0x0, 0xffffffff},
  {0x0017, 0xB3, 0xffffffff},
  {0x0018, 0x2, 0xffffffff},
};

// for V4 gamma IC
#define GAMMAIC_BUS 0
#define GAMMAIC_CLK_RATE 0x100
#define GAMMAIC_ID (0x74 << 1)
#define GAMMAIC_DATA_CNT 2


// Gamma
struct sTCONREGTABLE sRegCustGamma[] = {
  // Gamma voltage
  {0x0000, 0x6B03, 0xffffffff},
  {0x0001, 0xEB03, 0xffffffff},
  {0x0002, 0x6B03, 0xffffffff},
  {0x0003, 0x3E03, 0xffffffff},
  {0x0004, 0xFD02, 0xffffffff},
  {0x0005, 0xB602, 0xffffffff},
  {0x0006, 0x8402, 0xffffffff},
  {0x0007, 0x0902, 0xffffffff},
  {0x0008, 0xEF01, 0xffffffff},
  {0x0009, 0x7601, 0xffffffff},
  {0x000A, 0x4201, 0xffffffff},
  {0x000B, 0xFB00, 0xffffffff},
  {0x000C, 0xB900, 0xffffffff},
  {0x000D, 0x8E00, 0xffffffff},
  {0x000E, 0x1300, 0xffffffff},
  {0x000F, 0x8E00, 0xffffffff},
  {0x0012, 0xB581, 0xffffffff},
};


//-----------------------------------------------------------------------------
// mini LVDS Interface Setting
//-----------------------------------------------------------------------------

//miniLVDS LGD V4 Non-GIP
  struct sTCONREGTABLE sRegMini_MLVDS_LGDV4FHD60[] = {

  // Pixel reorder
  {0xF0035c1c, 0xD4002000, 0xFFFFFFFF}, 
  {0xF0035c2c, 0x00640780, 0xFFFFFFFF}, 
  {0xF0035c34, 0x00A00000, 0xFFFFFFFF}, 
  {0xF0035c4c, 0x00000780, 0xFFFFFFFF}, 
  {0xF0035c50, 0x80000780, 0xFFFFFFFF}, 
  {0xF0035c54, 0x00000001, 0xFFFFFFFF},
  {0xF0035c00, 0x001147FF, 0xFFFFFFFF},
  //{0xF0035c38, 0x00000464, 0xFFFFFFFF},
                                
  // mini-LVDS Encode
  {0xF0035000, 0x00000011, 0xFFFFFFFF}, 

  {0xF003500c, 0x0000003f, 0xFFFFFFFF}, 
  {0xF0035010, 0x00000000, 0xFFFFFFFF}, 
  {0xF0035014, 0x80010000, 0xFFFFFFFF}, 
  {0xF0035018, 0x00000000, 0xFFFFFFFF},  
  {0xF0035020, 0x00000001, 0xFFFFFFFF}, 

  {0xF0035028, 0x76012456, 0xFFFFFFFF}, 
  {0xF003502c, 0x76012456, 0xFFFFFFFF}, 
  {0xF0035030, 0x0A0A9898, 0xFFFFFFFF}, 
  {0xF0035034, 0x00000000, 0xFFFFFFFF}, 
  };

//miniLVDS Samsung MB7 TRD 
struct sTCONREGTABLE sRegMini_MLVDS_SAMSUNGMB7[] = {

  //Pixel Reorder
  {0xF0035c00, 0x00118400, 0xFFFFFFFF}, 
  {0xF0035c1c, 0xd4000000, 0xFFFFFFFF}, 
  {0xF0035c20, 0x28a80000, 0xFFFFFFFF},
  
  {0xF0035c28, 0x08980020, 0xFFFFFFFF}, 
  {0xF0035c2c, 0x00100284, 0xFFFFFFFF},
  {0xF0035c30, 0x005a0059, 0xFFFFFFFF}, 
  {0xF0035c34, 0x00320059, 0xFFFFFFFF}, 
  {0xF0035c4c, 0x0000078c, 0xFFFFFFFF}, 

  {0xF0035c48, 0x82dd0780, 0xFFFFFFFF}, 
  {0xF0035c50, 0x0000278c, 0xFFFFFFFF}, 
                                        
  {0xF0035c54, 0x0284278c, 0xFFFFFFFF}, 
  {0xF0035c58, 0x0508278c, 0xFFFFFFFF}, 

  {0xF0035c5c, 0x50000000, 0xFFFFFFFF}, 
  {0xF0035c60, 0x00008142, 0xFFFFFFFF},
  {0xF0035c64, 0x028493c6, 0xFFFFFFFF},
  {0xF0035c68, 0x0508a64a, 0xFFFFFFFF},
  {0xF0035cc0, 0x04800000, 0xFFFFFFFF}, 

  //mini-LVDS 
  {0xF0035000, 0x00000011, 0xFFFFFFFF},

  {0xF003500c, 0x0000003f, 0xFFFFFFFF}, 
  {0xF0035010, 0x00000000, 0xFFFFFFFF}, 
  {0xF0035014, 0x80010000, 0xFFFFFFFF}, 
  {0xF0035018, 0x00000000, 0xFFFFFFFF}, 
  {0xF0035020, 0x00000001, 0xFFFFFFFF},
  
  {0xF0035028, 0x76012456, 0xFFFFFFFF}, 
  {0xF003502c, 0x76012456, 0xFFFFFFFF},  
  {0xF0035030, 0x0A0A9898, 0xFFFFFFFF}, 
  };

//miniLVDS CMO 2011 Flip-Pixel-2
  struct sTCONREGTABLE sRegMini_MLVDS_CMO2011FHD60[] = {
  
  // Pixel reorder
  {0xF0035c1c, 0xD4000000, 0xFFFFFFFF}, 
  {0xF0035c2c, 0x00640782, 0xFFFFFFFF},
  {0xF0035c34, 0x00A00000, 0xFFFFFFFF},
  {0xF0035c4c, 0x00000781, 0xFFFFFFFF}, 
  {0xF0035c50, 0x80000781, 0xFFFFFFFF},
  {0xF0035c54, 0x00000000, 0xFFFFFFFF},
  {0xF0035c00, 0x001107FF, 0xFFFFFFFF},
  //{0xF0035c38, 0x00000464, 0xFFFFFFFF},
  
  // mini-LVDS Encode
  {0xF0035000, 0x00000011, 0xFFFFFFFF}, 

  {0xF003500c, 0x0000003f, 0xFFFFFFFF}, 
  {0xF0035010, 0x00000000, 0xFFFFFFFF}, 
  {0xF0035014, 0x80010000, 0xFFFFFFFF}, 
  {0xF0035018, 0x00000000, 0xFFFFFFFF}, 
  {0xF0035020, 0x00000004, 0xFFFFFFFF}, 
	
  {0xF0035028, 0x76012456, 0xFFFFFFFF}, 
  {0xF003502c, 0x76012456, 0xFFFFFFFF},  
  {0xF0035030, 0x0A0A9898, 0xFFFFFFFF},  
  {0xF0035034, 0x00000000, 0xFFFFFFFF}, 
  };

//miniLVDS Panasonic 2011 WXGA
struct sTCONREGTABLE sRegMini_MLVDS_PANASONIC32WXGA1P6P[] = {

  // Pixel reorder
  {0xF0035c00, 0x000007FF, 0xFFFFFFFF}, 
  {0xF0035c1c, 0xD4000000, 0xFFFFFFFF}, 
  {0xF0035c04, 0xFFFFFFFF, 0xFFFFFFFF}, 
  {0xF0035c0c, 0x002AB2AB, 0xFFFFFFFF},
  {0xF0035c10, 0x002AB557, 0xFFFFFFFF}, 
  {0xF0035c14, 0x00557557, 0xFFFFFFFF}, 
  {0xF0035c20, 0xA0000007, 0xFFFFFFFF}, 
  {0xF0035c4c, 0x00000558, 0xFFFFFFFF}, 
  {0xF0035c50, 0x00000558, 0xFFFFFFFF}, 
  {0xF0035c30, 0x003C0000, 0xFFFFFFFF},
  {0xF0035c2c, 0x00640558, 0xFFFFFFFF}, 
  {0xF0035c34, 0x00280000, 0xFFFFFFFF}, 
  //{0xF0035c38, 0x00000300, 0xFFFFFFFF},  
    
  // mini-LVDS Encode
  {0xF0035000, 0x00000010, 0xFFFFFFFF}, 

  {0xF003500c, 0x0000003F, 0xFFFFFFFF}, 
  {0xF0035010, 0x00FFFFFF, 0xFFFFFFFF},
  {0xF0035014, 0x80010000, 0xFFFFFFFF}, 
  {0xF0035018, 0x000003FF, 0xFFFFFFFF},
  {0xF0035020, 0x00000004, 0xFFFFFFFF}, 
  
  {0xF0035028, 0x76012456, 0xFFFFFFFF}, 
  {0xF003502c, 0x76012456, 0xFFFFFFFF}, 
  {0xF0035030, 0x0A0A9898, 0xFFFFFFFF},   
  {0xF0035034, 0x00000000, 0xFFFFFFFF}, 
}; 

//miniLVDS Panasonic 2012 WXGA
struct sTCONREGTABLE sRegMini_MLVDS_PANASONIC32WXGA2P3P[] = {
	
	{0xF0034008, 0x37F9FFFF, 0xFFFFFFFF}, 

    // Pixel reorder
	{0xF0035c00, 0x001107FF, 0xFFFFFFFF}, 
	{0xF0035c1c, 0xEA000000, 0xFFFFFFFF}, 
	{0xF0035c04, 0xFFFFFFFF, 0xFFFFFFFF}, 
	{0xF0035c0c, 0x002AB2AB, 0xFFFFFFFF},
	{0xF0035c10, 0x002AB557, 0xFFFFFFFF}, 
	{0xF0035c14, 0x00557557, 0xFFFFFFFF}, 
	{0xF0035c20, 0xA0000007, 0xFFFFFFFF}, 
	{0xF0035c4c, 0x00000558, 0xFFFFFFFF}, 
	{0xF0035c50, 0x00000558, 0xFFFFFFFF}, 
	{0xF0035c30, 0x003C0000, 0xFFFFFFFF},
	{0xF0035c2c, 0x00640558, 0xFFFFFFFF}, 
	{0xF0035c34, 0x00280000, 0xFFFFFFFF}, 
	{0xF0035c64, 0x02AC0000, 0xFFFFFFFF}, 
	//{0xF0035c38, 0x00000300, 0xFFFFFFFF},  
	  
	// mini-LVDS Encode
	{0xF0035000, 0x00000011, 0xFFFFFFFF}, 
  
	{0xF003500c, 0x0000003F, 0xFFFFFFFF}, 
	{0xF0035010, 0x00000000, 0xFFFFFFFF}, 
	{0xF0035014, 0x00010000, 0xFFFFFFFF}, 
	{0xF0035018, 0x00000000, 0xFFFFFFFF}, 
	{0xF0035020, 0x00000001, 0xFFFFFFFF}, 
	
	{0xF0035028, 0x76543210, 0xFFFFFFFF},
	{0xF003502c, 0x76543210, 0xFFFFFFFF},  
	{0xF0035030, 0x0A0A9898, 0xFFFFFFFF}, 
	{0xF0035034, 0x00000000, 0xFFFFFFFF}, 
	
}; 

//miniLVDS Panasonic FHD 120Hz
struct sTCONREGTABLE sRegMini_MLVDS_PANASONIC42FHD120[] = {

  // Pixel reorder
  {0xF0035c00, 0x001147FF, 0xFFFFFFFF},
  {0xF0035c1c, 0xE8000000, 0xFFFFFFFF}, 
  {0xF0035c2c, 0x00640782, 0xFFFFFFFF},
  //xF0035c34, 0x00A00000, 0xFFFFFFFF}, 
  {0xF0035c4c, 0x00000781, 0xFFFFFFFF}, 
  {0xF0035c50, 0x80000781, 0xFFFFFFFF}, 
  {0xF0035ca0, 0x843E0001, 0xFFFFFFFF}, 
  {0xF0035ca4, 0x8007843E, 0xFFFFFFFF},
  //{0xF0035c38, 0x00000464, 0xFFFFFFFF},

  {0xF0035CA0, 0x04410001, 0xFFFFFFFF},
  {0xF0035CA4, 0x00000464, 0xFFFFFFFF},
  
  {0xF0034008, 0x2001FFFF, 0xFFFFFFFF}, 
                                
  // mini-LVDS Encode
  {0xF0035000, 0x000000D1, 0xFFFFFFFF}, 
  
  {0xF003500c, 0x0000C01C, 0xFFFFFFFF}, 
  {0xF0035010, 0xE8E80000, 0xFFFFFFFF}, 
  {0xF0035014, 0x80000000, 0xFFFFFFFF}, 
  {0xF0035018, 0x00000000, 0xFFFFFFFF},
  {0xF0035020, 0x00000001, 0xFFFFFFFF}, 

  {0xF0035028, 0x1234A567, 0xFFFFFFFF},  
  {0xF003502c, 0x1234A567, 0xFFFFFFFF}, 
  {0xF0035030, 0x04049898, 0xFFFFFFFF}, 
  {0xF0035034, 0x00000000, 0xFFFFFFFF}, 

  {0xF0035108, 0x0000F000, 0xFFFFFFFF},
  {0xF0035114, 0x0000F000, 0xFFFFFFFF},
  {0xF0035120, 0x0000F000, 0xFFFFFFFF},
  {0xF0035124, 0x18C018C0, 0xFFFFFFFF},
  {0xF00351AC, 0xC8000477, 0xFFFFFFFF},

  {0xF003512C, 0x20201010, 0xFFFFFFFF},
  {0xF0035130, 0xF4B45420, 0xFFFFFFFF},
  {0xF0035134, 0xECB4A844, 0xFFFFFFFF},
  {0xF0035138, 0xF0A09020, 0xFFFFFFFF},
  {0xF003513C, 0x00000000, 0xFFFFFFFF},
  {0xF0035140, 0x000C181C, 0xFFFFFFFF},
  {0xF0035144, 0x00000000, 0xFFFFFFFF},
  {0xF0035148, 0x0C2C0C0C, 0xFFFFFFFF},

  {0xF003514C, 0x10102020, 0xFFFFFFFF},
  {0xF0035150, 0x2054B4F4, 0xFFFFFFFF},
  {0xF0035154, 0x44A8B4EC, 0xFFFFFFFF},
  {0xF0035158, 0x2898A8F8, 0xFFFFFFFF},
  {0xF003515C, 0x00000000, 0xFFFFFFFF},
  {0xF0035160, 0x1C180C00, 0xFFFFFFFF},
  {0xF0035164, 0x00000000, 0xFFFFFFFF},
  {0xF0035168, 0x0C0C2C0C, 0xFFFFFFFF},  
  
};

struct sTCONREGTABLE sRegMini_MLVDS_LGD32WXGAV9[] = {

  {0xf0035000, 0x20000058, 0xffffffff},
  {0xf0035110, 0x00100000, 0xffffffff},
	
  {0xf0035104, 0x00012456, 0xffffffff},
  {0xf0035108, 0x00012456, 0xffffffff},
  {0xf003510C, 0xBABA9898, 0xffffffff},
	
  {0xf0035100, 0x0000FC3F, 0xffffffff},
  {0xf0035130, 0x00000000, 0xffffffff},
  {0xf0035110, 0x00000000, 0xffffffff},
  {0xf0035004, 0x05580628, 0xffffffff},
  {0xf0035008, 0x0300033A, 0xffffffff},
  {0xf0035280, 0x82AA0000, 0xffffffff},

};

//miniLVDS Hisense 2013 WXGA
struct sTCONREGTABLE sRegMini_MLVDS_HISENSE32WXGA2P3P[] = {
	
    // Pixel reorder
	{0xF0035c00, 0x001107FF, 0xFFFFFFFF}, 
	{0xF0035c1c, 0xD4000000, 0xFFFFFFFF},
	{0xF0035c04, 0xFFFFFFFF, 0xFFFFFFFF},
	{0xF0035c0c, 0x002AB2AB, 0xFFFFFFFF},
	{0xF0035c10, 0x002AB557, 0xFFFFFFFF}, 
	{0xF0035c14, 0x00557557, 0xFFFFFFFF},
	{0xF0035c20, 0xA0000007, 0xFFFFFFFF},
	{0xF0035c2c, 0x00640558, 0xFFFFFFFF},
	{0xF0035c30, 0x003C0000, 0xFFFFFFFF}, 
	{0xF0035c34, 0x00280000, 0xFFFFFFFF},
	{0xF0035c4c, 0x00000558, 0xFFFFFFFF}, 
	{0xF0035c50, 0x00000558, 0xFFFFFFFF},
	{0xF0035c64, 0x02AC0000, 0xFFFFFFFF}, 
	//{0xF0035c38, 0x00000300, 0xFFFFFFFF},  
	  
	// mini-LVDS Encode
	{0xF0035000, 0x00000051, 0xFFFFFFFF}, 
  
	{0xF003500c, 0x000000E0, 0xFFFFFFFF}, 
	{0xF0035010, 0x00000000, 0xFFFFFFFF}, 
	{0xF0035014, 0x00010000, 0xFFFFFFFF}, 
	{0xF0035018, 0x00000000, 0xFFFFFFFF}, 
	{0xF0035020, 0x00000001, 0xFFFFFFFF}, 

	#ifdef CC_MT5565
	{0xF0035028, 0x765420A0, 0xFFFFFFFF},
	{0xF003502c, 0x7654210A, 0xFFFFFFFF},  
	{0xF0035030, 0xB1BA9898, 0xFFFFFFFF}, 
	{0xF0035034, 0x040C000E, 0xFFFFFFFF},
	#else
	{0xF0035028, 0x76012456, 0xFFFFFFFF},
	{0xF003502c, 0x76012456, 0xFFFFFFFF},  
	{0xF0035030, 0xBABA9898, 0xFFFFFFFF}, 
	{0xF0035034, 0x00380038, 0xFFFFFFFF},
	#endif
	
}; 

struct sTCONREGTABLE sRegMini_MLVDS_AUO_T420HVN06FHD60[] = {

   // Pixel reorder
   {0xF0035C00, 0x00110400, 0xFFFFFFFF},	
   {0xF0035C1C, 0xC0000000, 0xFFFFFFFF},	
   {0xF0035C2C, 0x00640780, 0xFFFFFFFF},
   {0xF0035c30, 0x00B40000, 0xFFFFFFFF},//pattern's edge shift 10 lines to right 
   {0xF0035C34, 0x00A00000, 0xFFFFFFFF},	
   {0xF0035C4C, 0x00000780, 0xFFFFFFFF},	 
   {0xF0035C50, 0x00000780, 0xFFFFFFFF},	
   {0xF0035C54, 0x00000000, 0xFFFFFFFF},
   {0xF0035CD8, 0x00000000, 0xFFFFFFFF},
   
   // mini-LVDS Encode
   {0xF0035000, 0x00000011, 0xFFFFFFFF},    
   {0xF003500c, 0x0000FF3F, 0xFFFFFFFF}, 
   {0xF0035008, 0xFFFFFFFF, 0xFFFFFFFF}, 
   {0xF0035004, 0x0000FFFF, 0xFFFFFFFF}, 
   {0xF0035010, 0x00000000, 0xFFFFFFFF}, 
   {0xF0035014, 0x00010000, 0xFFFFFFFF}, 
   {0xF0035018, 0x00000000, 0xFFFFFFFF}, 
   {0xF0035020, 0x00000001, 0xFFFFFFFF},

   #ifdef CC_MT5565
   {0xF0035028, 0x765402A0, 0xFFFFFFFF},
   {0xF003502c, 0x7654012A, 0xFFFFFFFF},  
   {0xF0035030, 0xB1BA9898, 0xFFFFFFFF}, 
   {0xF0035034, 0x040E000F, 0xFFFFFFFF},
   #else
   {0xF0035028, 0x76654210, 0xFFFFFFFF},
   {0xF003502c, 0x76654210, 0xFFFFFFFF},  
   {0xF0035030, 0xBABA9898, 0xFFFFFFFF},
   {0xF0035034, 0x0FFF0FFF, 0xFFFFFFFF},
   #endif
};

//-----------------------------------------------------------------------------
// EPI Interface Setting
//-----------------------------------------------------------------------------

  //EPI LGDV12FHD60
   struct sTCONREGTABLE sReg_PANEL_EPI_LGDV12FHD60[] = {

  {0xf0035000, 0x00000015, 0xffffffff}, 
  
  //{0xf0034004, 0x00000100, 0xffffffff}, 
  {0xf0034008, 0x0ffcffff, 0xffffffff}, 
  {0xf003400c, 0x00004000, 0xffffffff}, 
  
  {0xf0034014, 0x00210000, 0xffffffff}, 
  
  //panel interface
  {0xf0034600, 0x04802359, 0xffffffff},
  //{0xf0034604, 0x07800894, 0xffffffff},
  {0xf0034610, 0x001c0001, 0xffffffff},
  //{0xf0034614, 0x000003ff, 0xffffffff},
  {0xf0034618, 0x02000100, 0xffffffff},
  //{0xf0034710, 0x00000000, 0xffffffff},
  
  //pixel reorder
  {0xf0035c00, 0x005547ff, 0xffffffff},
  {0xf0035c1c, 0xd4ffe3ff, 0xffffffff},
  //{0xf0035c28, 0x0898001a, 0xffffffff},
  
  //  {0xf0035c38, 0x00000464, 0xffffffff},
  {0xf0035c4c, 0x00000780, 0xffffffff},
  {0xf0035c50, 0x80000780, 0xffffffff},
  {0xf0035c54, 0x00000001, 0xffffffff},
  {0xf0035c64, 0x01400000, 0xffffffff},
  {0xf0035c68, 0x02800000, 0xffffffff},
  {0xf0035c6c, 0x03c00000, 0xffffffff},
  {0xf0035c70, 0x05000000, 0xffffffff},
  {0xf0035c74, 0x06400000, 0xffffffff},
  
  //EPI
  {0xf0035400, 0x00001601, 0xffffffff},
  {0xf003541c, 0x00000000, 0xffffffff},
  {0xf0035508, 0x00000600, 0xffffffff},
  {0xf0035500, 0xfdfe0103, 0xffffffff},
  {0xf003551c, 0x04380006, 0xffffffff},
  {0xf0035524, 0x00020002, 0xffffffff},
  {0xf0035528, 0x00000000, 0xffffffff},
  {0xf003552c, 0x00000300, 0xffffffff},
  {0xf0035530, 0x76543211, 0xffffffff},
  {0xf0035534, 0xfedcba08, 0xffffffff},
  {0xf003550c, 0x00000080, 0xffffffff},
  //{0xf0035514, 0x00000000, 0xffffffff},
  //{0xf0035514, 0x00000001, 0xffffffff},

  };

  //EPI LGDV12FHD120
  struct sTCONREGTABLE sReg_PANEL_EPI_LGDV12FHD120[] = {

  {0xf0035000, 0x00000015, 0xffffffff}, 
  
  //{0xf0034004, 0x00000100, 0xffffffff}, 
  {0xf0034008, 0x0ffcffff, 0xffffffff}, 
  {0xf003400c, 0x00004000, 0xffffffff}, 
  
  {0xf0034014, 0x00210000, 0xffffffff}, 
  
  //panel interface
  {0xf0034600, 0x04802359, 0xffffffff},
  //{0xf0034604, 0x07800894, 0xffffffff},
  {0xf0034610, 0x001c0001, 0xffffffff},
  //{0xf0034614, 0x000003ff, 0xffffffff},
  {0xf0034618, 0x02000100, 0xffffffff},
  //{0xf0034710, 0x00000000, 0xffffffff},
  
  //pixel reorder
  {0xf0035c00, 0x005547ff, 0xffffffff},
  {0xf0035c1c, 0xd4ffe3ff, 0xffffffff},
  //{0xf0035c28, 0x0898001a, 0xffffffff},
  
  //  {0xf0035c38, 0x00000464, 0xffffffff},
  {0xf0035c4c, 0x00000780, 0xffffffff},
  {0xf0035c50, 0x80000780, 0xffffffff},
  {0xf0035c54, 0x00000001, 0xffffffff},
  {0xf0035c64, 0x01400000, 0xffffffff},
  {0xf0035c68, 0x02800000, 0xffffffff},
  {0xf0035c6c, 0x03c00000, 0xffffffff},
  {0xf0035c70, 0x05000000, 0xffffffff},
  {0xf0035c74, 0x06400000, 0xffffffff},
  
  //EPI
  {0xf0035400, 0x00001601, 0xffffffff},
  {0xf003541c, 0x00000000, 0xffffffff},
  {0xf0035508, 0x00000600, 0xffffffff},
  {0xf0035500, 0xfdfe0103, 0xffffffff},
  {0xf003551c, 0x04380006, 0xffffffff},
  {0xf0035524, 0x00020002, 0xffffffff},
  {0xf0035528, 0x00000000, 0xffffffff},
  {0xf003552c, 0x00000300, 0xffffffff},
  {0xf0035530, 0x76543211, 0xffffffff},
  {0xf0035534, 0xfedcba08, 0xffffffff},
  {0xf003550c, 0x00000080, 0xffffffff},
  //{0xf0035514, 0x00000000, 0xffffffff},
  //{0xf0035514, 0x00000001, 0xffffffff},

  };

//-----------------------------------------------------------------------------
// Timing Control Signal Setting
//-----------------------------------------------------------------------------

//TCON LGD LGD V4 Non-GIP
  struct sTCONREGTABLE sRegTg_MLVDS_LGDV4FHD60[] = {

  // SOE, TG0
  {0xf0034840, 0x01100035, 0xffffffff},
  {0xf0034844, 0x00000000, 0xffffffff},
  {0xf0034848, 0x01100035, 0xffffffff},  
  {0xf003484c, 0x0443000A, 0xffffffff},
  {0xf0034850, 0x20000000, 0xffffffff},
  {0xf0034854, 0x80000000, 0xffffffff},
  {0xf0034858, 0x00000007, 0xffffffff},
  {0xf003485c, 0x00000000, 0xffffffff},
                                    
  // POL, TG1,  2 Line Inversion                       
  {0xf0034860, 0x076C076C, 0xffffffff},
  {0xf0034864, 0x00000000, 0xffffffff},
  {0xf0034868, 0x076C076C, 0xffffffff},  
  {0xf003486c, 0x04430009, 0xffffffff},
  {0xf0034870, 0x80000404, 0xffffffff},
  {0xf0034874, 0x80020004, 0xffffffff},
  {0xf0034878, 0x00000007, 0xffffffff},
  {0xf003487c, 0x10000000, 0xffffffff},
   /*
  // POL, TG1,  1 Frame Inversion				   
  {0xf0034860, 0x00010001, 0xffffffff},
  {0xf0034864, 0x00000000, 0xffffffff},
  {0xf0034868, 0x00010001, 0xffffffff},  
  {0xf003486c, 0x04430443, 0xffffffff},
  {0xf0034870, 0x00000000, 0xffffffff},
  {0xf0034874, 0x04430443, 0xffffffff},
  {0xf0034878, 0x00000007, 0xffffffff},
  {0xf003487c, 0x80008001, 0xffffffff}, 
  */
  // GSP, TG11                      
  {0xf00349A0, 0x05AB03F0, 0xffffffff},
  {0xf00349A4, 0x00000000, 0xffffffff},
  {0xf00349A8, 0x00000000, 0xffffffff},
  {0xf00349Ac, 0x00090008, 0xffffffff},
  {0xf00349B0, 0x00000000, 0xffffffff},
  {0xf00349B4, 0x00000000, 0xffffffff},
  {0xf00349B8, 0x00000004, 0xffffffff},
  {0xf00349Bc, 0x00000000, 0xffffffff},
                                    
  // GSP_R, TG8                     
  {0xf0034940, 0x05AB03F0, 0xffffffff},
  {0xf0034944, 0x00000000, 0xffffffff},
  {0xf0034948, 0x00000000, 0xffffffff},
  {0xf003494c, 0x00090008, 0xffffffff},
  {0xf0034950, 0x00000000, 0xffffffff},
  {0xf0034954, 0x00000000, 0xffffffff},
  {0xf0034958, 0x00000004, 0xffffffff},
  {0xf003495c, 0x00000000, 0xffffffff},
                                    
  // GOE, TG2                       
  {0xf0034880, 0x08200642, 0xffffffff},
  {0xf0034884, 0x00000000, 0xffffffff},
  {0xf0034888, 0x08200642, 0xffffffff},
  {0xf003488c, 0x04420009, 0xffffffff},
  {0xf0034890, 0x20000000, 0xffffffff},
  {0xf0034894, 0x80000000, 0xffffffff},
  {0xf0034898, 0x00000007, 0xffffffff},
  {0xf003489c, 0x00000000, 0xffffffff},
                                    
  // GSC, TG12                      
  {0xf00349c0, 0x079D03DB, 0xffffffff},
  {0xf00349c4, 0x00000000, 0xffffffff},
  {0xf00349c8, 0x079D03DB, 0xffffffff},
  {0xf00349cc, 0x04420009, 0xffffffff},
  {0xf00349d0, 0x20000000, 0xffffffff},
  {0xf00349d4, 0x80000000, 0xffffffff},
  {0xf00349d8, 0x00000007, 0xffffffff},
  {0xf00349dc, 0x0f000000, 0xffffffff},
                                    
  // FLK, TG9                       
  {0xf0034960, 0x049C0726, 0xffffffff},
  {0xf0034964, 0x00000000, 0xffffffff},
  {0xf0034968, 0x049C0726, 0xffffffff},
  {0xf003496c, 0x04420006, 0xffffffff},
  {0xf0034970, 0x20000000, 0xffffffff},
  {0xf0034974, 0x80000000, 0xffffffff},
  {0xf0034978, 0x00000007, 0xffffffff},
  {0xf003497c, 0x00000000, 0xffffffff},
  
  // DPM, TG10                      
  {0xf0034820, 0x04000400, 0x04000400}, //GPO :1
                                    
  // H_CONV, TG5                    
  {0xf0034820, 0x00000020, 0x00000020}, //GPO :0
                                    
  // OPT_N, TG6                     
  {0xf0034820, 0x00400040, 0x00400040}, //GPO :1
                                    
  // 0PT_P , TG7                    
  {0xf0034820, 0x00000080, 0x00000080}  //GPO :0

  };

  //TCON Samsung MB7 TRD 
  struct sTCONREGTABLE sRegTg_MLVDS_SAMSUNGMB7[] = {
  
  // SOE, TG0 for TP											 
  {0xf0034840, 0x005a0038, 0xffffffff},    
  {0xf0034844, 0x00000000, 0xffffffff},    
  {0xf0034848, 0x005a0038, 0xffffffff},    
  {0xf003484c, 0x00180019, 0xffffffff},    
  {0xf0034850, 0x20000000, 0xffffffff},    
  {0xf0034854, 0x80000000, 0xffffffff},    
  {0xf0034858, 0x00000007, 0xffffffff},    
  {0xf003485c, 0x00000000, 0xffffffff},    
														   
  // POL, TG1  for POL (1 Line Inversion) 					 
  //{0xf0034860, 0x00600060, 0xffffffff},  
  //{0xf0034864, 0x00000000, 0xffffffff},  
  //{0xf0034868, 0x00600060, 0xffffffff},  
  //{0xf003486c, 0x0Cdf0007, 0xffffffff},  
  //{0xf0034870, 0x80000202, 0xffffffff},  
  //{0xf0034874, 0x80010002, 0xffffffff},  
  //{0xf0034878, 0x00000007, 0xffffffff},  
  //{0xf003487c, 0x10000000, 0xffffffff},  
										   
  // POL, TG1  for POL (1 Frame Inversion)				   
  {0xf0034860, 0x00010001, 0xffffffff},    
  {0xf0034864, 0x00000000, 0xffffffff},    
  {0xf0034868, 0x00010001, 0xffffffff},    
  {0xf003486c, 0x00050005, 0xffffffff},    
  {0xf0034870, 0x00000000, 0xffffffff},    
  {0xf0034874, 0x00050005, 0xffffffff},    
  {0xf0034878, 0x00000007, 0xffffffff},    
  {0xf003487c, 0x80008001, 0xffffffff}, 	 
										   
  // GSP, TG11 for STV										 
  {0xf00349A0, 0x01a101a1, 0xffffffff},    
  {0xf00349A4, 0x00000000, 0xffffffff},    
  {0xf00349A8, 0x00000000, 0xffffffff},    
  {0xf00349Ac, 0x001A0016, 0xffffffff},    
  {0xf00349B0, 0x00000000, 0xffffffff},    
  {0xf00349B4, 0x00000000, 0xffffffff},    
  {0xf00349B8, 0x00000004, 0xffffffff},    
  {0xf00349Bc, 0x00000000, 0xffffffff},    
															 
  // H-CONV, TG5 for CPV1					   
  {0xf00348e0, 0x01900200, 0xffffffff},    
  {0xf00348e4, 0x00000000, 0xffffffff},    
  {0xf00348e8, 0x01900200, 0xffffffff},    
  {0xf00348ec, 0x00160017, 0xffffffff},    
  {0xf00348f0, 0x80000303, 0xffffffff},    
  {0xf00348f4, 0x80020002, 0xffffffff},    
  {0xf00348f8, 0x00000007, 0xffffffff},    
  {0xf00348fc, 0x00000000, 0xffffffff},    
															 
  // GSC, TG12 for CPV2							 
  {0xf00349C0, 0x01900200, 0xffffffff},    
  {0xf00349C4, 0x00000000, 0xffffffff},    
  {0xf00349C8, 0x01900200, 0xffffffff},    
  {0xf00349Cc, 0x00160018, 0xffffffff},    
  {0xf00349D0, 0x80000303, 0xffffffff},    
  {0xf00349D4, 0x80010001, 0xffffffff},    
  {0xf00349D8, 0x00000007, 0xffffffff},    
  {0xf00349Dc, 0x0f000000, 0xffffffff}, 	 

  // GSP_R, TG8 for CPV3             
  {0xf0034940, 0x01900200, 0xffffffff},
  {0xf0034944, 0x00000000, 0xffffffff},
  {0xf0034948, 0x01900200, 0xffffffff},
  {0xf003494c, 0x00160019, 0xffffffff},
  {0xf0034950, 0x80000303, 0xffffffff},
  {0xf0034954, 0x80030003, 0xffffffff},
  {0xf0034958, 0x00000007, 0xffffffff},
  {0xf003495c, 0x00000000, 0xffffffff},						
							 
  };

  //TCON CMO 2011 Flip-Pixel-2
  struct sTCONREGTABLE sRegTg_MLVDS_CMO2011FHD60[] = {
  
  // SOE, TG0
  {0xf0034840, 0x01100035, 0xffffffff},
  {0xf0034844, 0x00000000, 0xffffffff},
  {0xf0034848, 0x01100035, 0xffffffff},  
  {0xf003484c, 0x0443000A, 0xffffffff},
  {0xf0034850, 0x20000000, 0xffffffff},
  {0xf0034854, 0x80000000, 0xffffffff},
  {0xf0034858, 0x00000007, 0xffffffff},
  {0xf003485c, 0x00000000, 0xffffffff},
                                    
  // POL, TG1,  2 Line Inversion                       
  {0xf0034860, 0x076C076C, 0xffffffff},
  {0xf0034864, 0x00000000, 0xffffffff},
  {0xf0034868, 0x076C076C, 0xffffffff},  
  {0xf003486c, 0x04430009, 0xffffffff},
  {0xf0034870, 0x80000404, 0xffffffff},
  {0xf0034874, 0x80020004, 0xffffffff},
  {0xf0034878, 0x00000007, 0xffffffff},
  {0xf003487c, 0x10000000, 0xffffffff},
   /*
  // POL, TG1,  1 Frame Inversion				   
  {0xf0034860, 0x00010001, 0xffffffff},
  {0xf0034864, 0x00000000, 0xffffffff},
  {0xf0034868, 0x00010001, 0xffffffff},  
  {0xf003486c, 0x04430443, 0xffffffff},
  {0xf0034870, 0x00000000, 0xffffffff},
  {0xf0034874, 0x04430443, 0xffffffff},
  {0xf0034878, 0x00000007, 0xffffffff},
  {0xf003487c, 0x80008001, 0xffffffff}, 
  */
  // GSP, TG11                      
  {0xf00349A0, 0x05AB03F0, 0xffffffff},
  {0xf00349A4, 0x00000000, 0xffffffff},
  {0xf00349A8, 0x00000000, 0xffffffff},
  {0xf00349Ac, 0x00090008, 0xffffffff},
  {0xf00349B0, 0x00000000, 0xffffffff},
  {0xf00349B4, 0x00000000, 0xffffffff},
  {0xf00349B8, 0x00000004, 0xffffffff},
  {0xf00349Bc, 0x00000000, 0xffffffff},
                                    
  // GSP_R, TG8                     
  {0xf0034940, 0x05AB03F0, 0xffffffff},
  {0xf0034944, 0x00000000, 0xffffffff},
  {0xf0034948, 0x00000000, 0xffffffff},
  {0xf003494c, 0x00090008, 0xffffffff},
  {0xf0034950, 0x00000000, 0xffffffff},
  {0xf0034954, 0x00000000, 0xffffffff},
  {0xf0034958, 0x00000004, 0xffffffff},
  {0xf003495c, 0x00000000, 0xffffffff},
                                    
  // GOE, TG2                       
  {0xf0034880, 0x08200642, 0xffffffff},
  {0xf0034884, 0x00000000, 0xffffffff},
  {0xf0034888, 0x08200642, 0xffffffff},
  {0xf003488c, 0x04420009, 0xffffffff},
  {0xf0034890, 0x20000000, 0xffffffff},
  {0xf0034894, 0x80000000, 0xffffffff},
  {0xf0034898, 0x00000007, 0xffffffff},
  {0xf003489c, 0x00000000, 0xffffffff},
                                    
  // GSC, TG12                      
  {0xf00349c0, 0x079D03DB, 0xffffffff},
  {0xf00349c4, 0x00000000, 0xffffffff},
  {0xf00349c8, 0x079D03DB, 0xffffffff},
  {0xf00349cc, 0x04420009, 0xffffffff},
  {0xf00349d0, 0x20000000, 0xffffffff},
  {0xf00349d4, 0x80000000, 0xffffffff},
  {0xf00349d8, 0x00000007, 0xffffffff},
  {0xf00349dc, 0x0f000000, 0xffffffff},
	                                  
  };

//TCON Panasonic 2011 WXGA
struct sTCONREGTABLE sRegTg_MLVDS_PANASONIC32WXGA1P6P[] = {

	{0xF003481C, 0x00000000, 0xffffffff},
	{0xF0034820, 0x00000000, 0xffffffff},
	{0xF0034824, 0x00000000, 0xffffffff},

	// GOE, TP2 for DATA1
	{0xF0034880, 0x03850321, 0xffffffff},
	{0xF0034884, 0x00000000, 0xffffffff},
	{0xF0034888, 0x03850321, 0xffffffff},
	{0xF003488C, 0x00090008, 0xffffffff},
	{0xF0034890, 0x20000000, 0xffffffff},
	{0xF0034894, 0x80000000, 0xffffffff},
	{0xF0034898, 0x00000007, 0xffffffff},
	{0xF003489C, 0x00000000, 0xffffffff},  
                                          
	// TP14 for DATA1                 
	{0xF0034A00, 0x03210321, 0xffffffff},
	{0xF0034A04, 0x00000000, 0xffffffff},
	{0xF0034A08, 0x00000000, 0xffffffff},
	{0xF0034A0c, 0x000B000A, 0xffffffff},
	{0xf0034A10, 0x00000000, 0xffffffff},
	{0xf0034A14, 0x00000000, 0xffffffff},
	{0xf0034A18, 0x00000004, 0xffffffff},
	{0xf0034A1c, 0x0F000000, 0xffffffff},  
                                          
	// HCONV, TPK5 for DATA2                 
	{0xf00348E0, 0x03850321, 0xffffffff},
	{0xf00348E4, 0x00000000, 0xffffffff},
	{0xf00348E8, 0x03850321, 0xffffffff},
	{0xf00348EC, 0x000A0009, 0xffffffff},
	{0xf00348F0, 0x20000000, 0xffffffff},
	{0xf00348F4, 0x80000000, 0xffffffff},
	{0xf00348F8, 0x00000007, 0xffffffff},
	{0xf00348FC, 0x00000000, 0xffffffff},  
                                          
	// TPK1 for DATA2                 
	{0xf0034860, 0x03210321, 0xffffffff},
	{0xf0034864, 0x00000000, 0xffffffff},
	{0xf0034868, 0x00000000, 0xffffffff},
	{0xf003486C, 0x030B030A, 0xffffffff},
	{0xf0034870, 0x00000000, 0xffffffff},
	{0xf0034874, 0x00000000, 0xffffffff},
	{0xf0034878, 0x00000004, 0xffffffff},
	{0xf003487C, 0x00000000, 0xffffffff},  
                                          
	// OR merge TP2 and TP14 to DATA2 
	// OR merge TP5 and TP1   to DATA1
	{0xF0034814, 0x00100E00, 0xffffffff},
	{0xF0034818, 0x00000410, 0xffffffff},  
                                          
	// OPT_N, TPK6 for CPV		   
	{0xf0034900, 0x03B40358, 0xffffffff},
	{0xf0034904, 0x00000000, 0xffffffff},
	{0xf0034908, 0x03B40358, 0xffffffff},
	{0xf003490C, 0x04420008, 0xffffffff},
	{0xf0034910, 0x20000000, 0xffffffff},
	{0xf0034914, 0x80000000, 0xffffffff},
	{0xf0034918, 0x00000007, 0xffffffff},
	{0xf003491C, 0x00000000, 0xffffffff},
                                          
	// SOE, TPK0 for LP		           
	{0xf0034840, 0x00600B9D, 0xffffffff},
	{0xf0034844, 0x00000000, 0xffffffff},
	{0xf0034848, 0x00600B9D, 0xffffffff},
	{0xf003484C, 0x04420009, 0xffffffff},
	{0xf0034850, 0x20000000, 0xffffffff},
	{0xf0034854, 0x80000000, 0xffffffff},
	{0xf0034858, 0x00000007, 0xffffffff},
	{0xf003485C, 0x00000000, 0xffffffff},
                                          
	// OPT_P, TPK7 for POLL						   
	{0xf0034920, 0x04550455, 0xffffffff},
	{0xf0034924, 0x00000000, 0xffffffff},
	{0xf0034928, 0x04550455, 0xffffffff},
	{0xf003492C, 0x00010001, 0xffffffff},
	{0xf0034930, 0x80000404, 0xffffffff},
	{0xf0034934, 0x80040002, 0xffffffff},
	{0xf0034938, 0x00000007, 0xffffffff},
	{0xf003493C, 0x10000000, 0xffffffff},
								   
	// GSC, TPK12 for POLR                 
	{0xf00349C0, 0x04550455, 0xffffffff}, 																													  
	{0xf00349C4, 0x00000000, 0xffffffff}, 																													  
	{0xf00349C8, 0x04550455, 0xffffffff}, 																													  
	{0xf00349CC, 0x00010001, 0xffffffff}, 																													  
	{0xf00349D0, 0x80000404, 0xffffffff}, 																													  
	{0xf00349D4, 0x80040002, 0xffffffff}, 																													  
	{0xf00349D8, 0x00000087, 0xffffffff}, 																													  
	{0xf00349DC, 0x1F000000, 0xffffffff},

  };

   struct sTCONREGTABLE sRegTg_MLVDS_PANASONIC32WXGA2P3P[] = {

	 // TP2 GOE for DATA1
	{0xF0034880, 0x08200765, 0xffffffff},
	{0xF0034884, 0x00000000, 0xffffffff},
	{0xF0034888, 0x08200765, 0xffffffff},
	{0xF003488C, 0x00090008, 0xffffffff},
	{0xF0034890, 0x20000000, 0xffffffff},
	{0xF0034894, 0x00080009, 0xffffffff},
	{0xF0034898, 0x00000007, 0xffffffff},
	{0xF003489C, 0x00000000, 0xffffffff},  
                                          
	 // TP14 for DATA1                
	{0xF0034A00, 0x0C000765, 0xffffffff},
	{0xF0034A04, 0x00000000, 0xffffffff},
	{0xF0034A08, 0x0C000C00, 0xffffffff},
	{0xF0034A0c, 0x000B000A, 0xffffffff},
	{0xf0034A10, 0x20000000, 0xffffffff},
	{0xf0034A14, 0x000A000B, 0xffffffff},
	{0xf0034A18, 0x00000007, 0xffffffff},
	{0xf0034A1c, 0x0F000000, 0xffffffff},  
                                          
	 // TPK5 H-CONV for DATA2                
	{0xf00348E0, 0x0C000765, 0xffffffff},
	{0xf00348E4, 0x00000000, 0xffffffff},
	{0xf00348E8, 0x07650765, 0xffffffff},
	{0xf00348EC, 0x00090008, 0xffffffff},
	{0xf00348F0, 0x20000000, 0xffffffff},
	{0xf00348F4, 0x00080009, 0xffffffff},
	{0xf00348F8, 0x00000007, 0xffffffff},
	{0xf00348FC, 0x00000000, 0xffffffff},  
                                          
	 // TPK1 for DATA2                
	{0xf0034860, 0x0C000765, 0xffffffff},
	{0xf0034864, 0x00000000, 0xffffffff},
	{0xf0034868, 0x08200765, 0xffffffff},
	{0xf003486C, 0x0307000A, 0xffffffff},
	{0xf0034870, 0x20000000, 0xffffffff},
	{0xf0034874, 0x000A0307, 0xffffffff},
	{0xf0034878, 0x00000007, 0xffffffff},
	{0xf003487C, 0x00000000, 0xffffffff},  
                                   
	// OR merge TP2 and TP14 to DATA1 
	// OR merge TP5 and TP1   to DATA2
	{0xF0034810, 0x000000D0, 0xffffffff},
	{0xF0034814, 0x00160E00, 0xffffffff},
	{0xF0034818, 0x00040510, 0xffffffff},  
                                        
	// TPK6 OPT_N for CPV		   
	{0xf0034900, 0x087007D0, 0xffffffff},
	{0xf0034904, 0x00000000, 0xffffffff},
	{0xf0034908, 0x087007D0, 0xffffffff},
	{0xf003490C, 0x00070008, 0xffffffff},
	{0xf0034910, 0x20000000, 0xffffffff},
	{0xf0034914, 0x80000000, 0xffffffff},
	{0xf0034918, 0x00000007, 0xffffffff},
	{0xf003491C, 0x00000000, 0xffffffff},
                                          
	// TPK0 SOE for LP		           
	{0xf0034840, 0x00600B9D, 0xffffffff},
	{0xf0034844, 0x00000000, 0xffffffff},
	{0xf0034848, 0x00600B9D, 0xffffffff},
	{0xf003484C, 0x00070008, 0xffffffff},
	{0xf0034850, 0x20000000, 0xffffffff},
	{0xf0034854, 0x80000000, 0xffffffff},
	{0xf0034858, 0x00000007, 0xffffffff},
	{0xf003485C, 0x00000000, 0xffffffff},
                                          
	// TPK7 OPT_P for POLL						   
	{0xf0034920, 0x05950595, 0xffffffff},
	{0xf0034924, 0x00000000, 0xffffffff},
	{0xf0034928, 0x05950595, 0xffffffff},
	{0xf003492C, 0x00070008, 0xffffffff},
	{0xf0034930, 0x80000404, 0xffffffff},
	{0xf0034934, 0x80040002, 0xffffffff},
	{0xf0034938, 0x00000007, 0xffffffff},
	{0xf003493C, 0x10000000, 0xffffffff},

  };
   
   //TCON Panasonic FHD 120Hz
struct sTCONREGTABLE sRegTg_MLVDS_PANASONIC42FHD120[] = {
	
	{0xF003481C, 0x00000000, 0xffffffff},
	{0xF0034820, 0x00000000, 0xffffffff},
	{0xF0034824, 0x00000000, 0xffffffff},
	
	// GOE, TP2 for DATA1
	{0xF0034880, 0x0CA00AB0, 0xffffffff},
	{0xF0034884, 0x00000000, 0xffffffff},
	{0xF0034888, 0x01A00AB0, 0xffffffff}, 
	{0xF003488C, 0x04420441, 0xffffffff},
	{0xF0034890, 0x20000000, 0xffffffff},
	{0xF0034894, 0x04420442, 0xffffffff},
	{0xF0034898, 0x00000007, 0xffffffff},
	{0xF003489C, 0x00000000, 0xffffffff},  
											  
	// TP14 for DATA1				  
	{0xF0034A00, 0x01A00AB0, 0xffffffff},
	{0xF0034A04, 0x00000000, 0xffffffff},
	{0xF0034A08, 0x01A00AB0, 0xffffffff},
	{0xF0034A0c, 0x04450443, 0xffffffff},
	{0xf0034A10, 0x20000000, 0xffffffff},
	{0xf0034A14, 0x04440444, 0xffffffff},
	{0xf0034A18, 0x00000007, 0xffffffff},
	{0xf0034A1c, 0x0F000000, 0xffffffff},  
										  
	// HCONV, TPK5 for DATA2				 
	{0xf00348E0, 0x01A00AB0, 0xffffffff},
	{0xf00348E4, 0x00000000, 0xffffffff},
	{0xf00348E8, 0x01A001A0, 0xffffffff},
	{0xf00348EC, 0x04420441, 0xffffffff},
	{0xf00348F0, 0x20000000, 0xffffffff},
	{0xf00348F4, 0x04420442, 0xffffffff},
	{0xf00348F8, 0x00000007, 0xffffffff},
	{0xf00348FC, 0x00000000, 0xffffffff},  
											  
	// TPK1 for DATA2				  
	{0xf0034860, 0x01A00AB0, 0xffffffff},
	{0xf0034864, 0x00000000, 0xffffffff},
	{0xf0034868, 0x0CA001A0, 0xffffffff},
	{0xf003486C, 0x04450443, 0xffffffff},
	{0xf0034870, 0x20000000, 0xffffffff},
	{0xf0034874, 0x04430445, 0xffffffff},
	{0xf0034878, 0x00000007, 0xffffffff},
	{0xf003487C, 0x00000000, 0xffffffff},  
	
	// TPK3 for DATA2				  
	{0xf00348A0, 0x0CA00AB0, 0xffffffff},
	{0xf00348A4, 0x00000000, 0xffffffff},
	{0xf00348A8, 0x0CA00AB0, 0xffffffff},
	{0xf00348AC, 0x00090008, 0xffffffff},
	{0xf00348B0, 0x20000000, 0xffffffff},
	{0xf00348B4, 0x00080007, 0xffffffff},
	{0xf00348B8, 0x00000007, 0xffffffff},
	{0xf00348BC, 0x00000000, 0xffffffff},  
		
	// OR merge TP2 and TP14 to DATA2 
	// OR merge TP5 and TP1   to DATA1
	{0xF0034814, 0x00100E00, 0xffffffff},
	{0xF0034818, 0x00000410, 0xffffffff},  
   
	// OR merge TP2, TP14,and TP3 to DATA2 
	{0xF0034828, 0x76343210, 0xffffffff}, 
		
	{0xF003483C, 0x76243510, 0xffffffff}, 
		
	// OPT_N, TPK6 for CPV		   
	{0xf0034900, 0x00A00BC0, 0xffffffff},
	{0xf0034904, 0x00000000, 0xffffffff},
	{0xf0034908, 0x00A00BC0, 0xffffffff},
	{0xf003490C, 0x00080008, 0xffffffff},
	{0xf0034910, 0x20000000, 0xffffffff},
	{0xf0034914, 0x80000000, 0xffffffff},
	{0xf0034918, 0x00000007, 0xffffffff},
	{0xf003491C, 0x00000000, 0xffffffff},
											  
	// SOE, TPK0 for LP 			   
	{0xf0034840, 0x01500040, 0xffffffff},
	{0xf0034844, 0x00000000, 0xffffffff},
	{0xf0034848, 0x01500040, 0xffffffff},
	{0xf003484C, 0x00080009, 0xffffffff},
	{0xf0034850, 0x20000000, 0xffffffff},
	{0xf0034854, 0x80000000, 0xffffffff},
	{0xf0034858, 0x00000007, 0xffffffff},
	{0xf003485C, 0x00000000, 0xffffffff},
											  
	// OPT_P, TPK7 for POLL 					   
	{0xf0034920, 0x00C800C8, 0xffffffff},
	{0xf0034924, 0x00000000, 0xffffffff},
	{0xf0034928, 0x00C800C8, 0xffffffff},
	{0xf003492C, 0x00050005, 0xffffffff},
	{0xf0034930, 0x00000000, 0xffffffff},
	{0xf0034934, 0x00050005, 0xffffffff},
	{0xf0034938, 0x00000007, 0xffffffff},
	{0xf003493C, 0x80008001, 0xffffffff},
									   
	// GSC, TPK12 for POLR				   
	{0xf00349C0, 0x00C800C8, 0xffffffff},																													  
	{0xf00349C4, 0x00000000, 0xffffffff},																													  
	{0xf00349C8, 0x00C800C8, 0xffffffff},																													  
	{0xf00349CC, 0x00050005, 0xffffffff},																													  
	{0xf00349D0, 0x00000000, 0xffffffff},																													  
	{0xf00349D4, 0x00050005, 0xffffffff},																													  
	{0xf00349D8, 0x00000087, 0xffffffff},																													  
	{0xf00349DC, 0x8F002001, 0xffffffff},
	
};

struct sTCONREGTABLE sRegTg_MLVDS_LGD32WXGAV9[] = {
	
  {0xF0034838, 0xFEDCBA28, 0xffffffff},

	// SOE, TG0
  {0xf0034840, 0x00D00002, 0xffffffff},
  {0xf0034844, 0x00000000, 0xffffffff},
  {0xf0034848, 0x00D00002, 0xffffffff},  
  {0xf003484c, 0x00060007, 0xffffffff},
  {0xf0034850, 0x20000000, 0xffffffff},
  {0xf0034854, 0x80000000, 0xffffffff},
  {0xf0034858, 0x00000007, 0xffffffff},
  {0xf003485c, 0x00000000, 0xffffffff},
	
  // POL, TG1
  {0xf0034860, 0x0B300B30, 0xffffffff},
  {0xf0034864, 0x00000000, 0xffffffff},
  {0xf0034868, 0x0B300B30, 0xffffffff},  
  {0xf003486c, 0x04430007, 0xffffffff},
  {0xf0034870, 0x80000404, 0xffffffff},
  {0xf0034874, 0x80010003, 0xffffffff},
  {0xf0034878, 0x00000007, 0xffffffff},
  {0xf003487c, 0x10000000, 0xffffffff},
	
  // GSP, TG11
  {0xf00349A0, 0x05200520, 0xffffffff},
  {0xf00349A4, 0x00000000, 0xffffffff},
  {0xf00349A8, 0x00000000, 0xffffffff},
  {0xf00349Ac, 0x00080007, 0xffffffff},
  {0xf00349B0, 0x00000000, 0xffffffff},
  {0xf00349B4, 0x00000000, 0xffffffff},
  {0xf00349B8, 0x00000004, 0xffffffff},
  {0xf00349Bc, 0x00000000, 0xffffffff},
	
  // GOE, TG2
  {0xf0034880, 0x003009A0, 0xffffffff},
  {0xf0034884, 0x00000000, 0xffffffff},
  {0xf0034888, 0x003009A0, 0xffffffff},
  {0xf003488c, 0x04420006, 0xffffffff},
  {0xf0034890, 0x20000000, 0xffffffff},
  {0xf0034894, 0x80000000, 0xffffffff},
  {0xf0034898, 0x00000007, 0xffffffff},
  {0xf003489c, 0x00000000, 0xffffffff},
	  
  // GSC, TG12
  {0xf00349c0, 0x05200B30, 0xffffffff},
  {0xf00349c4, 0x00000000, 0xffffffff},
  {0xf00349c8, 0x05200B30, 0xffffffff},
  {0xf00349cc, 0x04420006, 0xffffffff},
  {0xf00349d0, 0x20000000, 0xffffffff},
  {0xf00349d4, 0x80000000, 0xffffffff},
  {0xf00349d8, 0x00000007, 0xffffffff},
  {0xf00349dc, 0x0f000000, 0xffffffff},
	  
  // H_CONV, TG5
  {0xf0034820, 0x00000020, 0x00000020}, //GPO :0

};

struct sTCONREGTABLE sRegTg_MLVDS_HISENSE32WXGA2P3P[] = {

  // TCON1 for POL						 
  {0xf0034860, 0x03F003F0, 0xffffffff},
  {0xf0034864, 0x00000000, 0xffffffff},
  {0xf0034868, 0x03F003F0, 0xffffffff},
  {0xf003486C, 0x00080008, 0xffffffff},
  {0xf0034870, 0x00000000, 0xffffffff},
  {0xf0034874, 0x00080008, 0xffffffff},
  {0xf0034878, 0x00000007, 0xffffffff},
  {0xf003487C, 0x80008001, 0xffffffff},

  // TCON0 for TP						 
  {0xf0034840, 0x007D08BE, 0xffffffff}, //{0xf00348E0, 0x004C08D9, 0xffffffff},
  {0xf0034844, 0x00000000, 0xffffffff},
  {0xf0034848, 0x007D08BE, 0xffffffff}, //{0xf00348E8, 0x004C08D9, 0xffffffff},
  {0xf003484C, 0x00080008, 0xffffffff}, 
  {0xf0034850, 0x20000000, 0xffffffff},
  {0xf0034854, 0x80000000, 0xffffffff},
  {0xf0034858, 0x00000007, 0xffffffff},
  {0xf003485C, 0x00000000, 0xffffffff}, 									  

  // TCON6 for VST							 
  {0xf0034900, 0x04C504B5, 0xffffffff}, //{0xf0034860, 0x05570562, 0xffffffff},
  {0xf0034904, 0x00000000, 0xffffffff},
  {0xf0034908, 0x00000000, 0xffffffff}, 
  {0xf003490C, 0x000A0009, 0xffffffff},
  {0xf0034910, 0x00000000, 0xffffffff},
  {0xf0034914, 0x00000000, 0xffffffff},
  {0xf0034918, 0x00000004, 0xffffffff},
  {0xf003491C, 0x00000000, 0xffffffff},  

  // TCON5 for CPV							 
  {0xf00348E0, 0x037506CC, 0xffffffff}, //{0xf00348C0, 0x025706E0, 0xffffffff},
  {0xf00348E4, 0x00000000, 0xffffffff},
  {0xf00348E8, 0x037506CC, 0xffffffff}, //{0xf00348C8, 0x025706E0, 0xffffffff},
  {0xf00348EC, 0x00090009, 0xffffffff},
  {0xf00348F0, 0x20000000, 0xffffffff},
  {0xf00348F4, 0x80000000, 0xffffffff},
  {0xf00348F8, 0x00000007, 0xffffffff},
  {0xf00348FC, 0x00000000, 0xffffffff},

  // TCON2 for OE		 
  {0xf0034820, 0x00040004, 0xffffffff}, //GPO :1

  // TCON9 for FLK						 
  {0xF0034960, 0x06CB0578, 0xffffffff}, //{0xF0034880, 0x05AF0730, 0xffffffff}, 
  {0xf0034964, 0x00000000, 0xffffffff},
  {0xf0034968, 0x06CB0578, 0xffffffff}, //{0xf0034888, 0x05AF0730, 0xffffffff},
  {0xf003496C, 0x00080009, 0xffffffff}, //{0xf003488C, 0x00090009, 0xffffffff},
  {0xf0034970, 0x20000000, 0xffffffff},
  {0xf0034974, 0x80000000, 0xffffffff},
  {0xf0034978, 0x00000007, 0xffffffff},
  {0xf003497C, 0x00000000, 0xffffffff}, 										
};

struct sTCONREGTABLE sRegTg_MLVDS_AUO_T420HVN06FHD60[] = {				  
		
  // POL,TCO[6]  0xf0034900 (1 Frame Inversion) 
  {0xf0034900, 0x00000000, 0xffffffff},
  {0xf0034904, 0x00000000, 0xffffffff},
  {0xf0034908, 0x00000000, 0xffffffff},   
  {0xf003490c, 0x00000000, 0xffffffff},
  {0xf0034910, 0x00000000, 0xffffffff},
  {0xf0034914, 0x00000000, 0xffffffff},
  {0xf0034918, 0x00000080, 0xffffffff},
  {0xf003491c, 0x20000000, 0xffffffff},
													  
  //VST,TCO[2]   0xf0034880
  {0xf0034880, 0x10F01013, 0xffffffff},//{0xf0034880, 0x112C1013, 0xffffffff},
  {0xf0034884, 0x00000000, 0xffffffff},
  {0xf0034888, 0x10F01013, 0xffffffff},//{0xf0034888, 0x112C1013, 0xffffffff},
  {0xf003488c, 0x00090006, 0xffffffff},//{0xf003488c, 0x000A0006, 0xffffffff},
  {0xf0034890, 0x00000000, 0xffffffff},
  {0xf0034894, 0x00000000, 0xffffffff},
  {0xf0034898, 0x00000004, 0xffffffff},
  {0xf003489c, 0x00000000, 0xffffffff}, 

  /*   
  //OR VCE, TCON[1] 0xf0034860
  {0xf0034860, 0x01E5011B, 0xffffffff},//{0xf0034860, 0x04550054, 0xffffffff},
  {0xf0034864, 0x00000000, 0xffffffff},
  {0xf0034868, 0x00000000, 0xffffffff},
  {0xf003486c, 0x00090009, 0xffffffff},
  {0xf0034870, 0x00000000, 0xffffffff},
  {0xf0034874, 0x00000000, 0xffffffff},
  {0xf0034878, 0x00000004, 0xffffffff},
  {0xf003487c, 0x00000000, 0xffffffff},
  */
					
  //VCE,TCO[4]   0xf00348C0
  {0xf00348C0, 0x0BBE0FA2, 0xffffffff},//{0xf00348C0, 0x0CB61117, 0xffffffff},
  {0xf00348C4, 0x00000000, 0xffffffff},
  {0xf00348C8, 0x0BBE0FA2, 0xffffffff},//{0xf00348C8, 0x0CB61117, 0xffffffff},
  {0xf00348Cc, 0x044F0009, 0xffffffff},
  {0xf00348D0, 0x20000000, 0xffffffff},
  {0xf00348D4, 0x80000000, 0xffffffff},
  {0xf00348D8, 0x00000007, 0xffffffff},
  {0xf00348Dc, 0x00000000, 0xffffffff},
			  
  //STB,TCO[5]  0xf00348e0
  {0xf00348E0, 0x0146112D, 0xffffffff},//{0xf00348E0, 0x016010FD, 0xffffffff},
  {0xf00348E4, 0x00000000, 0xffffffff},
  {0xf00348E8, 0x0146112D, 0xffffffff},//{0xf00348E8, 0x016010FD, 0xffffffff},
  {0xf00348Ec, 0x04410009, 0xffffffff},
  {0xf00348F0, 0x20000000, 0xffffffff},
  {0xf00348F4, 0x80000000, 0xffffffff},
  {0xf00348F8, 0x00000007, 0xffffffff},
  {0xf00348Fc, 0x00000000, 0xffffffff},
			  
  //LC,TCO[0]	0xf0034840
  {0xf0034840, 0x00010001, 0xffffffff},
  {0xf0034844, 0x00000000, 0xffffffff},
  {0xf0034848, 0x00010001, 0xffffffff},
  {0xf003484c, 0x00010001, 0xffffffff},
  {0xf0034850, 0x00000000, 0xffffffff},
  {0xf0034854, 0x00030003, 0xffffffff},
  {0xf0034858, 0x00000007, 0xffffffff},
  {0xf003485c, 0x80190001, 0xffffffff},
				
  //TERMINATE,TCO[3]  0xf00348A0
  {0xf00348A0, 0x042801C3, 0xffffffff},//{0xf00348A0, 0x05E30288, 0xffffffff},
  {0xf00348A4, 0x00000000, 0xffffffff},
  {0xf00348A8, 0x00000000, 0xffffffff},
  {0xf00348Ac, 0x04500450, 0xffffffff},
  {0xf00348B0, 0x20000000, 0xffffffff},
  {0xf00348B4, 0x80000000, 0xffffffff},
  {0xf00348B8, 0x00000004, 0xffffffff},
  {0xf00348Bc, 0x00000000, 0xffffffff}, 
		   
  //{0xf0034814, 0x00010000, 0xffffffff}, //Bmux select
  //{0xf0034818, 0x00000100, 0xffffffff}, //combination

};

//SOE table
//         60Hz                      120Hz
//         start(T1) width(T2)  start(T1) width(T2)
//32 Inch  5            50            x            x
//42 Inch  5            43            5            24
//47 Inch  5            43            5            32
//55 Inch  5            43            5            32

struct sTCONREGTABLE sRegTg_EPI_LGDV12FHD120[] = {
    //SOE
//    {0xf0035508, 0x00001805, 0xffffffff}, //setting model by model
    {0xf0035550, 0x00001805, 0xffffffff}, //channel1 SOE
    {0xf0035554, 0x00001805, 0xffffffff}, //channel2 SOE
    {0xf0035558, 0x00001805, 0xffffffff}, //channel3 SOE
    {0xf003555C, 0x00001805, 0xffffffff}, //channel4 SOE
    {0xf0035560, 0x00001805, 0xffffffff}, //channel5 SOE
    {0xf0035564, 0x00001805, 0xffffffff}, //channel6 SOE

    //GSP    TCO[0]  0xf0034840
    {0xf0034840, 0x012c0001, 0xffffffff},
    {0xf0034844, 0x00000000, 0xffffffff},
    {0xf0034848, 0x012c0001, 0xffffffff},
    {0xf003484c, 0x00090008, 0xffffffff},
    {0xf0034850, 0x00000000, 0xffffffff},
    {0xf0034854, 0x00000000, 0xffffffff},
    {0xf0034858, 0x00000004, 0xffffffff},
    {0xf003485c, 0x00000000, 0xffffffff},
                                      
    //POL    TCO[1]  0xf0034860
    {0xf0034860, 0x00000000, 0xffffffff},
    {0xf0034864, 0x00000000, 0xffffffff},
    {0xf0034868, 0x00000000, 0xffffffff},
    {0xf003486c, 0x00000000, 0xffffffff},
    {0xf0034870, 0x00000000, 0xffffffff},
    {0xf0034874, 0x00000000, 0xffffffff},
    {0xf0034878, 0x00000080, 0xffffffff},
    {0xf003487c, 0x20000000, 0xffffffff},
                                      
    //GST    TCO[5]  0xf00348e0
    {0xf00348E0, 0x00100003, 0xffffffff},
    {0xf00348E4, 0x00000000, 0xffffffff},
    {0xf00348E8, 0x00100003, 0xffffffff},
    {0xf00348Ec, 0x00040002, 0xffffffff},
    {0xf00348F0, 0x00000000, 0xffffffff},
    {0xf00348F4, 0x00000000, 0xffffffff},
    {0xf00348F8, 0x00000004, 0xffffffff},
    {0xf00348Fc, 0x00000000, 0xffffffff},

    //MCLK    TCO[4]  0xf00348c0
    {0xf00348C0, 0x00FD00F5, 0xffffffff},
    {0xf00348C4, 0x00000000, 0xffffffff},
    {0xf00348C8, 0x00FD00F5, 0xffffffff},
    {0xf00348Cc, 0x04430007, 0xffffffff},
    {0xf00348D0, 0x20000000, 0xffffffff},
    {0xf00348D4, 0x80000000, 0xffffffff},
    {0xf00348D8, 0x00000007, 0xffffffff},
    {0xf00348Dc, 0x00000000, 0xffffffff},

    //GCLK    TCO[3]  0xf00348a0
    {0xf00348A0, 0x0064014F, 0xffffffff},
    {0xf00348A4, 0x00000000, 0xffffffff},
    {0xf00348A8, 0x0064014F, 0xffffffff},
    {0xf00348Ac, 0x04410004, 0xffffffff},
    {0xf00348B0, 0x20000000, 0xffffffff},
    {0xf00348B4, 0x80000000, 0xffffffff},
    {0xf00348B8, 0x00000007, 0xffffffff},
    {0xf00348Bc, 0x00000000, 0xffffffff},

    //GCLK_END    TCO[8]  0xf0034940
    {0xf0034940, 0x0014014F, 0xffffffff},
    {0xf0034944, 0x00000000, 0xffffffff},
    {0xf0034948, 0x0014014F, 0xffffffff},
    {0xf003494c, 0x04480441, 0xffffffff},
    {0xf0034950, 0x00000000, 0xffffffff},
    {0xf0034954, 0x00000000, 0xffffffff},
    {0xf0034958, 0x00000004, 0xffffffff},
    {0xf003495c, 0x00000000, 0xffffffff}, 

    //EO   TCO[6]  0xf0034900
    {0xf0034900, 0x00380018, 0xffffffff},
    {0xf0034904, 0x00000000, 0xffffffff},
    {0xf0034908, 0x00380018, 0xffffffff},
    {0xf003490c, 0x04490449, 0xffffffff},
    {0xf0034910, 0x00000000, 0xffffffff},
    {0xf0034914, 0x04490449, 0xffffffff},
    {0xf0034918, 0x00000007, 0xffffffff},
    {0xf003491c, 0x80004001, 0xffffffff},

    //GST_END    TCO[9]  0xf0034960
    {0xf0034960, 0x0014014F, 0xffffffff},
    {0xf0034964, 0x00000000, 0xffffffff},
    {0xf0034968, 0x0014014F, 0xffffffff},
    {0xf003496c, 0x04480445, 0xffffffff},
    {0xf0034970, 0x00000000, 0xffffffff},
    {0xf0034974, 0x00000000, 0xffffffff},
    {0xf0034978, 0x00000004, 0xffffffff},
    {0xf003497c, 0x00000000, 0xffffffff}, 

    //VCOM_DYN  TCO[7]  0xf0034920
    {0xf0034920, 0x00010001, 0xffffffff},
    {0xf0034924, 0x00000000, 0xffffffff},
    {0xf0034928, 0x00010001, 0xffffffff},
    {0xf003492c, 0x02320001, 0xffffffff},
    {0xf0034930, 0x00000000, 0xffffffff},
    {0xf0034934, 0x00000000, 0xffffffff},
    {0xf0034938, 0x00000004, 0xffffffff},
    {0xf003493c, 0x00000000, 0xffffffff},

    {0xf0034820, 0x00000000, 0xffffffff}, //GPO :1
                                      
//    {0xf0034800, 0x8100ffff, 0xffffffff},
    {0xf0034804, 0x00000000, 0xffffffff},
    {0xf0034814, 0x00908000, 0xffffffff}, //Bmux select
    {0xf0034818, 0x00000440, 0xffffffff}, //combination
    {0xf003481c, 0x00000000, 0xffffffff},

    };

struct sTCONREGTABLE sRegTg_EPI_LGDV12FHD60[] = {
    //SOE
//    {0xf0035508, 0x00002B05, 0xffffffff}, //setting model by model
    {0xf0035550, 0x00002B05, 0xffffffff}, //channel1 SOE
    {0xf0035554, 0x00002B05, 0xffffffff}, //channel2 SOE
    {0xf0035558, 0x00002B05, 0xffffffff}, //channel3 SOE
    {0xf003555C, 0x00002B05, 0xffffffff}, //channel4 SOE
    {0xf0035560, 0x00002B05, 0xffffffff}, //channel5 SOE
    {0xf0035564, 0x00002B05, 0xffffffff}, //channel6 SOE

    //GSP    TCO[0]  0xf0034840
    {0xf0034840, 0x012c0001, 0xffffffff},
    {0xf0034844, 0x00000000, 0xffffffff},
    {0xf0034848, 0x012c0001, 0xffffffff},
    {0xf003484c, 0x00090008, 0xffffffff},
    {0xf0034850, 0x00000000, 0xffffffff},
    {0xf0034854, 0x00000000, 0xffffffff},
    {0xf0034858, 0x00000004, 0xffffffff},
    {0xf003485c, 0x00000000, 0xffffffff},
                                      
    //POL    TCO[1]  0xf0034860
    {0xf0034860, 0x00E20112, 0xffffffff},
    {0xf0034864, 0x00000000, 0xffffffff},
    {0xf0034868, 0x00E20112, 0xffffffff},
    {0xf003486c, 0x043F0002, 0xffffffff},
    {0xf0034870, 0x80000404, 0xffffffff},
    {0xf0034874, 0x80040002, 0xffffffff},
    {0xf0034878, 0x00000007, 0xffffffff},
    {0xf003487c, 0x20000000, 0xffffffff},
                                      
    //GST    TCO[5]  0xf00348e0
    {0xf00348E0, 0x0013000B, 0xffffffff},
    {0xf00348E4, 0x00000000, 0xffffffff},
    {0xf00348E8, 0x0013000B, 0xffffffff},
    {0xf00348Ec, 0x00040002, 0xffffffff},
    {0xf00348F0, 0x00000000, 0xffffffff},
    {0xf00348F4, 0x00000000, 0xffffffff},
    {0xf00348F8, 0x00000004, 0xffffffff},
    {0xf00348Fc, 0x00000000, 0xffffffff},

    //MCLK    TCO[4]  0xf00348c0
    {0xf00348C0, 0x0082007E, 0xffffffff},
    {0xf00348C4, 0x00000000, 0xffffffff},
    {0xf00348C8, 0x0082007E, 0xffffffff},
    {0xf00348Cc, 0x04440007, 0xffffffff},
    {0xf00348D0, 0x20000000, 0xffffffff},
    {0xf00348D4, 0x80000000, 0xffffffff},
    {0xf00348D8, 0x00000007, 0xffffffff},
    {0xf00348Dc, 0x00000000, 0xffffffff},

    //GCLK    TCO[3]  0xf00348a0
    {0xf00348A0, 0x007000DC, 0xffffffff},
    {0xf00348A4, 0x00000000, 0xffffffff},
    {0xf00348A8, 0x007000DC, 0xffffffff},
    {0xf00348Ac, 0x04410004, 0xffffffff},
    {0xf00348B0, 0x20000000, 0xffffffff},
    {0xf00348B4, 0x80000000, 0xffffffff},
    {0xf00348B8, 0x00000007, 0xffffffff},
    {0xf00348Bc, 0x00000000, 0xffffffff},

    //GCLK_END    TCO[8]  0xf0034940
    {0xf0034940, 0x007000DC, 0xffffffff},
    {0xf0034944, 0x00000000, 0xffffffff},
    {0xf0034948, 0x007000DC, 0xffffffff},
    {0xf003494c, 0x04460441, 0xffffffff},
    {0xf0034950, 0x00000000, 0xffffffff},
    {0xf0034954, 0x00000000, 0xffffffff},
    {0xf0034958, 0x00000004, 0xffffffff},
    {0xf003495c, 0x00000000, 0xffffffff}, 

    //EO   TCO[6]  0xf0034900
    {0xf0034900, 0x00840074, 0xffffffff},
    {0xf0034904, 0x00000000, 0xffffffff},
    {0xf0034908, 0x00840074, 0xffffffff},
    {0xf003490c, 0x04470447, 0xffffffff},
    {0xf0034910, 0x00000000, 0xffffffff},
    {0xf0034914, 0x04470447, 0xffffffff},
    {0xf0034918, 0x00000007, 0xffffffff},
    {0xf003491c, 0x80004001, 0xffffffff},

    //GST_END    TCO[9]  0xf0034960
    {0xf0034960, 0x007000DC, 0xffffffff},
    {0xf0034964, 0x00000000, 0xffffffff},
    {0xf0034968, 0x007000DC, 0xffffffff},
    {0xf003496c, 0x04450442, 0xffffffff},
    {0xf0034970, 0x00000000, 0xffffffff},
    {0xf0034974, 0x00000000, 0xffffffff},
    {0xf0034978, 0x00000004, 0xffffffff},
    {0xf003497c, 0x00000000, 0xffffffff}, 

    //VCOM_DYN  TCO[7]  0xf0034920
    {0xf0034920, 0x00010001, 0xffffffff},
    {0xf0034924, 0x00000000, 0xffffffff},
    {0xf0034928, 0x00010001, 0xffffffff},
    {0xf003492c, 0x02320001, 0xffffffff},
    {0xf0034930, 0x00000000, 0xffffffff},
    {0xf0034934, 0x00000000, 0xffffffff},
    {0xf0034938, 0x00000004, 0xffffffff},
    {0xf003493c, 0x00000000, 0xffffffff},

    //EO2    TCO[10]  0xf0034980
    {0xf0034980, 0x00140004, 0xffffffff},
    {0xf0034984, 0x00000000, 0xffffffff},
    {0xf0034988, 0x00140004, 0xffffffff},
    {0xf003498c, 0x044D044D, 0xffffffff},
    {0xf0034990, 0x00000000, 0xffffffff},
    {0xf0034994, 0x044D044D, 0xffffffff},
    {0xf0034998, 0x00000007, 0xffffffff},
    {0xf003499c, 0x80200080, 0xffffffff}, 

    {0xf0034820, 0x00000000, 0xffffffff}, //GPO :1
                                      
//    {0xf0034800, 0x8100ffff, 0xffffffff},
    {0xf0034804, 0x00000000, 0xffffffff},
    {0xf0034814, 0x0A908000, 0xffffffff}, //Bmux select
    {0xf0034818, 0x00001440, 0xffffffff}, //combination
    {0xf003481c, 0x00000000, 0xffffffff},

    };

//#define EPIV13FHD60_32_TABLE
//#define EPIV13FHD60_42_TABLE
//#define EPIV13FHD60_47_TABLE
//#define EPIV13FHD60_55_TABLE
//#define EPIV12FHD60_47_TABLE
//#define EPIV12FHD120_47_TABLE
//SOE table
//         60Hz                      120Hz
//         start(T1) width(T2)  start(T1) width(T2)
//32 Inch  5            50            x            x
//42 Inch  5            43            5            24
//47 Inch  5            43            5            32
//55 Inch  5            43            5            32

struct sTCONREGTABLE sRegTg_EPI_LGDV12FHD60_47[] = {
    //SOE
    {0xf0035508, 0x00002B05, 0xffffffff}, //setting model by model
//    {0xf0035550, 0x00002B05, 0xffffffff}, //channel1 SOE
//    {0xf0035554, 0x00002B05, 0xffffffff}, //channel2 SOE
//    {0xf0035558, 0x00002B05, 0xffffffff}, //channel3 SOE
//    {0xf003555C, 0x00002B05, 0xffffffff}, //channel4 SOE
//    {0xf0035560, 0x00002B05, 0xffffffff}, //channel5 SOE
//    {0xf0035564, 0x00002B05, 0xffffffff}, //channel6 SOE

    //GSP    TCO[0]  0xf0034840
    {0xf0034840, 0x012c0001, 0xffffffff},
    {0xf0034844, 0x00000000, 0xffffffff},
    {0xf0034848, 0x012c0001, 0xffffffff},
    {0xf003484c, 0x00090008, 0xffffffff},
    {0xf0034850, 0x00000000, 0xffffffff},
    {0xf0034854, 0x00000000, 0xffffffff},
    {0xf0034858, 0x00000004, 0xffffffff},
    {0xf003485c, 0x00000000, 0xffffffff},
                                      
    //POL    TCO[1]  0xf0034860
    {0xf0034860, 0x00E20112, 0xffffffff},
    {0xf0034864, 0x00000000, 0xffffffff},
    {0xf0034868, 0x00E20112, 0xffffffff},
    {0xf003486c, 0x043F0002, 0xffffffff},
    {0xf0034870, 0x80000404, 0xffffffff},
    {0xf0034874, 0x80040002, 0xffffffff},
    {0xf0034878, 0x00000007, 0xffffffff},
    {0xf003487c, 0x20000000, 0xffffffff},
                                      
    //GST    TCO[5]  0xf00348e0
    {0xf00348E0, 0x0013000B, 0xffffffff},
    {0xf00348E4, 0x00000000, 0xffffffff},
    {0xf00348E8, 0x0013000B, 0xffffffff},
    {0xf00348Ec, 0x00040002, 0xffffffff},
    {0xf00348F0, 0x00000000, 0xffffffff},
    {0xf00348F4, 0x00000000, 0xffffffff},
    {0xf00348F8, 0x00000004, 0xffffffff},
    {0xf00348Fc, 0x00000000, 0xffffffff},

    //MCLK    TCO[4]  0xf00348c0
    {0xf00348C0, 0x01050089, 0xffffffff}, // 0x0082007E --> 0x01050089
    {0xf00348C4, 0x00000000, 0xffffffff},
    {0xf00348C8, 0x01050089, 0xffffffff}, // 0x0082007E --> 0x01050089
    {0xf00348Cc, 0x04440007, 0xffffffff},
    {0xf00348D0, 0x20000000, 0xffffffff},
    {0xf00348D4, 0x80000000, 0xffffffff},
    {0xf00348D8, 0x00000007, 0xffffffff},
    {0xf00348Dc, 0x00000000, 0xffffffff},

    //GCLK    TCO[3]  0xf00348a0
    {0xf00348A0, 0x00B20010, 0xffffffff}, // 0x007000DC --> 0x00B20010
    {0xf00348A4, 0x00000000, 0xffffffff},
    {0xf00348A8, 0x00B20010, 0xffffffff}, // 0x007000DC --> 0x00B20010
    {0xf00348Ac, 0x04450005, 0xffffffff}, // 0x043F0002 --> 0x04430003
    {0xf00348B0, 0x20000000, 0xffffffff},
    {0xf00348B4, 0x80000000, 0xffffffff},
    {0xf00348B8, 0x00000007, 0xffffffff},
    {0xf00348Bc, 0x00000000, 0xffffffff},

    //GCLK_END    TCO[8]  0xf0034940
    {0xf0034940, 0x00010001, 0xffffffff}, // 0x007000DC --> 0x00010001
    {0xf0034944, 0x00000000, 0xffffffff},
    {0xf0034948, 0x00010001, 0xffffffff}, // 0x007000DC --> 0x00010001
    {0xf003494c, 0x044A0442, 0xffffffff}, // 0x0444043F --> 0x04480440
    {0xf0034950, 0x00000000, 0xffffffff},
    {0xf0034954, 0x00000000, 0xffffffff},
    {0xf0034958, 0x00000004, 0xffffffff},
    {0xf003495c, 0x00000000, 0xffffffff}, 

    //EO   TCO[6]  0xf0034900
    {0xf0034900, 0x00140004, 0xffffffff}, // 0x00840074 --> 0x00140004
    {0xf0034904, 0x00000000, 0xffffffff},
    {0xf0034908, 0x00140004, 0xffffffff}, // 0x00840074 --> 0x00140004
    {0xf003490c, 0x044D044D, 0xffffffff}, // 0x04450445 --> 0x044B044B
    {0xf0034910, 0x00000000, 0xffffffff},
    {0xf0034914, 0x044D044D, 0xffffffff}, // 0x04450445 --> 0x044B044B
    {0xf0034918, 0x00000007, 0xffffffff}, // 0x00000003 --> 0x00000007
    {0xf003491c, 0x80004001, 0xffffffff},

    //GST_END    TCO[9]  0xf0034960
    {0xf0034960, 0x0001016E, 0xffffffff}, // 0x007000DC --> 0x0001016E
    {0xf0034964, 0x00000000, 0xffffffff},
    {0xf0034968, 0x0001016E, 0xffffffff}, // 0x007000DC --> 0x0001016E
    {0xf003496c, 0x044A0445, 0xffffffff}, // 0x04430440 ==> 0x04480443
    {0xf0034970, 0x00000000, 0xffffffff},
    {0xf0034974, 0x00000000, 0xffffffff},
    {0xf0034978, 0x00000004, 0xffffffff},
    {0xf003497c, 0x00000000, 0xffffffff}, 

    //VCOM_DYN  TCO[7]  0xf0034920
    {0xf0034920, 0x00010001, 0xffffffff},
    {0xf0034924, 0x00000000, 0xffffffff},
    {0xf0034928, 0x00010001, 0xffffffff},
    {0xf003492c, 0x02320001, 0xffffffff},
    {0xf0034930, 0x00000000, 0xffffffff},
    {0xf0034934, 0x00000000, 0xffffffff},
    {0xf0034938, 0x00000004, 0xffffffff},
    {0xf003493c, 0x00000000, 0xffffffff},

    //EO2    TCO[10]  0xf0034980
    {0xf0034980, 0x00140004, 0xffffffff},
    {0xf0034984, 0x00000000, 0xffffffff},
    {0xf0034988, 0x00140004, 0xffffffff},
    {0xf003498c, 0x044D044D, 0xffffffff},
    {0xf0034990, 0x00000000, 0xffffffff},
    {0xf0034994, 0x044D044D, 0xffffffff},
    {0xf0034998, 0x00000007, 0xffffffff},
    {0xf003499c, 0x80200080, 0xffffffff}, 

    {0xf0034820, 0x00000000, 0xffffffff}, //GPO :1
                                      
//    {0xf0034800, 0x8100ffff, 0xffffffff},
    {0xf0034804, 0x00000000, 0xffffffff},
    {0xf0034814, 0x0A908000, 0xffffffff}, //Bmux select
    {0xf0034818, 0x00001440, 0xffffffff}, //combination
    {0xf003481c, 0x00000000, 0xffffffff},

    };

struct sTCONREGTABLE sRegTg_EPI_LGDV12FHD120_47[] = {
    //SOE
    {0xf0035508, 0x00002005, 0xffffffff}, //setting model by model
//    {0xf0035550, 0x00002005, 0xffffffff}, //channel1 SOE
//    {0xf0035554, 0x00002005, 0xffffffff}, //channel2 SOE
//    {0xf0035558, 0x00002005, 0xffffffff}, //channel3 SOE
//    {0xf003555C, 0x00002005, 0xffffffff}, //channel4 SOE
//    {0xf0035560, 0x00002005, 0xffffffff}, //channel5 SOE
//    {0xf0035564, 0x00002005, 0xffffffff}, //channel6 SOE

    //GSP    TCO[0]  0xf0034840
    {0xf0034840, 0x012c0001, 0xffffffff},
    {0xf0034844, 0x00000000, 0xffffffff},
    {0xf0034848, 0x012c0001, 0xffffffff},
    {0xf003484c, 0x00090008, 0xffffffff},
    {0xf0034850, 0x00000000, 0xffffffff},
    {0xf0034854, 0x00000000, 0xffffffff},
    {0xf0034858, 0x00000004, 0xffffffff},
    {0xf003485c, 0x00000000, 0xffffffff},
                                      
    //POL    TCO[1]  0xf0034860
    {0xf0034860, 0x00000000, 0xffffffff},
    {0xf0034864, 0x00000000, 0xffffffff},
    {0xf0034868, 0x00000000, 0xffffffff},
    {0xf003486c, 0x00000000, 0xffffffff},
    {0xf0034870, 0x00000000, 0xffffffff},
    {0xf0034874, 0x00000000, 0xffffffff},
    {0xf0034878, 0x00000080, 0xffffffff},
    {0xf003487c, 0x20000000, 0xffffffff},
                                      
    //GST    TCO[5]  0xf00348e0
    {0xf00348E0, 0x000B000B, 0xffffffff},
    {0xf00348E4, 0x00000000, 0xffffffff},
    {0xf00348E8, 0x000B000B, 0xffffffff},
    {0xf00348Ec, 0x00040002, 0xffffffff},
    {0xf00348F0, 0x00000000, 0xffffffff},
    {0xf00348F4, 0x00000000, 0xffffffff},
    {0xf00348F8, 0x00000004, 0xffffffff},
    {0xf00348Fc, 0x00000000, 0xffffffff},

    //MCLK    TCO[4]  0xf00348c0
    {0xf00348C0, 0x00FB00F3, 0xffffffff},
    {0xf00348C4, 0x00000000, 0xffffffff},
    {0xf00348C8, 0x00FB00F3, 0xffffffff},
    {0xf00348Cc, 0x04440007, 0xffffffff},
    {0xf00348D0, 0x20000000, 0xffffffff},
    {0xf00348D4, 0x80000000, 0xffffffff},
    {0xf00348D8, 0x00000007, 0xffffffff},
    {0xf00348Dc, 0x00000000, 0xffffffff},

    //GCLK    TCO[3]  0xf00348a0
    {0xf00348A0, 0x00D6003D, 0xffffffff},
    {0xf00348A4, 0x00000000, 0xffffffff},
    {0xf00348A8, 0x00D6003D, 0xffffffff},
    {0xf00348Ac, 0x04430005, 0xffffffff},
    {0xf00348B0, 0x20000000, 0xffffffff},
    {0xf00348B4, 0x80000000, 0xffffffff},
    {0xf00348B8, 0x00000007, 0xffffffff},
    {0xf00348Bc, 0x00000000, 0xffffffff},

    //GCLK_END    TCO[8]  0xf0034940
    {0xf0034940, 0x003D003D, 0xffffffff},
    {0xf0034944, 0x00000000, 0xffffffff},
    {0xf0034948, 0x003D003D, 0xffffffff},
    {0xf003494c, 0x044A0442, 0xffffffff},
    {0xf0034950, 0x00000000, 0xffffffff},
    {0xf0034954, 0x00000000, 0xffffffff},
    {0xf0034958, 0x00000004, 0xffffffff},
    {0xf003495c, 0x00000000, 0xffffffff}, 

    //EO   TCO[6]  0xf0034900
    {0xf0034900, 0x00380018, 0xffffffff},
    {0xf0034904, 0x00000000, 0xffffffff},
    {0xf0034908, 0x00380018, 0xffffffff},
    {0xf003490c, 0x044D044D, 0xffffffff},
    {0xf0034910, 0x00000000, 0xffffffff},
    {0xf0034914, 0x044D044D, 0xffffffff},
    {0xf0034918, 0x00000007, 0xffffffff},
    {0xf003491c, 0x80004001, 0xffffffff},

    //GST_END    TCO[9]  0xf0034960
    {0xf0034960, 0x003D003D, 0xffffffff},
    {0xf0034964, 0x00000000, 0xffffffff},
    {0xf0034968, 0x003D003D, 0xffffffff},
    {0xf003496c, 0x044A0446, 0xffffffff},
    {0xf0034970, 0x00000000, 0xffffffff},
    {0xf0034974, 0x00000000, 0xffffffff},
    {0xf0034978, 0x00000004, 0xffffffff},
    {0xf003497c, 0x00000000, 0xffffffff}, 

    //VCOM_DYN  TCO[7]  0xf0034920
    {0xf0034920, 0x00010001, 0xffffffff},
    {0xf0034924, 0x00000000, 0xffffffff},
    {0xf0034928, 0x00010001, 0xffffffff},
    {0xf003492c, 0x02320001, 0xffffffff},
    {0xf0034930, 0x00000000, 0xffffffff},
    {0xf0034934, 0x00000000, 0xffffffff},
    {0xf0034938, 0x00000004, 0xffffffff},
    {0xf003493c, 0x00000000, 0xffffffff},

    {0xf0034820, 0x00000000, 0xffffffff}, //GPO :1
                                      
//    {0xf0034800, 0x8100ffff, 0xffffffff},
    {0xf0034804, 0x00000000, 0xffffffff},
    {0xf0034814, 0x00908000, 0xffffffff}, //Bmux select
    {0xf0034818, 0x00000440, 0xffffffff}, //combination
    {0xf003481c, 0x00000000, 0xffffffff},

    };

struct sTCONREGTABLE sRegTg_EPI_LGDV13FHD60_32[] = {
    //SOE
    {0xf0035508, 0x00011c06, 0xffffffff}, //setting model by model
//    {0xf0035550, 0x00003205, 0xffffffff}, //channel1 SOE
//    {0xf0035554, 0x00003205, 0xffffffff}, //channel2 SOE
//    {0xf0035558, 0x00003205, 0xffffffff}, //channel3 SOE
//    {0xf003555C, 0x00003205, 0xffffffff}, //channel4 SOE
//    {0xf0035560, 0x00003205, 0xffffffff}, //channel5 SOE
//    {0xf0035564, 0x00003205, 0xffffffff}, //channel6 SOE

    //GSP    TCO[0]  0xf0034840
    {0xf0034840, 0x012c0001, 0xffffffff},
    {0xf0034844, 0x00000000, 0xffffffff},
    {0xf0034848, 0x012c0001, 0xffffffff},
    {0xf003484c, 0x00090008, 0xffffffff},
    {0xf0034850, 0x00000000, 0xffffffff},
    {0xf0034854, 0x00000000, 0xffffffff},
    {0xf0034858, 0x00000004, 0xffffffff},
    {0xf003485c, 0x00000000, 0xffffffff},
                                      
    //POL    TCO[1]  0xf0034860
    {0xf0034860, 0x00E20112, 0xffffffff},
    {0xf0034864, 0x00000000, 0xffffffff},
    {0xf0034868, 0x00E20112, 0xffffffff},
    {0xf003486c, 0x043F0002, 0xffffffff},
    {0xf0034870, 0x80000404, 0xffffffff},
    {0xf0034874, 0x80040002, 0xffffffff},
    {0xf0034878, 0x00000007, 0xffffffff},
    {0xf003487c, 0x20000000, 0xffffffff},
                                      
    //GST    TCO[5]  0xf00348e0
    {0xf00348E0, 0x0020000B, 0xffffffff}, //0x0013000B -> 0x0020000B
    {0xf00348E4, 0x00000000, 0xffffffff},
    {0xf00348E8, 0x0020000B, 0xffffffff}, //0x0013000B -> 0x0020000B,
    {0xf00348Ec, 0x00040002, 0xffffffff},
    {0xf00348F0, 0x00000000, 0xffffffff},
    {0xf00348F4, 0x00000000, 0xffffffff},
    {0xf00348F8, 0x00000004, 0xffffffff},
    {0xf00348Fc, 0x00000000, 0xffffffff},

    //MCLK    TCO[4]  0xf00348c0
    {0xf00348C0, 0x010000C0, 0xffffffff}, //0x01050104 -> 0x00FA00F9
    {0xf00348C4, 0x00000000, 0xffffffff},
    {0xf00348C8, 0x010000C0, 0xffffffff}, //0x01050104 -> 0x00FA00F9
    {0xf00348Cc, 0x04440007, 0xffffffff},
    {0xf00348D0, 0x20000000, 0xffffffff},
    {0xf00348D4, 0x80000000, 0xffffffff},
    {0xf00348D8, 0x00000007, 0xffffffff},
    {0xf00348Dc, 0x00000000, 0xffffffff},

    //GCLK    TCO[3]  0xf00348a0
    {0xf00348A0, 0x00CD000B, 0xffffffff}, // 0x00B20010 -> 0x00B20162
    {0xf00348A4, 0x00000000, 0xffffffff},
    {0xf00348A8, 0x00CD000B, 0xffffffff}, // 0x00B20010 -> 0x00B20162
    {0xf00348Ac, 0x04450004, 0xffffffff}, // 0x04430003 -> 0x04430002
    {0xf00348B0, 0x20000000, 0xffffffff},
    {0xf00348B4, 0x80000000, 0xffffffff},
    {0xf00348B8, 0x00000007, 0xffffffff},
    {0xf00348Bc, 0x00000000, 0xffffffff},

    //GCLK_END    TCO[8]  0xf0034940
    {0xf0034940, 0x00010001, 0xffffffff}, // 0x007000DC --> 0x00010001
    {0xf0034944, 0x00000000, 0xffffffff},
    {0xf0034948, 0x00010001, 0xffffffff}, // 0x007000DC --> 0x00010001
    {0xf003494c, 0x044A0442, 0xffffffff}, // 0x0444043F --> 0x04480440
    {0xf0034950, 0x00000000, 0xffffffff},
    {0xf0034954, 0x00000000, 0xffffffff},
    {0xf0034958, 0x00000004, 0xffffffff},
    {0xf003495c, 0x00000000, 0xffffffff}, 

    //EO   TCO[6]  0xf0034900
    {0xf0034900, 0x00140004, 0xffffffff}, // 0x00840074 --> 0x00140004
    {0xf0034904, 0x00000000, 0xffffffff},
    {0xf0034908, 0x00140004, 0xffffffff}, // 0x00840074 --> 0x00140004
    {0xf003490c, 0x044D044D, 0xffffffff}, // 0x04450445 --> 0x044B044B
    {0xf0034910, 0x00000000, 0xffffffff},
    {0xf0034914, 0x044D044D, 0xffffffff}, // 0x04450445 --> 0x044B044B
    {0xf0034918, 0x00000007, 0xffffffff}, // 0x00000003 --> 0x00000007
    {0xf003491c, 0x80004001, 0xffffffff},

    //GST_END    TCO[9]  0xf0034960
    {0xf0034960, 0x0001016E, 0xffffffff}, // 0x007000DC --> 0x0001016E
    {0xf0034964, 0x00000000, 0xffffffff},
    {0xf0034968, 0x0001016E, 0xffffffff}, // 0x007000DC --> 0x0001016E
    {0xf003496c, 0x044A0445, 0xffffffff}, // 0x044B043e --> 0x04480443
    {0xf0034970, 0x00000000, 0xffffffff},
    {0xf0034974, 0x00000000, 0xffffffff},
    {0xf0034978, 0x00000004, 0xffffffff},
    {0xf003497c, 0x00000000, 0xffffffff}, 

    //VCOM_DYN  TCO[7]  0xf0034920
    {0xf0034920, 0x00010001, 0xffffffff},
    {0xf0034924, 0x00000000, 0xffffffff},
    {0xf0034928, 0x00010001, 0xffffffff},
    {0xf003492c, 0x02320001, 0xffffffff},
    {0xf0034930, 0x00000000, 0xffffffff},
    {0xf0034934, 0x00000000, 0xffffffff},
    {0xf0034938, 0x00000004, 0xffffffff},
    {0xf003493c, 0x00000000, 0xffffffff},

    //EO2    TCO[10]  0xf0034980
    {0xf0034980, 0x00140004, 0xffffffff},
    {0xf0034984, 0x00000000, 0xffffffff},
    {0xf0034988, 0x00140004, 0xffffffff},
    {0xf003498c, 0x044D044D, 0xffffffff},
    {0xf0034990, 0x00000000, 0xffffffff},
    {0xf0034994, 0x044D044D, 0xffffffff},
    {0xf0034998, 0x00000007, 0xffffffff},
    {0xf003499c, 0x80200080, 0xffffffff}, 

    {0xf0034820, 0x00000000, 0xffffffff}, //GPO :1
                                      
//    {0xf0034800, 0x8100ffff, 0xffffffff},
    {0xf0034804, 0x00000000, 0xffffffff},
    {0xf0034814, 0x0A908000, 0xffffffff}, //Bmux select
    {0xf0034818, 0x00001440, 0xffffffff}, //combination
    {0xf003481c, 0x00000000, 0xffffffff},

    };

struct sTCONREGTABLE sRegTg_EPI_LGDV13FHD60_42[] = {
    //SOE
    {0xf0035508, 0x00011c06, 0xffffffff}, //setting model by model
//    {0xf0035550, 0x00002B05, 0xffffffff}, //channel1 SOE
//    {0xf0035554, 0x00002B05, 0xffffffff}, //channel2 SOE
//    {0xf0035558, 0x00002B05, 0xffffffff}, //channel3 SOE
//    {0xf003555C, 0x00002B05, 0xffffffff}, //channel4 SOE
//    {0xf0035560, 0x00002B05, 0xffffffff}, //channel5 SOE
//    {0xf0035564, 0x00002B05, 0xffffffff}, //channel6 SOE

    //GSP    TCO[0]  0xf0034840
    {0xf0034840, 0x012c0001, 0xffffffff},
    {0xf0034844, 0x00000000, 0xffffffff},
    {0xf0034848, 0x012c0001, 0xffffffff},
    {0xf003484c, 0x00090008, 0xffffffff},
    {0xf0034850, 0x00000000, 0xffffffff},
    {0xf0034854, 0x00000000, 0xffffffff},
    {0xf0034858, 0x00000004, 0xffffffff},
    {0xf003485c, 0x00000000, 0xffffffff},
                                      
    //POL    TCO[1]  0xf0034860
    {0xf0034860, 0x00E20112, 0xffffffff},
    {0xf0034864, 0x00000000, 0xffffffff},
    {0xf0034868, 0x00E20112, 0xffffffff},
    {0xf003486c, 0x043F0002, 0xffffffff},
    {0xf0034870, 0x80000404, 0xffffffff},
    {0xf0034874, 0x80040002, 0xffffffff},
    {0xf0034878, 0x00000007, 0xffffffff},
    {0xf003487c, 0x20000000, 0xffffffff},
                                      
    //GST    TCO[5]  0xf00348e0
    {0xf00348E0, 0x0013000B, 0xffffffff},
    {0xf00348E4, 0x00000000, 0xffffffff},
    {0xf00348E8, 0x0013000B, 0xffffffff},
    {0xf00348Ec, 0x00040002, 0xffffffff},
    {0xf00348F0, 0x00000000, 0xffffffff},
    {0xf00348F4, 0x00000000, 0xffffffff},
    {0xf00348F8, 0x00000004, 0xffffffff},
    {0xf00348Fc, 0x00000000, 0xffffffff},

    //MCLK    TCO[4]  0xf00348c0
    {0xf00348C0, 0x010000C0, 0xffffffff},
    {0xf00348C4, 0x00000000, 0xffffffff},
    {0xf00348C8, 0x010000C0, 0xffffffff},
    {0xf00348Cc, 0x04440007, 0xffffffff},
    {0xf00348D0, 0x20000000, 0xffffffff},
    {0xf00348D4, 0x80000000, 0xffffffff},
    {0xf00348D8, 0x00000007, 0xffffffff},
    {0xf00348Dc, 0x00000000, 0xffffffff},

    //GCLK    TCO[3]  0xf00348a0
    {0xf00348A0, 0x00CD000B, 0xffffffff},
    {0xf00348A4, 0x00000000, 0xffffffff},
    {0xf00348A8, 0x00CD000B, 0xffffffff},
    {0xf00348Ac, 0x04410004, 0xffffffff},
    {0xf00348B0, 0x20000000, 0xffffffff},
    {0xf00348B4, 0x80000000, 0xffffffff},
    {0xf00348B8, 0x00000007, 0xffffffff},
    {0xf00348Bc, 0x00000000, 0xffffffff},

    //GCLK_END    TCO[8]  0xf0034940
    {0xf0034940, 0x007000DC, 0xffffffff},
    {0xf0034944, 0x00000000, 0xffffffff},
    {0xf0034948, 0x007000DC, 0xffffffff},
    {0xf003494c, 0x04460441, 0xffffffff},
    {0xf0034950, 0x00000000, 0xffffffff},
    {0xf0034954, 0x00000000, 0xffffffff},
    {0xf0034958, 0x00000004, 0xffffffff},
    {0xf003495c, 0x00000000, 0xffffffff}, 

    //EO   TCO[6]  0xf0034900
    {0xf0034900, 0x00840074, 0xffffffff},
    {0xf0034904, 0x00000000, 0xffffffff},
    {0xf0034908, 0x00840074, 0xffffffff},
    {0xf003490c, 0x04470447, 0xffffffff},
    {0xf0034910, 0x00000000, 0xffffffff},
    {0xf0034914, 0x04470447, 0xffffffff},
    {0xf0034918, 0x00000007, 0xffffffff},
    {0xf003491c, 0x80004001, 0xffffffff},

    //GST_END    TCO[9]  0xf0034960
    {0xf0034960, 0x007000DC, 0xffffffff},
    {0xf0034964, 0x00000000, 0xffffffff},
    {0xf0034968, 0x007000DC, 0xffffffff},
    {0xf003496c, 0x04450442, 0xffffffff},
    {0xf0034970, 0x00000000, 0xffffffff},
    {0xf0034974, 0x00000000, 0xffffffff},
    {0xf0034978, 0x00000004, 0xffffffff},
    {0xf003497c, 0x00000000, 0xffffffff}, 

    //VCOM_DYN  TCO[7]  0xf0034920
    {0xf0034920, 0x00010001, 0xffffffff},
    {0xf0034924, 0x00000000, 0xffffffff},
    {0xf0034928, 0x00010001, 0xffffffff},
    {0xf003492c, 0x02320001, 0xffffffff},
    {0xf0034930, 0x00000000, 0xffffffff},
    {0xf0034934, 0x00000000, 0xffffffff},
    {0xf0034938, 0x00000004, 0xffffffff},
    {0xf003493c, 0x00000000, 0xffffffff},

    //EO2    TCO[10]  0xf0034980
    {0xf0034980, 0x00140004, 0xffffffff},
    {0xf0034984, 0x00000000, 0xffffffff},
    {0xf0034988, 0x00140004, 0xffffffff},
    {0xf003498c, 0x044D044D, 0xffffffff},
    {0xf0034990, 0x00000000, 0xffffffff},
    {0xf0034994, 0x044D044D, 0xffffffff},
    {0xf0034998, 0x00000007, 0xffffffff},
    {0xf003499c, 0x80200080, 0xffffffff}, 

    {0xf0034820, 0x00000000, 0xffffffff}, //GPO :1
                                      
//    {0xf0034800, 0x8100ffff, 0xffffffff},
    {0xf0034804, 0x00000000, 0xffffffff},
    {0xf0034814, 0x0A908000, 0xffffffff}, //Bmux select
    {0xf0034818, 0x00001440, 0xffffffff}, //combination
    {0xf003481c, 0x00000000, 0xffffffff},

    };
// 20111017 by LGE jaewook.chung 
struct sTCONREGTABLE sRegTg_EPI_LGDV13FHD60_47[] = {
    //SOE
    {0xf0035508, 0x00011c06, 0xffffffff}, //setting model by model
//    {0xf0035550, 0x00002B05, 0xffffffff}, //channel1 SOE
//    {0xf0035554, 0x00002B05, 0xffffffff}, //channel2 SOE
//    {0xf0035558, 0x00002B05, 0xffffffff}, //channel3 SOE
//    {0xf003555C, 0x00002B05, 0xffffffff}, //channel4 SOE
//    {0xf0035560, 0x00002B05, 0xffffffff}, //channel5 SOE
//    {0xf0035564, 0x00002B05, 0xffffffff}, //channel6 SOE

    //GSP    TCO[0]  0xf0034840
    {0xf0034840, 0x012c0001, 0xffffffff},
    {0xf0034844, 0x00000000, 0xffffffff},
    {0xf0034848, 0x012c0001, 0xffffffff},
    {0xf003484c, 0x00090008, 0xffffffff},
    {0xf0034850, 0x00000000, 0xffffffff},
    {0xf0034854, 0x00000000, 0xffffffff},
    {0xf0034858, 0x00000004, 0xffffffff},
    {0xf003485c, 0x00000000, 0xffffffff},
                                      
    //POL    TCO[1]  0xf0034860
    {0xf0034860, 0x00E20112, 0xffffffff},
    {0xf0034864, 0x00000000, 0xffffffff},
    {0xf0034868, 0x00E20112, 0xffffffff},
    {0xf003486c, 0x043F0002, 0xffffffff},
    {0xf0034870, 0x80000404, 0xffffffff},
    {0xf0034874, 0x80040002, 0xffffffff},
    {0xf0034878, 0x00000007, 0xffffffff},
    {0xf003487c, 0x20000000, 0xffffffff},
                                      
    //GST    TCO[5]  0xf00348e0
    {0xf00348E0, 0x0013000B, 0xffffffff},
    {0xf00348E4, 0x00000000, 0xffffffff},
    {0xf00348E8, 0x0013000B, 0xffffffff},
    {0xf00348Ec, 0x00040002, 0xffffffff},
    {0xf00348F0, 0x00000000, 0xffffffff},
    {0xf00348F4, 0x00000000, 0xffffffff},
    {0xf00348F8, 0x00000004, 0xffffffff},
    {0xf00348Fc, 0x00000000, 0xffffffff},

    //MCLK    TCO[4]  0xf00348c0
    {0xf00348C0, 0x010000C0, 0xffffffff}, // 0x0082007E --> 0x01050089
    {0xf00348C4, 0x00000000, 0xffffffff},
    {0xf00348C8, 0x010000C0, 0xffffffff}, // 0x0082007E --> 0x01050089
    {0xf00348Cc, 0x04440007, 0xffffffff},
    {0xf00348D0, 0x20000000, 0xffffffff},
    {0xf00348D4, 0x80000000, 0xffffffff},
    {0xf00348D8, 0x00000007, 0xffffffff},
    {0xf00348Dc, 0x00000000, 0xffffffff},

    //GCLK    TCO[3]  0xf00348a0
    {0xf00348A0, 0x00CD000B, 0xffffffff}, // 0x007000DC --> 0x00B20010
    {0xf00348A4, 0x00000000, 0xffffffff},
    {0xf00348A8, 0x00CD000B, 0xffffffff}, // 0x007000DC --> 0x00B20010
    {0xf00348Ac, 0x04450005, 0xffffffff}, // 0x043F0002 --> 0x04430003
    {0xf00348B0, 0x20000000, 0xffffffff},
    {0xf00348B4, 0x80000000, 0xffffffff},
    {0xf00348B8, 0x00000007, 0xffffffff},
    {0xf00348Bc, 0x00000000, 0xffffffff},

    //GCLK_END    TCO[8]  0xf0034940
    {0xf0034940, 0x00010001, 0xffffffff}, // 0x007000DC --> 0x00010001
    {0xf0034944, 0x00000000, 0xffffffff},
    {0xf0034948, 0x00010001, 0xffffffff}, // 0x007000DC --> 0x00010001
    {0xf003494c, 0x044A0442, 0xffffffff}, // 0x0444043F --> 0x04480440
    {0xf0034950, 0x00000000, 0xffffffff},
    {0xf0034954, 0x00000000, 0xffffffff},
    {0xf0034958, 0x00000004, 0xffffffff},
    {0xf003495c, 0x00000000, 0xffffffff}, 

    //EO   TCO[6]  0xf0034900
    {0xf0034900, 0x00140004, 0xffffffff}, // 0x00840074 --> 0x00140004
    {0xf0034904, 0x00000000, 0xffffffff},
    {0xf0034908, 0x00140004, 0xffffffff}, // 0x00840074 --> 0x00140004
    {0xf003490c, 0x044D044D, 0xffffffff}, // 0x04450445 --> 0x044B044B
    {0xf0034910, 0x00000000, 0xffffffff},
    {0xf0034914, 0x044D044D, 0xffffffff}, // 0x04450445 --> 0x044B044B
    {0xf0034918, 0x00000007, 0xffffffff}, // 0x00000003 --> 0x00000007
    {0xf003491c, 0x80004001, 0xffffffff},

    //GST_END    TCO[9]  0xf0034960
    {0xf0034960, 0x0001016E, 0xffffffff}, // 0x007000DC --> 0x0001016E
    {0xf0034964, 0x00000000, 0xffffffff},
    {0xf0034968, 0x0001016E, 0xffffffff}, // 0x007000DC --> 0x0001016E
    {0xf003496c, 0x044A0445, 0xffffffff}, // 0x04430440 ==> 0x04480443
    {0xf0034970, 0x00000000, 0xffffffff},
    {0xf0034974, 0x00000000, 0xffffffff},
    {0xf0034978, 0x00000004, 0xffffffff},
    {0xf003497c, 0x00000000, 0xffffffff}, 

    //VCOM_DYN  TCO[7]  0xf0034920
    {0xf0034920, 0x00010001, 0xffffffff},
    {0xf0034924, 0x00000000, 0xffffffff},
    {0xf0034928, 0x00010001, 0xffffffff},
    {0xf003492c, 0x02320001, 0xffffffff},
    {0xf0034930, 0x00000000, 0xffffffff},
    {0xf0034934, 0x00000000, 0xffffffff},
    {0xf0034938, 0x00000004, 0xffffffff},
    {0xf003493c, 0x00000000, 0xffffffff},

    //EO2    TCO[10]  0xf0034980
    {0xf0034980, 0x00140004, 0xffffffff},
    {0xf0034984, 0x00000000, 0xffffffff},
    {0xf0034988, 0x00140004, 0xffffffff},
    {0xf003498c, 0x044D044D, 0xffffffff},
    {0xf0034990, 0x00000000, 0xffffffff},
    {0xf0034994, 0x044D044D, 0xffffffff},
    {0xf0034998, 0x00000007, 0xffffffff},
    {0xf003499c, 0x80200080, 0xffffffff}, 

    {0xf0034820, 0x00000000, 0xffffffff}, //GPO :1
                                      
//    {0xf0034800, 0x8100ffff, 0xffffffff},
    {0xf0034804, 0x00000000, 0xffffffff},
    {0xf0034814, 0x0A908000, 0xffffffff}, //Bmux select
    {0xf0034818, 0x00001440, 0xffffffff}, //combination
    {0xf003481c, 0x00000000, 0xffffffff},

    };

struct sTCONREGTABLE sRegTg_EPI_LGDV13FHD60_55[] = {
    //SOE
    {0xf0035508, 0x00011c06, 0xffffffff}, //setting model by model
//    {0xf0035550, 0x00002B05, 0xffffffff}, //channel1 SOE
//    {0xf0035554, 0x00002B05, 0xffffffff}, //channel2 SOE
//    {0xf0035558, 0x00002B05, 0xffffffff}, //channel3 SOE
//    {0xf003555C, 0x00002B05, 0xffffffff}, //channel4 SOE
//    {0xf0035560, 0x00002B05, 0xffffffff}, //channel5 SOE
//    {0xf0035564, 0x00002B05, 0xffffffff}, //channel6 SOE

    //GSP    TCO[0]  0xf0034840
    {0xf0034840, 0x012c0001, 0xffffffff},
    {0xf0034844, 0x00000000, 0xffffffff},
    {0xf0034848, 0x012c0001, 0xffffffff},
    {0xf003484c, 0x00090008, 0xffffffff},
    {0xf0034850, 0x00000000, 0xffffffff},
    {0xf0034854, 0x00000000, 0xffffffff},
    {0xf0034858, 0x00000004, 0xffffffff},
    {0xf003485c, 0x00000000, 0xffffffff},
                                      
    //POL    TCO[1]  0xf0034860
    {0xf0034860, 0x00E20112, 0xffffffff},
    {0xf0034864, 0x00000000, 0xffffffff},
    {0xf0034868, 0x00E20112, 0xffffffff},
    {0xf003486c, 0x043F0002, 0xffffffff},
    {0xf0034870, 0x80000404, 0xffffffff},
    {0xf0034874, 0x80040002, 0xffffffff},
    {0xf0034878, 0x00000007, 0xffffffff},
    {0xf003487c, 0x20000000, 0xffffffff},
                                      
    //GST    TCO[5]  0xf00348e0
    {0xf00348E0, 0x0013000B, 0xffffffff},
    {0xf00348E4, 0x00000000, 0xffffffff},
    {0xf00348E8, 0x0013000B, 0xffffffff},
    {0xf00348Ec, 0x00040002, 0xffffffff},
    {0xf00348F0, 0x00000000, 0xffffffff},
    {0xf00348F4, 0x00000000, 0xffffffff},
    {0xf00348F8, 0x00000004, 0xffffffff},
    {0xf00348Fc, 0x00000000, 0xffffffff},

    //MCLK    TCO[4]  0xf00348c0
    {0xf00348C0, 0x010000C0, 0xffffffff},
    {0xf00348C4, 0x00000000, 0xffffffff},
    {0xf00348C8, 0x010000C0, 0xffffffff},
    {0xf00348Cc, 0x04440007, 0xffffffff},
    {0xf00348D0, 0x20000000, 0xffffffff},
    {0xf00348D4, 0x80000000, 0xffffffff},
    {0xf00348D8, 0x00000007, 0xffffffff},
    {0xf00348Dc, 0x00000000, 0xffffffff},

    //GCLK    TCO[3]  0xf00348a0
    {0xf00348A0, 0x00CD000B, 0xffffffff},
    {0xf00348A4, 0x00000000, 0xffffffff},
    {0xf00348A8, 0x00CD000B, 0xffffffff},
    {0xf00348Ac, 0x04410005, 0xffffffff},
    {0xf00348B0, 0x20000000, 0xffffffff},
    {0xf00348B4, 0x80000000, 0xffffffff},
    {0xf00348B8, 0x00000007, 0xffffffff},
    {0xf00348Bc, 0x00000000, 0xffffffff},

    //GCLK_END    TCO[8]  0xf0034940
    {0xf0034940, 0x000C0001, 0xffffffff},
    {0xf0034944, 0x00000000, 0xffffffff},
    {0xf0034948, 0x000C0001, 0xffffffff},
    {0xf003494c, 0x044A0442, 0xffffffff},
    {0xf0034950, 0x00000000, 0xffffffff},
    {0xf0034954, 0x00000000, 0xffffffff},
    {0xf0034958, 0x00000004, 0xffffffff},
    {0xf003495c, 0x00000000, 0xffffffff}, 

    //EO   TCO[6]  0xf0034900
    {0xf0034900, 0x00140004, 0xffffffff},
    {0xf0034904, 0x00000000, 0xffffffff},
    {0xf0034908, 0x00140004, 0xffffffff},
    {0xf003490c, 0x044D044D, 0xffffffff},
    {0xf0034910, 0x00000000, 0xffffffff},
    {0xf0034914, 0x04470447, 0xffffffff},
    {0xf0034918, 0x00000007, 0xffffffff}, // 0x00000003 --> 0x00000007
    {0xf003491c, 0x80004001, 0xffffffff},

    //GST_END    TCO[9]  0xf0034960
    {0xf0034960, 0x000B016E, 0xffffffff},
    {0xf0034964, 0x00000000, 0xffffffff},
    {0xf0034968, 0x000B016E, 0xffffffff},
    {0xf003496c, 0x044A0445, 0xffffffff}, // 0x04430440 ==> 0x04480443
    {0xf0034970, 0x00000000, 0xffffffff},
    {0xf0034974, 0x00000000, 0xffffffff},
    {0xf0034978, 0x00000004, 0xffffffff},
    {0xf003497c, 0x00000000, 0xffffffff}, 

    //VCOM_DYN  TCO[7]  0xf0034920
    {0xf0034920, 0x00010001, 0xffffffff},
    {0xf0034924, 0x00000000, 0xffffffff},
    {0xf0034928, 0x00010001, 0xffffffff},
    {0xf003492c, 0x02320001, 0xffffffff},
    {0xf0034930, 0x00000000, 0xffffffff},
    {0xf0034934, 0x00000000, 0xffffffff},
    {0xf0034938, 0x00000004, 0xffffffff},
    {0xf003493c, 0x00000000, 0xffffffff},

    //EO2    TCO[10]  0xf0034980
    {0xf0034980, 0x00140004, 0xffffffff},
    {0xf0034984, 0x00000000, 0xffffffff},
    {0xf0034988, 0x00140004, 0xffffffff},
    {0xf003498c, 0x044D044D, 0xffffffff},
    {0xf0034990, 0x00000000, 0xffffffff},
    {0xf0034994, 0x044D044D, 0xffffffff},
    {0xf0034998, 0x00000007, 0xffffffff},
    {0xf003499c, 0x80200080, 0xffffffff}, 

    {0xf0034820, 0x00000000, 0xffffffff}, //GPO :1
                                      
//    {0xf0034800, 0x8100ffff, 0xffffffff},
    {0xf0034804, 0x00000000, 0xffffffff},
    {0xf0034814, 0x0A908000, 0xffffffff}, //Bmux select
    {0xf0034818, 0x00001440, 0xffffffff}, //combination
    {0xf003481c, 0x00000000, 0xffffffff},
    };

//-----------------------------------------------------------------------------
// Static functions
//-----------------------------------------------------------------------------
static UINT32 _u4TconCustGammaWrite(UINT8 u1offset, UINT8 *pu1Buf, UINT8 u1Count)
{
	Printf("0x%8x, 0x%8x, 0xffffffff,\n", u1offset, (pu1Buf[0]<<8) | pu1Buf[1]);
    if(PANEL_GetDisplayType()== PANEL_DISPLAY_TYPE_EPI)
    	return (SIF_Write(GAMMAIC_CLK_RATE, GAMMAIC_ID_V12, u1offset, (UINT8 *)pu1Buf, GAMMAIC_DATA_CNT_V12));
    else
    	return (SIF_Write(GAMMAIC_CLK_RATE, GAMMAIC_ID, u1offset, (UINT8 *)pu1Buf, GAMMAIC_DATA_CNT));
}

#if 0 // for warning free
static UINT32 _u4TconCustGammaRead(UINT8 u1offset, UINT8 *pu1Buf, UINT8 u1Count)
{
	return (SIF_Read(GAMMAIC_CLK_RATE, GAMMAIC_ID, u1offset, (UINT8 *)pu1Buf, GAMMAIC_DATA_CNT));
}
#endif

//-----------------------------------------------------------------------------
// Public functions
//-----------------------------------------------------------------------------

UINT8 u1TconCustDPMCtrlEN1(UINT8 val)
{
  vIO32WriteFldAlign(GR8, 1, GR8_TCGPOEN_A);
	
  if (val)
  {
      vIO32WriteFldAlign(GR8, 1, GR8_TCGPO_A);
  }
  else
  {
      vIO32WriteFldAlign(GR8, 0, GR8_TCGPO_A);
  }
  
  return(1);
}

UINT8 u1TconCustDPMCtrlEN2(UINT8 val)
{
    if (val)
    {
        // TODO
    }
    else
    {
        // TODO
    }

    return(1);
}

// Gamma
UINT8 u1TconCustGammaInit(void)
{
	UINT8 u1Err = 0;
	UINT8 i = 0;
	UINT8 u1count;
	UINT8 u1tmp[2];
	UINT16 u2GammaVoltage = 0;
    struct sTCONREGTABLE *pTgTable = NULL;    

	Printf("Tcon Gamma init\n");

    if(PANEL_GetDisplayType()== PANEL_DISPLAY_TYPE_EPI)
    {
        pTgTable = sRegCustGamma_V12;
	    u1count = (sizeof(sRegCustGamma_V12) / sizeof(struct sTCONREGTABLE));
    }
    else
    {
        pTgTable = sRegCustGamma;
	    u1count = (sizeof(sRegCustGamma) / sizeof(struct sTCONREGTABLE));
    }

	for ( i = 0 ; i < u1count ; i++)
    {
                //#if  HISENSE_IPS_2010_PANEL 
      		//u1tmp[1] = (UINT8)((sRegCustGamma[i].u4Val) >> 8);
		//u1tmp[0] = (UINT8)((sRegCustGamma[i].u4Val) & 0xff);
		u2GammaVoltage = pTgTable[i].u4Val;
		u1tmp[1] = (UINT8)(u2GammaVoltage >> 8);
		u1tmp[0] = (UINT8)(u2GammaVoltage & 0xff);
		if (_u4TconCustGammaWrite(pTgTable[i].u4Addr, u1tmp, 2) == 0)
		{
		
			u1Err = 1;
			Printf("!!!Tcon Gamma write fail %u, %d, %d \n", \
				              pTgTable[i].u4Addr, \
				              u1tmp[0], \
				              u1tmp[1]);			
		}
		else
		{
    		Printf("Tcon Gamma write ok %u , %d , %d \n", \
                              pTgTable[i].u4Addr, \
                              u1tmp[0], \
                              u1tmp[1]);
		}
    }

    // check if init ok
	if (u1Err == 0)
	{
		Printf("Program Tcon Gamma dacs %d counts, %d / %d\n", i, sizeof(pTgTable), sizeof(struct sTCONREGTABLE));
	}
	else
	{
	    Printf("Program Tcon Gamma dacs fail !!!\n");
	}
	
	return(1);
}

// program gamma value into non-volatile memory
UINT8  u1TconCustGammaFlashing(void)
{
	UINT8 u1Err = 0;
	UINT8 i = 0;
	UINT8 u1count;
	UINT8 u1tmp[2];
	UINT8 u1Ret = 0;
	UINT16 u2GammaVoltage = 0;
    struct sTCONREGTABLE *pTgTable = NULL;    

#ifdef TCON_DBG_MSG_EN
   	printf("Tcon Gamma init\n");
#endif
    if(PANEL_GetDisplayType()== PANEL_DISPLAY_TYPE_EPI)
    {
        pTgTable = sRegCustGamma_V12;
	    u1count = (sizeof(sRegCustGamma_V12) / sizeof(struct sTCONREGTABLE));
    }
    else
    {
        pTgTable = sRegCustGamma;
	    u1count = (sizeof(sRegCustGamma) / sizeof(struct sTCONREGTABLE));
    }

	for ( i = 0 ; i < u1count ; i++)
    {
    
		//when write non-voltial memory  D15 D14 must be 0 1
		u2GammaVoltage = (((pTgTable[i].u4Val)&0x03FF)|0x4000);
		u1tmp[0] = (UINT8)((u2GammaVoltage >> 8) );  // program gamma into non-voilate
		u1tmp[1] = (UINT8)(u2GammaVoltage & 0xff);

		if (_u4TconCustGammaWrite(pTgTable[i].u4Addr, u1tmp, 2) == 0)
		{
		
			u1Err = 1;
#ifdef TCON_DBG_MSG_EN
 		  	printf("!!!Tcon Gamma write fail 0x%x, 0x%x, 0x%x\n",\
				              pTgTable[i].u4Addr,\
				              u1tmp[0],\
				              u1tmp[1]);
#endif
		}
		else
		{
#ifdef TCON_DBG_MSG_EN
		   	printf("Tcon Gamma write ok 0x%x, 0x%x, 0x%x\n", \
                              pTgTable[i].u4Addr, \
                              u1tmp[0], \
                              u1tmp[1]);
#endif
		}
    }

    // check if init ok
	if (u1Err == 0)
	{
#ifdef TCON_DBG_MSG_EN
    	printf("Program Tcon Gamma dacs %d counts, %d / %d\n", i, sizeof(pTgTable), sizeof(struct sTCONREGTABLE));
#endif
	}
	else
	{
#ifdef TCON_DBG_MSG_EN
   	   printf("Program Tcon Gamma dacs fail !!!\n");
#endif
	}

    return (u1Ret);
}

UINT8 u1TconCustTgInit(void)
{
	UINT8 i = 0;
	UINT8 u1count = 0;
	UINT32 u4tmp, u4tmp1;
    struct sTCONREGTABLE *pTgTable = NULL;    

	switch (GetCurrentPanelIndex())
    {                 
#ifdef PANEL_MLVDS_LGDV4FHD60
        case PANEL_MLVDS_LGDV4FHD60:             
            u1count = (sizeof(sRegTg_MLVDS_LGDV4FHD60) / sizeof(struct sTCONREGTABLE));            
            pTgTable = sRegTg_MLVDS_LGDV4FHD60;            
        break;
#endif

#ifdef PANEL_MLVDS_LGDV4FHD120
		case PANEL_MLVDS_LGDV4FHD120:             
            u1count = (sizeof(sRegTg_MLVDS_LGDV4FHD60) / sizeof(struct sTCONREGTABLE));            
            pTgTable = sRegTg_MLVDS_LGDV4FHD60;            
        break;
#endif

#ifdef PANEL_MLVDS_PANASONIC32WXGA1P6P
        case PANEL_MLVDS_PANASONIC32WXGA1P6P:             
            u1count = (sizeof(sRegTg_MLVDS_PANASONIC32WXGA1P6P) / sizeof(struct sTCONREGTABLE));            
            pTgTable = sRegTg_MLVDS_PANASONIC32WXGA1P6P;            
        break;
#endif

#ifdef PANEL_MLVDS_PANASONIC32WXGA2P3P
		case PANEL_MLVDS_PANASONIC32WXGA2P3P:             
            u1count = (sizeof(sRegTg_MLVDS_PANASONIC32WXGA2P3P) / sizeof(struct sTCONREGTABLE));            
            pTgTable = sRegTg_MLVDS_PANASONIC32WXGA2P3P;            
        break;
#endif
		
#ifdef PANEL_MLVDS_PANASONIC42FHD120
        case PANEL_MLVDS_PANASONIC42FHD120:             
            u1count = (sizeof(sRegTg_MLVDS_PANASONIC42FHD120) / sizeof(struct sTCONREGTABLE));            
            pTgTable = sRegTg_MLVDS_PANASONIC42FHD120;            
        break;
#endif
		
#ifdef PANEL_MLVDS_CMO2011FHD60
        case PANEL_MLVDS_CMO2011FHD60:             
            u1count = (sizeof(sRegTg_MLVDS_CMO2011FHD60) / sizeof(struct sTCONREGTABLE));            
            pTgTable = sRegTg_MLVDS_CMO2011FHD60;            
        break;
#endif
		
#ifdef PANEL_MLVDS_CMO2011FHD120
		case PANEL_MLVDS_CMO2011FHD120:             
            u1count = (sizeof(sRegTg_MLVDS_CMO2011FHD60) / sizeof(struct sTCONREGTABLE));            
            pTgTable = sRegTg_MLVDS_CMO2011FHD60;            
        break;
#endif
		
#ifdef PANEL_MLVDS_SS_MB7
        case PANEL_MLVDS_SS_MB7:             
            u1count = (sizeof(sRegTg_MLVDS_SAMSUNGMB7) / sizeof(struct sTCONREGTABLE));            
            pTgTable = sRegTg_MLVDS_SAMSUNGMB7;            
        break;
#endif

#ifdef PANEL_EPI_LGDV12GIPFHD60
        case PANEL_EPI_LGDV12GIPFHD60:             
            u1count = (sizeof(sRegTg_EPI_LGDV12FHD60) / sizeof(struct sTCONREGTABLE));            
            pTgTable = sRegTg_EPI_LGDV12FHD60;            
        break;
#endif

#ifdef PANEL_EPI_LGDV12GIPFHD120
        case PANEL_EPI_LGDV12GIPFHD120:             
            u1count = (sizeof(sRegTg_EPI_LGDV12FHD120) / sizeof(struct sTCONREGTABLE));            
            pTgTable = sRegTg_EPI_LGDV12FHD120;            
        break;
#endif
		
#ifdef PANEL_MLVDS_LGD32WXGAV9
		case PANEL_MLVDS_LGD32WXGAV9:
			u1count = (sizeof(sRegTg_MLVDS_LGD32WXGAV9) / sizeof(struct sTCONREGTABLE));		   
			pTgTable = sRegTg_MLVDS_LGD32WXGAV9;	
		break;	
#endif

#ifdef PANEL_MLVDS_HISENSE32WXGA2P3P
		case PANEL_MLVDS_HISENSE32WXGA2P3P: 		  
			u1count = (sizeof(sRegTg_MLVDS_HISENSE32WXGA2P3P) / sizeof(struct sTCONREGTABLE));			
			pTgTable = sRegTg_MLVDS_HISENSE32WXGA2P3P;			
		break;
#endif
#ifdef PANEL_MLVDS_AUO_T420HVN06FHD60
		case PANEL_MLVDS_AUO_T420HVN06FHD60:
			u1count = (sizeof(sRegTg_MLVDS_AUO_T420HVN06FHD60) / sizeof(struct sTCONREGTABLE)); 	   
			pTgTable = sRegTg_MLVDS_AUO_T420HVN06FHD60; 
		break;	
#endif

        default:
          break;
    }               

    LOG(1,"cust tg init\n");
    if ((pTgTable != NULL) && u1count)    
        {        
        for ( i = 0 ; i < u1count ; i++)        
            {            
            u4tmp = pTgTable[i].u4Addr;            
            u4tmp1 = (u4IO32Read4B(u4tmp) & ~(pTgTable[i].u4Msk)) | ((pTgTable[i].u4Val) & (pTgTable[i].u4Msk));                 
            vIO32Write4B(u4tmp,u4tmp1);
            }    
        }      
//    LOG(1,"Tcon reg flashing %d counts, %d / %d\n", i, sizeof(pTgTable), sizeof(struct sTCONREGTABLE));

  return(1);
}

UINT8 u1TconCustMlvdsInit(void)
{
 	UINT8 i = 0;
	UINT8 u1count = 0;
	UINT32 u4tmp, u4tmp1;
    struct sTCONREGTABLE *pTgTable = NULL;    
	
	switch (GetCurrentPanelIndex())
    {                 
 #ifdef PANEL_MLVDS_LGDV4FHD60
        case PANEL_MLVDS_LGDV4FHD60:             
            u1count = (sizeof(sRegMini_MLVDS_LGDV4FHD60) / sizeof(struct sTCONREGTABLE));            
            pTgTable = sRegMini_MLVDS_LGDV4FHD60;            
        break;
#endif

#ifdef PANEL_MLVDS_LGDV4FHD120
        case PANEL_MLVDS_LGDV4FHD120:             
            u1count = (sizeof(sRegMini_MLVDS_LGDV4FHD60) / sizeof(struct sTCONREGTABLE));            
            pTgTable = sRegMini_MLVDS_LGDV4FHD60;            
        break;
#endif

#ifdef PANEL_MLVDS_CMO2011FHD60
        case PANEL_MLVDS_CMO2011FHD60:             
            u1count = (sizeof(sRegMini_MLVDS_CMO2011FHD60) / sizeof(struct sTCONREGTABLE));            
            pTgTable = sRegMini_MLVDS_CMO2011FHD60;            
        break;
#endif

#ifdef PANEL_MLVDS_CMO2011FHD120
		case PANEL_MLVDS_CMO2011FHD120:             
            u1count = (sizeof(sRegMini_MLVDS_CMO2011FHD60) / sizeof(struct sTCONREGTABLE));            
            pTgTable = sRegMini_MLVDS_CMO2011FHD60;            
        break;
#endif

#ifdef PANEL_MLVDS_PANASONIC32WXGA1P6P
        case PANEL_MLVDS_PANASONIC32WXGA1P6P:             
            u1count = (sizeof(sRegMini_MLVDS_PANASONIC32WXGA1P6P) / sizeof(struct sTCONREGTABLE));            
            pTgTable = sRegMini_MLVDS_PANASONIC32WXGA1P6P;            
        break;
#endif
		
#ifdef PANEL_MLVDS_PANASONIC32WXGA2P3P
        case PANEL_MLVDS_PANASONIC32WXGA2P3P:             
            u1count = (sizeof(sRegMini_MLVDS_PANASONIC32WXGA2P3P) / sizeof(struct sTCONREGTABLE));            
            pTgTable = sRegMini_MLVDS_PANASONIC32WXGA2P3P;            
        break;
#endif

#ifdef PANEL_MLVDS_PANASONIC42FHD120
		case PANEL_MLVDS_PANASONIC42FHD120:             
            u1count = (sizeof(sRegMini_MLVDS_PANASONIC42FHD120) / sizeof(struct sTCONREGTABLE));            
            pTgTable = sRegMini_MLVDS_PANASONIC42FHD120;            
        break;
#endif
		
#ifdef PANEL_MLVDS_SS_MB7
        case PANEL_MLVDS_SS_MB7:             
            u1count = (sizeof(sRegMini_MLVDS_SAMSUNGMB7) / sizeof(struct sTCONREGTABLE));            
            pTgTable = sRegMini_MLVDS_SAMSUNGMB7;            
        break;
#endif
		
#ifdef PANEL_MLVDS_LGD32WXGAV9
		case PANEL_MLVDS_LGD32WXGAV9:
            u1count = (sizeof(sRegMini_MLVDS_LGD32WXGAV9) / sizeof(struct sTCONREGTABLE));            
            pTgTable = sRegMini_MLVDS_LGD32WXGAV9;    
		break; 
#endif

#ifdef PANEL_MLVDS_HISENSE32WXGA2P3P
		case PANEL_MLVDS_HISENSE32WXGA2P3P: 		  
			u1count = (sizeof(sRegMini_MLVDS_HISENSE32WXGA2P3P) / sizeof(struct sTCONREGTABLE));			  
			pTgTable = sRegMini_MLVDS_HISENSE32WXGA2P3P;			  
		break;
#endif

#ifdef PANEL_MLVDS_AUO_T420HVN06FHD60
		case PANEL_MLVDS_AUO_T420HVN06FHD60:
			u1count = (sizeof(sRegMini_MLVDS_AUO_T420HVN06FHD60) / sizeof(struct sTCONREGTABLE));		  
			pTgTable = sRegMini_MLVDS_AUO_T420HVN06FHD60;	
		break; 
#endif

        default:
          break;
    }               

  LOG(1,"cust MLVDS init\n");
  if ((pTgTable != NULL) && u1count)    
      {        
      for ( i = 0 ; i < u1count ; i++)        
          {            
          u4tmp = pTgTable[i].u4Addr;            
          u4tmp1 = (u4IO32Read4B(u4tmp) & ~(pTgTable[i].u4Msk)) | ((pTgTable[i].u4Val) & (pTgTable[i].u4Msk));                 
          vIO32Write4B(u4tmp,u4tmp1);
          }    
      }      
//  LOG(1,"Tcon reg flashing %d counts, %d / %d\n", i, sizeof(pTgTable), sizeof(struct sTCONREGTABLE));

  return(1);
}

UINT8 u1TconCustEPIInit(void)
{
 	UINT8 i = 0;
	UINT8 u1count=0;
	UINT32 u4tmp, u4tmp1;
    struct sTCONREGTABLE *pTgTable = NULL;    

	switch (GetCurrentPanelIndex())
    {                 
#ifdef PANEL_EPI_LGDV12GIPFHD120
        case PANEL_EPI_LGDV12GIPFHD120:             
            u1count = (sizeof(sReg_PANEL_EPI_LGDV12FHD120) / sizeof(struct sTCONREGTABLE));            
            pTgTable = sReg_PANEL_EPI_LGDV12FHD120;            
        break;
#endif

#ifdef PANEL_EPI_LGDV12GIPFHD60
        case PANEL_EPI_LGDV12GIPFHD60:             
            u1count = (sizeof(sReg_PANEL_EPI_LGDV12FHD60) / sizeof(struct sTCONREGTABLE));            
            pTgTable = sReg_PANEL_EPI_LGDV12FHD60;            
        break;
#endif

        default:
        break;
    }               

    LOG(1,"cust EPI init\n");
    if ((pTgTable != NULL) && u1count)    
        {        
        for ( i = 0 ; i < u1count ; i++)        
            {            
            u4tmp = pTgTable[i].u4Addr;            
            u4tmp1 = (u4IO32Read4B(u4tmp) & ~(pTgTable[i].u4Msk)) | ((pTgTable[i].u4Val) & (pTgTable[i].u4Msk));                 
            vIO32Write4B(u4tmp,u4tmp1);
            }    
        }      
//    LOG(1,"Tcon reg flashing %d counts, %d / %d\n", i, sizeof(pTgTable), sizeof(struct sTCONREGTABLE));

  return(1);
}

void vDrvTCONCustSel(VIDEO_TCON_TABLE_T eTconTableSel)
{
    UINT8 i = 0;
    UINT8 u1count=0;
    UINT32 u4tmp, u4tmp1;
	struct sTCONREGTABLE *pTgTable = NULL;

    switch (eTconTableSel)
    {
         
        #ifdef EPIV13FHD60_32_TABLE
        case EPIV13FHD60_32: 
            u1count = (sizeof(sRegTg_EPI_LGDV13FHD60_32) / sizeof(struct sTCONREGTABLE));
            pTgTable = sRegTg_EPI_LGDV13FHD60_32;
			//printk("\n\n\nTconRegTable = sRegTg_EPI_LGDV13FHD60_32\n\n\n\n");
        break;
        #endif

        #ifdef EPIV13FHD60_42_TABLE
        case EPIV13FHD60_42: 
            u1count = (sizeof(sRegTg_EPI_LGDV13FHD60_42) / sizeof(struct sTCONREGTABLE));
            pTgTable = sRegTg_EPI_LGDV13FHD60_42;
			//printk("\n\n\nTconRegTable = sRegTg_EPI_LGDV13FHD60_42\n\n\n\n");
        break;
        #endif
		
        #ifdef EPIV13FHD60_47_TABLE
        case EPIV13FHD60_47: 
            u1count = (sizeof(sRegTg_EPI_LGDV13FHD60_47) / sizeof(struct sTCONREGTABLE));
            pTgTable = sRegTg_EPI_LGDV13FHD60_47;
			//printk("\n\n\nTconRegTable = sRegTg_EPI_LGDV13FHD60_47\n\n\n\n");
        break;
        #endif

        #ifdef EPIV13FHD60_55_TABLE
        case EPIV13FHD60_55: 
            u1count = (sizeof(sRegTg_EPI_LGDV13FHD60_55) / sizeof(struct sTCONREGTABLE));
            pTgTable = sRegTg_EPI_LGDV13FHD60_55;
			//printk("\n\n\nTconRegTable = sRegTg_EPI_LGDV13FHD60_55\n\n\n\n");
        break;
        #endif

        #ifdef EPIV12FHD60_47_TABLE
        case EPIV12FHD60_47: 
            u1count = (sizeof(sRegTg_EPI_LGDV12FHD60_47) / sizeof(struct sTCONREGTABLE));
            pTgTable = sRegTg_EPI_LGDV12FHD60_47;
			//printk("\n\n\nTconRegTable = sRegTg_EPI_LGDV12FHD60_47\n\n\n\n");
        break;
        #endif
        
        #ifdef EPIV12FHD120_47_TABLE
        case EPIV12FHD120_47: 
            u1count = (sizeof(sRegTg_EPI_LGDV12FHD120_47) / sizeof(struct sTCONREGTABLE));
            pTgTable = sRegTg_EPI_LGDV12FHD120_47;
			//printk("\n\n\nTconRegTable = sRegTg_EPI_LGDV12FHD120_47\n\n\n\n");
        break;
        #endif

        default:
        break;
    }   

    LOG(1,"cust tg init\n");
    if ((pTgTable != NULL) && u1count)
    {
        for ( i = 0 ; i < u1count ; i++)
        {
            u4tmp = pTgTable[i].u4Addr;
            u4tmp1 = (u4IO32Read4B(u4tmp) & ~(pTgTable[i].u4Msk)) | ((pTgTable[i].u4Val) & (pTgTable[i].u4Msk));
     
            vIO32Write4B(u4tmp,u4tmp1);
        }
    }  
//    LOG(1,"Tcon reg flashing %d counts, %d / %d\n", i, sizeof(pTgTable), sizeof(struct sTCONREGTABLE));
    
}

void _vDrvTconSetPinMux(void)
{
    BSP_PinSet( PIN_TCON0, PINMUX_FUNCTION1); 
    BSP_PinSet( PIN_TCON1, PINMUX_FUNCTION1); 
    BSP_PinSet( PIN_TCON2, PINMUX_FUNCTION1);      
#ifndef CC_MT5565_TURNKEY
    BSP_PinSet( PIN_TCON3, PINMUX_FUNCTION1);      
#endif
    BSP_PinSet( PIN_TCON4, PINMUX_FUNCTION1);  
    BSP_PinSet( PIN_TCON5, PINMUX_FUNCTION1);  
    BSP_PinSet( PIN_TCON6, PINMUX_FUNCTION1); 
    BSP_PinSet( PIN_TCON7, PINMUX_FUNCTION1);  
    BSP_PinSet( PIN_TCON8, PINMUX_FUNCTION1);  
    BSP_PinSet( PIN_TCON9, PINMUX_FUNCTION1);  
    BSP_PinSet( PIN_TCON10, PINMUX_FUNCTION1); 
    BSP_PinSet( PIN_TCON11, PINMUX_FUNCTION1); 
    BSP_PinSet( PIN_TCON12, PINMUX_FUNCTION1);
	if(PANEL_GetDisplayType()== PANEL_DISPLAY_TYPE_EPI)
    #if defined(CC_MT5398)
    	BSP_PinSet( PIN_GPIO42, PINMUX_FUNCTION2);  // LOCKN
    #else //
    	BSP_PinSet( PIN_GPIO0, PINMUX_FUNCTION3);  // LOCKN
    #endif	

}


