/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

#ifndef CONFIG_DEFAULT_H
#define CONFIG_DEFAULT_H


//----------------------------------------------------------------------------
// Initial dram settings
//----------------------------------------------------------------------------
#define DEFAULT_DRAM_TYPE                   DDR_III_x2
#define DEFAULT_DDR_CLOCK                   (1404000000)//(1296000000)

//#ifndef DRAM_PRIORITY_LIST
// Audio/0 > B2R/5 > NR/PSCAN/4 > Scpip/7 > OSD/3 > Mjc_in/13 > Mjc_out/14 > VLD1/9 > Vdec_mc/8 > CPU/6 > Gfx/11 > Demux/PVR/1 > VBI/3D/TVE/2 >VENC/12 > Test/15 > Unused/10
//#define DRAM_PRIORITY_LIST                  ((UINT8*)"0c9421a387fbd56e")
//#endif

//----------------------------------------------------------------------------
// FBM setup
//----------------------------------------------------------------------------
#define TOTAL_MEM_SIZE                      (512 * 1024 * 1024)

#if 1
#define CC_CONFIG_OSD_CM_SIZE               (4) // 4:argb 8888 ;2:argb 4444
#define CC_CONFIG_OSD_BUF_MODE              (2) // 2:double  buffer ;1:sngle buffer
        
#ifndef CC_CONFIG_OSD_PLANE1_MAX_W
#define CC_CONFIG_OSD_PLANE1_MAX_W          (0)
#endif
#ifndef CC_CONFIG_OSD_PLANE1_MAX_H
#define CC_CONFIG_OSD_PLANE1_MAX_H          (0)
#endif
#define CC_CONFIG_OSD_PLANE1_MEM_SIZE       (((CC_CONFIG_OSD_PLANE1_MAX_W*     \
                                        CC_CONFIG_OSD_PLANE1_MAX_H*        \
                                        CC_CONFIG_OSD_CM_SIZE*             \
                                        CC_CONFIG_OSD_BUF_MODE)+0x1000)&(0xFFFFF000))
        
        // osd 3d buffer size
#if (defined(CC_CONFIG_OSD_SBS_PLANE1)||defined(CC_CONFIG_OSD_TB_PLANE1))
#define CC_CONFIG_OSD_3D_PLANE1_MEM_SIZE    (CC_CONFIG_OSD_PLANE1_MEM_SIZE)
#else
#define CC_CONFIG_OSD_3D_PLANE1_MEM_SIZE    (0)
#endif
        
        // osd decompress  buffer size
#ifdef CONFIG_OSD_PLANE1_COMPRESSION
#define CC_CONFIG_OSD_DEC_PLANE1_MEM_SIZE   (CC_CONFIG_OSD_PLANE1_MEM_SIZE)
#else
#define CC_CONFIG_OSD_DEC_PLANE1_MEM_SIZE   (0)
#endif
        
#ifndef CC_CONFIG_OSD_PLANE2_MAX_W
#define CC_CONFIG_OSD_PLANE2_MAX_W          (960)
#endif
#ifndef CC_CONFIG_OSD_PLANE2_MAX_H
#define CC_CONFIG_OSD_PLANE2_MAX_H          (540)
#endif
#define CC_CONFIG_OSD_PLANE2_MEM_SIZE       (((CC_CONFIG_OSD_PLANE2_MAX_W*     \
                                            CC_CONFIG_OSD_PLANE2_MAX_H*        \
                                            CC_CONFIG_OSD_CM_SIZE*             \
                                            CC_CONFIG_OSD_BUF_MODE)+0x1000)&(0xFFFFF000))
        
#if (defined(CC_CONFIG_OSD_SBS_PLANE2)||defined(CC_CONFIG_OSD_TB_PLANE2))
#define CC_CONFIG_OSD_3D_PLANE2_MEM_SIZE    (CC_CONFIG_OSD_PLANE2_MEM_SIZE)
#else
#define CC_CONFIG_OSD_3D_PLANE2_MEM_SIZE    (0)
#endif
        
#ifndef CONFIG_OSD_PLANE2_COMPRESSION
        //#define  CONFIG_OSD_PLANE2_COMPRESSION
#endif
        
        // osd decompress  buffer size
#ifdef CONFIG_OSD_PLANE2_COMPRESSION
#define CC_CONFIG_OSD_DEC_PLANE2_MEM_SIZE   (CC_CONFIG_OSD_PLANE2_MEM_SIZE)
#else
#define CC_CONFIG_OSD_DEC_PLANE2_MEM_SIZE   (0)
#endif
        
#ifndef CC_CONFIG_OSD_PLANE3_MAX_W
#define CC_CONFIG_OSD_PLANE3_MAX_W          (1920)
#endif
#ifndef CC_CONFIG_OSD_PLANE3_MAX_H
#define CC_CONFIG_OSD_PLANE3_MAX_H          (1080)
#endif
#define CC_CONFIG_OSD_PLANE3_MEM_SIZE       (((CC_CONFIG_OSD_PLANE3_MAX_W*     \
                                            CC_CONFIG_OSD_PLANE3_MAX_H*        \
                                            CC_CONFIG_OSD_CM_SIZE*             \
                                            CC_CONFIG_OSD_BUF_MODE)+0x1000)&(0xFFFFF000))
        
#if (defined(CC_CONFIG_OSD_SBS_PLANE3)||defined(CC_CONFIG_OSD_TB_PLANE3))
#define CC_CONFIG_OSD_3D_PLANE3_MEM_SIZE    (CC_CONFIG_OSD_PLANE3_MEM_SIZE)
#else
#define CC_CONFIG_OSD_3D_PLANE3_MEM_SIZE    (0)
#endif
        
        // osd decompress  buffer size
#ifndef CONFIG_OSD_PLANE3_COMPRESSION
        // #define  CONFIG_OSD_PLANE3_COMPRESSION
#endif
        
#ifdef CONFIG_OSD_PLANE3_COMPRESSION
#define CC_CONFIG_OSD_DEC_PLANE3_MEM_SIZE   (CC_CONFIG_OSD_PLANE3_MEM_SIZE)
#else
#define CC_CONFIG_OSD_DEC_PLANE3_MEM_SIZE   (0)
#endif
        
#ifndef CC_CONFIG_OSD_PLANE4_MAX_W
#define CC_CONFIG_OSD_PLANE4_MAX_W          (0)
#endif
#ifndef CC_CONFIG_OSD_PLANE4_MAX_H
#define CC_CONFIG_OSD_PLANE4_MAX_H          (0)
#endif
#define CC_CONFIG_OSD_PLANE4_MEM_SIZE       (((CC_CONFIG_OSD_PLANE4_MAX_W*     \
                                            CC_CONFIG_OSD_PLANE4_MAX_H*        \
                                            CC_CONFIG_OSD_CM_SIZE*             \
                                            CC_CONFIG_OSD_BUF_MODE)+0x1000)&(0xFFFFF000))
        
#if (defined(CC_CONFIG_OSD_SBS_PLANE4)||defined(CC_CONFIG_OSD_TB_PLANE4))
#define CC_CONFIG_OSD_3D_PLANE4_MEM_SIZE    (CC_CONFIG_OSD_PLANE4_MEM_SIZE)
#else
#define CC_CONFIG_OSD_3D_PLANE4_MEM_SIZE    (0)
#endif
        
        // osd decompress  buffer size
#ifdef CONFIG_OSD_PLANE4_COMPRESSION
#define CC_CONFIG_OSD_DEC_PLANE4_MEM_SIZE   (CC_CONFIG_OSD_PLANE4_MEM_SIZE)
#else
#define CC_CONFIG_OSD_DEC_PLANE4_MEM_SIZE   (0)
#endif
        
#ifndef CC_CONFIG_OSD_PLANE5_MAX_W
#define CC_CONFIG_OSD_PLANE5_MAX_W          (100)
#endif
#ifndef CC_CONFIG_OSD_PLANE5_MAX_H
#define CC_CONFIG_OSD_PLANE5_MAX_H          (100)
#endif
        
#define CC_CONFIG_OSD_PLANE5_MEM_SIZE       (((CC_CONFIG_OSD_PLANE5_MAX_W*     \
                                    CC_CONFIG_OSD_PLANE5_MAX_H*        \
                                    CC_CONFIG_OSD_CM_SIZE)+0x1000)&(0xFFFFF000))
        
        // osd 3d buffer size
#if (defined(CC_CONFIG_OSD_SBS_PLANE5)||defined(CC_CONFIG_OSD_TB_PLANE5))
#define CC_CONFIG_OSD_3D_PLANE5_MEM_SIZE    (CC_CONFIG_OSD_PLANE5_MEM_SIZE)
#else
#define CC_CONFIG_OSD_3D_PLANE5_MEM_SIZE    (0)
#endif
        
        // osd decompress  buffer size
#ifdef CONFIG_OSD_PLANE5_COMPRESSION
#define CC_CONFIG_OSD_DEC_PLANE5_MEM_SIZE   (CC_CONFIG_OSD_PLANE5_MEM_SIZE)
#else
#define CC_CONFIG_OSD_DEC_PLANE5_MEM_SIZE   (0)
#endif
        
#define CC_CONFIG_OSD_PLANE_BASIC_MEM_SIZE  (CC_CONFIG_OSD_PLANE1_MEM_SIZE+ \
                                        CC_CONFIG_OSD_PLANE2_MEM_SIZE+  \
                                        CC_CONFIG_OSD_PLANE3_MEM_SIZE+  \
                                        CC_CONFIG_OSD_PLANE4_MEM_SIZE+  \
                                        CC_CONFIG_OSD_PLANE5_MEM_SIZE)
        
#define CC_CONFIG_OSD_3D_PLANE_MEM_SIZE     (CC_CONFIG_OSD_3D_PLANE1_MEM_SIZE+  \
                                            CC_CONFIG_OSD_3D_PLANE2_MEM_SIZE+   \
                                            CC_CONFIG_OSD_3D_PLANE3_MEM_SIZE+   \
                                            CC_CONFIG_OSD_3D_PLANE4_MEM_SIZE+   \
                                            CC_CONFIG_OSD_3D_PLANE5_MEM_SIZE)
        
#define CC_CONFIG_OSD_DEC_PLANE_MEM_SIZE    (CC_CONFIG_OSD_DEC_PLANE1_MEM_SIZE+ \
                                            CC_CONFIG_OSD_DEC_PLANE2_MEM_SIZE+  \
                                            CC_CONFIG_OSD_DEC_PLANE3_MEM_SIZE+  \
                                            CC_CONFIG_OSD_DEC_PLANE4_MEM_SIZE+  \
                                            CC_CONFIG_OSD_DEC_PLANE5_MEM_SIZE)
        
#define CC_CONFIG_GFX_TEMP_MEM_SIZE         (CC_CONFIG_OSD_PLANE3_MAX_W*    \
                                            CC_CONFIG_OSD_PLANE3_MAX_H*     \
                                            CC_CONFIG_OSD_CM_SIZE)
        
#define DFB_SUM_MEM_SIZE                    (CC_CONFIG_OSD_PLANE_BASIC_MEM_SIZE+\
                                            CC_CONFIG_OSD_3D_PLANE_MEM_SIZE+    \
                                            CC_CONFIG_OSD_DEC_PLANE_MEM_SIZE+   \
                                            CC_CONFIG_GFX_TEMP_MEM_SIZE)
#endif                                                    


#ifdef ANDROID
    #define DIRECT_FB_MEM_SIZE                  (1 * 1024 * 1024)
    // ANDROID need 8MB fb buffer
    #define FB_MEM_SIZE                         (20 * 1024 * 1024)
    #define GFX_FB_PARTITION_SIZE               (12 * 1024 * 1024)
#else

#ifdef CC_GFX_MMU
#define DIRECT_FB_MEM_SIZE                  ((DFB_SUM_MEM_SIZE+4*1024)&(0xFFFFF000)) 
#else
#define DIRECT_FB_MEM_SIZE                  (60 * 1024 * 1024)
#endif



#define FB_MEM_SIZE                         (0 * 1024 * 1024)

#endif
#ifndef FBM_MEM_CFG_SIZE
//#define FBM_MEM_CFG_SIZE                    (FBM_MEM_CFG_MT5396_DDR3x4)
#define FBM_MEM_CFG_SIZE                    (FBM_MEM_CFG_MT5880_DDR3x2)
/*
#ifdef CC_3D_SUPPORT
#define FBM_MEM_CFG_SIZE                    (FBM_MEM_CFG_MT5395_3DTV)
#else
#define FBM_MEM_CFG_SIZE                    (FBM_MEM_CFG_MT5395_DDR3x2_EU_NET)
#endif
*/
#endif /* FBM_MEM_CFG_SIZE */

#ifdef CC_TRUSTZONE_SUPPORT
#define TRUSTZONE_CODE_BASE                 (0x5000)
#define TRUSTZONE_MEM_SIZE                  (16 * 1024 * 1024)
#else
#define TRUSTZONE_MEM_SIZE                  (0)
#endif

#define LINUX_KERNEL_MEM_SIZE               ((TOTAL_MEM_SIZE > (FBM_MEM_CFG_SIZE + DIRECT_FB_MEM_SIZE + FB_MEM_SIZE + TRUSTZONE_MEM_SIZE)) ?\
                                            (TOTAL_MEM_SIZE - FBM_MEM_CFG_SIZE - DIRECT_FB_MEM_SIZE - FB_MEM_SIZE - TRUSTZONE_MEM_SIZE) : (54 * 1024 * 1024))

#define DEFAULT_TARGET_COUNTRY              (COUNTRY_EU)  

//----------------------------------------------------------------------------
// Default Panel setting
//----------------------------------------------------------------------------
#ifndef DEFAULT_PANEL_SELECT
#define DEFAULT_PANEL_SELECT                (PANEL_DEFAULT)
#endif
#define BACKLIGHT_GPIO                      (OPCTRL(1))
#define BACKLIGHT_ON_VAL                    (0)
#define PANELPOWER_GPIO                     (59)
#define PANELPOWER_ON_VAL                   (1)

// disable spread spectrum for vga output
#define SPREAD_SPECTRUM_PERMILLAGE          (0)

// pwm backlight adjustment setting
#define PANEL_BACKLIGHT_PWM_PORT            (2)

#define PDWNC_POLARITY                      (0)

//----------------------------------------------------------------------------
// Audio Customization
//----------------------------------------------------------------------------
#define AUDIO_INCLUDE_FILE                  "mtk/Viper_aud.h"
#define AUDIO_Mute_Gpio_Num                 GPIO_OPWM1
#define AUDIO_Amp_Gpio_Num                  (OPCTRL(0))//(GPIO(116))
#define AUDIO_MUTE_GPIO_POLARITY            AUD_MUTE_GPIO_LOW_ENALBE
#define AUDIO_AMP_GPIO_POLARITY             AUD_AMP_GPIO_LOW_ENALBE
#define AUDIO_HP_PLUG_IN_GPIO				(GPIO(65))
#define AUDIO_HP_PLUG_IN_POLARITY       	(AUD_GPIO_LOW_ENALBE)
#define AUDIO_INPUT_MUX_SEL_TABLE           (&_rViperAudInputMuxTable)
#define CC_MUTE_WHEN_CHANGE_DISP_FMT        (0)

//----------------------------------------------------------------------------
// MT8283 Customization
//----------------------------------------------------------------------------

#ifdef DRV_SUPPORT_EXTMJC
//#define MT8280_RESET_GPIO           (WT6720_GPIO2) //(GPIO(80))
//#define MT8280_RESET_GPIO_POLARITY  (0) //Low reset
//#define MT8283_LVDS_POWER_GPIO           (WT6720_GPIO5) //(GPIO(80))
#define CUSTOM_BootupMode           (GPIO_INIT_COMPANION_CHIP)
#endif

//----------------------------------------------------------------------------
// Other GPIO customization
#define DEFAULT_TUNER_RFAGC_SWITCH_GPIO     (GPIO(73))
//----------------------------------------------------------------------------
#define FLAG_EXT_STATUS                     (0)
// #define POWER_LED_GPIO                   (OPCTRL(0))
// #define POWER_LED_ON_VAL                 (0)
// #define BACKUP_LED_GPIO                  (OPCTRL(0))
// #define BACKUP_LED_ON_VAL                (0)
// #define POWER_CTRL_GPIO
// #define POWER_CTRL_ON_VAL
#define FLAG_IRRX_SOUND_SUPPORT             (1)

//----------------------------------------------------------------------------
// EEPROM customization
//----------------------------------------------------------------------------
#define SYSTEM_EEPROM_SIZE                  (4096)
#define SYSTEM_EEPROM_WP_GPIO               (66)
#define SYSTEM_EEPROM_WP_ENABLE_POLARITY    (1)
//#define EDID_EEPROM_WP_GPIO               (GPIO(4))   // GPIO14.
//#define EDID_EEPROM_WP_ENABLE_POLARITY    (1)

#define SYSTEM_EEPROM_BUS                   (0)
//----------------------------------------------------------------------------
// European CI (Common Interface) customization
//----------------------------------------------------------------------------
#define CI_EXTERNAL_IC_INT_GPIO             (GPIO(84))  // Set:Interrupt Mode, UnSet:Polling Mode
//#define CI_5V_OC_GPIO                       (GPIO(49))  // GPIO49
#define CI_5V_POWERON_GPIO                  (GPIO(58))
#define CI_5V_POWERON_POLARITY              (1)
//#define CI_5V_OC_POLARITY                   (0)
#define CI_EXTERNAL_IC_DRIVING_CURRENT      (2)         // 2mA
#define CI_SYSTEM_CLOCK                     (72)        // 72 MHz
#define CI_TS_CLOCK                         (108)       // 108 MHz
#define CI_SPI_CLOCK                        (27)        // 72 MHz
//----------------------------------------------------------------------------
// USB Customization
//----------------------------------------------------------------------------
// 1. Loader/Nuclues system, USB port using define (1)=used (0)=not used
#define USB0_PORT_USING_LOADER              (1)
#define USB1_PORT_USING_LOADER              (1)
#define USB2_PORT_USING_LOADER              (1)
#define USB3_PORT_USING_LOADER              (0)

// 2. Linux/Android System USB port using define (1)=used (0)=not used
#define USB0_PORT_USING                     (1)
#define USB1_PORT_USING                     (1)
#define USB2_PORT_USING                     (1)
#define USB3_PORT_USING                     (0)

// 3. USB power switch Vbus GPIO control, if vbus not control by GPIO, mark off it.
#define USB0_VBUS_GPIO                                  (63)
#define USB0_VBUS_GPIO_POLARITY             (1)
#define USB1_VBUS_GPIO                                  (64)
#define USB1_VBUS_GPIO_POLARITY             (1)
#define USB2_VBUS_GPIO                                  (61)
#define USB2_VBUS_GPIO_POLARITY             (1)

// 4. USB power switch overcurrent GPIO control, if have not ic to control by GPIO, mark off it.
#define USB0_OC_GPIO                                    ADIN(3)
#define USB0_OC_GPIO_POLARITY               (0)
#define USB1_OC_GPIO                                    ADIN(3)
#define USB1_OC_GPIO_POLARITY               (0)
#define USB2_OC_GPIO                                    ADIN(3)
#define USB2_OC_GPIO_POLARITY               (0)

// 5. Detect USB upgrade time, default is 0, but some device maybe can't detect when upgrade.
// If possible, set it to (300)ms when in customer's module.
#define USB_LOADER_WAIT_TIME                (0)

//#define USB_DISABLE_SUSPEND_MODE /* Disable USB suspend, share 240 Mhz with H.264.*/
//----------------------------------------------------------------------------
// Button Customization
//----------------------------------------------------------------------------
#define FLAG_BUTTON_SUPPORT                 (0)

#ifndef T8032UP_INCLUDE_FILE
#define T8032UP_INCLUDE_FILE                "mtk/mtk_t8032fw.h"
#define T8032UP_OFFSET                      au1T8032FW
#define T8032UP_SIZE                        24576//16384
#endif

//----------------------------------------------------------------------------
// MTK IR only setting
//----------------------------------------------------------------------------
#define IR_INCLUDE_FILE                     "mtk/mtk_ir.h"

#ifndef NPTV_SOURCE_TABLE
#define NPTV_SOURCE_TABLE                   "mtk/source_table.c"
#endif

//----------------------------------------------------------------------------
// default PIN Setup
//----------------------------------------------------------------------------
#ifndef PINMUX_INCLUDE_FILE
#define PINMUX_INCLUDE_FILE                 "mtk/mtk_viper_m1v1_pin_setup.h"
#endif

//----------------------------------------------------------------------------
// default HDMI GPIO control
//----------------------------------------------------------------------------
#ifndef HDMI_GPIO_CONF
#define HDMI_GPIO_CONF                      "mtk/hdmi_conf.c"
#endif

/*
 * default VGA table
*/
#ifndef VGA_INCLUDE_FILE
#define VGA_INCLUDE_FILE                    "mtk/mtk_vga.h"
#endif

//----------------------------------------------------------------------------
// Tcon Customization
//----------------------------------------------------------------------------
// support LVDS and MLVDS both
#define PANEL_DISPLAY_TYPE_ALLOWED_MASK ((1<<PANEL_DISPLAY_TYPE_LVDS) | (1 << PANEL_DISPLAY_TYPE_MLVDS))

#ifndef TCON_CUST_FILE
#define TCON_CUST_FILE                      "mtk/Viper_tcon_cust.c"
#endif
//#define SUPPORT_LOCK_FROM_SRVAD 

//----------------------------------------------------------------------------
// SCART out configuration
//----------------------------------------------------------------------------
#ifndef TVE_INCLUDE_FILE
#define TVE_INCLUDE_FILE                    "mtk/mtk_tve.c"
#endif

//----------------------------------------------------------------------------
// DMX configuration
//----------------------------------------------------------------------------
#ifndef DMX_INCLUDE_FILE
#define DMX_INCLUDE_FILE                    "mtk/mtk_dmx.h"
#endif
//----------------------------------------------------------------------------
// SIF configuration
//----------------------------------------------------------------------------
#define SIF_INCLUDE_FILE               "mtk/mtk_sif_cfg.h"

//----------------------------------------------------------------------------
// PCIE configuration
//----------------------------------------------------------------------------
//#define PCIE_RESET_GPIO                     GPIO(47) // OPCTRL4
#ifdef ANDROID
//----------------------------------------------------------------------------
// NAND customization
//----------------------------------------------------------------------------

#if defined (CC_USE_2TB_EMMC)

#define NAND_FLASH_TOTAL_SIZE            ((UINT64)4*1024*1024*1024)
#define MAX_UPGRADE_IMAGE_FILE_SIZE      ((UINT64)4*1024*1024*1024)

    #define NAND_PART_SIZE_0        ((UINT64)0x00200000)        /* loader image               2 */
    #define NAND_PART_SIZE_1        ((UINT64)0x00200000)        /* nand_1  - uboot env        2 */
    #define NAND_PART_SIZE_2        ((UINT64)0x00100000)        /* nand_2  - misc             1 */
    #define NAND_PART_SIZE_3        ((UINT64)0x01000000)        /* nand_3  - recovery        16 */
    #define NAND_PART_SIZE_4        ((UINT64)0x01000000)        /* nand_4  - boot            16 */
    #define NAND_PART_SIZE_5        ((UINT64)0x10400000)        /* nand_5  - system         260 */
    #define NAND_PART_SIZE_6        ((UINT64)0x07900000)        /* nand_6  - userdata       121 */
    #define NAND_PART_SIZE_7        ((UINT64)0x04D00000)        /* nand_7  - cache           77 */
    #define NAND_PART_SIZE_8        ((UINT64)0x00100000)        /* nand_8  - reserved         1 */
    #define NAND_PART_SIZE_9        ((UINT64)0x00100000)        /* nand_9  - channel list A   1 */
    #define NAND_PART_SIZE_10       ((UINT64)0x00100000)        /* nand_10 - channel list B   1 */
    #define NAND_PART_SIZE_11       ((UINT64)0x00100000)        /* nand_11 - Flash PQ         1 */
    #define NAND_PART_SIZE_12       ((UINT64)0x00100000)        /* nand_12 - Flash AQ         1 */
    #define NAND_PART_SIZE_13       ((UINT64)0x00400000)        /* nand_13 - Capture Logo     4 */
    #define NAND_PART_SIZE_14       ((UINT64)0x00400000)        /* nand_14 - Loader Logo      4 */
    #define NAND_PART_SIZE_15       ((UINT64)0x0)
    #define NAND_PART_SIZE_16       ((UINT64)0x0)

#elif defined (CC_USE_512MB_NAND)

#define NAND_FLASH_TOTAL_SIZE            (512*1024*1024)
#define MAX_UPGRADE_IMAGE_FILE_SIZE      (512*1024*1024)

    #define NAND_PART_SIZE_0                (0x0200000)         /* loader image              2 */
    #define NAND_PART_SIZE_1                (0x0200000)         /* nand_1 - uboot env        2 */
    #define NAND_PART_SIZE_2                (0x0100000)         /* nand_2 - misc             1 */
    #define NAND_PART_SIZE_3                (0x1000000)         /* nand_3 - recovery         16 */
    #define NAND_PART_SIZE_4                (0x1000000)         /* nand_4 - boot             16 */
    #define NAND_PART_SIZE_5                (0x10400000)         /* nand_5 - system           260 */
    #define NAND_PART_SIZE_6                (0x7900000)         /* nand_6 - userdata         121 */
    #define NAND_PART_SIZE_7                (0x4D00000)         /* nand_7 - cache            77 */
    #define NAND_PART_SIZE_8                (0x0100000)         /* nand_8 - reserved         1 */
    #define NAND_PART_SIZE_9                (0x0100000)         /* nand_9 - channel list A   1 */
    #define NAND_PART_SIZE_10               (0x0100000)         /* nand_10 - channel list B  1 */
    #define NAND_PART_SIZE_11               (0x0100000)         /* nand_11 - Flash PQ        1 */
    #define NAND_PART_SIZE_12               (0x0100000)         /* nand_12 - Flash AQ        1 */
    #define NAND_PART_SIZE_13               (0x0400000)         /* nand_13 - Capture Logo    4 */
    #define NAND_PART_SIZE_14               (0x0400000)         /* nand_14 - Loader Logo     4 */
    #define NAND_PART_SIZE_15               (0)
    #define NAND_PART_SIZE_16               (0)

#else

#define NAND_FLASH_TOTAL_SIZE            (256*1024*1024)
#define MAX_UPGRADE_IMAGE_FILE_SIZE      (256*1024*1024)

    #define NAND_PART_SIZE_0                (0x0200000)         /* loader image              2*/
    #define NAND_PART_SIZE_1                (0x0200000)         /* nand_1 - uboot env    2*/
    #define NAND_PART_SIZE_2                (0x0040000)         /* nand_16 - misc          128K*/
    #define NAND_PART_SIZE_3                (0x0C00000)         /* nand_16 - recovery   12 */
	#define NAND_PART_SIZE_4				(0x0800000) 		/* nand_16 - boot	         8 */
    #define NAND_PART_SIZE_5                (0x6400000)         /* nand_3 - system     100  */
    #define NAND_PART_SIZE_6                (0x5000000)         /* nand_5 - userdata  80  */
    #define NAND_PART_SIZE_7                (0x3200000)         /* nand_4 - cache      50  */
    #define NAND_PART_SIZE_8                (0x0040000)         /* nand_8 - reserved        128KB */
    #define NAND_PART_SIZE_9                (0x0040000)         /* nand_9 - channel list A  256KB*/
    #define NAND_PART_SIZE_10               (0x0040000)         /* nand_10 - channel list B 256KB */
    #define NAND_PART_SIZE_11               (0x0040000)         /* nand_11 - Flash PQ   128K */
    #define NAND_PART_SIZE_12               (0x0040000)         /* nand_12 - Flash AQ   128K */
    #define NAND_PART_SIZE_13               (0x00e0000)         /* nand_13 - Logo       1M   */
    #define NAND_PART_SIZE_14               (0)                 /* nand_14 -            0    */
    #define NAND_PART_SIZE_15               (0)                 /* nand_15 -            0    */
    #define NAND_PART_SIZE_16               (0)         		/* nand_16 - 			0    */
#endif


    #define NAND_PART_NAME_0                "uboot"
    #define NAND_PART_NAME_1                "uboot_env"
    #define NAND_PART_NAME_2                "misc"
    #define NAND_PART_NAME_3                "recovery"
    #define NAND_PART_NAME_4                "boot"
    #define NAND_PART_NAME_5                "system"
    #define NAND_PART_NAME_6                "userdata"
    #define NAND_PART_NAME_7                "cache"
    #define NAND_PART_NAME_8                "reserved"
    #define NAND_PART_NAME_9                "channelA"
    #define NAND_PART_NAME_10               "channelB"
    #define NAND_PART_NAME_11               "pq"
    #define NAND_PART_NAME_12               "aq"
    #define NAND_PART_NAME_13               "logo"
    #define NAND_PART_NAME_14               "bootlogo"


#define NAND_FLASH_STATIC_LAST_PART_ID   (8)

#define NAND_FLASH_STATIC_PART_SIZE \
        (   (NAND_PART_SIZE_0) + \
            (NAND_PART_SIZE_1) + (NAND_PART_SIZE_2) + (NAND_PART_SIZE_3) + \
            (NAND_PART_SIZE_4) + (NAND_PART_SIZE_5) + (NAND_PART_SIZE_6) + \
            (NAND_PART_SIZE_7) + (NAND_PART_SIZE_8) )
            
#ifndef NAND_PART_OFFSET_13
    #define NAND_PART_OFFSET_13 \
            ((NAND_PART_SIZE_0) + \
            (NAND_PART_SIZE_1) + (NAND_PART_SIZE_2) + (NAND_PART_SIZE_3) + \
            (NAND_PART_SIZE_4) + (NAND_PART_SIZE_5) + (NAND_PART_SIZE_6) + \
            (NAND_PART_SIZE_7) + (NAND_PART_SIZE_8) + (NAND_PART_SIZE_9) + \
            (NAND_PART_SIZE_10) + (NAND_PART_SIZE_11) + (NAND_PART_SIZE_12))
#endif

#else

//----------------------------------------------------------------------------
// Loader configuration
//----------------------------------------------------------------------------
#ifdef CC_USE_128MB_NAND
#define MAX_UPGRADE_IMAGE_FILE_SIZE         (128*1024*1024)     /* 128 MB */
#else
#define MAX_UPGRADE_IMAGE_FILE_SIZE         (512*1024*1024) //512MB 	//old is: (256*1024*1024)     /* 256 MB */
#endif

//----------------------------------------------------------------------------
// Flash Partition configuration
//----------------------------------------------------------------------------
#ifdef CC_USE_128MB_NAND
#define NAND_FLASH_TOTAL_SIZE               (128*1024*1024)
#else
#define NAND_FLASH_TOTAL_SIZE               (512*1024*1024)//old is: (256*1024*1024)
#endif

#if defined(DEFAULT_DB_SUPPORT)
    #define NAND_FLASH_DEFAULT_DB_SIZE      (256*1024)         /* DVB-S default db    */
#endif

#ifndef LINUX_NAND_USE_SDM
    #define NAND_PART_SIZE_0                (2*1024*1024)         /* loader image              */
    #define NAND_PART_SIZE_1                (2*1024*1024)         /* nand_1 - uboot env        */
    #define NAND_PART_SIZE_2                (256*1024)         /* nand_2 - reserved         */
    #define NAND_PART_SIZE_3                (256*1024)         /* nand_3 - reserved         */
    #define NAND_PART_SIZE_4                (2*1024*1024)         /* nand_4 - kernel A         */
    #define NAND_PART_SIZE_5                (2*1024*1024)         /* nand_5 - kernel B         */
    #ifndef CC_DISABLE_BASIC_PART
    #ifndef CC_MSDC_ENABLE
    #define NAND_PART_SIZE_6                (10*1024*1024)         /* nand_6 - rootfs A         nand support*/
    #define NAND_PART_SIZE_7                (10*1024*1024)         /* nand_7 - rootfs B         nand support*/
    #else
    #define NAND_PART_SIZE_6                (40*1024*1024)         /* nand_6 - rootfs A         emmc support*/
    #define NAND_PART_SIZE_7                (40*1024*1024)         /* nand_7 - rootfs B         emmc support*/
    #endif
    #define NAND_PART_SIZE_8                (34*1024*1024)         /* nand_8 - basic            */
    #else
    #ifndef CC_MSDC_ENABLE
    #define NAND_PART_SIZE_6                (27*1024*1024)         /* nand_6 - rootfs A         nand support*/
    #define NAND_PART_SIZE_7                (27*1024*1024)         /* nand_7 - rootfs B         nand support*/
    #else
    #define NAND_PART_SIZE_6                (40*1024*1024)         /* nand_6 - rootfs A         emmc support*/
    #define NAND_PART_SIZE_7                (40*1024*1024)         /* nand_7 - rootfs B         emmc support*/
    #endif
    #define NAND_PART_SIZE_8                (256*1024)         /* nand_8 - basic            */
    #endif
    #ifdef CC_USE_128MB_NAND
    #define NAND_PART_SIZE_9                (39*1024*1024)         /* nand_9 - 3rd              */
    #else
    #define NAND_PART_SIZE_9                (167*1024*1024)         /* nand_9 - 3rd              */
    #endif
    #define NAND_PART_SIZE_10               (5*1024*1024)         /* nand_10 - perm            */
    #define NAND_PART_SIZE_11               (256*1024)         /* nand_11 - reserved        */
    #define NAND_PART_SIZE_12               (2*1024*1024)         /* nand_12 - channel list A  */
    #define NAND_PART_SIZE_13               (2*1024*1024)         /* nand_13 - channel list B  */
    #define NAND_PART_SIZE_14               (2*1024*1024)         /* nand_14 - Flash PQ        */
    #define NAND_PART_SIZE_15               (2*1024*1024)         /* nand_15 - Flash AQ        */
    #define NAND_PART_SIZE_16               (3*1024*1024)         /* nand_16 - Capture Logo    */
    #if defined(CI_PLUS_SUPPORT)
    #define NAND_PART_SIZE_17               (256*1024)         /* nand_17 - ci    */
    #else
    #define NAND_PART_SIZE_17               (0)                 /* nand_17 - reserved    */
    #endif

#if defined(DEFAULT_DB_SUPPORT)
    #define NAND_PART_SIZE_18               NAND_FLASH_DEFAULT_DB_SIZE      /* nand_18 - DVB-S default db */
#endif

#if defined(DEFAULT_DB_SUPPORT)
    #define NAND_FLASH_STATIC_LAST_PART_ID  (18)
    #define NAND_FLASH_STATIC_PART_SIZE \
           ((NAND_PART_SIZE_0) + \
            (NAND_PART_SIZE_1) + (NAND_PART_SIZE_2) + (NAND_PART_SIZE_3) + \
            (NAND_PART_SIZE_4) + (NAND_PART_SIZE_5) + (NAND_PART_SIZE_6) + \
            (NAND_PART_SIZE_7) + (NAND_PART_SIZE_8) + (NAND_PART_SIZE_9) + \
            (NAND_PART_SIZE_10) + (NAND_PART_SIZE_11) + (NAND_PART_SIZE_12) + \
            (NAND_PART_SIZE_13) + (NAND_PART_SIZE_14) + (NAND_PART_SIZE_15) + \
            (NAND_PART_SIZE_16) + (NAND_PART_SIZE_17) + (NAND_PART_SIZE_18))
#else
    #define NAND_FLASH_STATIC_LAST_PART_ID  (17)
    #define NAND_FLASH_STATIC_PART_SIZE \
           ((NAND_PART_SIZE_0) + \
            (NAND_PART_SIZE_1) + (NAND_PART_SIZE_2) + (NAND_PART_SIZE_3) + \
            (NAND_PART_SIZE_4) + (NAND_PART_SIZE_5) + (NAND_PART_SIZE_6) + \
            (NAND_PART_SIZE_7) + (NAND_PART_SIZE_8) + (NAND_PART_SIZE_9) + \
            (NAND_PART_SIZE_10) + (NAND_PART_SIZE_11) + (NAND_PART_SIZE_12) + \
            (NAND_PART_SIZE_13) + (NAND_PART_SIZE_14) + (NAND_PART_SIZE_15) + \
            (NAND_PART_SIZE_16) + (NAND_PART_SIZE_17))
#endif

#else
    #define NAND_PART_SIZE_0                (2*1024*1024)         /* loader image              */
    #define NAND_PART_SIZE_1                (2*1024*1024)         /* nand_1 - uboot env        */
    #define NAND_PART_SIZE_2                (256*1024)         /* nand_2 - reserved         */
    #define NAND_PART_SIZE_3                (256*1024)         /* nand_3 - reserved         */
    #define NAND_PART_SIZE_4                (3*1024*1024)         /* nand_4 - kernel A         */
    #define NAND_PART_SIZE_5                (3*1024*1024)         /* nand_5 - kernel B         */
    #ifndef CC_DISABLE_BASIC_PART
    #ifndef CC_MSDC_ENABLE
    #define NAND_PART_SIZE_6                (10*1024*1024)         /* nand_6 - rootfs A         nand support*/
    #define NAND_PART_SIZE_7                (10*1024*1024)         /* nand_7 - rootfs B         nand support*/
    #else
    #define NAND_PART_SIZE_6                (40*1024*1024)         /* nand_6 - rootfs A         emmc support*/
    #define NAND_PART_SIZE_7                (40*1024*1024)         /* nand_7 - rootfs B         emmc support*/
    #endif
    #define NAND_PART_SIZE_8                (34*1024*1024)         /* nand_8 - basic            */
    #else
    #ifndef CC_MSDC_ENABLE
    #define NAND_PART_SIZE_6                (27*1024*1024)         /* nand_6 - rootfs A         nand support*/
    #define NAND_PART_SIZE_7                (27*1024*1024)         /* nand_7 - rootfs B         nand support*/
    #else
    #define NAND_PART_SIZE_6                (40*1024*1024)         /* nand_6 - rootfs A         emmc support*/
    #define NAND_PART_SIZE_7                (40*1024*1024)         /* nand_7 - rootfs B         emmc support*/
    #endif
    #define NAND_PART_SIZE_8                (256*1024)         /* nand_8 - basic            */
    #endif
    #define NAND_PART_SIZE_9               (5*1024*1024)         /* nand_9 - perm            */
    #ifdef CC_3RD_RO
        #define NAND_PART_SIZE_10             (182*1024*1024)         /* nand_10 - 3rd ro   */
    #else
        #define NAND_PART_SIZE_10               (256*1024)      /* nand 10 - reserved */
    #endif    
	#ifdef CC_USE_128MB_NAND
    #define NAND_PART_SIZE_11                (50*1024*1024)         /* nand_11 - 3rd              */
    #else
        #ifdef CC_3RD_RO
            #define NAND_PART_SIZE_11               (5*1024*1024 )      /* nand_11 - 3rd_rw           */
        #else
            #define NAND_PART_SIZE_11                (178*1024*1024)         /* nand_11 - 3rd              */
        #endif
    #endif
    #define NAND_PART_SIZE_12               (256*1024)         /* nand_12 - reserved        */
    #define NAND_PART_SIZE_13               (256*1024)         /* nand_13 - channel list B  */
    #define NAND_PART_SIZE_14               (256*1024)         /* nand_14 - Flash PQ        */
    #define NAND_PART_SIZE_15               (256*1024)         /* nand_15 - Flash AQ        */
    #define NAND_PART_SIZE_16               (256*1024)         /* nand_16 - Flash AQ        */
    #define NAND_PART_SIZE_17               (1*1024*1024)         /* nand_17 - Capture Logo    */
    #if defined(CI_PLUS_SUPPORT)
    #define NAND_PART_SIZE_18               (256*1024)         /* nand_18 - ci              */
    #else
    #define NAND_PART_SIZE_18               (0)                 /* nand_18 - reserved        */
    #endif
#if defined(DEFAULT_DB_SUPPORT)
    #define NAND_PART_SIZE_19               NAND_FLASH_DEFAULT_DB_SIZE      /* nand_19 - DVB-S default db */
#endif

	#ifdef SYS_ACFG_DESC_SDM_SUPPORT
	#define NAND_PART_SIZE_20               (1*1024*1024)                   /* nand_20 - PART_ACFG_DESC_SIZE */
	#else
	#define NAND_PART_SIZE_20               (0)                             
	#endif

	#ifdef SYS_SCHED_PVR_FLASH_SUPPORT
	#define NAND_PART_SIZE_21               (256*1024)          /* nand_21 - Schedule PVR size 256K */
	#else
	#define NAND_PART_SIZE_21               (0)                             
	#endif

    #define NAND_FLASH_STATIC_LAST_PART_ID  (12)

    #define NAND_FLASH_STATIC_PART_SIZE \
            ((NAND_PART_SIZE_0) + \
            (NAND_PART_SIZE_1) + (NAND_PART_SIZE_2) + (NAND_PART_SIZE_3) + \
            (NAND_PART_SIZE_4) + (NAND_PART_SIZE_5) + (NAND_PART_SIZE_6) + \
            (NAND_PART_SIZE_7) + (NAND_PART_SIZE_8) + (NAND_PART_SIZE_9) + \
            (NAND_PART_SIZE_10) + (NAND_PART_SIZE_11) + (NAND_PART_SIZE_12))
#endif


#ifdef LINUX_TURNKEY_SOLUTION
    #if defined(DEFAULT_DB_SUPPORT)
        #define NAND_PART_NAME_18           "dvbsDB"
    #endif
#endif
#endif

/*
 * default quality table
*/
#ifndef QTYTBL_INCLUDE_FILE
//#define QTYTBL_INCLUDE_FILE               "mtk/QTY_DEFAULT/mtk_QtyTbl.h"
#endif

#define NAND_FLASH_APPIMAGE_SIZE            (8*1024*1024)//(6*1024*1024)    // temporary solution [DTV00212237]

#ifdef SUPPORT_FLASH_PQ
#ifdef LINUX_TURNKEY_SOLUTION
#define FLASH_PQ_USE_NAND_FLASH             (1)
#ifndef ANDROID
#define FLASH_PQ_BASE_PARTITION             (15)
#else
#define FLASH_PQ_BASE_PARTITION             (11)
#endif
#endif
#endif // #if SUPPORT_FLASH_PQ

#ifdef SUPPORT_FLASH_AQ
#ifdef LINUX_TURNKEY_SOLUTION
#ifndef ANDROID
#define FLASH_AQ_BASE_PARTITION             (16)
#else
#define FLASH_AQ_BASE_PARTITION             (12)
#endif
#endif
#endif // #if SUPPORT_FLASH_AQ

/*
 * default color parameter
*/
#ifndef COLOR_PARAM_INCLUDE_FILE
//#define COLOR_PARAM_INCLUDE_FILE          "mtk/PANEL_DEFAULT/color_param.h"
#endif

/*
 * dynamic backlight parameter
*/
/*------ For capture logo start --------*/
// driver logo setting
#define DRV_LOGO_ENABLE                 (1)
#ifdef CC_BOOT_VDEC_LOGO
#ifndef ANDROID
#define DRV_LOGO_VDEC_FLASH_ADDR        NAND_PART_OFFSET_17
#define DRV_LOGO_VDEC_FLASH_SIZE        NAND_PART_SIZE_17
#define DRV_LOGO_VDEC_FLASH_SLOT_NUM    (2)
#define DRV_LOGO_VDEC_DEVICE_ID         (17)
#else
#define DRV_LOGO_VDEC_FLASH_ADDR        NAND_PART_OFFSET_13
#define DRV_LOGO_VDEC_FLASH_SIZE        NAND_PART_SIZE_13
#define DRV_LOGO_VDEC_FLASH_SLOT_NUM    (2)
#define DRV_LOGO_VDEC_DEVICE_ID         (13)
#endif
#define DRV_LOGO_H_FILE                 "mtk/MediaTek_Mpeg2Logo.h"
#else
#define DRV_LOGO_H_FILE                 "mtk/MediaTek_DrvLogo.h"
#endif
#define DRV_POWER_MUSIC_H_FILE          "mtk/mtk_PowerMusic.h"
/*--------- For capture logo end --------*/


/*
 * OD setting
*/
#define DEFAULT_DEMOD_RESET_GPIO    (GPIO(57))   //DEMOD RESET PIN

#define SUPPORT_OD                          (0)

#else /* CONFIG_DEFAULT_H */
#error "Cannot include multi-config files"
#endif /* CONFIG_DEFAULT_H */

