/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
#ifndef VIPER_AUD_H
#define VIPER_AUD_H

#include "aud_if.h"

// Note: AdcMuxSel select which AINx will be used as audio input source
static const AUD_INPUT_MUX_SEL_T _rmt5880m1v2AudInputMuxTable[] =
{   // Input ID                 AdcMuxSel,  SwGpio1,    SwGpio2,    SwGpio3,    SwGpio4
    {AUD_INPUT_ID_COMP_VID_0,   1,    	    SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},    // AV1 audio-in
    {AUD_INPUT_ID_COMP_VID_1,   1,          SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_COMP_VID_2,   NO_USED,    SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_COMP_VID_3,   NO_USED, 	SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_S_VID_0,      NO_USED,    SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_S_VID_1,      NO_USED,    SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_S_VID_2,      NO_USED,    SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_YPBPR_0,      2,          SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},    // YPbPr0, Audio-in, The same with SCART0
    {AUD_INPUT_ID_YPBPR_1,      3,          SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},    // YPbPr1, Audio-in, The same with SCART1
    {AUD_INPUT_ID_YPBPR_2,    	NO_USED, 	SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_VGA_0,        4,          SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},    /// VGA audio-in, The same with DVI&HDMI
    {AUD_INPUT_ID_VGA_1,        NO_USED, 	SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_HDMI_0,       4,          SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_HDMI_1,       4,          SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_HDMI_2,       4,          SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_HDMI_3,       4,          SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_HDMI_4,       4,          SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_DVI_0,        4,          SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},    /// The same with VGA Audioin
    {AUD_INPUT_ID_DVI_1,        NO_USED, 	SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_DVI_2,        NO_USED,    SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_DVI_3,        NO_USED,    SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_DVI_4,        NO_USED,    SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_SCART_0,      3, 		    SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_SCART_1,      NO_USED, 	SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},    // SCART0, The same with YPbPr0.
    {AUD_INPUT_ID_SCART_2,      NO_USED, 	SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},    // SCART1, The same with YPbPr1. //scart0 is used for YPbPr0, so ,when source is scart0 on UI, audio input from scart1 on PCB.
    {AUD_INPUT_ID_SCART_3,      NO_USED, 	SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_AUXIN_0,      NO_USED,    SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_AUXIN_1,      NO_USED,    SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED}
};

static const AUD_INPUT_MUX_SEL_TABLE_T _rViperAudInputMuxTable =
{
    (sizeof(_rmt5880m1v2AudInputMuxTable)/sizeof(AUD_INPUT_MUX_SEL_T)),
    _rmt5880m1v2AudInputMuxTable
};

//-----------------------------------------------------------------------------
// Audio adac input/output format, volume control
//-----------------------------------------------------------------------------
static const AOUT_CFG_T _arSonyAudOutFmtTable =
{
    FORMAT_I2S,              // format of alignment
    DAC_24_BIT,             // number of bits per sample
    LRCK_CYC_32,            // cycles per sample
    MCLK_256FS,             // DAC sampling frequence
    TRUE,                  // Invert audio output for OP phase
    FALSE                  // Invert L/R audio output
};

//-----------------------------------------------------------------------------
// Internal DAC channel config
//-----------------------------------------------------------------------------
static const AUD_INTER_DAC_CFG_T _arViperInterDacUsage =
{
    AUD_CHL_LS_RS,
    AUD_CHL_LS_RS,
    AUD_CHL_L_R,
    AUD_CHL_BYPASS
};


static const AUD_ADAC_USAGE_T _arViperAdacUsage =
{
    AUD_ADAC_NULL,
    AUD_ADAC_NULL,
    AUD_ADAC_NULL,
    AUD_ADAC_NULL,
    AUD_CODEC_MT5398,
    AUD_CODEC_NULL,
    AUD_AMP_NULL,
    AUD_AMP_NULL
};

static const AUD_POST_SM_T _arIrisSoundModeCase[AUD_SOUND_MODE_NUM][AUD_STREAM_FROM_NUM] = 
{
    {//AUD_SOUND_MODE_DYNAMIC
    AUD_SM_CASE0,//AUD_STREAM_FROM_OTHERS
    AUD_SM_CASE2,//AUD_STREAM_FROM_DIGITAL_TUNER
    AUD_SM_CASE1,//AUD_STREAM_FROM_ANALOG_TUNER
    AUD_SM_CASE0,//AUD_STREAM_FROM_SPDIF
    AUD_SM_CASE0,//AUD_STREAM_FROM_LINE_IN
    AUD_SM_CASE0,//AUD_STREAM_FROM_HDMI
    AUD_SM_CASE0,//AUD_STREAM_FROM_MEMORY
    AUD_SM_CASE0,//AUD_STREAM_FROM_BUF_AGT
    AUD_SM_CASE0,//AUD_STREAM_FROM_FEEDER
    AUD_SM_CASE0 //AUD_STREAM_FROM_MULTI_MEDIA
    },
    {//AUD_SOUND_MODE_STANDARD
    AUD_SM_CASE3,//AUD_STREAM_FROM_OTHERS
    AUD_SM_CASE5,//AUD_STREAM_FROM_DIGITAL_TUNER
    AUD_SM_CASE4,//AUD_STREAM_FROM_ANALOG_TUNER
    AUD_SM_CASE3,//AUD_STREAM_FROM_SPDIF
    AUD_SM_CASE3,//AUD_STREAM_FROM_LINE_IN
    AUD_SM_CASE3,//AUD_STREAM_FROM_HDMI
    AUD_SM_CASE3,//AUD_STREAM_FROM_MEMORY
    AUD_SM_CASE3,//AUD_STREAM_FROM_BUF_AGT
    AUD_SM_CASE3,//AUD_STREAM_FROM_FEEDER
    AUD_SM_CASE3 //AUD_STREAM_FROM_MULTI_MEDIA
    },
    {//AUD_SOUND_MODE_CLEAR_VOICE
    AUD_SM_CASE6,//AUD_STREAM_FROM_OTHERS
    AUD_SM_CASE8,//AUD_STREAM_FROM_DIGITAL_TUNER
    AUD_SM_CASE7,//AUD_STREAM_FROM_ANALOG_TUNER
    AUD_SM_CASE6,//AUD_STREAM_FROM_SPDIF
    AUD_SM_CASE6,//AUD_STREAM_FROM_LINE_IN
    AUD_SM_CASE6,//AUD_STREAM_FROM_HDMI
    AUD_SM_CASE6,//AUD_STREAM_FROM_MEMORY
    AUD_SM_CASE6,//AUD_STREAM_FROM_BUF_AGT
    AUD_SM_CASE6,//AUD_STREAM_FROM_FEEDER
    AUD_SM_CASE6 //AUD_STREAM_FROM_MULTI_MEDIA
    },
    {//AUD_SOUND_MODE_CUST
    AUD_SM_CASE9, //AUD_STREAM_FROM_OTHERS
    AUD_SM_CASE11,//AUD_STREAM_FROM_DIGITAL_TUNER
    AUD_SM_CASE10,//AUD_STREAM_FROM_ANALOG_TUNER
    AUD_SM_CASE9, //AUD_STREAM_FROM_SPDIF
    AUD_SM_CASE9, //AUD_STREAM_FROM_LINE_IN
    AUD_SM_CASE9, //AUD_STREAM_FROM_HDMI
    AUD_SM_CASE9, //AUD_STREAM_FROM_MEMORY
    AUD_SM_CASE9, //AUD_STREAM_FROM_BUF_AGT
    AUD_SM_CASE9, //AUD_STREAM_FROM_FEEDER
    AUD_SM_CASE9  //AUD_STREAM_FROM_MULTI_MEDIA
    }
};
#ifdef CC_AUD_USE_FLASH_AQ
static const AUD_AQ_DSCRPT_T _arIrisAudNvmDscrpt[] =
{
#if 1///def CC_SONY_2K13_FLASH_AQ
/// For 2K13 FlashAQ "MTK Function Field" sheet
    ///Common Part = 621
    {AQ_TYPE_VERSION,       "Ver",          8},
    {AQ_TYPE_SRC_VOLUME,    "Src Vol",      7},
    {AQ_TYPE_VOL_TABLE,     "Vol Tab",      303},
    {AQ_TYPE_HP_VOL_TABLE,  "HP Vol",       303},
    ///AQ Part = 2006
    {AQ_TYPE_PEQ,           "Peq",          720},
    {AQ_TYPE_BASS_TREBLE,   "Bass/Tre",     32},
    {AQ_TYPE_VBASS,         "VBass",        112},
    {AQ_TYPE_SPKHEIGHT,     "SpkHght",      16},
    {AQ_TYPE_LOUDNESS,      "Loudness",     25},    ///Change
    {AQ_TYPE_MVS,           "VSurr",        105},
    {AQ_TYPE_MTKDRC,        "MtkDrc",       33},    ///Change
    {AQ_TYPE_AVC,           "AVC",          5},     ///Change
    {AQ_TYPE_LIMITER,       "Limiter",      12},    ///Change
    {AQ_TYPE_BASS_MANAGEMENT,"BassMana",    128},
    {AQ_TYPE_CH_VOLUME,     "Ch Vol G",     50},
    {AQ_TYPE_FIR,           "FIR",          768},   ///Comm+AQ part = 2627
    ///Common + AQ Part = 2627
#else
    {AQ_TYPE_VERSION,    "Ver",        8},
    {AQ_TYPE_SRC_VOLUME, "Src Vol",    7},
    {AQ_TYPE_VOL_TABLE,  "Vol Tab",  303},
    {AQ_TYPE_HP_VOL_TABLE, "HP Vol", 303},
    {AQ_TYPE_LEVEL,      "Level",     48},
    {AQ_TYPE_BASS_TREBLE,"Bass/Tre",  32},
    {AQ_TYPE_PEQ, "Peq",  720},
    {AQ_TYPE_BASS_MANAGEMENT,"BassMana",  128},
    {AQ_TYPE_DRC,        "DRC",      128},
    {AQ_TYPE_AVC,        "AVC",       20},
    {AQ_TYPE_LIMITER,    "Limiter",   48},
    {AQ_TYPE_MVS,        "VSurr",    105},
    {AQ_TYPE_POST,       "PostScl",    6},
    {AQ_TYPE_VBASS,      "VBass",    112},
    {AQ_TYPE_FIR,        "FIR",      768},
    {AQ_TYPE_CH_VOLUME,  "Ch Vol",    50},
    {AQ_TYPE_SPKHEIGHT,  "SpkHght",   16},
    {AQ_TYPE_LOUDNESS,  "Loudness",   20},
#ifdef CC_AUD_MTK_NEW_DRC
    {AQ_TYPE_MTKDRC,  "MtkDrc",   30},
#else
    {AQ_TYPE_MTKDRC,  "MtkDrc",   22},
#endif    
#endif
};
static const UINT8 u1IrisAudAQDscrptSize = sizeof(_arIrisAudNvmDscrpt)/sizeof(AUD_AQ_DSCRPT_T);

/// For 2K13 FlashAQ "AMP Function Field" sheet
static const AUD_AQ_DSCRPT_T _arIrisAmpNvmDscrpt[] =    ///CC_SONY_2K13_FLASH_AQ
{
    ///AMP Function Field
    ///Amp AQ Part = 54
    {AQ_TYPE_LEVEL,         "Level",        48},
    {AQ_TYPE_POST,          "PostScl",      6},
};
static const UINT8 u1IrisAmpAQDscrptSize = sizeof(_arIrisAmpNvmDscrpt)/sizeof(AUD_AQ_DSCRPT_T); ///CC_SONY_2K13_FLASH_AQ
#endif

#if 0//def CC_AUD_USE_FLASH_AQ
static const AUD_AQ_DSCRPT_T _arIrisAudNvmDscrpt[] =
{
    {AQ_TYPE_VERSION,    "Ver",        8},
    {AQ_TYPE_SRC_VOLUME, "Src Vol",    7},
    {AQ_TYPE_VOL_TABLE,  "Vol Tab",  303},
    {AQ_TYPE_HP_VOL_TABLE, "HP Vol", 303},
    {AQ_TYPE_LEVEL,      "Level",     48},
    {AQ_TYPE_BASS_TREBLE,"Bass/Tre",  32},
    {AQ_TYPE_PEQ, "Peq",  720},
    {AQ_TYPE_BASS_MANAGEMENT,"BassMana",  128},
    {AQ_TYPE_DRC,        "DRC",      128},
    {AQ_TYPE_AVC,        "AVC",       20},
    {AQ_TYPE_LIMITER,    "Limiter",   48},
    {AQ_TYPE_MVS,        "VSurr",    105},
    {AQ_TYPE_POST,       "PostScl",    6},
    {AQ_TYPE_VBASS,      "VBass",    112},
    {AQ_TYPE_FIR,        "FIR",      768},
    {AQ_TYPE_CH_VOLUME,  "Ch Vol",    50},
    {AQ_TYPE_SPKHEIGHT,  "SpkHght",   16},
    {AQ_TYPE_LOUDNESS,  "Loudness",   20},
#ifdef CC_AUD_MTK_NEW_DRC
    {AQ_TYPE_MTKDRC,  "MtkDrc",   30},
#else
    {AQ_TYPE_MTKDRC,  "MtkDrc",   22},
#endif    
};
static const UINT8 u1IrisAudAQDscrptSize = sizeof(_arIrisAudNvmDscrpt)/sizeof(AUD_AQ_DSCRPT_T);
#endif //CC_AUD_USE_FLASH_AQ
#endif /* VIPER_AUD_H */

