/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
#include "general.h"
#include "util.h"
#include "pe_if.h"
#include "drv_nr.h"
#include "video_def.h"
#include "drv_video.h"
#include "api_backlt.h"
#include "drv_contrast.h"
#include "api_eep.h"
#include "eepdef.h"
#include "drv_tvd.h"
#include "vdo_misc.h"
#include "vdp_drvif.h"
#include "drv_scpos.h"
#include "eeprom_if.h"
#include "u_drv_cust.h"
#include "drvcust_if.h"
#include "drv_hdtv.h"
#include "drv_mpeg.h"
#include "x_debug.h"
#include "x_hal_5381.h"
#include "drv_vdoclk.h"
#include "drv_adcset.h"
#include "drv_autocolor.h"
#include "source_select.h"
#include "drv_pq_cust.h"
#include "drv_dvi.h"
#include "srm_drvif.h"
#include "drv_meter.h"
#include "drv_od.h"
#include "nptv_debug.h"
#include "panel.h"
#include "drv_lcdim.h"
#include "drv_default.h"
#include "drv_upscaler.h"
#include "drv_tdtv_drvif.h"
#include "hw_ycproc.h"

#include "mtk_video_drv.c"

#define INT32_CLIP(val, min, max) (((val>=max) ? max : ((val<=min) ? min : val)))  

static UINT8 gbSmartPicIndex = 0;
static UINT8 gbSceUi = 0;
static UINT8 gbOdUi = 0;
static UINT8 gbGammaUi = 0;
static UINT16 gu2RawDataTblIndex = 0;
static UINT16 gu2RawDataCaseIndex = 0;

extern MMAppInfo sMMAppInfo;
extern UINT32 u4SCHCCoeff[][SCPQ_COEF_TBLSIZE];
extern UINT32 u4SCHYCoeff[][SCPQ_COEF_TBLSIZE];
extern UINT32 u4SCVYCCoeff[][SCPQ_COEF_TBLSIZE];

//extern PE_UI_RANGE_TBL rPEUITable;
#define EN_PEDASTAL_IN_SUB_PATH 0

UINT16 vApiFlashPqGetSceId()
{
    //This is sample code : SCE ID can be decided 
    //by panel id , ui setting, picture mode .....
    //UINT8 bPanelIdx = GetCurrentPanelIndex();

    switch (gbSceUi)
    {
        case 0:
        default:
            return 0;
    }
}

UINT16 vApiFlashPqGetMinSceId()
{
    //This is sample code : SCE ID can be decided 
    //by panel id , ui setting, picture mode .....
    //UINT8 bPanelIdx = GetCurrentPanelIndex();

    return (1);
}

void vApiFlashPqSetSceId(UINT8 bIndex)
{
    gbSceUi = bIndex;
}

UINT16 vApiFlashPqGetOdId(void)
{
    //UINT8 bPanelIdx = GetCurrentPanelIndex();   
    
    return gbOdUi;
}

void vApiFlashPqSetOdId(UINT8 bIndex)
{
    gbOdUi = bIndex;
}

UINT16 vApiFlashPqGetGammaId()
{
    //This is sample code : GAMMA ID can be deside 
    //by panel id , ui setting, picture mode .....
    //UINT8 bPanelIdx = GetCurrentPanelIndex();

    switch (gbGammaUi)
    {
        case 1:
            return 0;
        case 2:
            return 1;
        case 3:
            return 2;
        default:
    		return 0;
	}

#if 0 // This is sample code for different gamma table under 3D PR Panel
    switch (gbGammaUi)
    {
        case 1:
            // 3D Using Shutter Glass : IS_LVDS_DISP_3D_SHUTTER
            // 3D Using Polarized Panel : IS_LVDS_DISP_3D_POLARIZED
            // 
            // u4DrvTDTV3DModeQuery() : Query 3D Mode
            
            if((u4DrvTDTV3DModeQuery() != E_TDTV_UI_3D_MODE_OFF) && (IS_LVDS_DISP_3D_POLARIZED))
            {               
                return 0;       // gamma table for PR panel
            }
            else
			{
                return 1;       // gamma table for normal state
            }
        default:
    		return 0;
	}
#endif    
}

void vApiFlashPqSetGammaId(UINT8 bIndex)
{
    gbGammaUi = bIndex;
}

UINT16 vApiFlashPqGetQtyId(UINT8 bIndex)
{
	UNUSED(bIndex);
    if (PANEL_GetPanelWidth() <= 1440)
    {
        return (1);
    }
    else
    {
        return (0);
    }
}


void vApiFlashPqSetSmartPicId(UINT8 bIndex)
{
#if 0    
#ifndef CC_DRIVER_PROGRAM    
	static UINT8 bPreNoDropMode=0xFF;  
	UINT8 bCurNoDropMode;
	UINT8 i4UiIndex, j;
	PE_UI_RANGE_T rUiVqMinMaxDft;

	Printf("Smart Pic XXXXX %d\n", bIndex);
#endif
#endif

    gbSmartPicIndex = bIndex;
#if 0
#ifndef CC_DRIVER_PROGRAM
#ifdef __KERNEL__   
	ASSERT(rPEUITable.ptUiPicMinMaxDftTbl!=NULL && gbSmartPicIndex<rPEUITable.bSmartPicNum);   
	// update all source UI default table, since the table is same
	for (i4UiIndex = 0; i4UiIndex < (UINT8)EVDP_VIS_MAX; i4UiIndex++)
	{
		for(j=0; j< rPEUITable.bUIPQItemNum; j++)
		{
			if(rPEUITable.ptUiPicMinMaxDftTbl[gbSmartPicIndex][j].rPQItemType >=PE_ARG_BRIGHTNESS &&
				rPEUITable.ptUiPicMinMaxDftTbl[gbSmartPicIndex][j].rPQItemType < PE_ARG_NS)
			{
/*				printf("rPEUITable.ptUiPicMinMaxDftTbl[%d][%d].rPQItemType| %x, Min %x, Max %x, Dft %x \n", gbSmartPicIndex,j,rPEUITable.ptUiPicMinMaxDftTbl[gbSmartPicIndex][j].rPQItemType,
					rPEUITable.ptUiPicMinMaxDftTbl[gbSmartPicIndex][j].rPQItemRange.i4Min, rPEUITable.ptUiPicMinMaxDftTbl[gbSmartPicIndex][j].rPQItemRange.i4Max,
					rPEUITable.ptUiPicMinMaxDftTbl[gbSmartPicIndex][j].rPQItemRange.i4Dft);
*/
				PE_SetUiRange(i4UiIndex, rPEUITable.ptUiPicMinMaxDftTbl[gbSmartPicIndex][j].rPQItemType, 
														 &(rPEUITable.ptUiPicMinMaxDftTbl[gbSmartPicIndex][j].rPQItemRange));
			}
		}
}
#endif
#endif
#endif
}

UINT8 vApiFlashPqGetSmartPicId()
{
    return (gbSmartPicIndex);
}

UINT16 u2ApiFlashPqGetRawDataTblId(void)
{
    return gu2RawDataTblIndex;
}

UINT16 u2ApiFlashPqGetRawDataCaseId(void)
{
    return gu2RawDataCaseIndex;
}

void vApiFlashPqSetRawDataTblId(UINT16 u2Index)
{
    gu2RawDataTblIndex = u2Index;
}

void vApiFlashPqSetRawDataCaseId(UINT16 u2Index)
{
    gu2RawDataCaseIndex = u2Index;
}

UINT8 bApiFlashPqUpdateRawDataEx(UINT16 u2TblId, UINT16 u2CaseId)
{
    vApiFlashPqSetRawDataTblId(u2TblId);
    vApiFlashPqSetRawDataCaseId(u2CaseId);

    return bApiFlashPqUpdateRawData();
}

void DRVCUST_HwInit(void)
{
    return;
}

void DRVCUST_VideoInit(void)
{
    DRVCUST_AdaptiveBacklightInit();
#ifdef SUPPORT_AMBI_GLOW
    vIO32WriteFldAlign(AMBILRATIO, 0x140, AMBL_SAT_GAIN);
#endif
    return;
}
void DRVCUST_HUPSCaleCoeff(UINT8 bPath)
{

    UINT8 bHCoeffIdx;
	UINT32 dwScHIn = u4IO32Read4B(SCALER_COEF_MAIN_H_IN);
	UINT32 dwScHOut= u4IO32Read4B(SCALER_COEF_MAIN_H_OUT);
		
    static UINT8 bPreHCoeffIdx = 0xFF;
	
    if(bPath!=SV_VP_MAIN)
        return;

	//	bHCoeffIdx
	//		0: up scaling
	//		1: down scaling 1.5
	//		2: down scaling 2
	//		3: down scaling 3
	//		4: down scaling 4
	//		5: down scaling 5
 
	bHCoeffIdx = (dwScHOut>=dwScHIn)?0: // upscaling only 1 hw default tbl
			  (dwScHOut*9<dwScHIn*2)?5: // DS ratio > 4.5 use 5
			  (dwScHOut*7<dwScHIn*2)?4: // DS ratio > 3.5 use 4
			  (dwScHOut*5<dwScHIn*2)?3: // DS ratio > 2.5 use 3
			  (dwScHOut*3<dwScHIn*2)?2: // DS ratio > 1.75 use 2
			  (1);						// DS ratio < 1.75 use 1.5

    if(!bIsScalerInput444(bPath)) // 422 mode Y/C needs different coeff
    {
			if(bPreHCoeffIdx!=bHCoeffIdx)
			{
				bPreHCoeffIdx = bHCoeffIdx;
		        vDrvSCPQSetSramCoeff(COEFTYP_HOR_Y,u4SCHYCoeff[bHCoeffIdx]);
		        vDrvSCPQSetSramCoeff(COEFTYP_HOR_C,u4SCHCCoeff[bHCoeffIdx]);
			}
	}
    else // 444 mode Y/C use same coeff
    {
        // turn off sram coeff, Both HY, HC use Hw SC_H_COEF_TABLE_SEL default coeff tbls 
        // when SC_H_422_MODE_EN_1 is 0
        vIO32WriteFldAlign(SCPIP_SCCTRL1_07, bHCoeffIdx, SCCTRL1_07_SC_H_COEF_TABLE_SEL);
        //vIO32WriteFldAlign(SCPIP_SCCTRL1_33, bHCoeffIdx, SCCTRL2_13_SC_HC_COEF_TABLE_SEL);
        vIO32WriteFldAlign(SCFIR_0C, SV_OFF, H_SRAM_COEFF_EN); 
    }
    return;

}

void DRVCUST_VUPSCaleCoeff(UINT8 bPath)
{

    UINT8 bVCoeffIdx;
    UINT8 bLineInterleave;
	UINT32 dwScVIn = u4IO32Read4B(SCALER_COEF_MAIN_V_IN);
	UINT32 dwScVOut= u4IO32Read4B(SCALER_COEF_MAIN_V_OUT);		
    //static UINT8 bPreVCoeffIdx = 0xFF;
	UINT8 bPingPongMode = IO32ReadFldAlign(SCPIP_SCCTRL1_04, SCCTRL1_04_SC_COEF_PP_ENABLE);
    UINT8 bPingPongWRTVC = IO32ReadFldAlign(SCPIP_SCCTRL1_05, SCCTRL1_05_SC_COEF_PP_RD_A);
    UINT32   u4SCL  = u4DrvTDTVScalerModeQuery();
    E_TD_OUT eSCLOut= TD_SCL_OUT(u4SCL);
    E_TD_IN  eSCLIn = TD_SCL_IN(u4SCL);
	
    if(bPath!=SV_VP_MAIN)
        return;
	
	//scaler out line interleave or not
	bLineInterleave =((E_TD_OUT_3D_LI==eSCLOut)||
					 ((E_TD_IN_LI_P==eSCLIn)&&(E_TD_OUT_NATIVE==eSCLOut))); 

     //  bVCoeffIdx
     //   0: up scaling
     //   1: down scaling 1.5
     //   2: down scaling 2
     //   3: down scaling 3
     //   4: down scaling 4
     //   5: down scaling 5

    bVCoeffIdx = ((dwScVOut>=dwScVIn) && (!bLineInterleave))?0: // upscaling only 1 hw default tbl
    		  	  (dwScVOut>=dwScVIn)?6: // upscaling use 4 taps tbl
	              (dwScVOut*9<dwScVIn*2)?5: // DS ratio > 4.5 use 5
	              (dwScVOut*7<dwScVIn*2)?4: // DS ratio > 3.5 use 4
	              (dwScVOut*5<dwScVIn*2)?3: // DS ratio > 2.5 use 3
	              (dwScVOut*3<dwScVIn*2)?2: // DS ratio > 1.75 use 2
	              (1);                      // DS ratio < 1.75 use 1.5	

        //Use Hw default coeff tbl          
        //vIO32WriteFldAlign(SCFIR_0C, SV_OFF, V_SRAM_COEFF_EN);
        //vIO32WriteFldAlign(SCPIP_SCCTRL1_07, bVCoeffIdx, SCCTRL1_07_SC_V_COEF_TABLE_SEL);
        if(bPingPongMode)
        {
            //Ping-pong R/W VYC same tbl         
            vDrvSCPQSetSramCoeff(((bPingPongWRTVC)?COEFTYP_VER_C:COEFTYP_VER_Y), 
                                                          u4SCVYCCoeff[bVCoeffIdx]);
            vIO32WriteFldAlign(SCPIP_SCCTRL1_05, (!bPingPongWRTVC), SCCTRL1_05_SC_COEF_PP_RD_A);
        }
        else
        {
			vDrvSCPQSetSramCoeff(COEFTYP_VER_C, u4SCVYCCoeff[0]);
		}

    return;
}
void DRVCUST_VdoModeChgDone(UINT8 bPath)
{
    UNUSED(bPath);
    return;
}

UINT8 DRVCUST_IsEnablePedastal(UINT8 bPath)
{

    UINT32 u4SrcType = bGetSignalType(bPath);
    
    if (u4SrcType == SV_ST_TV || u4SrcType == SV_ST_AV)
    {
        if((GET_MATRIX_PED) && (bPath == SV_VP_MAIN))   
        {
            return SV_TRUE;
        }
        else if(bPath == SV_VP_PIP && EN_PEDASTAL_IN_SUB_PATH)
        {
            return SV_TRUE;
        }
    }
    
    return SV_FALSE;
}
void DRVCUST_VideoMainloop()
{
    DRVCUST_AdaptiveBacklightProc();
}

void DRVCUST_OutVSyncISR()
{
#ifdef SUPPORT_AMBI_GLOW
    vDrvAmbiGlowProc();
#endif
    return;
}

void DRVCUST_VdoInISR()
{
    return;
}

UINT32 DRVCUST_RGBOfstRemap(UINT32 u4Value)
{
    return u4Value<<2;
}

UINT16 DRVCUST_Y2RMap(void)
{
    //HSI SPEC change , Always -16 For video mode / Special Mode , 
    //because of DEMO Mode Support
    return  0;
}

/* @ Auto NR default Initial setting
 *      1: low
 *      2: Middle
 */
UINT8 DRVCUST_AutoNRDefSet(void)
{
    return 2;
}

/* @ Auto NR noise level implement
 * @ return noise level
 */
UINT8 DRVCUST_NoiseLevel(void)
{
#if 0
    UINT8 bNoiseLevel = NM_INVALIDLEVEL;
    UINT8 bRFNMLevel;

    if((bGetVideoDecType(bDrvNRGetCurrentPath())==SV_VD_TVD3D)&&
        	 (bGetSignalType(bDrvNRGetCurrentPath())==SV_ST_TV))// TVD RF source
    {

        bRFNMLevel = bTvdSignalStrengthLevel(1);   //RF level 0 ~ 80

        if(bRFNMLevel > 75)
        {
            bNoiseLevel = NM_LEVEL1_3;
        }
        else if(bRFNMLevel > 69)
        {
            bNoiseLevel = NM_LEVEL2;
        }
        else if(bRFNMLevel > 59)
        {
            bNoiseLevel = NM_LEVEL3;
        }
        else if(bRFNMLevel > 55)
        {
            bNoiseLevel = NM_LEVEL4;
        }
        else
        {
            bNoiseLevel = NM_LEVEL5;
        }
    }
    else
    {
        bNoiseLevel = vDrvNMLevel();   //content NR, Noise level 0 ~ 4
    }
    
    return bNoiseLevel;
#endif
    return 0;
}

void DRVCUST_PANEL_GAMMA_REMAP(UINT32 u4GammaSel)
{
    UNUSED(u4GammaSel);
}

void DRVCUST_SetBlackLvlCtrl(UINT8 bPath)
{    
#if 0 // Below is SAMPLE CODE for function customization.
    UINT8 bLevel = GET_BLK_LVL(bPath);
    if (bPath == SV_VP_MAIN)
    {
        if(fgIsMainDVI())
    {
        SET_MATRIX_PED(SV_OFF);
            switch (bLevel)
            {
                case SV_OFF:
                    vSetHDMIRangeMode(SV_HDMI_RANGE_FORCE_FULL);
                    break;
                case SV_ON:
                    vSetHDMIRangeMode(SV_HDMI_RANGE_FORCE_LIMIT);
                    break;
                default:
                    vSetHDMIRangeMode(SV_HDMI_RANGE_FORCE_AUTO);
                    break;                
            }
        }
        else if (fgIsMainTvd3d() || fgIsMainYPbPr())
        {
            SET_MATRIX_PED(bLevel);
            vSetHDMIRangeMode(SV_HDMI_RANGE_FORCE_AUTO);
        }
        else
        {
            SET_MATRIX_PED(SV_OFF);
            vSetHDMIRangeMode(SV_HDMI_RANGE_FORCE_AUTO);
        }
    }
    else
    {
        SET_MATRIX_PED(SV_OFF);
        vSetHDMIRangeMode(SV_HDMI_RANGE_FORCE_AUTO);
    }
#endif
}

UINT32 DRVCUST_HDMIRange(UINT8 bPath)
{
    return (bDviIsVideoTiming() ? SV_HDMI_RANGE_LIMIT : SV_HDMI_RANGE_FULL);
}

UINT32 DRVCUST_GetOSMatrix709(UINT8 bPath)
{
    UINT32 u4Matrix709;

#if 1
    u4Matrix709 = GET_MATRIX_HD_709 && (wDrvVideoInputHeight(bPath) >= 720);
#else
    UINT32 u4ScrTiming = bDrvVideoGetSourceTypeTiming(bPath);
    u4Matrix709 = ((u4ScrTiming >= SOURCE_TYPE_TIMING_MM_SD_I) && (u4ScrTiming <= SOURCE_TYPE_TIMING_MM_1080IP_HD)) ? 
                    SV_FALSE : (GET_MATRIX_HD_709 && (wDrvVideoInputHeight(bPath) >= 720));
#endif
    return u4Matrix709;

}

UINT8 DRVCUST_MMAPPGetTiming(UINT8 bOutputTiming)
{
    if (sMMAppInfo.u1AppType == 0xFF) //Pretend for Netflix App
    {
        // Temp threshold
        bOutputTiming = (sMMAppInfo.u4BitRate < 100) ?  
            SOURCE_TYPE_TIMING_MM_720P_SD : SOURCE_TYPE_TIMING_MM_720P_HD;
    }

    LOG(5, "DRVCUST_MMAPPGetTiming %d %d\n", sMMAppInfo.u4BitRate, bOutputTiming);

    return (bOutputTiming);
}

extern OD_PARAM_T _ODParam;
void DRVCUST_SetODTable(void)
{
    //get OD table from flashPQ
    bApiFlashPqUpdateOD();

    //change OD table DMA, only support OD
//    vDrvODSetDMA(OD_TABLE_CONFIG,OD_Table,sizeof(OD_Table));
    vDrvODMode(_ODParam.u1OD_ON);
    
    //channge OD table in Vsync
    //vApiRegisterVideoEvent(PE_EVENT_OD, SV_VP_MAIN, SV_ON);
}

#define MAUNAL_GAMMA_STEP 4
#define MAUNAL_GAMMA_UI_OFFSET 0
UINT32 iCtlValue[3][11];
void DRVCUST_SET_MAUNAL_GAMMA(INT32 i4GammaCtrlPts[3][11])
{
    UINT32 i;
    const UINT8 GAMMA_NUM = 11;
    const INT32 i4LinearGamma[11] = {0, 416, 816, 1232, 1632, 2048, 2464, 2864, 3280, 3680, 4096};//allencyhsu 20131225

    for (i = 0; i < GAMMA_NUM; i++)
    {
        iCtlValue[0][i] = INT32_CLIP(i4LinearGamma[i] + ((i4GammaCtrlPts[0][i] - MAUNAL_GAMMA_UI_OFFSET) * MAUNAL_GAMMA_STEP), 0, 4095);
        iCtlValue[1][i] = INT32_CLIP(i4LinearGamma[i] + ((i4GammaCtrlPts[1][i] - MAUNAL_GAMMA_UI_OFFSET) * MAUNAL_GAMMA_STEP), 0, 4095);
        iCtlValue[2][i] = INT32_CLIP(i4LinearGamma[i] + ((i4GammaCtrlPts[2][i] - MAUNAL_GAMMA_UI_OFFSET) * MAUNAL_GAMMA_STEP), 0, 4095);
    }

    for (i = 0; i < GAMMA_NUM; i++)
    {
        vIO32Write2B(GAMMA_MAUNAL_REMAP_R_00 + i * 2, iCtlValue[0][i]);
        vIO32Write2B(GAMMA_MAUNAL_REMAP_G_00 + i * 2, iCtlValue[1][i]);
        vIO32Write2B(GAMMA_MAUNAL_REMAP_B_00 + i * 2, iCtlValue[2][i]);
    }
}

void DRVCUST_SET_GAMMA(void)
{
    /* ============================= Sample code ===================================
    
    1. Read gamma data from EEPROM, maybe need some check flow
        => Example 8bit 6 control points with 12bit gamma data
        INT32 iCtlPos[6] =   {0x000, 0x020, 0x040, 0x080, 0x0C0, 0x0FF};
        INT32 iCtlValue_R[6] = {0x013, 0x233, 0x3E5, 0x7C4, 0xB20, 0xEF4};

    2. Interplaotion to 257 red gamma table
        static INT32 OutputLut[257];
        vDrvGammaInterpolation(6, iCtlPos, iCtlValue_R, OutputLut);        

    3. Copy 257 data to u2GammaDecodedTable[] 
        
    ============================= Sample code End ===================================*/        
}

void DRVCUST_AutoColorTempUpdate(AUTO_COLORTEMP_SETS_INFO_T *aCTInfo)
{

}

void DRVCUST_MMAPProc(void)
{
    if (sMMAppInfo.u1AppType == 0xFF) /*Pretend for Netflix App */
    {
        //Update new QtyTbl
        bApiVideoProc(SV_VP_MAIN, PE_ARG_3D_NR);
        bApiVideoProc(SV_VP_MAIN, PE_ARG_NR);
        bApiVideoProc(SV_VP_MAIN, PE_ARG_MPEG_NR);
        bApiVideoProc(SV_VP_MAIN, PE_ARG_SHARPNESS);
    }
}

void DRVCUST_GetLcdimPanelOrder(UINT8 *u1PanelOrder, UINT8 u1BlockNum)
{
	UINT8 bIndex;
	UINT16 i;
    bIndex = GetCurrentPanelIndex();

    if(bIndex == PANEL_EPI_LGDV12GIPFHD120)          // 1 * 12, LGD protocal
    {
        UINT8 u1PanelOrderCust[12] = {0, 2, 4, 6, 8, 10, 11, 9, 7, 5, 3, 1};      // MTK IC HW Sequence            
        x_memcpy(u1PanelOrder, u1PanelOrderCust, sizeof(u1PanelOrderCust));
    }   
    else if(bIndex == PANEL_LG_47_EUH_PR)          // 8 * 2, AMS protocal
    {
        UINT8 u1PanelOrderCust[16] = {0, 15, 1, 14, 2, 13, 3, 12, 4, 11, 5, 10, 6, 9, 7, 8};      // MTK IC HW Sequence
        x_memcpy(u1PanelOrder, u1PanelOrderCust, sizeof(u1PanelOrderCust));
    }       
    else
    {
        for(i = 0; i < u1BlockNum; i++)
        {
            u1PanelOrder[i] = i;
        }
    }        
    
    LOG(0, "Panel Order = ");
    
    for(i = 0; i < u1BlockNum; i++)
    {
        LOG(0, "%d  ", u1PanelOrder[i]);
    }    
}

void DRVCUST_GetLcdimPanelDimGain(UINT8 *u1PanelDimGain, UINT8 u1BlockNum)
{
	UINT8 bIndex;
	UINT16 i;
    bIndex = GetCurrentPanelIndex();

    if(bIndex == PANEL_EPI_LGDV12GIPFHD120)          // 1 * 12, LGD protocal
    {
        UINT8 u1PanelDimGainCust[12] = {0x98, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x98};
        x_memcpy(u1PanelDimGain, u1PanelDimGainCust, sizeof(u1PanelDimGainCust));
    }
    else if(bIndex == PANEL_LG_47_EUH_PR)          // 8 * 2, AMS protocal
    {
        UINT8 u1PanelDimGainCust[16] = {0xFF, 0xFF, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0xFF, 0xFF};
        x_memcpy(u1PanelDimGain, u1PanelDimGainCust, sizeof(u1PanelDimGainCust));
    }       
    else
    {
        for(i = 0; i < u1BlockNum; i++)
        {
            u1PanelDimGain[i] = 0x80;   //0x80 means gain 1
        }
    }        
    
    LOG(0, "Panel Dim Gain = ");
    
    for(i = 0; i < u1BlockNum; i++)
    {
        LOG(0, "%d  ", u1PanelDimGain[i]);
    }    
}

void DRVCUST_GetLcdimPanelDelay(UINT8 *u1PanelDelay, UINT8 u1BlockNum)
{
    UINT8 bIndex;
    UINT16 i;
    bIndex = GetCurrentPanelIndex();

    if(bIndex == PANEL_LG_47_EUH_PR)
    {

        UINT8 u1PanelDelayCust[16] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15};
        x_memcpy(u1PanelDelay, u1PanelDelayCust, sizeof(u1PanelDelayCust));
    }   
    else
    {
        for(i = 0; i < u1BlockNum; i++)
        {
            u1PanelDelay[i] = 0;
        }
    }        
}

void DRVCUST_PqModeChange(UINT8 bPath)
{
    UINT32 i;
    
    for (i=0; i < (UINT8)PE_ARG_NS; i++)
    {
        switch (i)
        {
            // List all the quality items that do not update after mode change done.
            //  the back light is not relative to video timing, nor main/pip change.
            case PE_ARG_ADAPTIVE_BACK_LIGHT:
            case PE_ARG_BACK_LIGHT_LVL:
                break;
            default:
                UNUSED(bApiVideoProc(bPath, (PE_ARG_TYPE)i));
                break;
        }
    }
}
/***************************************************************************/
/******************************* AMBI-GLOW *********************************/
/***************************************************************************/

#ifdef SUPPORT_AMBI_GLOW

typedef enum
{
	RGB_ITEM_R1,
    RGB_ITEM_G1,
    RGB_ITEM_B1,
    RGB_ITEM_R2,
    RGB_ITEM_G2,
    RGB_ITEM_B2,    
	RGB_ITEM_MAX,
} RGB_QUE_ITEM;

UINT32 RGBDataQue[RGB_ITEM_MAX][256];
UINT32 RGBQueCounter[RGB_ITEM_MAX] = {0, 0, 0, 0, 0, 0};

UINT32 u4ReturnRGBQueAverage(UINT32 dwValue, UINT8 bItem)
{
	UINT32 bi;
	UINT32 PWMAverage=0;
	UINT32 RGBQueSize = IO32ReadFldAlign(OPC_0E, RUN_QUE_SIZE);

    if(RGBQueSize == 0)
    {
        RGBQueSize = 1;
    }

	if (RGBQueCounter[bItem] == 0)
	{
		RGBQueCounter[bItem]++;
		RGBDataQue[bItem][0] = dwValue;
		return dwValue;
	}

	if (RGBQueCounter[bItem] < RGBQueSize)
	{
		RGBQueCounter[bItem]++;

	}
	else
	{
        RGBQueCounter[bItem] = RGBQueSize;
	}

	for (bi = RGBQueCounter[bItem] - 1; bi > 0 ; bi--)
	{
		RGBDataQue[bItem][bi] = RGBDataQue[bItem][bi - 1];
	}

	// Insert New Item
	RGBDataQue[bItem][0] = dwValue;

	// Average Running Que
	for (bi = 0; bi < RGBQueCounter[bItem]; bi++)
	{
		PWMAverage += RGBDataQue[bItem][bi];
	}

	PWMAverage = PWMAverage / RGBQueCounter[bItem];

	return PWMAverage;
}


#ifdef AbsDiff
#undef AbsDiff
#endif
#define AbsDiff(a, b)  (((a)>(b)) ? ((a)-(b)) : ((b)-(a)))

UINT16 u4SatHist[8] = {0,0,0,0,0,30961,0,0};
UINT16 u4SatBound[9] = {0,1,4,9,20,36,54,80,80};

UINT16 u4HueHist[8] = {0,0,0,0,0,0,30961,0};
UINT16 u4HueBound[8] = {32, 64, 96, 128, 160, 192, 224, 0};

//sin(0 deg ~ 90 deg) = 0 ~ (2 ^ 14 = 16384)
INT32 const COLOR_TRANSFORM_HUE[129] =
{
    0,201,402,603,803,1004,1205,1405,               
    1605,1805,2005,2204,2404,2602,2801,2998,        
    3196,3393,3589,3785,3980,4175,4369,4563,        
    4756,4948,5139,5329,5519,5708,5896,6083,        
    6269,6455,6639,6822,7005,7186,7366,7545,        
    7723,7900,8075,8249,8423,8594,8765,8934,        
    9102,9268,9434,9597,9759,9920,10079,10237,      
    10393,10548,10701,10853,11002,11150,11297,11442,
    11585,11726,11866,12003,12139,12273,12406,12536,
    12665,12791,12916,13038,13159,13278,13395,13510,
    13622,13733,13842,13948,14053,14155,14255,14353,
    14449,14543,14634,14723,14810,14895,14978,15058,
    15136,15212,15286,15357,15426,15492,15557,15618,
    15678,15735,15790,15842,15892,15940,15985,16028,
    16069,16107,16142,16175,16206,16234,16260,16284,
    16305,16323,16339,16353,16364,16372,16379,16382,
    16384
};

UINT32 u4GetMainHue(UINT16 *u2Hist, UINT16 *u2Bound)
{
    UINT32 HueResult0_3 = 0, HueResult4_7 = 0, HueResult = 0;
    UINT32 u2HistSumHalf0_3 = u2Hist[0]  +  u2Hist[1]  +  u2Hist[2]  +  u2Hist[3] + u2Hist[7];
    UINT32 u2HistSumHalf4_7 =  u2Hist[4] + u2Hist[5]  +  u2Hist[6];    
    UINT32 u2HistSum = u2Hist[0]  +  u2Hist[1]  +  u2Hist[2]  +  u2Hist[3] + u2Hist[4]  +  u2Hist[5]  +  u2Hist[6]  +  u2Hist[7];
   
    
    if(u2HistSumHalf0_3 != 0)
    {
        HueResult0_3 = (u2Hist[0] * u2Bound[0] +  u2Hist[1] * u2Bound[1] +  u2Hist[2] * u2Bound[2] +  u2Hist[3] * u2Bound[3] +   u2Hist[7] * u2Bound[7]) / u2HistSumHalf0_3;
    }
    
    if(u2HistSumHalf4_7 != 0)
    {
        HueResult4_7 = (u2Hist[4] * u2Bound[4] + u2Hist[5] * u2Bound[5] +  u2Hist[6] * u2Bound[6]) / u2HistSumHalf4_7; 
    }

    if(u2HistSum != 0)
    {
        if((HueResult4_7 - HueResult0_3) > 128)
        {
            HueResult = ((( HueResult0_3 + 256 ) * u2HistSumHalf0_3) + (HueResult4_7 * u2HistSumHalf4_7)) / u2HistSum;            
        }
        else
        {
            HueResult = (( HueResult0_3  * u2HistSumHalf0_3) + (HueResult4_7 * u2HistSumHalf4_7)) / u2HistSum;

        }
    }

   
    HueResult = HueResult % 256;
    

    return (HueResult << 1);
}

UINT32 u4GetAverageHue(UINT16 *u2Hist, UINT16 *u2Bound)
{
	UINT32 i, HueSum = 0, TotalPxlCnt = 0, HueResult = 0;

	for(i = 0; i < 8; i++)
	{
		HueSum += u2Hist[i] * u2Bound[i];
		TotalPxlCnt += u2Hist[i];
	}
	if(TotalPxlCnt != 0)
	{
    	HueResult = (HueSum * 2) / TotalPxlCnt;
	}

	return HueResult;
}

UINT32 u4GetAverageSat(UINT16 *u2Hist, UINT16 *u2Bound)
{
	UINT32 i, SatSum = 0, TotalPxlCnt = 0, SatResult = 0;

	for(i = 0; i < 8; i++)
	{
		SatSum += ((u2Bound[i]+u2Bound[i+1])>>1) * u2Hist[i];
		TotalPxlCnt += u2Hist[i];
	}

	if(TotalPxlCnt != 0)
	{	
    	SatResult = SatSum / TotalPxlCnt;
	}

	return SatResult;
}

UINT8 u1HueHistCenter[8] = {16, 48, 80, 112, 144, 176, 208, 240};

UINT8 u1RemmapedSatGain[256] = {
0	,	0	,	0	,	0	,	0	,	0	,	0	,	0	,
2	,	4	,	6	,	8	,	10	,	12	,	14	,	16	,
19	,	22	,	25	,	28	,	31	,	34	,	37	,	40	,
44	,	48	,	52	,	56	,	60	,	64	,	68	,	72	,
77	,	82	,	87	,	92	,	97	,	102	,	107	,	112	,
118	,	124	,	130	,	136	,	142	,	148	,	154	,	160	,
167	,	174	,	181	,	188	,	195	,	202	,	209	,	216	,
224	,	232	,	240	,	248	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
};


UINT8 u1RemmapedSatGainWeighted[256] = {
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
251, 247, 243, 239, 235, 231, 227, 223, 219, 215, 211, 207, 203, 199, 195, 191,
187, 183, 179, 175, 171, 167, 163, 159, 155, 151, 147, 143, 139, 135, 131, 127,
123, 119, 115, 111, 107, 103, 99, 95, 91, 87, 83, 79, 75, 71, 67, 63,
57, 53, 49, 45, 41, 37, 33, 30, 30, 30, 30, 30, 30, 30, 30, 30,
30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30,
30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30,
30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30,
30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30,
30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30,
};


UINT32 u4HueProtectOnDistr(UINT32 u4Hue, UINT16 *u2Hist)
{
    UINT8 i;
    UINT32 u4HueDiff;
    UINT32 u4Distribution = 0;
    UINT32 u2HistSum = u2Hist[0]  +  u2Hist[1]  +  u2Hist[2]  +  u2Hist[3] + u2Hist[4]  +  u2Hist[5]  +  u2Hist[6]  +  u2Hist[7];    
    static UINT32 u4LogCnt = 0;

    u4Hue = u4Hue >> 1;


    for(i = 0; i < 8; i++)
    {
        if(AbsDiff(u4Hue, u1HueHistCenter[i]) > 128)
        {
            u4HueDiff = (AbsDiff(MIN(u4Hue, u1HueHistCenter[i]) + 256, MAX(u4Hue, u1HueHistCenter[i]))) % 256;
        }
        else
        {
            u4HueDiff = AbsDiff(u4Hue, u1HueHistCenter[i]);
        }
        u4Distribution += u4HueDiff * u2Hist[i];
    }

    if(u2HistSum == 0)
    {
        return 0;
    }
    
    u4Distribution = (u4Distribution * 0xFF) / ( u2HistSum * 64 );

    if((u4LogCnt ++ % 121) == 0)
    { 
        Printf("u4Distribution = %d, u4Hue = %d\n", u4Distribution, u4Hue);
        Printf("u2Hist[0] = %d, u2Hist[1] = %d, u2Hist[2] = %d, u2Hist[3] = %d, u2Hist[4] = %d, u2Hist[5] = %d, u2Hist[6] = %d, u2Hist[7] = %d\n", 
            u2Hist[0],u2Hist[1],u2Hist[2],u2Hist[3],u2Hist[4],u2Hist[5],u2Hist[6],u2Hist[7]);
    }


    if(u4Distribution > 255){u4Distribution = 255;}

    

    return u1RemmapedSatGainWeighted[u4Distribution];
}

UINT32 u4HueProtect(UINT32 u4Hue, UINT16 *u2Hist)
{
    UINT32 u2HistSum = u2Hist[0]  +  u2Hist[1]  +  u2Hist[2]  +  u2Hist[3] + u2Hist[4]  +  u2Hist[5]  +  u2Hist[6]  +  u2Hist[7];
    UINT32 u4SpecifiedSum;
    UINT32 u4MainVectorRatio;
    
    static UINT32 u4LogCnt = 0;

    UINT8 i;

    u4Hue = (u4Hue >> 1);

    if((u4Hue >= u1HueHistCenter[7]) || (u4Hue < u1HueHistCenter[0]))
    {
        u4SpecifiedSum = u2Hist[7];
    }
    else
    {
        for(i = 0; i < 7; i++)
        {
            if((u4Hue >= u1HueHistCenter[i]) && (u4Hue < u1HueHistCenter[i+1]))
            {
                u4SpecifiedSum = u2Hist[i];            
            }
        }
    }

    if(u2HistSum != 0)
    {
        u4MainVectorRatio = (u4SpecifiedSum * 0xFF) / u2HistSum;
    }
    else
    {
        u4MainVectorRatio = 0;
    }

    if((u4LogCnt ++ % 120) == 0)
    { 
        Printf("u4SpecifiedSum = %d, u2HistSum = %d, u4MainVectorRatio = %d RemappedGain = %d\n", u4SpecifiedSum, u2HistSum, u4MainVectorRatio, u1RemmapedSatGain[u4MainVectorRatio]);
    }

    return u1RemmapedSatGain[u4MainVectorRatio];
}

UINT8 u1MaxLumaofHue[16] = {29/*BLUE*/,51,102,56,46/*RED*/,79,114,173,204/*YELLOW*/,178,163,152,193/*CYAN*/,152,71,38};
UINT8 u1LumaWeightArray[16] =     {0, 32, 64, 96, 128, 160, 192, 208, 208, 208, 208, 208, 208, 208, 208, 208};

UINT32 u4RemmapLuma(UINT8 u1RGBMax, UINT8 u1APL, UINT32 u4Hue, UINT32 u4Sat)
{
    UINT8 u1LumaWeight = u1LumaWeightArray[u4Sat>>4]; ; 
    UINT32 RemmapedY;
	UINT32 YOffset = IO32ReadFldAlign(AMBILRATIO_2, AMBIL_Y_OFST);	    
    static UINT32 u4LogCnt = 0;     
#if 0
    RemmapedY = ((((UINT32)u1APL * (UINT32)u1MaxLumaofHue[u4Hue>>5] * (UINT32)u1LumaWeight)/0xFF)+
                ((UINT32)u1RGBMax * (UINT32)(0xFF-u1LumaWeight)))/0xFF;

    // patch for cyan
    if((u4Hue > CYAN_LOWER_BOUND) &&(u4Hue < CYAN_UPPER_BOUND))
    {
        YOffset = (((CYAN_UPPER_BOUND - CYAN_LOWER_BOUND)/2) - AbsDiff(u4Hue, (CYAN_LOWER_BOUND+CYAN_UPPER_BOUND)/2 ))*2;
    }
    
#else
    UNUSED(u1APL);
    RemmapedY = ((((UINT32)u1RGBMax * (UINT32)u1MaxLumaofHue[u4Hue>>5] * (UINT32)u1LumaWeight)/0xFF)+
                ((UINT32)u1RGBMax * (UINT32)(0xFF-u1LumaWeight)))/0xFF;
#endif


    if((u4LogCnt ++ % 121) == 0)
    { 
        Printf("RemmapedY = %d\n", RemmapedY);
    }    
    
    return MIN((RemmapedY+YOffset), 255);
}

#define HUE_REMAP_START 320
#define HUE_REMAP_END   HUE_REMAP_START+128

UINT32 u4HueRemap[128] = {320, 322, 324, 326, 328, 330, 332, 334, 336, 338, 340, 342, 344, 346, 348, 350, 
                          352, 354, 356, 358, 360, 362, 364, 366, 368, 370, 372, 374, 376, 378, 380, 382, 
                          384, 386, 388, 390, 392, 394, 396, 398, 400, 400, 401, 401, 402, 402, 403, 403, 
                          404, 404, 405, 405, 406, 406, 407, 407, 408, 408, 409, 409, 410, 410, 410, 411, 
                          411, 412, 412, 413, 413, 414, 414, 415, 415, 416, 416, 417, 417, 418, 418, 419, 
                          419, 420, 420, 421, 421, 422, 422, 423, 423, 424, 424, 425, 425, 426, 426, 426, 
                          427, 427, 428, 428, 429, 429, 430, 430, 431, 431, 432, 432, 433, 433, 434, 434, 
                          435, 435, 436, 436, 437, 437, 438, 439, 440, 441, 442, 443, 444, 445, 446, 447};

UINT32 u4HueRemapping(UINT32 u4Hue)
{
    if((u4Hue >= HUE_REMAP_START) && (u4Hue < HUE_REMAP_END))
    {
        u4Hue = u4HueRemap[u4Hue-HUE_REMAP_START];
    }

    return u4Hue;
}

// 1024 as 1.0
void vConvertYSH2RGB(INT32 u4Y, INT32 u4Cb, INT32 u4Cr,
						INT32 *u4R, INT32 *u4G, INT32 *u4B)
{
	*u4R = ((1187 * u4Y + 1638 * u4Cr) >> 10) - 18;
	*u4G = ((1187 * u4Y - 399 * u4Cb - 834*u4Cr) >> 10) - 18;
	*u4B = ((1187 * u4Y + 2068 * u4Cb) >> 10) - 18;
}

UINT16 u2LeftWindow[4] = {0, 0, 319, 1079};
UINT16 u2RightWindow[4] = {1600, 0, 1919, 1079};

void vDrvAmbiGlowProc(void)
{
	INT32 i4Cb, i4Cr;
	UINT32 u4Hue, u4Sat, u4PxlCnt, u4R, u4G, u4B;
	INT32 i4SinTheta, i4CosTheta;
	INT32 i4Y = 128;//IO32ReadFldAlign(TEMP_APL_VAL, TEMP_APL_VAL0);
	UINT8 u1Y[6];
	UINT8 u1APL = bDrvGetAPL();
	UINT8 u1LumaRgbRatio = IO32ReadFldAlign(AMBILRATIO, LUMA_RGB_RATIO);
	UINT8 u1SatControlBypass = IO32ReadFldAlign(AMBILRATIO, SAT_PROT_BYP);
    UINT8 u1LumaControlBypass = IO32ReadFldAlign(AMBILRATIO, LUMA_CTRL_BYP);
    UINT8 u1HueControlBypass = IO32ReadFldAlign(AMBILRATIO, HUE_CTRL_BYP);    
	UINT8 u1SatControlModul = IO32ReadFldAlign(AMBILRATIO, SAT_PROT_MODULE);	
	UINT32 u4SatGain = IO32ReadFldAlign(AMBILRATIO, AMBL_SAT_GAIN);	
	UINT32 HOffset = IO32ReadFldAlign(AMBILRATIO_2, AMBIL_H_OFST);	 
	
	INT32 i4R, i4G, i4B;
	static UINT8 u1CurrentSide = 0; // 0 : Left / 1 : right
	static UINT32 u4LogCnt = 0;

    vDrvGetHueHistHW();
    vDrvGetSatHistHW();
    u1DrvGetSatHist(u4SatHist, 0);
    u1DrvGetHueHist(u4HueHist, &u4PxlCnt, 0);    
    vDrvGetLcDimAverageResult(u1Y);
	// hue range : 0 ~ 511
//	u4Hue = u4GetAverageHue(u4HueHist, u4HueBound);	
	u4Hue = u4GetMainHue(u4HueHist, u4HueBound);	
	
	// sat range : 0 ~ 255
	u4Sat = u4GetAverageSat(u4SatHist, u4SatBound);

    if(u1SatControlBypass==0)
    {
        if(u1SatControlModul == 1)
        {
            u4Sat = (u4Sat * u4HueProtect(u4Hue, u4HueHist))/0xFF;
            u4Sat = ( u4Sat * u4SatGain ) / 0xFF;
        }
        else
        {
            u4Sat = (u4Sat * u4HueProtectOnDistr(u4Hue, u4HueHist))/0xFF;
            u4Sat = ( u4Sat * u4SatGain ) / 0xFF;
        }
    }

    if(u1HueControlBypass==0)
    {   
        u4Hue = u4HueRemapping(u4Hue);
    }
    else
    {
        u4Hue = (u4Hue + HOffset)%512;
    }
	
	// sin / cos range : 0 ~ (+/-)16384
	if(u4Hue <= 0x80)
	{
		i4SinTheta = COLOR_TRANSFORM_HUE[u4Hue];
		i4CosTheta = COLOR_TRANSFORM_HUE[0x80 - u4Hue];
	}
	else if(u4Hue <= 0x100)
	{
		i4SinTheta = COLOR_TRANSFORM_HUE[0x100 - u4Hue];
		i4CosTheta = -COLOR_TRANSFORM_HUE[u4Hue - 0x80];
	}
	else if(u4Hue <= 0x180)
	{
		i4SinTheta = -COLOR_TRANSFORM_HUE[u4Hue - 0x100];
		i4CosTheta = -COLOR_TRANSFORM_HUE[0x180 - u4Hue];
	}
	else // if(u4Hue < 0x200)
	{
		i4SinTheta = -COLOR_TRANSFORM_HUE[0x200 - u4Hue];
		i4CosTheta = COLOR_TRANSFORM_HUE[u4Hue - 0x180];
	}	  

	i4Cb = ((INT32)u4Sat * i4CosTheta) >> 14;
	i4Cr = ((INT32)u4Sat * i4SinTheta) >> 14;

	if(u1CurrentSide == 0)
	{
	    if(u1LumaControlBypass)
	    {
            i4Y = (u1Y[u1CurrentSide] * ( 0xFF - u1LumaRgbRatio ) + (u1APL * u1LumaRgbRatio)) / 0xFF;
	    }
	    else
	    {
            i4Y = u4RemmapLuma(u1Y[u1CurrentSide], u1APL, u4Hue, u4Sat);
	    }
	}
	else
	{
	    if(u1LumaControlBypass)
	    {
            i4Y = (u1Y[5] * ( 0xFF - u1LumaRgbRatio ) + (u1APL * u1LumaRgbRatio)) / 0xFF;
	    }
	    else
	    {
            i4Y = u4RemmapLuma(u1Y[5], u1APL, u4Hue, u4Sat);
	    }
	}

	vConvertYSH2RGB(i4Y, i4Cb, i4Cr, &i4R, &i4G, &i4B);

    i4R = (i4R > 255) ? 255 : i4R;
    i4R = (i4R <=  0) ? 0   : i4R;    
    i4G = (i4G > 255) ? 255 : i4G;
    i4G = (i4G <=  0) ? 0   : i4G;    
    i4B = (i4B > 255) ? 255 : i4B;
    i4B = (i4B <=  0) ? 0   : i4B;        
	
	u4R = (UINT32)i4R << 2;
	u4G = (UINT32)i4G << 2;
	u4B = (UINT32)i4B << 2;

    if((u4LogCnt ++ % 121) == 0)
    { 
        Printf("u4Sat = %d, u4Hue = %d\n", u4Sat, u4Hue);
    }

   
    if(u1CurrentSide == 0)
    {
        u4R = u4ReturnRGBQueAverage(u4R, RGB_ITEM_R1);
        u4G = u4ReturnRGBQueAverage(u4G, RGB_ITEM_G1);
        u4B = u4ReturnRGBQueAverage(u4B, RGB_ITEM_B1); 
        
        vDrvSetSatHueHistWindow(u2RightWindow);       
        vRegWriteFldAlign(WINDOW_00, ((u4R>>1) << 20) | ((u4G>>1) << 10) | (u4B>>1), WINDOW_COLOR1);
        u1CurrentSide = 1;        
    }
    else
    {
        u4R = u4ReturnRGBQueAverage(u4R, RGB_ITEM_R2);
        u4G = u4ReturnRGBQueAverage(u4G, RGB_ITEM_G2);
        u4B = u4ReturnRGBQueAverage(u4B, RGB_ITEM_B2);        

        vDrvSetSatHueHistWindow(u2LeftWindow);
        vRegWriteFldAlign(WINDOW_01, ((u4R>>1) << 20) | ((u4G>>1) << 10) | (u4B>>1), WINDOW_COLOR2);
        u1CurrentSide = 0;
    }	
}

#endif
