/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
/*-----------------------------------------------------------------------------
 *
 * $Author: dtvbm11 $
 * $Date  $
 * $RCSfile: drv_pwm.h,v $
 * $Revision: #1 $
 *
 *---------------------------------------------------------------------------*/

#ifndef DRV_PWM_H
#define DRV_PWM_H


//-----------------------------------------------------------------------------
// Include files
//-----------------------------------------------------------------------------

#include "x_typedef.h"
#include "x_bim.h"

//-----------------------------------------------------------------------------
// Constant definitions
//-----------------------------------------------------------------------------

#define SrcPWM0 0
#define SrcPWM1 1
#define SrcPWM2 2
#define SrcPWM3 3
#define SrcPWM4 4
#define SrcPWM5 5
#define SrcPWM6 6

#define MINILVDS_IS_HSYNC 0
#define MINILVDS_IS_VSYNC 1

#ifdef CUST_SOEM_DRV
#define SCAN_PWM_LATCH_MODE_SETDATA_OFF     0
#define SCAN_PWM_LATCH_MODE_SETDATA         1
#define SCAN_PWM_LATCH_MODE_OFF             0
#define SCAN_PWM_LATCH_MODE_ON              1
#define SCAN_PWM_ALIGN_MODE_ONCE            0
#define SCAN_PWM_ALIGN_MODE_VSYNC           1
#endif

#if defined(CC_MT5880)
//OPWM0
#define PAD_PWM0_PWM0 	0	//FUNC1 
#define PAD_PWM0_GPIO4  1	//FUNC1

//OPWM1
#define PAD_PWM1_PWM1 	0	//FUNC1 
#define PAD_PWM1_GPIO5  1	//FUNC1
//OPWM2
#define PAD_PWM2_PWM2 	0	//FUNC1 

#elif defined(CC_MT5398)
//OPWM0
#define PAD_PWM0_PWM0 	0	//FUNC2 
//OPWM1
#define PAD_PWM1_PWM1 	0	//FUNC2 (FUNC3 SCANPWM)
#define PAD_PWM1_GPIO48 1	//FUNC1
//OPWM2
#define PAD_PWM2_PWM2 	0	//FUNC2 

#elif defined(CC_MT5396)
//OPWM0
#define PAD_PWM0_PWM0 	0	//FUNC2 
//OPWM1
#define PAD_PWM1_PWM1 	0	//FUNC2 (FUNC3 SCANPWM)
#define PAD_PWM1_GPIO48 1	//FUNC1
//OPWM2
#define PAD_PWM2_PWM2 	0	//FUNC2

#elif defined(CC_MT5389)
//OPWM0
#define PAD_PWM0_GPIO3  0	//FUNC1	//opwm0
#define PAD_PWM0_OSDA0  1	//FUNC3
//OPWM1
#define PAD_PWM1_IF_AGC 0	//FUNC2	//opwm1
#define PAD_PWM1_OSCL0  1	//FUNC3
//OPWM2
#define PAD_PWM2_PWM0 	0	// FUNC1	//opwm2

#else	//defined(CC_MT5368)
//OPWM0
#define PAD_PWM0_PWM0 	0	// FUNC1
#define PAD_PWM0_GPIO4  1	//FUNC1
#define PAD_PWM0_OSDA0  2	//FUNC3
//OPWM1
#define PAD_PWM1_PWM1 	0	// FUNC1 ( FUNC2 SCANPWM)
#define PAD_PWM1_GPIO5  1	//FUNC1
#define PAD_PWM1_GPIO8  2	//FUNC1
#define PAD_PWM1_IF_AGC 3	//FUNC2
#define PAD_PWM1_OSCL0  4	//FUNC3
//OPWM2
#define PAD_PWM2_PWM2 	0	//FUNC1
#endif

#define SCAN_PWM_LATCH_MODE_OFF             0
#define SCAN_PWM_LATCH_MODE_ON              1

#define vDrvSetScan1Start(u4Val) vIO32WriteFldAlign(PWM_SCAN_00, u4Val, REG_PWM_SCAN1_START)
#define vDrvSetScan1High(u4Val) vIO32WriteFldAlign(PWM_SCAN_01, u4Val, REG_PWM_SCAN1_HIGH)
#define vDrvSetScan1Low(u4Val) vIO32WriteFldAlign(PWM_SCAN_02, u4Val, REG_PWM_SCAN1_LOW)
#define vDrvSetScan2Start(u4Val) vIO32WriteFldAlign(PWM_SCAN_03, u4Val, REG_PWM_SCAN2_START)
#define vDrvSetScan2High(u4Val) vIO32WriteFldAlign(PWM_SCAN_04, u4Val, REG_PWM_SCAN2_HIGH)
#define vDrvSetScan2Low(u4Val) vIO32WriteFldAlign(PWM_SCAN_05, u4Val, REG_PWM_SCAN2_LOW)
// MT5396/68 New feature for ECO
#define vDrvSetScan3Start(u4Val) vIO32WriteFldAlign(PWM_SCAN_07, u4Val, REG_PWM_SCAN3_START)
#define vDrvSetScan3High(u4Val) vIO32WriteFldAlign(PWM_SCAN_08, u4Val, REG_PWM_SCAN3_HIGH)
#define vDrvSetScan3Low(u4Val) vIO32WriteFldAlign(PWM_SCAN_09, u4Val, REG_PWM_SCAN3_LOW)
#define vDrvSetScan4Start(u4Val) vIO32WriteFldAlign(PWM_SCAN_0A, u4Val, REG_PWM_SCAN4_START)
#define vDrvSetScan4High(u4Val) vIO32WriteFldAlign(PWM_SCAN_0B, u4Val, REG_PWM_SCAN4_HIGH)
#define vDrvSetScan4Low(u4Val) vIO32WriteFldAlign(PWM_SCAN_0C, u4Val, REG_PWM_SCAN4_LOW)
#define vDrvSetScan5Start(u4Val) vIO32WriteFldAlign(PWM_SCAN_0D, u4Val, REG_PWM_SCAN5_START)
#define vDrvSetScan5High(u4Val) vIO32WriteFldAlign(PWM_SCAN_0E, u4Val, REG_PWM_SCAN5_HIGH)
#define vDrvSetScan5Low(u4Val) vIO32WriteFldAlign(PWM_SCAN_0F, u4Val, REG_PWM_SCAN5_LOW)
// MT5398 new feature
#define vDrvSetScan6Start(u4Val) vIO32WriteFldAlign(PWM_SCAN_23, u4Val, REG_PWM_SCAN6_START)
#define vDrvSetScan6High(u4Val) vIO32WriteFldAlign(PWM_SCAN_24, u4Val, REG_PWM_SCAN6_HIGH)
#define vDrvSetScan6Low(u4Val) vIO32WriteFldAlign(PWM_SCAN_25, u4Val, REG_PWM_SCAN6_LOW)

//-----------------------------------------------------------------------------
// Public functions
//-----------------------------------------------------------------------------

extern void vDrvSetPWM(UINT32 u4Src, UINT32 u4TimeBase, UINT32 u4DutyON,
                       UINT32 u4DutyAll);
void vDrvSetLock(UINT32 u4Src, UINT32 u4LockON);
UINT8 vDrvGetPWMDutyCycleRatio(void);
void vDrvInitSCANPWM(UINT8 u1Src);
void vDrvSetScanPWM(UINT8 u1Src, UINT32 u4Start, UINT32 u4High, UINT32 u4Low);
void vDrvSetScanPWMPolarity(UINT32 u4Src, UINT8 u1blPol);
void vDrvSetScanPWMOnOff(UINT32 u4Src, UINT8 u1OnOff);
void vDrvSetScanPWMLatchMode(UINT8 u1Mode);
void vDrvSetScanPWMOutBL(UINT32 u4Src, UINT8 u1OutBL);
void vDrvSetScanBLPolarity(UINT8 u1blPol);
void vDrvSetScanBLOnOff(UINT8 u1OnOff);
void vDrvSetScanBLLatchMode(UINT8 u1Mode);

void vDrvSetISOnOff(UINT8 u1Src, UINT8 u1OnOff);
void vDrvSetISMaskNum(UINT8 u1Src, UINT8 u1MaskNum);
void vDrvSetISInputInverse(UINT8 u1Src, UINT8 u1Enable);
void vDrvSetISDelayOnOff(UINT8 u1Src, UINT8 u1OnOff);
void vDrvSetISDelayNum(UINT8 u1Src, UINT16 u2DelayNum);
void vDrvSetISHoldOnOff(UINT8 u1Src, UINT8 u1OnOff);
void vDrvSetISRelation(UINT8 u1Src, UINT8 u1SyncCnt, UINT8 u1ISSyncCnt);
extern void PWM_pm_str_suspend(void);
extern void PWM_pm_str_resume(void);


#endif
