/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
#ifndef MTK_AUD_H
#define MTK_AUD_H

#include "aud_if.h"

//-----------------------------------------------------------------------------
// Audio input SW
//-----------------------------------------------------------------------------

#ifdef AUDIO_INPUT_SW_GPIO_SEL_DEFAULT
static const AUD_INPUT_SW_GPIO_T _arMtkInputSwGpio =
{
    UNUSED_GPIO,                         // AUD_GPIO_SWITCH_0       17
    UNUSED_GPIO,                         // AUD_GPIO_SWITCH_0 15
    UNUSED_GPIO,
    UNUSED_GPIO
};
#endif

#ifdef AUDIO_INPUT_MUX_SEL_TABLE_DEFAULT
static const AUD_INPUT_MUX_SEL_T _arMtkAudInputMux[] =
{
    // Input ID             AdcMuxSel,    SwGpio1,    SwGpio2,    SwGpio3,    SwGpio4
    {AUD_INPUT_ID_COMP_VID_0,    3,      SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_COMP_VID_1,    4,      SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_COMP_VID_2,    NO_USED,      SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_COMP_VID_3, NO_USED,  SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_S_VID_0,          6,      SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_S_VID_1,       NO_USED,    SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_S_VID_2,       NO_USED,    SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_YPBPR_0,          5,  SW_NO_USED,SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_YPBPR_1,          NO_USED,             SW_NO_USED, SW_NO_USED,SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_YPBPR_2,     NO_USED,  SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_VGA_0,             2,             SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_VGA_1,       NO_USED,  SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_HDMI_0,           NO_USED,  SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_HDMI_1,     NO_USED,   SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_HDMI_2,     NO_USED,   SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_HDMI_3,     NO_USED,   SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_HDMI_4,     NO_USED,   SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_DVI_0,             NO_USED,  SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_DVI_1,           NO_USED,  SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_DVI_2,      NO_USED,   SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_DVI_3,      NO_USED,   SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_DVI_4,      NO_USED,   SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_SCART_0,         0,   SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_SCART_1,         1,   SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_SCART_2,         NO_USED,  SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_SCART_3,         NO_USED,  SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_AUXIN_0,      2,   SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_AUXIN_1,      NO_USED,   SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED}
};

static const AUD_INPUT_MUX_SEL_TABLE_T _rMtkAudInputMuxTable =
{
    (sizeof(_arMtkAudInputMux)/sizeof(AUD_INPUT_MUX_SEL_T)),
    _arMtkAudInputMux
};
#endif

//-----------------------------------------------------------------------------
// Audio adac input/output format, volume control
//-----------------------------------------------------------------------------
#ifdef AUDIO_OUT_FMT_TABLE_DEFAULT
static const AOUT_CFG_T _arMtkAudOutFmtTable =
{
#ifdef CC_FPGA
    FORMAT_RJ,              // format of alignment
#else
    FORMAT_I2S,              // format of alignment
#endif
    DAC_24_BIT,             // number of bits per sample
    LRCK_CYC_32,            // cycles per sample
    MCLK_256FS,             // DAC sampling frequence
    FALSE,                  // Invert audio output for OP phase
    FALSE                    // Invert L/R audio output
};
#endif

#ifdef AUDIO_OUT_FMT_TABLE2_DEFAULT
static const AOUT_CFG_T _arMtkAudOutFmtTable2 =
{
#ifdef CC_FPGA
    FORMAT_RJ,              // format of alignment
#else
    FORMAT_I2S,              // format of alignment
#endif
    DAC_24_BIT,             // number of bits per sample
    LRCK_CYC_32,            // cycles per sample
    MCLK_256FS,             // DAC sampling frequence
    FALSE,                  // Invert audio output for OP phase
    FALSE                    // Invert L/R audio output
};
#endif

#ifdef AUDIO_IN_FMT_TABLE_DEFAULT
#ifndef __MODEL_slt__
static const AOUT_CFG_T _arMtkAudInFmtTable =
{
    FORMAT_I2S,             // format of alignment
    DAC_24_BIT,             // number of bits per sample
    LRCK_CYC_32,            // cycles per sample
    MCLK_256FS,             // DAC sampling frequence
    FALSE,                  // Invert audio output for OP phase
    TRUE                    // Invert L/R audio output
};
#else
static const AOUT_CFG_T _arMtkAudInFmtTable =
{
    FORMAT_I2S,             // format of alignment
    DAC_24_BIT,             // number of bits per sample
    LRCK_CYC_32,            // cycles per sample
    MCLK_256FS,             // DAC sampling frequence
    FALSE,                  // Invert audio output for OP phase
    TRUE                    // Invert L/R audio output
};
#endif  // __MODEL_slt__
#endif

//-----------------------------------------------------------------------------
// Audio adjustable volume
//-----------------------------------------------------------------------------

#define VOL_SHM_0_DB        (0x20000)
#define VOL_SHM_NEG_6_DB    (0x20000/2)
#define VOL_SHM_NEG_12_DB   (0x20000/4)

#ifdef AUDIO_INPUT_SRC_VOL_DEFAULT
static const INT16 _aai2MtkAudInputSrcVol[AUD_DEC_NUM][AUD_STREAM_FROM_NUM] =
{
    //Others   DTV       ATV       SPDIF     LINE_IN   HDMI      MEMORY    BUFF_AGT  FEEDER    MM
    {VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB},
    {VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB}
};
#endif

#ifdef AUDIO_INPUT_SRC_LINE_OUT_VOL_DEFAULT
static const INT16 _aai2MtkAudInputSrcLineOutVol[AUD_DEC_NUM][AUD_STREAM_FROM_NUM] =
{
    //Others   DTV       ATV       SPDIF     LINE_IN   HDMI      MEMORY    BUFF_AGT  FEEDER    MM
    {VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB},
    {VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB}
};
#endif

#ifdef AUDIO_INPUT_SRC_AGC_VOL_DEFAULT
static const UINT32 _aau4MtkAudInputSrcAgcVol[AUD_DEC_NUM][AUD_STREAM_FROM_NUM] =
{
    //Others       DTV           ATV           SPDIF         LINE_IN       HDMI          MEMORY        BUFF_AGT      FEEDER        MM
    {VOL_SHM_0_DB, VOL_SHM_0_DB, VOL_SHM_0_DB, VOL_SHM_0_DB, VOL_SHM_0_DB, VOL_SHM_0_DB, VOL_SHM_0_DB, VOL_SHM_0_DB, VOL_SHM_0_DB, VOL_SHM_0_DB},
    {VOL_SHM_0_DB, VOL_SHM_0_DB, VOL_SHM_0_DB, VOL_SHM_0_DB, VOL_SHM_0_DB, VOL_SHM_0_DB, VOL_SHM_0_DB, VOL_SHM_0_DB, VOL_SHM_0_DB, VOL_SHM_0_DB}
};
#endif

#ifdef AUDIO_INPUT_SRC_AGC_FLAG_DEFAULT
static const BOOL _aafgMtkAudInputSrcAgcFlag[AUD_DEC_NUM][AUD_STREAM_FROM_NUM] =
{
    {TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE},
    {TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE}
};
#endif

#ifdef AUDIO_AV_INPUT_SRC_VOL_DEFAULT
static const INT16 _ai2MtkAudAvInputSrcVol[AUD_INPUT_ID_MAX] =
    {   VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB,
        VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB
    };
#endif

//-----------------------------------------------------------------------------
// Channel volume extra gain
//-----------------------------------------------------------------------------
#ifdef AUDIO_CHL_VOL_EXTRA_GAIN_DEFAULT
// Table value: dB value for 0.5dB/step
// Range: -64dB (-64*2) ~ 47.5dB (47.5*2)
// Ex: +5dB => table value = 5*2 = 10
//     : -4dB => table value = -4*2 = -8
// Note: data may saturate if extra gain is larger than 0dB
static const INT8 _aai1MtkAudChVolExtraGain[AUD_DEC_NUM][AUD_CH_NUM] =
{
    //AUD_DEC_MAIN
      //L      R         SL        SR        Center    Subwoofer BypassL   BypassR   DownmixL  DownmixR
    {VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB},
    //AUD_DEX_AUX
      //L      R
    {VOL_0_DB, VOL_0_DB}
};
#endif

#ifdef AUDIO_CHL_VOL_EXTRA_GAIN_NON_LINE_IN_DEFAULT
// Table value: dB value for 0.5dB/step
// Range: -64dB (-64*2) ~ 47.5dB (47.5*2)
// Ex: +5dB => table value = 5*2 = 10
//     : -4dB => table value = -4*2 = -8
// Note: data may saturate if extra gain is larger than 0dB
static const INT8 _aai1MtkAudChVolExtraGainNonLineIn[AUD_DEC_NUM][AUD_CH_NUM] =
{
    //AUD_DEC_MAIN
      //L      R         SL        SR        Center    Subwoofer BypassL   BypassR   DownmixL  DownmixR
    {VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB},
    //AUD_DEX_AUX
      //L      R
    {VOL_0_DB, VOL_0_DB}
};
#endif

//-----------------------------------------------------------------------------
// AVC
//-----------------------------------------------------------------------------
#ifdef AUDIO_AVC_TARGET_LEV_DEFAULT
static const INT16 _ai2MtkAudAvcTarget[AUD_STREAM_FROM_NUM] =
{
    -20,        // OTHERS
    -20,        // DIGITAL_TUNER
    -20,        // ANALOG_TUNER
    -20,        // SPDIF
    -20,        // LINE_IN
    -20,        // HDMI
    -20,        // MEMORY
    -20,        // BUF_AGT
    -20,        // FEEDER
    -20,        // MM
};
#endif

#ifdef AUDIO_AVC_GAIN_UP_DEFAULT
static const INT16 _ai2MtkAudAvcGainUp[AUD_STREAM_FROM_NUM] =
{
    6,        // OTHERS
    6,        // DIGITAL_TUNER
    6,        // ANALOG_TUNER
    6,        // SPDIF
    6,        // LINE_IN
    6,        // HDMI
    6,        // MEMORY
    6,        // BUF_AGT
    6,        // FEEDER
    6,        // MM
};
#endif

#ifdef AUDIO_AVC_ADJUST_RATE_DEFAULT
static const INT16 _ai2MtkAudAvcAdjRate[AUD_STREAM_FROM_NUM] =
{
    0x80,        // OTHERS
    0x80,        // DIGITAL_TUNER
    0x80,        // ANALOG_TUNER
    0x80,        // SPDIF
    0x80,        // LINE_IN
    0x80,        // HDMI
    0x80,        // MEMORY
    0x80,        // BUF_AGT
    0x80,        // FEEDER
    0x80,        // MM
};
#endif

#ifdef AUDIO_AVC_UI_ADJUST_RATE_DEFAULT
static const INT16 _ai2MtkAudAvcUiAdjRate[AUD_STREAM_FROM_NUM] =
{
    0x80,        // OTHERS
    0x80,        // DIGITAL_TUNER
    0x80,        // ANALOG_TUNER
    0x80,        // SPDIF
    0x80,        // LINE_IN
    0x80,        // HDMI
    0x80,        // MEMORY
    0x80,        // BUF_AGT
    0x80,        // FEEDER
    0x80,        // MM
};
#endif

//-----------------------------------------------------------------------------
// Volume table
//-----------------------------------------------------------------------------
#ifdef AUDIO_VOL_TABLE_DEFAULT
#if 1
static const UINT32 _au4VolumeTable[100 + 1] =
{

//  1~9
    0x0000000, 0x0000020, 0x0000030, 0x0000050,0x0000070, 0x00000C0, 0x0000120, 0x00001A0,
    0x0000250, 0x0000340,

//10~14,2db,-41db~-33db
    0x0000490, 0x00005C0, 0x0000740, 0x0000920, 0x0000B70,

//15~26,1db,-31db~-20db
    0x0000E70, 0x0001030, 0x0001230, 0x0001460,
    0x00016E0, 0x00019B0, 0x0001CD0, 0x0002050, 0x0002440, 0x00028B0, 0x0002DA0, 0x0003330,

//27~45,0.5db,-19db~-10db
    0x0003970, 0x0003CE0, 0x0004070,
    0x0004440, 0x0004850, 0x0004CA0, 0x0005120, 0x00055F0, 0x0005B10, 0x0006070, 0x0006630,
    0x0006C30, 0x00072A0, 0x0007970, 0x00080A0, 0x0008840, 0x0009050, 0x00098E0, 0x000A1F0,

//46~67,0.25db,-9.5db~-4.25
    0x000AB80, 0x000B080, 0x000B5B0,
    0x000BB00, 0x000C070, 0x000C610, 0x000CBD0, 0x000D1D0, 0x000D7F0, 0x000DE30, 0x000E4B0,
    0x000EB60, 0x000F240, 0x000F950, 0x00100A0, 0x0010820, 0x0010FD0, 0x00117C0, 0x0011FF0,
    0x0012850, 0x0013100, 0x00139E0,

//68~100,0.125dB,-4db~0db
    0x0014310, 0x00147C0, 0x0014C80, 0x0015150, 0x0015630,
    0x0015B20, 0x0016030, 0x0016550, 0x0016A70, 0x0016FC0, 0x0017510, 0x0017A70, 0x0017FF0,
    0x0018580, 0x0018B30, 0x00190E0, 0x00196B0, 0x0019C90, 0x001A290, 0x001A8A0, 0x001AED0,
    0x001B510, 0x001BB60, 0x001C1D0, 0x001C850, 0x001CEF0, 0x001D5A0, 0x001DC70, 0x001E360,
    0x001EA60, 0x001F180, 0x001F8B0, 0x0020000,
};

static const UINT32 _au4ChannelVolumeTable[100 + 1] =
{

//  1~9
    0x0000000, 0x0000020, 0x0000030, 0x0000050,0x0000070, 0x00000C0, 0x0000120, 0x00001A0,
    0x0000250, 0x0000340,

//10~14,2db,-41db~-33db
    0x0000490, 0x00005C0, 0x0000740, 0x0000920, 0x0000B70,

//15~26,1db,-31db~-20db
    0x0000E70, 0x0001030, 0x0001230, 0x0001460,
    0x00016E0, 0x00019B0, 0x0001CD0, 0x0002050, 0x0002440, 0x00028B0, 0x0002DA0, 0x0003330,

//27~45,0.5db,-19db~-10db
    0x0003970, 0x0003CE0, 0x0004070,
    0x0004440, 0x0004850, 0x0004CA0, 0x0005120, 0x00055F0, 0x0005B10, 0x0006070, 0x0006630,
    0x0006C30, 0x00072A0, 0x0007970, 0x00080A0, 0x0008840, 0x0009050, 0x00098E0, 0x000A1F0,

//46~67,0.25db,-9.5db~-4.25
    0x000AB80, 0x000B080, 0x000B5B0,
    0x000BB00, 0x000C070, 0x000C610, 0x000CBD0, 0x000D1D0, 0x000D7F0, 0x000DE30, 0x000E4B0,
    0x000EB60, 0x000F240, 0x000F950, 0x00100A0, 0x0010820, 0x0010FD0, 0x00117C0, 0x0011FF0,
    0x0012850, 0x0013100, 0x00139E0,

//68~100,0.125dB,-4db~0db
    0x0014310, 0x00147C0, 0x0014C80, 0x0015150, 0x0015630,
    0x0015B20, 0x0016030, 0x0016550, 0x0016A70, 0x0016FC0, 0x0017510, 0x0017A70, 0x0017FF0,
    0x0018580, 0x0018B30, 0x00190E0, 0x00196B0, 0x0019C90, 0x001A290, 0x001A8A0, 0x001AED0,
    0x001B510, 0x001BB60, 0x001C1D0, 0x001C850, 0x001CEF0, 0x001D5A0, 0x001DC70, 0x001E360,
    0x001EA60, 0x001F180, 0x001F8B0, 0x0020000,
};

#else
//20050510,kevin,large mode
WORD code VOLUME[VOL_LEVEL_MAX + 1] =
{

//  0~10
    0x000000, 0x000003, 0x000006,
    0x00000C, 0x000015, 0x000025, 0x000041, 0x00005C, 0x000082,
    0x0000B7, 0x000103,

// 11~20,1db -27db~-18db
    0x00016E, 0x00019B, 0x0001CD, 0x000205, 0x000244, 0x00028B, 0x0002DA, 0x000333,
    0x000397, 0x000407,

// 21~33,0.5db -17db~-11db
    0x000485, 0x0004CA, 0x000512, 0x00055F, 0x0005B1, 0x000607, 0x000663,
    0x0006C3, 0x00072A, 0x000797, 0x00080A, 0x000884,0x000905,

//34~51,0.25db -11db~-6.25db
    0x00098E, 0x0009D5,
    0x000A1F, 0x000A6A, 0x000AB8, 0x000B08, 0x000B5B,
    0x000BB0, 0x000C07, 0x000C61, 0x000CBD, 0x000D1D, 0x000D7F, 0x000DE3, 0x000E4B,
    0x000EB6, 0x000F24, 0x000F95,

//52~67  ,0.125db -6db~-4.125
    0x00100A, 0x001045, 0x001082, 0x0010BF, 0x0010FD,
    0x00113C, 0x00117C, 0x0011BD, 0x0011FF, 0x001241, 0x001285, 0x0012CA, 0x001310,
    0x001356, 0x00139E, 0x0013E7,

//68~100,0.125dB,-4db~0db
    0x001431, 0x00147C, 0x0014C8, 0x001515, 0x001563,
    0x0015B2, 0x001603, 0x001655, 0x0016A7, 0x0016FC, 0x001751, 0x0017A7, 0x0017FF,
    0x001858, 0x0018B3, 0x00190E, 0x00196B, 0x0019C9, 0x001A29, 0x001A8A, 0x001AED,
    0x001B51, 0x001BB6, 0x001C1D, 0x001C85, 0x001CEF, 0x001D5A, 0x001DC7, 0x001E36,
    0x001EA6, 0x001F18, 0x001F8B, 0x002000,
};
#endif
#endif

#ifdef AUDIO_SRS_PEQ_COEF_DEFAULT
///MT5395 use 48K    DSP_SUPPORT_SRS_SSHD
static const UINT32 _arSRSPEQHPFCoef_DEF[3][40+10+10] =
{
        //32k
        {
                //--0--
                0x3bf14b, 0xff867061, 0xffc40eb5, 0x798f9f, 0x400000,
                //--1--
                0x3bf14b, 0xff867061, 0xffc40eb5, 0x798f9f, 0x400000,
                //--2--
                0x3d07cd, 0xff843c85, 0xffc2f833, 0x7bc37b, 0x400000,
                //--3--
                0x3d07cd, 0xff843c85, 0xffc2f833, 0x7bc37b, 0x400000,
                //--4--
                0x3bf14b, 0xff867061, 0xffc40eb5, 0x798f9f, 0x400000,
                //--5--
                0x3bf14b, 0xff867061, 0xffc40eb5, 0x798f9f, 0x400000,
                //--6--
                0x3d07cd, 0xff843c85, 0xffc2f833, 0x7bc37b, 0x400000,
                //--7--
                0x3d07cd, 0xff843c85, 0xffc2f833, 0x7bc37b, 0x400000,
                //HPF1
                0x000ff4a8, 0xffe016b0, 0xffc05aa1, 0x7fa51e, 0x000ff4a8,
                //HPF2
                0x000ff4a8, 0xffe016b0, 0xffc05aa1, 0x7fa51e, 0x000ff4a8,
        },
        //44k
        {
                //--0--
                0x3d07cd, 0xff843c85, 0xffc2f833, 0x7bc37b, 0x400000,
                //--1--
                0x3d07cd, 0xff843c85, 0xffc2f833, 0x7bc37b, 0x400000,
                //--2--
                0x3f9aea, 0xff8087db, 0xffc0765f, 0x7f7825, 0x3feeb7,
                //--3--
                0x3fa063, 0xff80a480, 0xffc0842f, 0x7f5b80, 0x3fdb6e,
                //--4--
                0x3d07cd, 0xff843c85, 0xffc2f833, 0x7bc37b, 0x400000,
                //--5--
                0x3d07cd, 0xff843c85, 0xffc2f833, 0x7bc37b, 0x400000,
                //--6--
                0x3f9aea, 0xff8087db, 0xffc0765f, 0x7f7825, 0x3feeb7,
                //--7--
                0x3fa063, 0xff80a480, 0xffc0842f, 0x7f5b80, 0x3fdb6e,
                //HPF1
                0x000ff7c4, 0xffe01078, 0xffc041d0, 0x7fbe0e, 0x000ff7c4,
                0x000ff7c4, 0xffe01078, 0xffc041d0, 0x7fbe0e, 0x000ff7c4,
                //HPF2
                0x000ff7c4, 0xffe01078, 0xffc041d0, 0x7fbe0e, 0x000ff7c4,
                0x000ff7c4, 0xffe01078, 0xffc041d0, 0x7fbe0e, 0x000ff7c4
        },
        //48k
        {
                //--0--
               0x3f7fdc,0xff805998,0xffc05590,0x7fa668,0x402a94,
                //--1--
               0x3db3d2,0xff824329,0xffc1a76a,0x7dbcd7,0x40a4c5,
                //--2--
                0x3ed565,0xff817faf,0xffc15dab,0x7e8051,0x3fccf1,
                //--3--
                0x2558d3,0xffc997e6,0xffd32fcd,0x36681a,0x477761,
                //--4--
                0x2deaff,0xff9a1116,0xffca4c31,0x65eeea,0x47c8d0,
                //--5--
                0x346d1e,0xffa094f3,0xffc7ba61,0x5f6b0d,0x43d881,
                //--6--
                0x3c5107,0xff8464dd,0xffc30dba,0x7b9b23,0x40a13f,
                //--7--
                0x23fb3c,0xffe4e205,0xffd73a3e,0x1b1dfb,0x44ca86,
                //HPF1
                0x0feb6c,0xffe02928,0xffc0a33a,0x7f59fc,0x0feb6c,
                0x3f3ba8,0xff8188b1,0xffc1874e,0x7e75ed,0x3f3ba8,
                //HPF2
                0x0feb6c,0xffe02928,0xffc0a33a,0x7f59fc,0x0feb6c,
                0x3f3ba8,0xff8188b1,0xffc1874e,0x7e75ed,0x3f3ba8
        }
};
#endif

#ifdef AUDIO_CHL_VOLUME_OFFSET_MAP_DEFAULT
static const INT32 _aai4MtkAudVolOffsetMap[AUD_VOLUME_OFFSET_IDX_NUM] =
{
    -18,
    -15,
    -12,
    -9,
    -6,
    -3,
    0,
    3,
    6,
    9,
    12,
    15,
    18
};
#endif
#ifdef AUD_CHL_SOUND_MODE_CFG_DEFAULT
static const AUD_POST_SM_T _arMtkSoundModeCase[AUD_SOUND_MODE_NUM][AUD_STREAM_FROM_NUM] =
{
    {//AUD_SOUND_MODE_DEFAULT
        AUD_SM_CASE0,//AUD_STREAM_FROM_OTHERS
        AUD_SM_CASE0,//AUD_STREAM_FROM_DIGITAL_TUNER
        AUD_SM_CASE0,//AUD_STREAM_FROM_ANALOG_TUNER
        AUD_SM_CASE0,//AUD_STREAM_FROM_SPDIF
        AUD_SM_CASE0,//AUD_STREAM_FROM_LINE_IN
        AUD_SM_CASE0,//AUD_STREAM_FROM_HDMI
        AUD_SM_CASE0,//AUD_STREAM_FROM_MEMORY
        AUD_SM_CASE0,//AUD_STREAM_FROM_BUF_AGT
        AUD_SM_CASE0,//AUD_STREAM_FROM_FEEDER
        AUD_SM_CASE0//AUD_STREAM_FROM_MULTI_MEDIA
    },
    {//AUD_SOUND_MODE_STANDARD
        AUD_SM_CASE0,//AUD_STREAM_FROM_OTHERS
        AUD_SM_CASE0,//AUD_STREAM_FROM_DIGITAL_TUNER
        AUD_SM_CASE7,//AUD_STREAM_FROM_ANALOG_TUNER
        AUD_SM_CASE0,//AUD_STREAM_FROM_SPDIF
        AUD_SM_CASE1,//AUD_STREAM_FROM_LINE_IN
        AUD_SM_CASE4,//AUD_STREAM_FROM_HDMI
        AUD_SM_CASE4,//AUD_STREAM_FROM_MEMORY
        AUD_SM_CASE0,//AUD_STREAM_FROM_BUF_AGT
        AUD_SM_CASE0,//AUD_STREAM_FROM_FEEDER
        AUD_SM_CASE4//AUD_STREAM_FROM_MULTI_MEDIA
    },
    {//AUD_SOUND_MODE_DYNAMIC
        AUD_SM_CASE0,//AUD_STREAM_FROM_OTHERS
        AUD_SM_CASE0,//AUD_STREAM_FROM_DIGITAL_TUNER
        AUD_SM_CASE6,//AUD_STREAM_FROM_ANALOG_TUNER
        AUD_SM_CASE0,//AUD_STREAM_FROM_SPDIF
        AUD_SM_CASE0,//AUD_STREAM_FROM_LINE_IN
        AUD_SM_CASE3,//AUD_STREAM_FROM_HDMI
        AUD_SM_CASE3,//AUD_STREAM_FROM_MEMORY
        AUD_SM_CASE0,//AUD_STREAM_FROM_BUF_AGT
        AUD_SM_CASE0,//AUD_STREAM_FROM_FEEDER
        AUD_SM_CASE3//AUD_STREAM_FROM_MULTI_MEDIA
    },
    {//AUD_SOUND_MODE_CLEAR_VOICE
        AUD_SM_CASE0,//AUD_STREAM_FROM_OTHERS
        AUD_SM_CASE0,//AUD_STREAM_FROM_DIGITAL_TUNER
        AUD_SM_CASE8,//AUD_STREAM_FROM_ANALOG_TUNER
        AUD_SM_CASE0,//AUD_STREAM_FROM_SPDIF
        AUD_SM_CASE2,//AUD_STREAM_FROM_LINE_IN
        AUD_SM_CASE5,//AUD_STREAM_FROM_HDMI
        AUD_SM_CASE5,//AUD_STREAM_FROM_MEMORY
        AUD_SM_CASE0,//AUD_STREAM_FROM_BUF_AGT
        AUD_SM_CASE0,//AUD_STREAM_FROM_FEEDER
        AUD_SM_CASE5//AUD_STREAM_FROM_MULTI_MEDIA
    }
};
#endif

//-----------------------------------------------------------------------------
// Bass and Trebel Configuration
//-----------------------------------------------------------------------------
#ifdef AUDIO_CHL_BASS_TREBLE_CFG_DEFAULT
static const UINT8 _aai1MtkAudBassTrebleTable[AUD_SM_NUM][2] =
{
//bass ,treble
    {18,26},
    {18,26},
    {18,26},
    {18,26},
    {18,26},
    {18,26},
    {18,26},
    {18,26},
    {18,26},
    {18,26},
    {18,26},
    {18,26}
};
#endif

//-----------------------------------------------------------------------------
// PEQ Configuration
//-----------------------------------------------------------------------------
#ifdef AUDIO_CHL_PEQ_FQ_CFG_DEFAULT
static const UINT16 _aai1MtkAudPeqFq[AUD_SM_NUM][PEQ_SETTING_MAX] =
{
    {100,  200,  500,  1000,  2000,  5000,  10000,  305,  3000},//case 0
    {100,  200,  500,  1000,  2000,  5000,  10000,  305,  3000},//case 1
    {100,  200,  500,  1000,  2000,  5000,  10000,  305,  3000},//case 2
    {100,  200,  500,  1000,  2000,  5000,  10000,  305,  3000},//case 3
    {100,  200,  500,  1000,  2000,  5000,  10000,  305,  3000},//case 4
    {100,  200,  500,  1000,  2000,  5000,  10000,  305,  3000},//case 5
    {100,  200,  500,  1000,  2000,  5000,  10000,  305,  3000},//case 6
    {100,  200,  500,  1000,  2000,  5000,  10000,  305,  3000},//case 7
    {100,  200,  500,  1000,  2000,  5000,  10000,  305,  3000},//case 8
    {100,  200,  500,  1000,  2000,  5000,  10000,  305,  3000},//case 9
    {100,  200,  500,  1000,  2000,  5000,  10000,  305,  3000},//case 10
    {100,  200,  500,  1000,  2000,  5000,  10000,  305,  3000},//case 11
};
#endif
#ifdef AUDIO_CHL_PEQ_BW_CFG_DEFAULT
static const UINT16 _aai1MtkAudPeqBw[AUD_SM_NUM][PEQ_SETTING_MAX] =
{
    {70,  90,  300,  1000,  1500,  2000,  5000,  150,  1600},
    {70,  90,  300,  1000,  1500,  2000,  5000,  150,  1600},
    {70,  90,  300,  1000,  1500,  2000,  5000,  150,  1600},
    {70,  90,  300,  1000,  1500,  2000,  5000,  150,  1600},
    {70,  90,  300,  1000,  1500,  2000,  5000,  150,  1600},
    {70,  90,  300,  1000,  1500,  2000,  5000,  150,  1600},
    {70,  90,  300,  1000,  1500,  2000,  5000,  150,  1600},
    {70,  90,  300,  1000,  1500,  2000,  5000,  150,  1600},
    {70,  90,  300,  1000,  1500,  2000,  5000,  150,  1600},
    {70,  90,  300,  1000,  1500,  2000,  5000,  150,  1600},
    {70,  90,  300,  1000,  1500,  2000,  5000,  150,  1600},
    {70,  90,  300,  1000,  1500,  2000,  5000,  150,  1600},
};
#endif
#ifdef AUDIO_CHL_PEQ_GAIN_CFG_DEFAULT
static const INT8 _aai1MtkAudPeqGain[AUD_SM_NUM][PEQ_SETTING_MAX] =
{
    {9,  1,  -5,  -0,  -2,  -1,  15,  18,  5},
    {9,  1,  -5,  -0,  -2, -1,  15,  18,  5},
    {9,  1,  -5,  -0,  -2, -1,  15,  18,  5},
    {9,  1,  -5,  -0,  -2, -1,  15,  18,  5},
    {9,  1,  -5,  -0,  -2, -1,  15,  18,  5},
    {9,  1,  -5,  -0,  -2, -1,  15,  18,  5},
    {9,  1,  -5,  -0,  -2, -1,  15,  18,  5},
    {9,  1,  -5,  -0,  -2, -1,  15,  18,  5},
    {9,  1,  -5,  -0,  -2, -1,  15,  18,  5},
    {9,  1,  -5,  -0,  -2, -1,  15,  18,  5},
    {9,  1,  -5,  -0,  -2, -1,  15,  18,  5},
    {9,  1,  -5,  -0,  -2, -1,  15,  18,  5},
};
#endif

//-----------------------------------------------------------------------------
//Surround Configuration
//-----------------------------------------------------------------------------
#ifdef AUDIO_CHL_VS_MODE_CFG_DEFAULT
static const UINT32 _aai1MtkAudVSTable[AUD_VS_NUM][AUD_SUR_PRAR_NUM] =
{
#ifdef CC_SONY_2K15_FLASH_AQ
    {0x1a0000, 0x200000, 0x90000, 0x50000, 0x10000, 0x7f4300},    
    {0x1a0000, 0x200000, 0x90000, 0x50000, 0x10000, 0x7f4300},
    {0x1a0001, 0x200000, 0x90000, 0x50000, 0x10000, 0x7f4301},
    {0x1a0002, 0x200000, 0x90000, 0x50000, 0x10000, 0x7f4302},
    {0x1a0003, 0x200000, 0x90000, 0x50000, 0x10000, 0x7f4303}
#else
    {0x100000, 0x1a0000, 0x200000, 0x90000, 0x50000, 0x10000, 0x7f4300},
    {0x100000, 0x1a0000, 0x200000, 0x90000, 0x50000, 0x10000, 0x7f4300},
    {0x100001, 0x1a0001, 0x200000, 0x90000, 0x50000, 0x10000, 0x7f4301},
    {0x100002, 0x1a0002, 0x200000, 0x90000, 0x50000, 0x10000, 0x7f4302},
    {0x100003, 0x1a0003, 0x200000, 0x90000, 0x50000, 0x10000, 0x7f4303}
#endif
};
#endif

//-----------------------------------------------------------------------------
// EQ Configuration
//-----------------------------------------------------------------------------
#ifdef AUDIO_CHL_EQ_CFG_DEFAULT
#ifdef CC_AUD_7BAND_EQUALIZER
static INT8 _aai1MtkAudChlEqCfg[AUD_EQ_NUM][CH_EQ_BAND_NO+1] = {
    { 0,   0,   0,   0,   0,   0,    0,   0},    /* 00 NONE   */
    { 0,   0,   0,   0,   0,   0,    0,   0},    /* 01 ROCK   */
    { 0,   0,   0,   0,   0,   0,    0,   0},    /* 02 POP    */
    { 0,   0,   0,   0,   0,   0,    0,   0},    /* 03 LIVE   */
    { 0,   0,   0,   0,   0,   0,    0,   0},    /* 04 DANCE  */
    { 0,   0,   0,   0,   0,   0,    0,   0},    /* 05 TECHNO */
    { 0,   0,   0,   0,   0,   0,    0,   0},    /* 06 Classic */
    { 0,   0,   0,   0,   0,   0,    0,   0},    /* 07 Soft */
    { 0,   0,   0,   0,   0,   0,    0,   0},    /* 08 User 1 */
    { 0,   0,   0,   0,   0,   0,    0,   0},    /* 09 User 2 */
    { 0,   0,   0,   0,   0,   0,    0,   0},    /* 10 User 3 */
    { 0,   0,   0,   0,   0,   0,    0,   0},    /* 11 User 4 */
    { 0,   0,   0,   0,   0,   0,    0,   0},    /* 12 User 5 */
    { 0,   0,   0,   0,   0,   0,    0,   0},    /* 13 User 6 */
    { 0,   0,   0,   0,   0,   0,    0,   0},    /* 14 User 7 */
    { 0,   0,   0,   0,   0,   0,    0,   0},    /* 15 User 8 */
    { 0,   0,   0,   0,   0,   0,    0,   0},    /* 16 BBE TV */
    { 0,   0,   0,   0,   0,   0,    0,   0},    /* 17 BBE AV */
    { 0,   0,   0,   0,   0,   0,    0,   0},    /* 18 SBASS */
};
#else
static INT8 _aai1MtkAudChlEqCfg[AUD_EQ_NUM][CH_EQ_BAND_NO+1] = {
    { 0,   0 ,   0 ,   0 ,   0 ,   0  },    /* 00 NONE   */
    { 0,  18 ,   5 , (-2),   6 ,  18  },    /* 01 ROCK   */
    { 0, (-2),  12 ,  18 ,   6 , (-6) },    /* 02 POP    */
    { 0,  20 ,  10 , (-2),  16 ,  12  },    /* 03 LIVE   */
    { 0,  19 ,  11 , (-3), (-8), (-1) },    /* 04 DANCE  */
    { 0, (-6), (-1),   4 ,  14 ,  19  },    /* 05 TECHNO */
    { 0,   0 ,   0 ,   0 , (-3), (-8) },    /* 06 Classic */
    { 0,   9 ,   5 ,   0 , (-8),(-15) },    /* 07 Soft */
    { 0,   0,    0,    0,    0,    0  },    /* 08 User 1 */
    { 0,   0,    0,    0,    0,    0  },    /* 09 User 2 */
    { 0,   0,    0,    0,    0,    0  },    /* 10 User 3 */
    { 0,   0,    0,    0,    0,    0  },    /* 11 User 4 */
    { 0,   0,    0,    0,    0,    0  },    /* 12 User 5 */
    { 0,   0,    0,    0,    0,    0  },    /* 13 User 6 */
    { 0,   0,    0,    0,    0,    0  },    /* 14 User 7 */
    { 0,   0,    0,    0,    0,    0  },    /* 15 User 8 */
    { 0,   0,    0,    0,    0,    0  },    /* 16 BBE TV */
    { 0,   0,    0,    0,    0,    0  },    /* 17 BBE AV */
    { 0,   0,    0,    0,    0,    0  },    /* 18 SBASS */
};
#endif
#endif

#ifdef AUDIO_CHL_EQ_COEF_TBL_DEFAULT //20100524
#ifdef CC_AUD_7BAND_EQUALIZER
//MT5388 : 100, 200, 500, 1k, 2k, 5k, 10kHz
static const UINT32 _aau4MtkAudChlEqCoefTbl[(57+57+57+57+57+57+57)*5] =
{
        // 48000.0 Hz  
        // Band 1, -21.0 dB ~ +21.0 dB (57 sets)
        0x003eed45, 0xff81fb44, 0xffc1f880, 0x007e04bc, 0x003f1a3c, //-21.00
        0x003ef6c3, 0xff81e644, 0xffc1e37f, 0x007e19bc, 0x003f25be, //-20.25
        0x003effc8, 0xff81d220, 0xffc1cf5b, 0x007e2de0, 0x003f30dd, //-19.50
        0x003f0857, 0xff81bed0, 0xffc1bc0a, 0x007e4130, 0x003f3b9e, //-18.75
        0x003f1074, 0xff81ac4c, 0xffc1a986, 0x007e53b4, 0x003f4606, //-18.00
        0x003f1823, 0xff819a8b, 0xffc197c4, 0x007e6575, 0x003f5019, //-17.25
        0x003f1f66, 0xff818985, 0xffc186be, 0x007e767b, 0x003f59dd, //-16.50
        0x003f2641, 0xff817933, 0xffc1766b, 0x007e86cd, 0x003f6354, //-15.75
        0x003f2cb7, 0xff81698d, 0xffc166c5, 0x007e9673, 0x003f6c84, //-15.00
        0x003f32cb, 0xff815a8d, 0xffc157c5, 0x007ea573, 0x003f7570, //-14.25
        0x003f387f, 0xff814c2c, 0xffc14964, 0x007eb3d4, 0x003f7e1d, //-13.50
        0x003f3dd6, 0xff813e64, 0xffc13b9b, 0x007ec19c, 0x003f868e, //-12.75
        0x003f42d3, 0xff81312e, 0xffc12e65, 0x007eced2, 0x003f8ec8, //-12.00
        0x003f4777, 0xff812484, 0xffc121ba, 0x007edb7c, 0x003f96ce, //-11.25
        0x003f4bc5, 0xff811861, 0xffc11597, 0x007ee79f, 0x003f9ea4, //-10.50
        0x003f4fbe, 0xff810cbe, 0xffc109f5, 0x007ef342, 0x003fa64d, //-9.75
        0x003f5365, 0xff810198, 0xffc0fece, 0x007efe68, 0x003fadcd, //-9.00
        0x003f56ba, 0xff80f6e9, 0xffc0f41e, 0x007f0917, 0x003fb528, //-8.25
        0x003f59c0, 0xff80ecab, 0xffc0e9e0, 0x007f1355, 0x003fbc60, //-7.50
        0x003f5c77, 0xff80e2db, 0xffc0e010, 0x007f1d25, 0x003fc379, //-6.75
        0x003f5ee1, 0xff80d973, 0xffc0d6a8, 0x007f268d, 0x003fca77, //-6.00
        0x003f6100, 0xff80d070, 0xffc0cda5, 0x007f2f90, 0x003fd15c, //-5.25
        0x003f62d3, 0xff80c7cd, 0xffc0c502, 0x007f3833, 0x003fd82c, //-4.50
        0x003f645b, 0xff80bf86, 0xffc0bcbb, 0x007f407a, 0x003fdeea, //-3.75
        0x003f659a, 0xff80b798, 0xffc0b4cc, 0x007f4868, 0x003fe599, //-3.00
        0x003f6690, 0xff80afff, 0xffc0ad33, 0x007f5001, 0x003fec3d, //-2.25
        0x003f673d, 0xff80a8b7, 0xffc0a5eb, 0x007f5749, 0x003ff2d8, //-1.50
        0x003f67a2, 0xff80a1bd, 0xffc09ef1, 0x007f5e43, 0x003ff96d, //-0.75
        0x003f67be, 0xff809b0e, 0xffc09842, 0x007f64f2, 0x00400000, //0.00
        0x003f6792, 0xff8094a6, 0xffc091da, 0x007f6b5a, 0x00400694, //0.75
        0x003f671e, 0xff808e84, 0xffc08bb7, 0x007f717c, 0x00400d2b, //1.50
        0x003f6661, 0xff8088a3, 0xffc085d6, 0x007f775d, 0x004013c9, //2.25
        0x003f655b, 0xff808301, 0xffc08034, 0x007f7cff, 0x00401a72, //3.00
        0x003f640b, 0xff807d9b, 0xffc07ace, 0x007f8265, 0x00402127, //3.75
        0x003f6271, 0xff807870, 0xffc075a3, 0x007f8790, 0x004027ed, //4.50
        0x003f608b, 0xff80737c, 0xffc070ae, 0x007f8c84, 0x00402ec6, //5.25
        0x003f5e5a, 0xff806ebd, 0xffc06bf0, 0x007f9143, 0x004035b6, //6.00
        0x003f5bdc, 0xff806a31, 0xffc06764, 0x007f95cf, 0x00403cc0, //6.75
        0x003f590f, 0xff8065d6, 0xffc06309, 0x007f9a2a, 0x004043e8, //7.50
        0x003f55f3, 0xff8061aa, 0xffc05edc, 0x007f9e56, 0x00404b30, //8.25
        0x003f5286, 0xff805dab, 0xffc05add, 0x007fa255, 0x0040529d, //9.00
        0x003f4ec6, 0xff8059d7, 0xffc05709, 0x007fa629, 0x00405a31, //9.75
        0x003f4ab1, 0xff80562c, 0xffc0535e, 0x007fa9d4, 0x004061f1, //10.50
        0x003f4646, 0xff8052a8, 0xffc04fda, 0x007fad58, 0x004069e0, //11.25
        0x003f4182, 0xff804f4a, 0xffc04c7c, 0x007fb0b6, 0x00407201, //12.00
        0x003f3c63, 0xff804c11, 0xffc04943, 0x007fb3ef, 0x00407a5a, //12.75
        0x003f36e7, 0xff8048fa, 0xffc0462c, 0x007fb706, 0x004082ed, //13.50
        0x003f310b, 0xff804605, 0xffc04337, 0x007fb9fb, 0x00408bbf, //14.25
        0x003f2acc, 0xff80432f, 0xffc04061, 0x007fbcd1, 0x004094d3, //15.00
        0x003f2427, 0xff804078, 0xffc03daa, 0x007fbf88, 0x00409e2f, //15.75
        0x003f1d19, 0xff803dde, 0xffc03b10, 0x007fc222, 0x0040a7d7, //16.50
        0x003f159e, 0xff803b61, 0xffc03892, 0x007fc49f, 0x0040b1cf, //17.25
        0x003f0db4, 0xff8038fe, 0xffc0362f, 0x007fc702, 0x0040bc1c, //18.00
        0x003f0556, 0xff8036b5, 0xffc033e6, 0x007fc94b, 0x0040c6c4, //18.75
        0x003efc80, 0xff803484, 0xffc031b6, 0x007fcb7c, 0x0040d1ca, //19.50
        0x003ef32f, 0xff80326b, 0xffc02f9d, 0x007fcd95, 0x0040dd35, //20.25
        0x003ee95d, 0xff803069, 0xffc02d9a, 0x007fcf97, 0x0040e909, //21.00
        // Band 2, -21.0 dB ~ +21.0 dB (57 sets)
        0x000f790a, 0xffe0fa8c, 0xfff0f7d5, 0x001f0574, 0x000f8f21, //-21.00
        0x000f7d9f, 0xffe0f062, 0xfff0edaa, 0x001f0f9e, 0x000f94b7, //-20.25
        0x000f81fb, 0xffe0e69f, 0xfff0e3e7, 0x001f1961, 0x000f9a1f, //-19.50
        0x000f861e, 0xffe0dd41, 0xfff0da87, 0x001f22bf, 0x000f9f5a, //-18.75
        0x000f8a0c, 0xffe0d442, 0xfff0d188, 0x001f2bbe, 0x000fa46c, //-18.00
        0x000f8dc4, 0xffe0cba0, 0xfff0c8e5, 0x001f3460, 0x000fa957, //-17.25
        0x000f914a, 0xffe0c356, 0xfff0c09b, 0x001f3caa, 0x000fae1b, //-16.50
        0x000f949d, 0xffe0bb63, 0xfff0b8a6, 0x001f449d, 0x000fb2bc, //-15.75
        0x000f97c1, 0xffe0b3c1, 0xfff0b104, 0x001f4c3f, 0x000fb73b, //-15.00
        0x000f9ab5, 0xffe0ac6e, 0xfff0a9b1, 0x001f5392, 0x000fbb9a, //-14.25
        0x000f9d7b, 0xffe0a568, 0xfff0a2aa, 0x001f5a98, 0x000fbfdc, //-13.50
        0x000fa014, 0xffe09eaa, 0xfff09bec, 0x001f6156, 0x000fc401, //-12.75
        0x000fa281, 0xffe09833, 0xfff09574, 0x001f67cd, 0x000fc80b, //-12.00
        0x000fa4c3, 0xffe091ff, 0xfff08f40, 0x001f6e01, 0x000fcbfd, //-11.25
        0x000fa6db, 0xffe08c0c, 0xfff0894c, 0x001f73f4, 0x000fcfd9, //-10.50
        0x000fa8cb, 0xffe08657, 0xfff08397, 0x001f79a9, 0x000fd39f, //-9.75
        0x000faa92, 0xffe080de, 0xfff07e1d, 0x001f7f22, 0x000fd751, //-9.00
        0x000fac31, 0xffe07b9f, 0xfff078dd, 0x001f8461, 0x000fdaf2, //-8.25
        0x000fadaa, 0xffe07696, 0xfff073d4, 0x001f896a, 0x000fde82, //-7.50
        0x000faefc, 0xffe071c3, 0xfff06f00, 0x001f8e3d, 0x000fe204, //-6.75
        0x000fb029, 0xffe06d22, 0xfff06a5f, 0x001f92de, 0x000fe578, //-6.00
        0x000fb130, 0xffe068b2, 0xfff065ef, 0x001f974e, 0x000fe8e2, //-5.25
        0x000fb212, 0xffe06471, 0xfff061ad, 0x001f9b8f, 0x000fec41, //-4.50
        0x000fb2d0, 0xffe0605d, 0xfff05d99, 0x001f9fa3, 0x000fef97, //-3.75
        0x000fb369, 0xffe05c74, 0xfff059af, 0x001fa38c, 0x000ff2e7, //-3.00
        0x000fb3df, 0xffe058b4, 0xfff055ef, 0x001fa74c, 0x000ff632, //-2.25
        0x000fb430, 0xffe0551c, 0xfff05257, 0x001faae4, 0x000ff978, //-1.50
        0x000fb45e, 0xffe051aa, 0xfff04ee5, 0x001fae56, 0x000ffcbd, //-0.75
        0x000fb468, 0xffe04e5d, 0xfff04b98, 0x001fb1a3, 0x00100000, //0.00
        0x000fb44f, 0xffe04b33, 0xfff0486d, 0x001fb4cd, 0x00100344, //0.75
        0x000fb411, 0xffe0482a, 0xfff04564, 0x001fb7d6, 0x0010068a, //1.50
        0x000fb3b0, 0xffe04542, 0xfff0427c, 0x001fbabe, 0x001009d4, //2.25
        0x000fb32a, 0xffe04279, 0xfff03fb2, 0x001fbd87, 0x00100d23, //3.00
        0x000fb280, 0xffe03fcd, 0xfff03d06, 0x001fc033, 0x00101079, //3.75
        0x000fb1b1, 0xffe03d3e, 0xfff03a77, 0x001fc2c2, 0x001013d8, //4.50
        0x000fb0bd, 0xffe03aca, 0xfff03803, 0x001fc536, 0x00101740, //5.25
        0x000fafa3, 0xffe03870, 0xfff035a9, 0x001fc790, 0x00101ab4, //6.00
        0x000fae63, 0xffe03630, 0xfff03368, 0x001fc9d0, 0x00101e35, //6.75
        0x000facfc, 0xffe03407, 0xfff0313f, 0x001fcbf9, 0x001021c5, //7.50
        0x000fab6d, 0xffe031f6, 0xfff02f2e, 0x001fce0a, 0x00102565, //8.25
        0x000fa9b6, 0xffe02ffa, 0xfff02d32, 0x001fd006, 0x00102917, //9.00
        0x000fa7d6, 0xffe02e14, 0xfff02b4c, 0x001fd1ec, 0x00102cde, //9.75
        0x000fa5cc, 0xffe02c42, 0xfff0297a, 0x001fd3be, 0x001030ba, //10.50
        0x000fa397, 0xffe02a84, 0xfff027bb, 0x001fd57c, 0x001034ae, //11.25
        0x000fa135, 0xffe028d9, 0xfff02610, 0x001fd727, 0x001038bb, //12.00
        0x000f9ea7, 0xffe0273f, 0xfff02476, 0x001fd8c1, 0x00103ce4, //12.75
        0x000f9be9, 0xffe025b6, 0xfff022ed, 0x001fda4a, 0x0010412a, //13.50
        0x000f98fc, 0xffe0243e, 0xfff02175, 0x001fdbc2, 0x0010458f, //14.25
        0x000f95de, 0xffe022d6, 0xfff0200c, 0x001fdd2a, 0x00104a16, //15.00
        0x000f928d, 0xffe0217c, 0xfff01eb3, 0x001fde84, 0x00104ec0, //15.75
        0x000f8f08, 0xffe02032, 0xfff01d68, 0x001fdfce, 0x00105390, //16.50
        0x000f8b4c, 0xffe01ef5, 0xfff01c2b, 0x001fe10b, 0x00105889, //17.25
        0x000f8759, 0xffe01dc5, 0xfff01afb, 0x001fe23b, 0x00105dac, //18.00
        0x000f832c, 0xffe01ca2, 0xfff019d8, 0x001fe35e, 0x001062fb, //18.75
        0x000f7ec4, 0xffe01b8c, 0xfff018c2, 0x001fe474, 0x0010687b, //19.50
        0x000f7a1d, 0xffe01a81, 0xfff017b7, 0x001fe57f, 0x00106e2c, //20.25
        0x000f7537, 0xffe01981, 0xfff016b7, 0x001fe67f, 0x00107412, //21.00
        // Band 3, -21.0 dB ~ +21.0 dB (57 sets)
        0x000ebc01, 0xffe26350, 0xfff252f8, 0x001d9cb0, 0x000ef108, //-21.00
        0x000ec671, 0xffe24bfa, 0xfff23b95, 0x001db406, 0x000efdfa, //-20.25
        0x000ed066, 0xffe2357e, 0xfff2250c, 0x001dca82, 0x000f0a8e, //-19.50
        0x000ed9e2, 0xffe21fd5, 0xfff20f57, 0x001de02b, 0x000f16c7, //-18.75
        0x000ee2e7, 0xffe20af9, 0xfff1fa70, 0x001df507, 0x000f22a9, //-18.00
        0x000eeb79, 0xffe1f6e3, 0xfff1e64f, 0x001e091d, 0x000f2e38, //-17.25
        0x000ef39a, 0xffe1e38d, 0xfff1d2ee, 0x001e1c73, 0x000f3978, //-16.50
        0x000efb4d, 0xffe1d0f1, 0xfff1c048, 0x001e2f0f, 0x000f446c, //-15.75
        0x000f0292, 0xffe1bf09, 0xfff1ae55, 0x001e40f7, 0x000f4f19, //-15.00
        0x000f096d, 0xffe1adce, 0xfff19d11, 0x001e5232, 0x000f5982, //-14.25
        0x000f0fe0, 0xffe19d3b, 0xfff18c75, 0x001e62c5, 0x000f63ab, //-13.50
        0x000f15ed, 0xffe18d4a, 0xfff17c7b, 0x001e72b6, 0x000f6d98, //-12.75
        0x000f1b95, 0xffe17df7, 0xfff16d1f, 0x001e8209, 0x000f774c, //-12.00
        0x000f20da, 0xffe16f3a, 0xfff15e5a, 0x001e90c6, 0x000f80cb, //-11.25
        0x000f25be, 0xffe16110, 0xfff15028, 0x001e9ef0, 0x000f8a19, //-10.50
        0x000f2a43, 0xffe15372, 0xfff14283, 0x001eac8e, 0x000f933a, //-9.75
        0x000f2e69, 0xffe1465c, 0xfff13566, 0x001eb9a4, 0x000f9c31, //-9.00
        0x000f3233, 0xffe139ca, 0xfff128cd, 0x001ec636, 0x000fa501, //-8.25
        0x000f35a0, 0xffe12db5, 0xfff11cb2, 0x001ed24b, 0x000fadae, //-7.50
        0x000f38b3, 0xffe1221b, 0xfff11111, 0x001edde5, 0x000fb63c, //-6.75
        0x000f3b6c, 0xffe116f6, 0xfff105e5, 0x001ee90a, 0x000fbeae, //-6.00
        0x000f3dcc, 0xffe10c41, 0xfff0fb2b, 0x001ef3bf, 0x000fc709, //-5.25
        0x000f3fd4, 0xffe101fa, 0xfff0f0de, 0x001efe06, 0x000fcf4e, //-4.50
        0x000f4184, 0xffe0f81b, 0xfff0e6fa, 0x001f07e5, 0x000fd782, //-3.75
        0x000f42dd, 0xffe0eea2, 0xfff0dd7b, 0x001f115e, 0x000fdfa8, //-3.00
        0x000f43de, 0xffe0e589, 0xfff0d45d, 0x001f1a77, 0x000fe7c5, //-2.25
        0x000f4488, 0xffe0dcce, 0xfff0cb9d, 0x001f2332, 0x000fefda, //-1.50
        0x000f44dc, 0xffe0d46c, 0xfff0c337, 0x001f2b94, 0x000ff7ed, //-0.75
        0x000f44d8, 0xffe0cc61, 0xfff0bb28, 0x001f339f, 0x00100000, //0.00
        0x000f447d, 0xffe0c4a9, 0xfff0b36c, 0x001f3b57, 0x00100817, //0.75
        0x000f43ca, 0xffe0bd41, 0xfff0abff, 0x001f42bf, 0x00101036, //1.50
        0x000f42bf, 0xffe0b626, 0xfff0a4e0, 0x001f49da, 0x00101860, //2.25
        0x000f415b, 0xffe0af55, 0xfff09e0b, 0x001f50ab, 0x00102099, //3.00
        0x000f3f9d, 0xffe0a8ca, 0xfff0977d, 0x001f5736, 0x001028e6, //3.75
        0x000f3d84, 0xffe0a284, 0xfff09134, 0x001f5d7c, 0x00103148, //4.50
        0x000f3b0f, 0xffe09c80, 0xfff08b2c, 0x001f6380, 0x001039c5, //5.25
        0x000f383d, 0xffe096ba, 0xfff08563, 0x001f6946, 0x00104260, //6.00
        0x000f350b, 0xffe09131, 0xfff07fd6, 0x001f6ecf, 0x00104b1e, //6.75
        0x000f317a, 0xffe08be1, 0xfff07a84, 0x001f741f, 0x00105402, //7.50
        0x000f2d86, 0xffe086ca, 0xfff0756a, 0x001f7936, 0x00105d10, //8.25
        0x000f292d, 0xffe081e8, 0xfff07085, 0x001f7e18, 0x0010664e, //9.00
        0x000f246e, 0xffe07d39, 0xfff06bd4, 0x001f82c7, 0x00106fbe, //9.75
        0x000f1f46, 0xffe078bc, 0xfff06754, 0x001f8744, 0x00107965, //10.50
        0x000f19b3, 0xffe0746e, 0xfff06304, 0x001f8b92, 0x00108348, //11.25
        0x000f13b2, 0xffe0704e, 0xfff05ee2, 0x001f8fb2, 0x00108d6c, //12.00
        0x000f0d40, 0xffe06c59, 0xfff05aeb, 0x001f93a7, 0x001097d6, //12.75
        0x000f0659, 0xffe0688e, 0xfff0571e, 0x001f9772, 0x0010a289, //13.50
        0x000efefb, 0xffe064eb, 0xfff05379, 0x001f9b15, 0x0010ad8c, //14.25
        0x000ef722, 0xffe0616f, 0xfff04ffb, 0x001f9e91, 0x0010b8e4, //15.00
        0x000eeeca, 0xffe05e18, 0xfff04ca2, 0x001fa1e8, 0x0010c495, //15.75
        0x000ee5ee, 0xffe05ae4, 0xfff0496c, 0x001fa51c, 0x0010d0a5, //16.50
        0x000edc8c, 0xffe057d3, 0xfff04659, 0x001fa82d, 0x0010dd1b, //17.25
        0x000ed29e, 0xffe054e1, 0xfff04366, 0x001fab1f, 0x0010e9fc, //18.00
        0x000ec820, 0xffe05210, 0xfff04093, 0x001fadf0, 0x0010f74e, //18.75
        0x000ebd0b, 0xffe04f5c, 0xfff03dde, 0x001fb0a4, 0x00110517, //19.50
        0x000eb15c, 0xffe04cc5, 0xfff03b45, 0x001fb33b, 0x0011135e, //20.25
        0x000ea50d, 0xffe04a4a, 0xfff038c8, 0x001fb5b6, 0x0011222b, //21.00
        // Band 4, -21.0 dB ~ +21.0 dB (57 sets)
        0x000da63c, 0xffe48dad, 0xfff4510b, 0x001b7253, 0x000e08b9, //-21.00
        0x000db815, 0xffe46566, 0xfff4286b, 0x001b9a9a, 0x000e1f81, //-20.25
        0x000dc92d, 0xffe43e63, 0xfff40112, 0x001bc19d, 0x000e35c2, //-19.50
        0x000dd987, 0xffe4189e, 0xfff3daf9, 0x001be762, 0x000e4b80, //-18.75
        0x000de924, 0xffe3f411, 0xfff3b61b, 0x001c0bef, 0x000e60c1, //-18.00
        0x000df807, 0xffe3d0b4, 0xfff39271, 0x001c2f4c, 0x000e7588, //-17.25
        0x000e0632, 0xffe3ae83, 0xfff36ff4, 0x001c517d, 0x000e89db, //-16.50
        0x000e13a5, 0xffe38d75, 0xfff34e9d, 0x001c728b, 0x000e9dbe, //-15.75
        0x000e2064, 0xffe36d84, 0xfff32e65, 0x001c927c, 0x000eb137, //-15.00
        0x000e2c70, 0xffe34ea9, 0xfff30f46, 0x001cb157, 0x000ec44a, //-14.25
        0x000e37cb, 0xffe330dd, 0xfff2f138, 0x001ccf23, 0x000ed6fd, //-13.50
        0x000e4277, 0xffe31419, 0xfff2d435, 0x001cebe7, 0x000ee954, //-12.75
        0x000e4c75, 0xffe2f856, 0xfff2b835, 0x001d07aa, 0x000efb56, //-12.00
        0x000e55c7, 0xffe2dd8e, 0xfff29d31, 0x001d2272, 0x000f0d08, //-11.25
        0x000e5e6f, 0xffe2c3b8, 0xfff28322, 0x001d3c48, 0x000f1e6f, //-10.50
        0x000e666d, 0xffe2aacf, 0xfff26a02, 0x001d5531, 0x000f2f91, //-9.75
        0x000e6dc4, 0xffe292cc, 0xfff251ca, 0x001d6d34, 0x000f4073, //-9.00
        0x000e7473, 0xffe27ba7, 0xfff23a72, 0x001d8459, 0x000f511b, //-8.25
        0x000e7a7d, 0xffe2655a, 0xfff223f4, 0x001d9aa6, 0x000f618f, //-7.50
        0x000e7fe2, 0xffe24fdf, 0xfff20e49, 0x001db021, 0x000f71d5, //-6.75
        0x000e84a2, 0xffe23b2f, 0xfff1f96c, 0x001dc4d1, 0x000f81f2, //-6.00
        0x000e88bf, 0xffe22744, 0xfff1e554, 0x001dd8bc, 0x000f91ed, //-5.25
        0x000e8c38, 0xffe21417, 0xfff1d1fd, 0x001debe9, 0x000fa1cb, //-4.50
        0x000e8f0e, 0xffe201a2, 0xfff1bf60, 0x001dfe5e, 0x000fb192, //-3.75
        0x000e9141, 0xffe1efe0, 0xfff1ad76, 0x001e1020, 0x000fc149, //-3.00
        0x000e92cf, 0xffe1deca, 0xfff19c3a, 0x001e2136, 0x000fd0f7, //-2.25
        0x000e93ba, 0xffe1ce5a, 0xfff18ba6, 0x001e31a6, 0x000fe0a0, //-1.50
        0x000e9400, 0xffe1be8c, 0xfff17bb5, 0x001e4174, 0x000ff04b, //-0.75
        0x000e93a0, 0xffe1af59, 0xfff16c60, 0x001e50a7, 0x00100000, //0.00
        0x000e9299, 0xffe1a0bc, 0xfff15da3, 0x001e5f44, 0x00100fc4, //0.75
        0x000e90ea, 0xffe192af, 0xfff14f78, 0x001e6d51, 0x00101f9e, //1.50
        0x000e8e91, 0xffe1852f, 0xfff141d9, 0x001e7ad1, 0x00102f95, //2.25
        0x000e8b8d, 0xffe17835, 0xfff134c3, 0x001e87cb, 0x00103fb0, //3.00
        0x000e87da, 0xffe16bbe, 0xfff12830, 0x001e9442, 0x00104ff6, //3.75
        0x000e8378, 0xffe15fc3, 0xfff11c1b, 0x001ea03d, 0x0010606d, //4.50
        0x000e7e62, 0xffe15442, 0xfff11080, 0x001eabbe, 0x0010711e, //5.25
        0x000e7897, 0xffe14935, 0xfff1055a, 0x001eb6cb, 0x0010820f, //6.00
        0x000e7212, 0xffe13e97, 0xfff0faa6, 0x001ec169, 0x00109348, //6.75
        0x000e6ad1, 0xffe13466, 0xfff0f05e, 0x001ecb9a, 0x0010a4d1, //7.50
        0x000e62cf, 0xffe12a9d, 0xfff0e67f, 0x001ed563, 0x0010b6b2, //8.25
        0x000e5a08, 0xffe12137, 0xfff0dd05, 0x001edec9, 0x0010c8f3, //9.00
        0x000e5078, 0xffe11832, 0xfff0d3ec, 0x001ee7ce, 0x0010db9c, //9.75
        0x000e4619, 0xffe10f8a, 0xfff0cb31, 0x001ef076, 0x0010eeb6, //10.50
        0x000e3ae7, 0xffe1073b, 0xfff0c2cf, 0x001ef8c5, 0x0011024a, //11.25
        0x000e2edb, 0xffe0ff41, 0xfff0bac4, 0x001f00bf, 0x00111661, //12.00
        0x000e21f1, 0xffe0f79a, 0xfff0b30c, 0x001f0866, 0x00112b04, //12.75
        0x000e1421, 0xffe0f042, 0xfff0aba3, 0x001f0fbe, 0x0011403c, //13.50
        0x000e0564, 0xffe0e936, 0xfff0a488, 0x001f16ca, 0x00115614, //14.25
        0x000df5b4, 0xffe0e273, 0xfff09db6, 0x001f1d8d, 0x00116c96, //15.00
        0x000de508, 0xffe0dbf7, 0xfff0972c, 0x001f2409, 0x001183cc, //15.75
        0x000dd359, 0xffe0d5bf, 0xfff090e6, 0x001f2a41, 0x00119bc2, //16.50
        0x000dc09d, 0xffe0cfc7, 0xfff08ae1, 0x001f3039, 0x0011b482, //17.25
        0x000daccd, 0xffe0ca0e, 0xfff0851b, 0x001f35f2, 0x0011ce18, //18.00
        0x000d97de, 0xffe0c491, 0xfff07f92, 0x001f3b6f, 0x0011e891, //18.75
        0x000d81c6, 0xffe0bf4d, 0xfff07a42, 0x001f40b3, 0x001203f8, //19.50
        0x000d6a7a, 0xffe0ba40, 0xfff0752b, 0x001f45c0, 0x0012205b, //20.25
        0x000d51f0, 0xffe0b569, 0xfff07049, 0x001f4a97, 0x00123dc7, //21.00
        // Band 5, -21.0 dB ~ +21.0 dB (57 sets)
        0x000be450, 0xffe85f94, 0xfff78b40, 0x0017a06c, 0x000c9070, //-21.00
        0x000bff1c, 0xffe822b9, 0xfff74c41, 0x0017dd47, 0x000cb4a3, //-20.25
        0x000c18f3, 0xffe7e747, 0xfff70eb9, 0x001818b9, 0x000cd854, //-19.50
        0x000c31d2, 0xffe7ad3f, 0xfff6d2a8, 0x001852c1, 0x000cfb86, //-18.75
        0x000c49b6, 0xffe774a4, 0xfff69810, 0x00188b5c, 0x000d1e3a, //-18.00
        0x000c609d, 0xffe73d73, 0xfff65eef, 0x0018c28d, 0x000d4074, //-17.25
        0x000c7684, 0xffe707ac, 0xfff62745, 0x0018f854, 0x000d6237, //-16.50
        0x000c8b69, 0xffe6d34f, 0xfff5f111, 0x00192cb1, 0x000d8386, //-15.75
        0x000c9f4a, 0xffe6a058, 0xfff5bc51, 0x00195fa8, 0x000da465, //-15.00
        0x000cb225, 0xffe66ec6, 0xfff58901, 0x0019913a, 0x000dc4da, //-14.25
        0x000cc3f8, 0xffe63e95, 0xfff5571f, 0x0019c16b, 0x000de4e9, //-13.50
        0x000cd4c2, 0xffe60fc2, 0xfff526a7, 0x0019f03e, 0x000e0497, //-12.75
        0x000ce482, 0xffe5e249, 0xfff4f795, 0x001a1db7, 0x000e23ea, //-12.00
        0x000cf334, 0xffe5b625, 0xfff4c9e4, 0x001a49db, 0x000e42e8, //-11.25
        0x000d00d9, 0xffe58b51, 0xfff49d90, 0x001a74af, 0x000e6197, //-10.50
        0x000d0d6e, 0xffe561ca, 0xfff47293, 0x001a9e36, 0x000e7ffe, //-9.75
        0x000d18f3, 0xffe53988, 0xfff448e8, 0x001ac678, 0x000e9e25, //-9.00
        0x000d2364, 0xffe51288, 0xfff42089, 0x001aed78, 0x000ebc13, //-8.25
        0x000d2cc2, 0xffe4ecc2, 0xfff3f970, 0x001b133e, 0x000ed9ce, //-7.50
        0x000d3509, 0xffe4c831, 0xfff3d396, 0x001b37cf, 0x000ef761, //-6.75
        0x000d3c39, 0xffe4a4ce, 0xfff3aef5, 0x001b5b32, 0x000f14d2, //-6.00
        0x000d424e, 0xffe48293, 0xfff38b87, 0x001b7d6d, 0x000f322b, //-5.25
        0x000d4748, 0xffe4617a, 0xfff36945, 0x001b9e86, 0x000f4f74, //-4.50
        0x000d4b22, 0xffe4417c, 0xfff34827, 0x001bbe84, 0x000f6cb7, //-3.75
        0x000d4ddc, 0xffe42293, 0xfff32828, 0x001bdd6d, 0x000f89fd, //-3.00
        0x000d4f71, 0xffe404b6, 0xfff3093f, 0x001bfb4a, 0x000fa750, //-2.25
        0x000d4fdf, 0xffe3e7e1, 0xfff2eb66, 0x001c181f, 0x000fc4bb, //-1.50
        0x000d4f22, 0xffe3cc0c, 0xfff2ce97, 0x001c33f4, 0x000fe247, //-0.75
        0x000d4d37, 0xffe3b12f, 0xfff2b2c9, 0x001c4ed1, 0x00100000, //0.00
        0x000d4a19, 0xffe39745, 0xfff297f6, 0x001c68bb, 0x00101df1, //0.75
        0x000d45c4, 0xffe37e47, 0xfff27e18, 0x001c81b9, 0x00103c24, //1.50
        0x000d4034, 0xffe3662e, 0xfff26526, 0x001c99d2, 0x00105aa6, //2.25
        0x000d3962, 0xffe34ef3, 0xfff24d1a, 0x001cb10d, 0x00107983, //3.00
        0x000d314a, 0xffe33890, 0xfff235ee, 0x001cc770, 0x001098c8, //3.75
        0x000d27e5, 0xffe322fe, 0xfff21f9a, 0x001cdd02, 0x0010b880, //4.50
        0x000d1d2e, 0xffe30e38, 0xfff20a19, 0x001cf1c8, 0x0010d8b9, //5.25
        0x000d111c, 0xffe2fa35, 0xfff1f563, 0x001d05cb, 0x0010f981, //6.00
        0x000d03a8, 0xffe2e6f2, 0xfff1e172, 0x001d190e, 0x00111ae6, //6.75
        0x000cf4ca, 0xffe2d466, 0xfff1ce40, 0x001d2b9a, 0x00113cf5, //7.50
        0x000ce47b, 0xffe2c28d, 0xfff1bbc7, 0x001d3d73, 0x00115fbf, //8.25
        0x000cd2af, 0xffe2b161, 0xfff1aa00, 0x001d4e9f, 0x00118351, //9.00
        0x000cbf5f, 0xffe2a0db, 0xfff198e6, 0x001d5f25, 0x0011a7bb, //9.75
        0x000caa7f, 0xffe290f7, 0xfff18873, 0x001d6f09, 0x0011cd0f, //10.50
        0x000c9404, 0xffe281ae, 0xfff178a1, 0x001d7e52, 0x0011f35c, //11.25
        0x000c7be2, 0xffe272fc, 0xfff1696a, 0x001d8d04, 0x00121ab4, //12.00
        0x000c620e, 0xffe264db, 0xfff15aca, 0x001d9b25, 0x00124328, //12.75
        0x000c4679, 0xffe25746, 0xfff14cbb, 0x001da8ba, 0x00126ccc, //13.50
        0x000c2916, 0xffe24a38, 0xfff13f38, 0x001db5c8, 0x001297b2, //14.25
        0x000c09d6, 0xffe23dad, 0xfff1323c, 0x001dc253, 0x0012c3ed, //15.00
        0x000be8aa, 0xffe231a0, 0xfff125c2, 0x001dce60, 0x0012f193, //15.75
        0x000bc581, 0xffe2260b, 0xfff119c6, 0x001dd9f5, 0x001320b9, //16.50
        0x000ba049, 0xffe21aec, 0xfff10e43, 0x001de514, 0x00135174, //17.25
        0x000b78f1, 0xffe2103d, 0xfff10334, 0x001defc3, 0x001383db, //18.00
        0x000b4f65, 0xffe205fa, 0xfff0f895, 0x001dfa06, 0x0013b806, //18.75
        0x000b2391, 0xffe1fc20, 0xfff0ee62, 0x001e03e0, 0x0013ee0d, //19.50
        0x000af55f, 0xffe1f2aa, 0xfff0e498, 0x001e0d56, 0x0014260a, //20.25
        0x000ac4b9, 0xffe1e995, 0xfff0db31, 0x001e166b, 0x00146016, //21.00
        // Band 6, -21.0 dB ~ +21.0 dB (57 sets)
        0x0008a788, 0xfff154ed, 0xfffd7d2c, 0x000eab13, 0x0009db4c, //-21.00
        0x0008c8cc, 0xfff110d4, 0xfffd273c, 0x000eef2c, 0x000a0ff8, //-20.25
        0x0008e933, 0xfff0cd41, 0xfffcd1f5, 0x000f32bf, 0x000a44d8, //-19.50
        0x000908af, 0xfff08a41, 0xfffc7d68, 0x000f75bf, 0x000a79ea, //-18.75
        0x0009272f, 0xfff047e3, 0xfffc29a7, 0x000fb81d, 0x000aaf2b, //-18.00
        0x000944a4, 0xfff00634, 0xfffbd6c2, 0x000ff9cc, 0x000ae49a, //-17.25
        0x00096100, 0xffefc541, 0xfffb84cb, 0x00103abf, 0x000b1a35, //-16.50
        0x00097c33, 0xffef8515, 0xfffb33d0, 0x00107aeb, 0x000b4ffd, //-15.75
        0x0009962f, 0xffef45bd, 0xfffae3df, 0x0010ba43, 0x000b85f2, //-15.00
        0x0009aee5, 0xffef0743, 0xfffa9507, 0x0010f8bd, 0x000bbc14, //-14.25
        0x0009c646, 0xffeec9b1, 0xfffa4754, 0x0011364f, 0x000bf267, //-13.50
        0x0009dc44, 0xffee8d10, 0xfff9fad1, 0x001172f0, 0x000c28eb, //-12.75
        0x0009f0d1, 0xffee516a, 0xfff9af8a, 0x0011ae96, 0x000c5fa6, //-12.00
        0x000a03de, 0xffee16c5, 0xfff96588, 0x0011e93b, 0x000c969a, //-11.25
        0x000a155d, 0xffeddd29, 0xfff91cd5, 0x001222d7, 0x000ccdce, //-10.50
        0x000a2541, 0xffeda49d, 0xfff8d578, 0x00125b63, 0x000d0547, //-9.75
        0x000a337b, 0xffed6d26, 0xfff88f7a, 0x001292da, 0x000d3d0b, //-9.00
        0x000a3ffd, 0xffed36ca, 0xfff84adf, 0x0012c936, 0x000d7524, //-8.25
        0x000a4ab9, 0xffed018b, 0xfff807ae, 0x0012fe75, 0x000dad99, //-7.50
        0x000a53a2, 0xffeccd6f, 0xfff7c5eb, 0x00133291, 0x000de673, //-6.75
        0x000a5aa9, 0xffec9a78, 0xfff78599, 0x00136588, 0x000e1fbe, //-6.00
        0x000a5fbf, 0xffec68a7, 0xfff746bc, 0x00139759, 0x000e5985, //-5.25
        0x000a62d8, 0xffec37ff, 0xfff70955, 0x0013c801, 0x000e93d4, //-4.50
        0x000a63e3, 0xffec0881, 0xfff6cd65, 0x0013f77f, 0x000eceb8, //-3.75
        0x000a62d3, 0xffebda2d, 0xfff692ee, 0x001425d3, 0x000f0a3f, //-3.00
        0x000a5f98, 0xffebad03, 0xfff659ef, 0x001452fd, 0x000f4679, //-2.25
        0x000a5a23, 0xffeb8102, 0xfff62266, 0x00147efe, 0x000f8377, //-1.50
        0x000a5265, 0xffeb5628, 0xfff5ec53, 0x0014a9d8, 0x000fc148, //-0.75
        0x000a484c, 0xffeb2c75, 0xfff5b7b4, 0x0014d38b, 0x00100000, //0.00
        0x000a3bca, 0xffeb03e6, 0xfff58484, 0x0014fc1a, 0x00103fb2, //0.75
        0x000a2ccc, 0xffeadc79, 0xfff552c3, 0x00152387, 0x00108071, //1.50
        0x000a1b41, 0xffeab62a, 0xfff5226b, 0x001549d6, 0x0010c254, //2.25
        0x000a0717, 0xffea90f6, 0xfff4f378, 0x00156f0a, 0x00110570, //3.00
        0x0009f03b, 0xffea6cdb, 0xfff4c5e7, 0x00159325, 0x001149de, //3.75
        0x0009d699, 0xffea49d3, 0xfff499b1, 0x0015b62d, 0x00118fb6, //4.50
        0x0009ba1c, 0xffea27da, 0xfff46ed3, 0x0015d826, 0x0011d712, //5.25
        0x00099aaf, 0xffea06ed, 0xfff44545, 0x0015f913, 0x0012200c, //6.00
        0x0009783c, 0xffe9e707, 0xfff41d03, 0x001618f9, 0x00126ac1, //6.75
        0x000952ab, 0xffe9c822, 0xfff3f607, 0x001637de, 0x0012b74e, //7.50
        0x000929e5, 0xffe9aa3a, 0xfff3d049, 0x001655c6, 0x001305d2, //8.25
        0x0008fdcf, 0xffe98d49, 0xfff3abc4, 0x001672b7, 0x0013566d, //9.00
        0x0008ce4f, 0xffe9714b, 0xfff38870, 0x00168eb5, 0x0013a940, //9.75
        0x00089b49, 0xffe9563b, 0xfff36648, 0x0016a9c5, 0x0013fe6e, //10.50
        0x000864a0, 0xffe93c11, 0xfff34544, 0x0016c3ef, 0x0014561c, //11.25
        0x00082a34, 0xffe922ca, 0xfff3255e, 0x0016dd36, 0x0014b06e, //12.00
        0x0007ebe7, 0xffe90a5f, 0xfff3068e, 0x0016f5a1, 0x00150d8b, //12.75
        0x0007a995, 0xffe8f2cc, 0xfff2e8cd, 0x00170d34, 0x00156d9e, //13.50
        0x0007631c, 0xffe8dc0a, 0xfff2cc15, 0x001723f6, 0x0015d0d0, //14.25
        0x00071856, 0xffe8c614, 0xfff2b05e, 0x001739ec, 0x0016374c, //15.00
        0x0006c91d, 0xffe8b0e4, 0xfff295a1, 0x00174f1c, 0x0016a143, //15.75
        0x00067547, 0xffe89c75, 0xfff27bd7, 0x0017638b, 0x00170ee2, //16.50
        0x00061caa, 0xffe888c1, 0xfff262fa, 0x0017773f, 0x0017805b, //17.25
        0x0005bf19, 0xffe875c3, 0xfff24b03, 0x00178a3d, 0x0017f5e4, //18.00
        0x00055c65, 0xffe86376, 0xfff233ea, 0x00179c8a, 0x00186fb1, //18.75
        0x0004f45d, 0xffe851d4, 0xfff21da9, 0x0017ae2c, 0x0018edfa, //19.50
        0x000486cc, 0xffe840d8, 0xfff2083a, 0x0017bf28, 0x001970fa, //20.25
        0x0004137c, 0xffe8307c, 0xfff1f396, 0x0017cf84, 0x0019f8ee, //21.00
        // Band 7, -21.0 dB ~ +21.0 dB (57 sets)
        0x0006aa1a, 0xfffc27a0, 0x000124a7, 0x0003d860, 0x0008313e, //-21.00
        0x0006c8ca, 0xfffc10d4, 0x0000cc90, 0x0003ef2c, 0x00086aa5, //-20.25
        0x0006e6c3, 0xfffbf9fa, 0x00007448, 0x00040606, 0x0008a4f4, //-19.50
        0x000703f1, 0xfffbe31a, 0x00001be5, 0x00041ce6, 0x0008e029, //-18.75
        0x0007203e, 0xfffbcc38, 0xffffc37b, 0x000433c8, 0x00091c47, //-18.00
        0x00073b93, 0xfffbb559, 0xffff6b20, 0x00044aa7, 0x0009594d, //-17.25
        0x000755db, 0xfffb9e84, 0xffff12e8, 0x0004617c, 0x0009973d, //-16.50
        0x00076eff, 0xfffb87be, 0xfffebae8, 0x00047842, 0x0009d619, //-15.75
        0x000786e8, 0xfffb710b, 0xfffe6335, 0x00048ef5, 0x000a15e3, //-15.00
        0x00079d7f, 0xfffb5a71, 0xfffe0be4, 0x0004a58f, 0x000a569d, //-14.25
        0x0007b2ac, 0xfffb43f6, 0xfffdb508, 0x0004bc0a, 0x000a984d, //-13.50
        0x0007c656, 0xfffb2d9f, 0xfffd5eb5, 0x0004d261, 0x000adaf5, //-12.75
        0x0007d865, 0xfffb1770, 0xfffd08ff, 0x0004e890, 0x000b1e9c, //-12.00
        0x0007e8c1, 0xfffb016e, 0xfffcb3f7, 0x0004fe92, 0x000b6348, //-11.25
        0x0007f751, 0xfffaeb9e, 0xfffc5fb0, 0x00051462, 0x000ba8fe, //-10.50
        0x000803fc, 0xfffad604, 0xfffc0c3b, 0x000529fc, 0x000befc9, //-9.75
        0x00080ea8, 0xfffac0a5, 0xfffbb9a9, 0x00053f5b, 0x000c37af, //-9.00
        0x0008173b, 0xfffaab85, 0xfffb6809, 0x0005547b, 0x000c80bc, //-8.25
        0x00081d9b, 0xfffa96a7, 0xfffb176b, 0x00056959, 0x000ccafa, //-7.50
        0x000821ae, 0xfffa8210, 0xfffac7dc, 0x00057df0, 0x000d1676, //-6.75
        0x00082359, 0xfffa6dc2, 0xfffa796a, 0x0005923e, 0x000d633d, //-6.00
        0x00082282, 0xfffa59c2, 0xfffa2c21, 0x0005a63e, 0x000db15e, //-5.25
        0x00081f0b, 0xfffa4611, 0xfff9e00c, 0x0005b9ef, 0x000e00e8, //-4.50
        0x000818db, 0xfffa32b2, 0xfff99537, 0x0005cd4e, 0x000e51ee, //-3.75
        0x00080fd4, 0xfffa1fa9, 0xfff94bab, 0x0005e057, 0x000ea481, //-3.00
        0x000803da, 0xfffa0cf8, 0xfff90370, 0x0005f308, 0x000ef8b6, //-2.25
        0x0007f4cf, 0xfff9fa9f, 0xfff8bc8e, 0x00060561, 0x000f4ea3, //-1.50
        0x0007e295, 0xfff9e8a2, 0xfff8770d, 0x0006175e, 0x000fa65e, //-0.75
        0x0007cd0e, 0xfff9d701, 0xfff832f2, 0x000628ff, 0x00100000, //0.00
        0x0007b41b, 0xfff9c5bf, 0xfff7f042, 0x00063a41, 0x00105ba4, //0.75
        0x0007979b, 0xfff9b4db, 0xfff7af01, 0x00064b25, 0x0010b964, //1.50
        0x0007776e, 0xfff9a458, 0xfff76f32, 0x00065ba8, 0x00111960, //2.25
        0x00075371, 0xfff99435, 0xfff730d9, 0x00066bcb, 0x00117bb6, //3.00
        0x00072b82, 0xfff98473, 0xfff6f3f7, 0x00067b8d, 0x0011e086, //3.75
        0x0006ff7e, 0xfff97512, 0xfff6b88d, 0x00068aee, 0x001247f5, //4.50
        0x0006cf3f, 0xfff96612, 0xfff67e9b, 0x000699ee, 0x0012b227, //5.25
        0x00069a9e, 0xfff95774, 0xfff64620, 0x0006a88c, 0x00131f42, //6.00
        0x00066175, 0xfff94937, 0xfff60f1c, 0x0006b6c9, 0x00138f6f, //6.75
        0x0006239a, 0xfff93b5a, 0xfff5d98c, 0x0006c4a6, 0x001402d9, //7.50
        0x0005e0e3, 0xfff92ddd, 0xfff5a56f, 0x0006d223, 0x001479ad, //8.25
        0x00059924, 0xfff920bf, 0xfff572c2, 0x0006df41, 0x0014f41a, //9.00
        0x00054c2f, 0xfff91400, 0xfff54180, 0x0006ec00, 0x00157251, //9.75
        0x0004f9d4, 0xfff9079e, 0xfff511a7, 0x0006f862, 0x0015f485, //10.50
        0x0004a1e1, 0xfff8fb97, 0xfff4e332, 0x00070469, 0x00167aed, //11.25
        0x00044423, 0xfff8efec, 0xfff4b61d, 0x00071014, 0x001705c1, //12.00
        0x0003e064, 0xfff8e49b, 0xfff48a61, 0x00071b65, 0x0017953b, //12.75
        0x0003766b, 0xfff8d9a1, 0xfff45ffa, 0x0007265f, 0x0018299b, //13.50
        0x000305fe, 0xfff8ceff, 0xfff436e3, 0x00073101, 0x0018c320, //14.25
        0x00028edf, 0xfff8c4b1, 0xfff40f15, 0x00073b4f, 0x0019620d, //15.00
        0x000210cf, 0xfff8bab7, 0xfff3e889, 0x00074549, 0x001a06a8, //15.75
        0x00018b8a, 0xfff8b110, 0xfff3c33b, 0x00074ef0, 0x001ab13b, //16.50
        0x0000fecb, 0xfff8a7b8, 0xfff39f23, 0x00075848, 0x001b6212, //17.25
        0x00006a48, 0xfff89eaf, 0xfff37c3a, 0x00076151, 0x001c197e, //18.00
        0xffffcdb7, 0xfff895f3, 0xfff35a7a, 0x00076a0d, 0x001cd7d0, //18.75
        0xffff28c5, 0xfff88d82, 0xfff339dc, 0x0007727e, 0x001d9d60, //19.50
        0xfffe7b20, 0xfff8855a, 0xfff31a59, 0x00077aa6, 0x001e6a89, //20.25
        0xfffdc470, 0xfff87d79, 0xfff2fbe9, 0x00078287, 0x001f3fa8, //21.00
};
#else // 100Hz, 300Hz, 1KHz, 3KHz, 10KHz
static const UINT32 _aau4MtkAudChlEqCoefTbl[(57+57*2+57*2+57*2+57)*5] =
{
    // 48000.0 Hz
    // Band 1, -14.0 dB ~ +14.0 dB (57 sets)
    0x003e4973, 0xff826497, 0xffc258e3, 0x007d939a, 0x003f55db, //-14.0
    0x003e4bd9, 0xff825bf3, 0xffc25076, 0x007d9c94, 0x003f5c37, //-13.5
    0x003e4e27, 0xff82536e, 0xffc24827, 0x007da56b, 0x003f628c, //-13.0
    0x003e505f, 0xff824b0a, 0xffc23ff5, 0x007dae22, 0x003f68d8, //-12.5
    0x003e5280, 0xff8242c4, 0xffc237e0, 0x007db6b8, 0x003f6f1c, //-12.0
    0x003e548a, 0xff823a9d, 0xffc22fe7, 0x007dbf2e, 0x003f755a, //-11.5
    0x003e567e, 0xff823295, 0xffc2280b, 0x007dc784, 0x003f7b90, //-11.0
    0x003e585b, 0xff822aab, 0xffc2204a, 0x007dcfbb, 0x003f81c0, //-10.5
    0x003e5a23, 0xff8222de, 0xffc218a5, 0x007dd7d3, 0x003f87ea, //-10.0
    0x003e5bd4, 0xff821b2e, 0xffc2111b, 0x007ddfce, 0x003f8e0d, //-9.5
    0x003e5d6f, 0xff82139b, 0xffc209ab, 0x007de7aa, 0x003f942b, //-9.0
    0x003e5ef4, 0xff820c24, 0xffc20256, 0x007def69, 0x003f9a44, //-8.5
    0x003e6063, 0xff8204ca, 0xffc1fb1a, 0x007df70b, 0x003fa058, //-8.0
    0x003e61bc, 0xff81fd8b, 0xffc1f3f8, 0x007dfe91, 0x003fa668, //-7.5
    0x003e62ff, 0xff81f667, 0xffc1ecf0, 0x007e05fa, 0x003fac73, //-7.0
    0x003e642d, 0xff81ef5f, 0xffc1e600, 0x007e0d48, 0x003fb27a, //-6.5
    0x003e6545, 0xff81e870, 0xffc1df29, 0x007e147b, 0x003fb87d, //-6.0
    0x003e6647, 0xff81e19c, 0xffc1d86b, 0x007e1b93, 0x003fbe7d, //-5.5
    0x003e6734, 0xff81dae2, 0xffc1d1c4, 0x007e2290, 0x003fc47a, //-5.0
    0x003e680c, 0xff81d442, 0xffc1cb35, 0x007e2973, 0x003fca75, //-4.5
    0x003e68ce, 0xff81cdba, 0xffc1c4bd, 0x007e303d, 0x003fd06d, //-4.0
    0x003e697b, 0xff81c74c, 0xffc1be5c, 0x007e36ed, 0x003fd663, //-3.5
    0x003e6a12, 0xff81c0f6, 0xffc1b812, 0x007e3d85, 0x003fdc57, //-3.0
    0x003e6a94, 0xff81bab8, 0xffc1b1de, 0x007e4404, 0x003fe24a, //-2.5
    0x003e6b01, 0xff81b493, 0xffc1abc0, 0x007e4a6b, 0x003fe83c, //-2.0
    0x003e6b59, 0xff81ae85, 0xffc1a5b8, 0x007e50b9, 0x003fee2e, //-1.5
    0x003e6b9b, 0xff81a88e, 0xffc19fc5, 0x007e56f1, 0x003ff41e, //-1.0
    0x003e6bc8, 0xff81a2ae, 0xffc199e8, 0x007e5d11, 0x003ffa0f, //-0.5
    0x003e6be0, 0xff819ce5, 0xffc19420, 0x007e631b, 0x00400000, //0.0
    0x003e6be3, 0xff819733, 0xffc18e6c, 0x007e690e, 0x004005f1, //0.5
    0x003e6bd1, 0xff819196, 0xffc188cc, 0x007e6eeb, 0x00400be4, //1.0
    0x003e6baa, 0xff818c10, 0xffc18341, 0x007e74b2, 0x004011d7, //1.5
    0x003e6b6d, 0xff81869f, 0xffc17dc9, 0x007e7a64, 0x004017cc, //2.0
    0x003e6b1c, 0xff818144, 0xffc17865, 0x007e8000, 0x00401dc3, //2.5
    0x003e6ab5, 0xff817bfe, 0xffc17314, 0x007e8588, 0x004023bc, //3.0
    0x003e6a39, 0xff8176cc, 0xffc16dd6, 0x007e8afb, 0x004029b8, //3.5
    0x003e69a8, 0xff8171b0, 0xffc168ab, 0x007e905a, 0x00402fb7, //4.0
    0x003e6902, 0xff816ca7, 0xffc16393, 0x007e95a5, 0x004035b8, //4.5
    0x003e6847, 0xff8167b3, 0xffc15e8c, 0x007e9add, 0x00403bbd, //5.0
    0x003e6776, 0xff8162d3, 0xffc15998, 0x007ea001, 0x004041c6, //5.5
    0x003e6690, 0xff815e07, 0xffc154b5, 0x007ea512, 0x004047d3, //6.0
    0x003e6595, 0xff81594e, 0xffc14fe4, 0x007eaa10, 0x00404de5, //6.5
    0x003e6484, 0xff8154a8, 0xffc14b24, 0x007eaefc, 0x004053fb, //7.0
    0x003e635e, 0xff815015, 0xffc14675, 0x007eb3d5, 0x00405a17, //7.5
    0x003e6223, 0xff814b95, 0xffc141d7, 0x007eb89c, 0x00406038, //8.0
    0x003e60d2, 0xff814728, 0xffc13d49, 0x007ebd52, 0x0040665e, //8.5
    0x003e5f6c, 0xff8142cd, 0xffc138cc, 0x007ec1f6, 0x00406c8b, //9.0
    0x003e5df0, 0xff813e84, 0xffc1345f, 0x007ec689, 0x004072bf, //9.5
    0x003e5c5e, 0xff813a4d, 0xffc13001, 0x007ecb0b, 0x004078f9, //10.0
    0x003e5ab7, 0xff813629, 0xffc12bb4, 0x007ecf7d, 0x00407f3b, //10.5
    0x003e58fa, 0xff813216, 0xffc12776, 0x007ed3de, 0x00408584, //11.0
    0x003e5727, 0xff812e14, 0xffc12347, 0x007ed82f, 0x00408bd5, //11.5
    0x003e553e, 0xff812a24, 0xffc11f27, 0x007edc6f, 0x0040922f, //12.0
    0x003e533f, 0xff812645, 0xffc11b16, 0x007ee0a0, 0x00409891, //12.5
    0x003e512a, 0xff812276, 0xffc11713, 0x007ee4c2, 0x00409efc, //13.0
    0x003e4efe, 0xff811eb9, 0xffc1131f, 0x007ee8d4, 0x0040a570, //13.5
    0x003e4cbd, 0xff811b0c, 0xffc10f39, 0x007eecd7, 0x0040abee, //14.0
    // Band 2, -14.0 dB ~ +14.0 dB (57*2 sets)
    0x0006f502, 0xfff1d461, 0xfff043ce, 0x001fbb35, 0x000738d1, //-14.0
    0x00072947, 0xfff16ae0, 0xfff044c8, 0x001fba34, 0x00076e0e, //-13.5
    0x00075f11, 0xfff0fe4e, 0xfff045c5, 0x001fb930, 0x0007a4d5, //-13.0
    0x0007966c, 0xfff08e97, 0xfff046c5, 0x001fb827, 0x0007dd31, //-12.5
    0x0007cf64, 0xfff01ba2, 0xfff047ca, 0x001fb71b, 0x0008172e, //-12.0
    0x00080a05, 0xffefa558, 0xfff048d2, 0x001fb60b, 0x000852d7, //-11.5
    0x0008465c, 0xffef2b9f, 0xfff049dd, 0x001fb4f7, 0x00089039, //-11.0
    0x00088474, 0xffeeae5f, 0xfff04aed, 0x001fb3de, 0x0008cf61, //-10.5
    0x0008c45b, 0xffee2d7d, 0xfff04c00, 0x001fb2c2, 0x0009105b, //-10.0
    0x0009061f, 0xffeda8df, 0xfff04d18, 0x001fb1a2, 0x00095336, //-9.5
    0x000949cc, 0xffed2069, 0xfff04e33, 0x001fb07d, 0x000997ff, //-9.0
    0x00098f72, 0xffec93fe, 0xfff04f52, 0x001faf54, 0x0009dec4, //-8.5
    0x0009d71e, 0xffec0381, 0xfff05076, 0x001fae26, 0x000a2794, //-8.0
    0x000a20e1, 0xffeb6ed5, 0xfff0519d, 0x001facf4, 0x000a727e, //-7.5
    0x000a6cc9, 0xffead5d9, 0xfff052c9, 0x001fabbe, 0x000abf92, //-7.0
    0x000abae6, 0xffea386f, 0xfff053f9, 0x001faa83, 0x000b0ede, //-6.5
    0x000b0b48, 0xffe99676, 0xfff0552d, 0x001fa944, 0x000b6075, //-6.0
    0x000b5e01, 0xffe8efcc, 0xfff05666, 0x001fa7ff, 0x000bb467, //-5.5
    0x000bb321, 0xffe8444e, 0xfff057a3, 0x001fa6b6, 0x000c0ac4, //-5.0
    0x000c0abb, 0xffe793d9, 0xfff058e5, 0x001fa569, 0x000c63a0, //-4.5
    0x000c64e0, 0xffe6de48, 0xfff05a2b, 0x001fa416, 0x000cbf0b, //-4.0
    0x000cc1a4, 0xffe62375, 0xfff05b76, 0x001fa2be, 0x000d1d1a, //-3.5
    0x000d211a, 0xffe5633a, 0xfff05cc5, 0x001fa161, 0x000d7ddf, //-3.0
    0x000d8356, 0xffe49d6e, 0xfff05e19, 0x001f9fff, 0x000de16f, //-2.5
    0x000de86c, 0xffe3d1e9, 0xfff05f72, 0x001f9e98, 0x000e47de, //-2.0
    0x000e5071, 0xffe30081, 0xfff060d0, 0x001f9d2c, 0x000eb141, //-1.5
    0x000ebb7b, 0xffe22909, 0xfff06233, 0x001f9bba, 0x000f1dae, //-1.0
    0x000f29a0, 0xffe14b57, 0xfff0639b, 0x001f9a43, 0x000f8d3b, //-0.5
    0x000f9af8, 0xffe0673a, 0xfff06508, 0x001f98c6, 0x00100000, //0.0
    0x00100f9a, 0xffdf7c85, 0xfff0667a, 0x001f9744, 0x00107614, //0.5
    0x0010879d, 0xffde8b06, 0xfff067f1, 0x001f95bb, 0x0010ef8f, //1.0
    0x0011031c, 0xffdd928c, 0xfff0696e, 0x001f942e, 0x00116c8a, //1.5
    0x0011822f, 0xffdc92e3, 0xfff06af0, 0x001f929a, 0x0011ed1f, //2.0
    0x001204f2, 0xffdb8bd7, 0xfff06c77, 0x001f9100, 0x00127169, //2.5
    0x00128b7e, 0xffda7d31, 0xfff06e04, 0x001f8f60, 0x0012f983, //3.0
    0x001315f1, 0xffd966b8, 0xfff06f97, 0x001f8dbb, 0x00138588, //3.5
    0x0013a467, 0xffd84835, 0xfff0712f, 0x001f8c0e, 0x00141596, //4.0
    0x001436fd, 0xffd7216a, 0xfff072cd, 0x001f8a5c, 0x0014a9ca, //4.5
    0x0014cdd2, 0xffd5f21d, 0xfff07471, 0x001f88a3, 0x00154243, //5.0
    0x00156905, 0xffd4ba0d, 0xfff0761b, 0x001f86e4, 0x0015df1f, //5.5
    0x001608b6, 0xffd378fb, 0xfff077ca, 0x001f851e, 0x00168080, //6.0
    0x0016ad06, 0xffd22ea4, 0xfff07980, 0x001f8351, 0x00172686, //6.5
    0x00175618, 0xffd0dac5, 0xfff07b3c, 0x001f817e, 0x0017d154, //7.0
    0x0018040e, 0xffcf7d17, 0xfff07cfe, 0x001f7fa3, 0x0018810c, //7.5
    0x0018b70c, 0xffce1552, 0xfff07ec7, 0x001f7dc2, 0x001935d2, //8.0
    0x00196f37, 0xffcca32d, 0xfff08095, 0x001f7bd9, 0x0019efcc, //8.5
    0x001a2cb5, 0xffcb265b, 0xfff0826b, 0x001f79ea, 0x001aaf20, //9.0
    0x001aefae, 0xffc99e8e, 0xfff08447, 0x001f77f3, 0x001b73f4, //9.5
    0x001bb849, 0xffc80b75, 0xfff08629, 0x001f75f4, 0x001c3e72, //10.0
    0x001c86b0, 0xffc66cbe, 0xfff08813, 0x001f73ee, 0x001d0ec2, //10.5
    0x001d5b0d, 0xffc4c213, 0xfff08a03, 0x001f71e0, 0x001de50f, //11.0
    0x001e358c, 0xffc30b1e, 0xfff08bfa, 0x001f6fcb, 0x001ec186, //11.5
    0x001f165a, 0xffc14783, 0xfff08df8, 0x001f6dad, 0x001fa452, //12.0
    0x001ffda6, 0xffbf76e6, 0xfff08ffd, 0x001f6b88, 0x00208da3, //12.5
    0x0020eb9e, 0xffbd98e9, 0xfff0920a, 0x001f695a, 0x00217da8, //13.0
    0x0021e074, 0xffbbad28, 0xfff0941e, 0x001f6724, 0x00227492, //13.5
    0x0022dc5b, 0xffb9b341, 0xfff09639, 0x001f64e6, 0x00237293, //14.0
    0x0020da85, 0xffbc97f5, 0xfff1c7ed, 0x001e0940, 0x0022a272, //-14.0
    0x001fefff, 0xffbe7323, 0xfff1c1ce, 0x001e10a9, 0x0021b1cd, //-13.5
    0x001f0bdf, 0xffc04174, 0xfff1bbc3, 0x001e17f5, 0x0020c7a2, //-13.0
    0x001e2df8, 0xffc2033e, 0xfff1b5cb, 0x001e1f25, 0x001fe3c3, //-12.5
    0x001d5621, 0xffc3b8d6, 0xfff1afe6, 0x001e2639, 0x001f0607, //-12.0
    0x001c8430, 0xffc5628e, 0xfff1aa15, 0x001e2d32, 0x001e2e44, //-11.5
    0x001bb7fd, 0xffc700b7, 0xfff1a456, 0x001e3411, 0x001d5c52, //-11.0
    0x001af161, 0xffc893a0, 0xfff19ea9, 0x001e3ad5, 0x001c900a, //-10.5
    0x001a3036, 0xffca1b94, 0xfff1990f, 0x001e417f, 0x001bc945, //-10.0
    0x00197457, 0xffcb98de, 0xfff19387, 0x001e4810, 0x001b07de, //-9.5
    0x0018bd9f, 0xffcd0bc8, 0xfff18e12, 0x001e4e87, 0x001a4bb1, //-9.0
    0x00180bec, 0xffce7496, 0xfff188ae, 0x001e54e5, 0x00199499, //-8.5
    0x00175f1b, 0xffcfd38f, 0xfff1835b, 0x001e5b2c, 0x0018e276, //-8.0
    0x0016b70a, 0xffd128f5, 0xfff17e1a, 0x001e615a, 0x00183524, //-7.5
    0x00161399, 0xffd2750b, 0xfff178ea, 0x001e6770, 0x00178c83, //-7.0
    0x001574a9, 0xffd3b80f, 0xfff173cb, 0x001e6d6f, 0x0016e874, //-6.5
    0x0014da19, 0xffd4f23f, 0xfff16ebd, 0x001e7357, 0x001648d6, //-6.0
    0x001443cd, 0xffd623d9, 0xfff169c0, 0x001e7929, 0x0015ad8d, //-5.5
    0x0013b1a6, 0xffd74d17, 0xfff164d3, 0x001e7ee4, 0x00151679, //-5.0
    0x00132389, 0xffd86e32, 0xfff15ff6, 0x001e848a, 0x0014837f, //-4.5
    0x00129959, 0xffd98763, 0xfff15b29, 0x001e8a19, 0x0013f482, //-4.0
    0x001212fb, 0xffda98df, 0xfff1566d, 0x001e8f94, 0x00136967, //-3.5
    0x00119054, 0xffdba2dc, 0xfff151c0, 0x001e94f9, 0x0012e214, //-3.0
    0x0011114c, 0xffdca58e, 0xfff14d22, 0x001e9a4a, 0x00125e6e, //-2.5
    0x001095c9, 0xffdda126, 0xfff14894, 0x001e9f87, 0x0011de5d, //-2.0
    0x00101db2, 0xffde95d6, 0xfff14415, 0x001ea4b0, 0x001161c7, //-1.5
    0x000fa8f0, 0xffdf83cd, 0xfff13fa6, 0x001ea9c5, 0x0010e895, //-1.0
    0x000f376b, 0xffe06b3a, 0xfff13b45, 0x001eaec7, 0x001072b0, //-0.5
    0x000ec90e, 0xffe14c4b, 0xfff136f2, 0x001eb3b5, 0x00100000, //0.0
    0x000e5dc2, 0xffe2272a, 0xfff132ae, 0x001eb891, 0x000f9070, //0.5
    0x000df571, 0xffe2fc03, 0xfff12e79, 0x001ebd5a, 0x000f23ea, //1.0
    0x000d9008, 0xffe3cb01, 0xfff12a51, 0x001ec212, 0x000eba59, //1.5
    0x000d2d72, 0xffe4944a, 0xfff12638, 0x001ec6b7, 0x000e53a9, //2.0
    0x000ccd9a, 0xffe55807, 0xfff1222c, 0x001ecb4a, 0x000defc6, //2.5
    0x000c706f, 0xffe6165f, 0xfff11e2e, 0x001ecfcc, 0x000d8e9d, //3.0
    0x000c15dc, 0xffe6cf77, 0xfff11a3e, 0x001ed43d, 0x000d301a, //3.5
    0x000bbdd1, 0xffe78374, 0xfff1165b, 0x001ed89d, 0x000cd42c, //4.0
    0x000b683b, 0xffe83278, 0xfff11285, 0x001edced, 0x000c7ac0, //4.5
    0x000b1509, 0xffe8dca8, 0xfff10ebc, 0x001ee12c, 0x000c23c5, //5.0
    0x000ac42b, 0xffe98223, 0xfff10b00, 0x001ee55b, 0x000bcf2b, //5.5
    0x000a7590, 0xffea230c, 0xfff10750, 0x001ee97a, 0x000b7ce0, //6.0
    0x000a2928, 0xffeabf82, 0xfff103ad, 0x001eed89, 0x000b2cd5, //6.5
    0x0009dee3, 0xffeb57a3, 0xfff10017, 0x001ef189, 0x000adefa, //7.0
    0x000996b4, 0xffebeb90, 0xfff0fc8d, 0x001ef57a, 0x000a9340, //7.5
    0x0009508a, 0xffec7b64, 0xfff0f90f, 0x001ef95c, 0x000a4999, //8.0
    0x00090c58, 0xffed073c, 0xfff0f59c, 0x001efd30, 0x000a01f4, //8.5
    0x0008ca10, 0xffed8f35, 0xfff0f236, 0x001f00f4, 0x0009bc46, //9.0
    0x000889a5, 0xffee1369, 0xfff0eedb, 0x001f04ab, 0x00097880, //9.5
    0x00084b08, 0xffee93f3, 0xfff0eb8c, 0x001f0853, 0x00093694, //10.0
    0x00080e2f, 0xffef10ed, 0xfff0e848, 0x001f0bee, 0x0008f677, //10.5
    0x0007d30b, 0xffef8a6f, 0xfff0e50f, 0x001f0f7b, 0x0008b81b, //11.0
    0x00079992, 0xfff00092, 0xfff0e1e2, 0x001f12fb, 0x00087b74, //11.5
    0x000761b7, 0xfff0736d, 0xfff0debf, 0x001f166d, 0x00084076, //12.0
    0x00072b6e, 0xfff0e318, 0xfff0dba7, 0x001f19d2, 0x00080715, //12.5
    0x0006f6ad, 0xfff14fa9, 0xfff0d89a, 0x001f1d2b, 0x0007cf48, //13.0
    0x0006c369, 0xfff1b936, 0xfff0d597, 0x001f2077, 0x00079901, //13.5
    0x00069198, 0xfff21fd3, 0xfff0d29f, 0x001f23b6, 0x00076437, //14.0
    // Band 3, -14.0 dB ~ +14.0 dB (57*2 sets)
    0x00069198, 0xfff21fd3, 0xfff0d29f, 0x001f23b6, 0x00076437, //-14.0
    0x0006c369, 0xfff1b936, 0xfff0d597, 0x001f2077, 0x00079901, //-13.5
    0x0006f6ad, 0xfff14fa9, 0xfff0d89a, 0x001f1d2b, 0x0007cf48, //-13.0
    0x00072b6e, 0xfff0e318, 0xfff0dba7, 0x001f19d2, 0x00080715, //-12.5
    0x000761b7, 0xfff0736d, 0xfff0debf, 0x001f166d, 0x00084076, //-12.0
    0x00079992, 0xfff00092, 0xfff0e1e2, 0x001f12fb, 0x00087b74, //-11.5
    0x0007d30b, 0xffef8a6f, 0xfff0e50f, 0x001f0f7b, 0x0008b81b, //-11.0
    0x00080e2f, 0xffef10ed, 0xfff0e848, 0x001f0bee, 0x0008f677, //-10.5
    0x00084b08, 0xffee93f3, 0xfff0eb8c, 0x001f0853, 0x00093694, //-10.0
    0x000889a5, 0xffee1369, 0xfff0eedb, 0x001f04ab, 0x00097880, //-9.5
    0x0008ca10, 0xffed8f35, 0xfff0f236, 0x001f00f4, 0x0009bc46, //-9.0
    0x00090c58, 0xffed073c, 0xfff0f59c, 0x001efd30, 0x000a01f4, //-8.5
    0x0009508a, 0xffec7b64, 0xfff0f90f, 0x001ef95c, 0x000a4999, //-8.0
    0x000996b4, 0xffebeb90, 0xfff0fc8d, 0x001ef57a, 0x000a9340, //-7.5
    0x0009dee3, 0xffeb57a3, 0xfff10017, 0x001ef189, 0x000adefa, //-7.0
    0x000a2928, 0xffeabf82, 0xfff103ad, 0x001eed89, 0x000b2cd5, //-6.5
    0x000a7590, 0xffea230c, 0xfff10750, 0x001ee97a, 0x000b7ce0, //-6.0
    0x000ac42b, 0xffe98223, 0xfff10b00, 0x001ee55b, 0x000bcf2b, //-5.5
    0x000b1509, 0xffe8dca8, 0xfff10ebc, 0x001ee12c, 0x000c23c5, //-5.0
    0x000b683b, 0xffe83278, 0xfff11285, 0x001edced, 0x000c7ac0, //-4.5
    0x000bbdd1, 0xffe78374, 0xfff1165b, 0x001ed89d, 0x000cd42c, //-4.0
    0x000c15dc, 0xffe6cf77, 0xfff11a3e, 0x001ed43d, 0x000d301a, //-3.5
    0x000c706f, 0xffe6165f, 0xfff11e2e, 0x001ecfcc, 0x000d8e9d, //-3.0
    0x000ccd9a, 0xffe55807, 0xfff1222c, 0x001ecb4a, 0x000defc6, //-2.5
    0x000d2d72, 0xffe4944a, 0xfff12638, 0x001ec6b7, 0x000e53a9, //-2.0
    0x000d9008, 0xffe3cb01, 0xfff12a51, 0x001ec212, 0x000eba59, //-1.5
    0x000df571, 0xffe2fc03, 0xfff12e79, 0x001ebd5a, 0x000f23ea, //-1.0
    0x000e5dc2, 0xffe2272a, 0xfff132ae, 0x001eb891, 0x000f9070, //-0.5
    0x000ec90e, 0xffe14c4b, 0xfff136f2, 0x001eb3b5, 0x00100000, //0.0
    0x000f376b, 0xffe06b3a, 0xfff13b45, 0x001eaec7, 0x001072b0, //0.5
    0x000fa8f0, 0xffdf83cd, 0xfff13fa6, 0x001ea9c5, 0x0010e895, //1.0
    0x00101db2, 0xffde95d6, 0xfff14415, 0x001ea4b0, 0x001161c7, //1.5
    0x001095c9, 0xffdda126, 0xfff14894, 0x001e9f87, 0x0011de5d, //2.0
    0x0011114c, 0xffdca58e, 0xfff14d22, 0x001e9a4a, 0x00125e6e, //2.5
    0x00119054, 0xffdba2dc, 0xfff151c0, 0x001e94f9, 0x0012e214, //3.0
    0x001212fb, 0xffda98df, 0xfff1566d, 0x001e8f94, 0x00136967, //3.5
    0x00129959, 0xffd98763, 0xfff15b29, 0x001e8a19, 0x0013f482, //4.0
    0x00132389, 0xffd86e32, 0xfff15ff6, 0x001e848a, 0x0014837f, //4.5
    0x0013b1a6, 0xffd74d17, 0xfff164d3, 0x001e7ee4, 0x00151679, //5.0
    0x001443cd, 0xffd623d9, 0xfff169c0, 0x001e7929, 0x0015ad8d, //5.5
    0x0014da19, 0xffd4f23f, 0xfff16ebd, 0x001e7357, 0x001648d6, //6.0
    0x001574a9, 0xffd3b80f, 0xfff173cb, 0x001e6d6f, 0x0016e874, //6.5
    0x00161399, 0xffd2750b, 0xfff178ea, 0x001e6770, 0x00178c83, //7.0
    0x0016b70a, 0xffd128f5, 0xfff17e1a, 0x001e615a, 0x00183524, //7.5
    0x00175f1b, 0xffcfd38f, 0xfff1835b, 0x001e5b2c, 0x0018e276, //8.0
    0x00180bec, 0xffce7496, 0xfff188ae, 0x001e54e5, 0x00199499, //8.5
    0x0018bd9f, 0xffcd0bc8, 0xfff18e12, 0x001e4e87, 0x001a4bb1, //9.0
    0x00197457, 0xffcb98de, 0xfff19387, 0x001e4810, 0x001b07de, //9.5
    0x001a3036, 0xffca1b94, 0xfff1990f, 0x001e417f, 0x001bc945, //10.0
    0x001af161, 0xffc893a0, 0xfff19ea9, 0x001e3ad5, 0x001c900a, //10.5
    0x001bb7fd, 0xffc700b7, 0xfff1a456, 0x001e3411, 0x001d5c52, //11.0
    0x001c8430, 0xffc5628e, 0xfff1aa15, 0x001e2d32, 0x001e2e44, //11.5
    0x001d5621, 0xffc3b8d6, 0xfff1afe6, 0x001e2639, 0x001f0607, //12.0
    0x001e2df8, 0xffc2033e, 0xfff1b5cb, 0x001e1f25, 0x001fe3c3, //12.5
    0x001f0bdf, 0xffc04174, 0xfff1bbc3, 0x001e17f5, 0x0020c7a2, //13.0
    0x001fefff, 0xffbe7323, 0xfff1c1ce, 0x001e10a9, 0x0021b1cd, //13.5
    0x0020da85, 0xffbc97f5, 0xfff1c7ed, 0x001e0940, 0x0022a272, //14.0
    0x001b1d9f, 0xffc58e7c, 0xfff4ee1b, 0x00197659, 0x00200bba, //-14.0
    0x001a64c8, 0xffc70f1b, 0xfff4dfb5, 0x00198f40, 0x001f447d, //-13.5
    0x0019b07a, 0xffc88687, 0xfff4d16c, 0x0019a7cb, 0x001e81e6, //-13.0
    0x0019009d, 0xffc9f4f4, 0xfff4c33f, 0x0019bffb, 0x001dc3dc, //-12.5
    0x00185519, 0xffcb5a90, 0xfff4b52f, 0x0019d7d0, 0x001d0a48, //-12.0
    0x0017add6, 0xffccb78e, 0xfff4a73c, 0x0019ef4c, 0x001c5511, //-11.5
    0x00170abb, 0xffce0c1b, 0xfff49965, 0x001a0670, 0x001ba420, //-11.0
    0x00166bb2, 0xffcf5867, 0xfff48bac, 0x001a1d3d, 0x001af75e, //-10.5
    0x0015d0a2, 0xffd09c9f, 0xfff47e10, 0x001a33b5, 0x001a4eb2, //-10.0
    0x00153977, 0xffd1d8f1, 0xfff47091, 0x001a49d7, 0x0019aa09, //-9.5
    0x0014a619, 0xffd30d89, 0xfff46330, 0x001a5fa7, 0x0019094a, //-9.0
    0x00141673, 0xffd43a93, 0xfff455ed, 0x001a7523, 0x00186c60, //-8.5
    0x00138a70, 0xffd56038, 0xfff448c7, 0x001a8a4f, 0x0017d336, //-8.0
    0x001301f9, 0xffd67ea4, 0xfff43bbe, 0x001a9f2a, 0x00173db7, //-7.5
    0x00127cfc, 0xffd795ff, 0xfff42ed3, 0x001ab3b7, 0x0016abcf, //-7.0
    0x0011fb62, 0xffd8a672, 0xfff42206, 0x001ac7f5, 0x00161d69, //-6.5
    0x00117d1a, 0xffd9b025, 0xfff41557, 0x001adbe6, 0x00159271, //-6.0
    0x0011020e, 0xffdab33f, 0xfff408c5, 0x001aef8c, 0x00150ad3, //-5.5
    0x00108a2c, 0xffdbafe6, 0xfff3fc51, 0x001b02e6, 0x0014867d, //-5.0
    0x00101561, 0xffdca641, 0xfff3effb, 0x001b15f7, 0x0014055c, //-4.5
    0x000fa39a, 0xffdd9673, 0xfff3e3c3, 0x001b28bf, 0x0013875d, //-4.0
    0x000f34c6, 0xffde80a1, 0xfff3d7a8, 0x001b3b3f, 0x00130c6e, //-3.5
    0x000ec8d3, 0xffdf64ee, 0xfff3cbab, 0x001b4d79, 0x0012947e, //-3.0
    0x000e5faf, 0xffe0437e, 0xfff3bfcc, 0x001b5f6d, 0x00121f7a, //-2.5
    0x000df949, 0xffe11c73, 0xfff3b40a, 0x001b711c, 0x0011ad53, //-2.0
    0x000d9591, 0xffe1efed, 0xfff3a865, 0x001b8287, 0x00113df6, //-1.5
    0x000d3476, 0xffe2be0e, 0xfff39cde, 0x001b93af, 0x0010d154, //-1.0
    0x000cd5e8, 0xffe386f6, 0xfff39174, 0x001ba496, 0x0010675d, //-0.5
    0x000c79d8, 0xffe44ac5, 0xfff38628, 0x001bb53b, 0x00100000, //0.0
    0x000c2036, 0xffe50999, 0xfff37af9, 0x001bc5a1, 0x000f9b2f, //0.5
    0x000bc8f3, 0xffe5c390, 0xfff36fe6, 0x001bd5c7, 0x000f38d9, //1.0
    0x000b7400, 0xffe678c9, 0xfff364f1, 0x001be5af, 0x000ed8f2, //1.5
    0x000b2150, 0xffe7295f, 0xfff35a19, 0x001bf55b, 0x000e7b68, //2.0
    0x000ad0d3, 0xffe7d571, 0xfff34f5d, 0x001c04c9, 0x000e2030, //2.5
    0x000a827c, 0xffe87d18, 0xfff344be, 0x001c13fc, 0x000dc73a, //3.0
    0x000a363d, 0xffe92071, 0xfff33a3b, 0x001c22f5, 0x000d7078, //3.5
    0x0009ec0a, 0xffe9bf96, 0xfff32fd5, 0x001c31b4, 0x000d1bdf, //4.0
    0x0009a3d5, 0xffea5aa1, 0xfff3258b, 0x001c403a, 0x000cc960, //4.5
    0x00095d91, 0xffeaf1ac, 0xfff31b5d, 0x001c4e88, 0x000c78ee, //5.0
    0x00091933, 0xffeb84cf, 0xfff3114b, 0x001c5c9f, 0x000c2a7e, //5.5
    0x0008d6ae, 0xffec1423, 0xfff30754, 0x001c6a7f, 0x000bde02, //6.0
    0x000895f6, 0xffec9fc0, 0xfff2fd7a, 0x001c782a, 0x000b936f, //6.5
    0x000856ff, 0xffed27be, 0xfff2f3ba, 0x001c85a0, 0x000b4aba, //7.0
    0x000819bf, 0xffedac32, 0xfff2ea16, 0x001c92e2, 0x000b03d6, //7.5
    0x0007de2a, 0xffee2d33, 0xfff2e08e, 0x001c9ff0, 0x000abeb8, //8.0
    0x0007a436, 0xffeeaad8, 0xfff2d720, 0x001caccc, 0x000a7b56, //8.5
    0x00076bd8, 0xffef2535, 0xfff2cdcd, 0x001cb977, 0x000a39a4, //9.0
    0x00073505, 0xffef9c5f, 0xfff2c494, 0x001cc5f0, 0x0009f999, //9.5
    0x0006ffb3, 0xfff0106b, 0xfff2bb76, 0x001cd23a, 0x0009bb29, //10.0
    0x0006cbd9, 0xfff0816c, 0xfff2b272, 0x001cde53, 0x00097e4c, //10.5
    0x0006996e, 0xfff0ef77, 0xfff2a988, 0x001cea3e, 0x000942f6, //11.0
    0x00066866, 0xfff15a9d, 0xfff2a0b8, 0x001cf5fb, 0x0009091f, //11.5
    0x000638ba, 0xfff1c2f2, 0xfff29802, 0x001d018b, 0x0008d0bd, //12.0
    0x00060a61, 0xfff22888, 0xfff28f66, 0x001d0ced, 0x000899c6, //12.5
    0x0005dd51, 0xfff28b70, 0xfff286e2, 0x001d1824, 0x00086433, //13.0
    0x0005b182, 0xfff2ebbc, 0xfff27e78, 0x001d232f, 0x00082ffa, //13.5
    0x000586ec, 0xfff3497d, 0xfff27627, 0x001d2e10, 0x0007fd13, //14.0
    // Band 4, -14.0 dB ~ +14.0 dB (57*2 sets)
    0x000586ec, 0xfff3497d, 0xfff27627, 0x001d2e10, 0x0007fd13, //-14.0
    0x0005b182, 0xfff2ebbc, 0xfff27e78, 0x001d232f, 0x00082ffa, //-13.5
    0x0005dd51, 0xfff28b70, 0xfff286e2, 0x001d1824, 0x00086433, //-13.0
    0x00060a61, 0xfff22888, 0xfff28f66, 0x001d0ced, 0x000899c6, //-12.5
    0x000638ba, 0xfff1c2f2, 0xfff29802, 0x001d018b, 0x0008d0bd, //-12.0
    0x00066866, 0xfff15a9d, 0xfff2a0b8, 0x001cf5fb, 0x0009091f, //-11.5
    0x0006996e, 0xfff0ef77, 0xfff2a988, 0x001cea3e, 0x000942f6, //-11.0
    0x0006cbd9, 0xfff0816c, 0xfff2b272, 0x001cde53, 0x00097e4c, //-10.5
    0x0006ffb3, 0xfff0106b, 0xfff2bb76, 0x001cd23a, 0x0009bb29, //-10.0
    0x00073505, 0xffef9c5f, 0xfff2c494, 0x001cc5f0, 0x0009f999, //-9.5
    0x00076bd8, 0xffef2535, 0xfff2cdcd, 0x001cb977, 0x000a39a4, //-9.0
    0x0007a436, 0xffeeaad8, 0xfff2d720, 0x001caccc, 0x000a7b56, //-8.5
    0x0007de2a, 0xffee2d33, 0xfff2e08e, 0x001c9ff0, 0x000abeb8, //-8.0
    0x000819bf, 0xffedac32, 0xfff2ea16, 0x001c92e2, 0x000b03d6, //-7.5
    0x000856ff, 0xffed27be, 0xfff2f3ba, 0x001c85a0, 0x000b4aba, //-7.0
    0x000895f6, 0xffec9fc0, 0xfff2fd7a, 0x001c782a, 0x000b936f, //-6.5
    0x0008d6ae, 0xffec1423, 0xfff30754, 0x001c6a7f, 0x000bde02, //-6.0
    0x00091933, 0xffeb84cf, 0xfff3114b, 0x001c5c9f, 0x000c2a7e, //-5.5
    0x00095d91, 0xffeaf1ac, 0xfff31b5d, 0x001c4e88, 0x000c78ee, //-5.0
    0x0009a3d5, 0xffea5aa1, 0xfff3258b, 0x001c403a, 0x000cc960, //-4.5
    0x0009ec0a, 0xffe9bf96, 0xfff32fd5, 0x001c31b4, 0x000d1bdf, //-4.0
    0x000a363d, 0xffe92071, 0xfff33a3b, 0x001c22f5, 0x000d7078, //-3.5
    0x000a827c, 0xffe87d18, 0xfff344be, 0x001c13fc, 0x000dc73a, //-3.0
    0x000ad0d3, 0xffe7d571, 0xfff34f5d, 0x001c04c9, 0x000e2030, //-2.5
    0x000b2150, 0xffe7295f, 0xfff35a19, 0x001bf55b, 0x000e7b68, //-2.0
    0x000b7400, 0xffe678c9, 0xfff364f1, 0x001be5af, 0x000ed8f2, //-1.5
    0x000bc8f3, 0xffe5c390, 0xfff36fe6, 0x001bd5c7, 0x000f38d9, //-1.0
    0x000c2036, 0xffe50999, 0xfff37af9, 0x001bc5a1, 0x000f9b2f, //-0.5
    0x000c79d8, 0xffe44ac5, 0xfff38628, 0x001bb53b, 0x00100000, //0.0
    0x000cd5e8, 0xffe386f6, 0xfff39174, 0x001ba496, 0x0010675d, //0.5
    0x000d3476, 0xffe2be0e, 0xfff39cde, 0x001b93af, 0x0010d154, //1.0
    0x000d9591, 0xffe1efed, 0xfff3a865, 0x001b8287, 0x00113df6, //1.5
    0x000df949, 0xffe11c73, 0xfff3b40a, 0x001b711c, 0x0011ad53, //2.0
    0x000e5faf, 0xffe0437e, 0xfff3bfcc, 0x001b5f6d, 0x00121f7a, //2.5
    0x000ec8d3, 0xffdf64ee, 0xfff3cbab, 0x001b4d79, 0x0012947e, //3.0
    0x000f34c6, 0xffde80a1, 0xfff3d7a8, 0x001b3b3f, 0x00130c6e, //3.5
    0x000fa39a, 0xffdd9673, 0xfff3e3c3, 0x001b28bf, 0x0013875d, //4.0
    0x00101561, 0xffdca641, 0xfff3effb, 0x001b15f7, 0x0014055c, //4.5
    0x00108a2c, 0xffdbafe6, 0xfff3fc51, 0x001b02e6, 0x0014867d, //5.0
    0x0011020e, 0xffdab33f, 0xfff408c5, 0x001aef8c, 0x00150ad3, //5.5
    0x00117d1a, 0xffd9b025, 0xfff41557, 0x001adbe6, 0x00159271, //6.0
    0x0011fb62, 0xffd8a672, 0xfff42206, 0x001ac7f5, 0x00161d69, //6.5
    0x00127cfc, 0xffd795ff, 0xfff42ed3, 0x001ab3b7, 0x0016abcf, //7.0
    0x001301f9, 0xffd67ea4, 0xfff43bbe, 0x001a9f2a, 0x00173db7, //7.5
    0x00138a70, 0xffd56038, 0xfff448c7, 0x001a8a4f, 0x0017d336, //8.0
    0x00141673, 0xffd43a93, 0xfff455ed, 0x001a7523, 0x00186c60, //8.5
    0x0014a619, 0xffd30d89, 0xfff46330, 0x001a5fa7, 0x0019094a, //9.0
    0x00153977, 0xffd1d8f1, 0xfff47091, 0x001a49d7, 0x0019aa09, //9.5
    0x0015d0a2, 0xffd09c9f, 0xfff47e10, 0x001a33b5, 0x001a4eb2, //10.0
    0x00166bb2, 0xffcf5867, 0xfff48bac, 0x001a1d3d, 0x001af75e, //10.5
    0x00170abb, 0xffce0c1b, 0xfff49965, 0x001a0670, 0x001ba420, //11.0
    0x0017add6, 0xffccb78e, 0xfff4a73c, 0x0019ef4c, 0x001c5511, //11.5
    0x00185519, 0xffcb5a90, 0xfff4b52f, 0x0019d7d0, 0x001d0a48, //12.0
    0x0019009d, 0xffc9f4f4, 0xfff4c33f, 0x0019bffb, 0x001dc3dc, //12.5
    0x0019b07a, 0xffc88687, 0xfff4d16c, 0x0019a7cb, 0x001e81e6, //13.0
    0x001a64c8, 0xffc70f1b, 0xfff4dfb5, 0x00198f40, 0x001f447d, //13.5
    0x001b1d9f, 0xffc58e7c, 0xfff4ee1b, 0x00197659, 0x00200bba, //14.0
    0x000e7ea5, 0xffddbcbf, 0xfffa261f, 0x000aef9a, 0x0018a4c4, //-14.0
    0x000e2df0, 0xffde76de, 0xfffa1939, 0x000b3219, 0x00184729, //-13.5
    0x000dde8a, 0xffdf2e90, 0xfffa0c17, 0x000b741d, 0x0017eaa2, //-13.0
    0x000d9074, 0xffdfe3d5, 0xfff9febb, 0x000bb5a5, 0x00178f2f, //-12.5
    0x000d43ab, 0xffe096ad, 0xfff9f125, 0x000bf6ae, 0x001734d0, //-12.0
    0x000cf830, 0xffe14717, 0xfff9e358, 0x000c3737, 0x0016db88, //-11.5
    0x000cae01, 0xffe1f513, 0xfff9d555, 0x000c773e, 0x00168356, //-11.0
    0x000c651c, 0xffe2a0a2, 0xfff9c71f, 0x000cb6c3, 0x00162c3b, //-10.5
    0x000c1d81, 0xffe349c4, 0xfff9b8b6, 0x000cf5c3, 0x0015d637, //-10.0
    0x000bd72d, 0xffe3f07b, 0xfff9aa1d, 0x000d343d, 0x0015814a, //-9.5
    0x000b921f, 0xffe494c8, 0xfff99b55, 0x000d7230, 0x00152d74, //-9.0
    0x000b4e55, 0xffe536ac, 0xfff98c5f, 0x000daf9b, 0x0014dab5, //-8.5
    0x000b0bce, 0xffe5d62a, 0xfff97d3e, 0x000dec7d, 0x0014890c, //-8.0
    0x000aca87, 0xffe67342, 0xfff96df3, 0x000e28d4, 0x0014387a, //-7.5
    0x000a8a7e, 0xffe70df8, 0xfff95e80, 0x000e64a1, 0x0013e8fe, //-7.0
    0x000a4bb0, 0xffe7a64e, 0xfff94ee7, 0x000e9fe1, 0x00139a97, //-6.5
    0x000a0e1b, 0xffe83c48, 0xfff93f29, 0x000eda94, 0x00134d44, //-6.0
    0x0009d1be, 0xffe8cfe7, 0xfff92f47, 0x000f14ba, 0x00130105, //-5.5
    0x00099694, 0xffe9612f, 0xfff91f44, 0x000f4e52, 0x0012b5d9, //-5.0
    0x00095c9c, 0xffe9f023, 0xfff90f22, 0x000f875a, 0x00126bbe, //-4.5
    0x000923d2, 0xffea7cc8, 0xfff8fee1, 0x000fbfd4, 0x001222b3, //-4.0
    0x0008ec34, 0xffeb0721, 0xfff8ee83, 0x000ff7be, 0x0011dab7, //-3.5
    0x0008b5bf, 0xffeb8f32, 0xfff8de0a, 0x00102f18, 0x001193ca, //-3.0
    0x00088070, 0xffec1500, 0xfff8cd78, 0x001065e1, 0x00114de8, //-2.5
    0x00084c43, 0xffec988e, 0xfff8bcce, 0x00109c1a, 0x00110911, //-2.0
    0x00081936, 0xffed19e1, 0xfff8ac0e, 0x0010d1c2, 0x0010c544, //-1.5
    0x0007e745, 0xffed98fe, 0xfff89b39, 0x001106da, 0x0010827d, //-1.0
    0x0007b66c, 0xffee15eb, 0xfff88a51, 0x00113b60, 0x001040bd, //-0.5
    0x000786aa, 0xffee90aa, 0xfff87956, 0x00116f56, 0x00100000, //0.0
    0x000757f9, 0xffef0943, 0xfff8684c, 0x0011a2ba, 0x000fc045, //0.5
    0x00072a57, 0xffef7fba, 0xfff85733, 0x0011d58f, 0x000f818a, //1.0
    0x0006fdc0, 0xffeff414, 0xfff8460c, 0x001207d2, 0x000f43cd, //1.5
    0x0006d231, 0xfff06658, 0xfff834da, 0x00123986, 0x000f070b, //2.0
    0x0006a7a6, 0xfff0d68a, 0xfff8239d, 0x00126aa9, 0x000ecb43, //2.5
    0x00067e1c, 0xfff144b0, 0xfff81257, 0x00129b3d, 0x000e9072, //3.0
    0x0006558e, 0xfff1b0d0, 0xfff80109, 0x0012cb42, 0x000e5697, //3.5
    0x00062df9, 0xfff21af0, 0xfff7efb4, 0x0012fab8, 0x000e1dad, //4.0
    0x0006075b, 0xfff28316, 0xfff7de5a, 0x0013299f, 0x000de5b5, //4.5
    0x0005e1ad, 0xfff2e948, 0xfff7ccfc, 0x001357f9, 0x000daeaa, //5.0
    0x0005bcee, 0xfff34d8b, 0xfff7bb9c, 0x001385c6, 0x000d788a, //5.5
    0x0005991a, 0xfff3afe7, 0xfff7aa3a, 0x0013b306, 0x000d4354, //6.0
    0x0005762c, 0xfff41060, 0xfff798d8, 0x0013dfba, 0x000d0f04, //6.5
    0x00055421, 0xfff46efe, 0xfff78776, 0x00140be3, 0x000cdb97, //7.0
    0x000532f5, 0xfff4cbc7, 0xfff77617, 0x00143781, 0x000ca90d, //7.5
    0x000512a5, 0xfff526c0, 0xfff764bb, 0x00146295, 0x000c7760, //8.0
    0x0004f32d, 0xfff57ff0, 0xfff75363, 0x00148d21, 0x000c4690, //8.5
    0x0004d488, 0xfff5d75e, 0xfff74211, 0x0014b724, 0x000c1699, //9.0
    0x0004b6b4, 0xfff62d10, 0xfff730c5, 0x0014e09f, 0x000be779, //9.5
    0x000499ad, 0xfff6810c, 0xfff71f80, 0x00150995, 0x000bb92d, //10.0
    0x00047d6e, 0xfff6d359, 0xfff70e44, 0x00153205, 0x000b8bb2, //10.5
    0x000461f5, 0xfff723fc, 0xfff6fd11, 0x001559f0, 0x000b5f06, //11.0
    0x0004473d, 0xfff772fd, 0xfff6ebe9, 0x00158157, 0x000b3326, //11.5
    0x00042d44, 0xfff7c062, 0xfff6dacc, 0x0015a83c, 0x000b080f, //12.0
    0x00041405, 0xfff80c31, 0xfff6c9ba, 0x0015ce9f, 0x000addbf, //12.5
    0x0003fb7c, 0xfff85670, 0xfff6b8b6, 0x0015f481, 0x000ab432, //13.0
    0x0003e3a7, 0xfff89f26, 0xfff6a7c0, 0x001619e4, 0x000a8b67, //13.5
    0x0003cc81, 0xfff8e658, 0xfff696d8, 0x00163ec8, 0x000a6359, //14.0
    // Band 5, -14.0 dB ~ +14.0 dB (57 sets)
    0x0001b267, 0xfffcd416, 0xfff696d8, 0x00163ec8, 0x0004a3e3, //-14.0
    0x0001c9ba, 0xfffc9ba5, 0xfff6a7c0, 0x001619e4, 0x0004d8fd, //-13.5
    0x0001e25f, 0xfffc5fe3, 0xfff6b8b6, 0x0015f481, 0x00051087, //-13.0
    0x0001fc67, 0xfffc20a1, 0xfff6c9ba, 0x0015ce9f, 0x00054a9f, //-12.5
    0x000217e7, 0xfffbddb0, 0xfff6dacc, 0x0015a83c, 0x00058762, //-12.0
    0x000234f3, 0xfffb96dd, 0xfff6ebe9, 0x00158157, 0x0005c6f0, //-11.5
    0x000253a1, 0xfffb4bf3, 0xfff6fd11, 0x001559f0, 0x0006096b, //-11.0
    0x00027409, 0xfffafcbb, 0xfff70e44, 0x00153205, 0x00064ef4, //-10.5
    0x00029641, 0xfffaa8fa, 0xfff71f80, 0x00150995, 0x000697af, //-10.0
    0x0002ba65, 0xfffa5074, 0xfff730c5, 0x0014e09f, 0x0006e3c3, //-9.5
    0x0002e08e, 0xfff9f2e7, 0xfff74211, 0x0014b724, 0x00073356, //-9.0
    0x000308d9, 0xfff99012, 0xfff75363, 0x00148d21, 0x00078691, //-8.5
    0x00033364, 0xfff927ad, 0xfff764bb, 0x00146295, 0x0007dd9f, //-8.0
    0x0003604d, 0xfff8b96e, 0xfff77617, 0x00143781, 0x000838ad, //-7.5
    0x00038fb5, 0xfff84508, 0xfff78776, 0x00140be3, 0x000897ea, //-7.0
    0x0003c1bf, 0xfff7ca29, 0xfff798d8, 0x0013dfba, 0x0008fb87, //-6.5
    0x0003f68f, 0xfff7487c, 0xfff7aa3a, 0x0013b306, 0x000963b5, //-6.0
    0x00042e4a, 0xfff6bfa9, 0xfff7bb9c, 0x001385c6, 0x0009d0ab, //-5.5
    0x00046919, 0xfff62f51, 0xfff7ccfc, 0x001357f9, 0x000a42a0, //-5.0
    0x0004a726, 0xfff59712, 0xfff7de5a, 0x0013299f, 0x000ab9cf, //-4.5
    0x0004e89b, 0xfff4f687, 0xfff7efb4, 0x0012fab8, 0x000b3672, //-4.0
    0x00052da8, 0xfff44d43, 0xfff80109, 0x0012cb42, 0x000bb8ca, //-3.5
    0x0005767d, 0xfff39ad6, 0xfff81257, 0x00129b3d, 0x000c4119, //-3.0
    0x0005c34d, 0xfff2decb, 0xfff8239d, 0x00126aa9, 0x000ccfa2, //-2.5
    0x0006144c, 0xfff218a6, 0xfff834da, 0x00123986, 0x000d64ae, //-2.0
    0x000669b2, 0xfff147e7, 0xfff8460c, 0x001207d2, 0x000e0088, //-1.5
    0x0006c3ba, 0xfff06c07, 0xfff85733, 0x0011d58f, 0x000ea37d, //-1.0
    0x000722a2, 0xffef847a, 0xfff8684c, 0x0011a2ba, 0x000f4dde, //-0.5
    0x000786aa, 0xffee90aa, 0xfff87956, 0x00116f56, 0x00100000, //0.0
    0x0007f014, 0xffed9000, 0xfff88a51, 0x00113b60, 0x0010ba3c, //0.5
    0x00085f27, 0xffec81d9, 0xfff89b39, 0x001106da, 0x00117ced, //1.0
    0x0008d42e, 0xffeb658e, 0xfff8ac0e, 0x0010d1c2, 0x00124873, //1.5
    0x00094f76, 0xffea3a6f, 0xfff8bcce, 0x00109c1a, 0x00131d33, //2.0
    0x0009d14f, 0xffe8ffc4, 0xfff8cd78, 0x001065e1, 0x0013fb93, //2.5
    0x000a5a0f, 0xffe7b4cd, 0xfff8de0a, 0x00102f18, 0x0014e402, //3.0
    0x000aea0e, 0xffe658c2, 0xfff8ee83, 0x000ff7be, 0x0015d6ef, //3.5
    0x000b81a9, 0xffe4ead3, 0xfff8fee1, 0x000fbfd4, 0x0016d4d0, //4.0
    0x000c2141, 0xffe36a24, 0xfff90f22, 0x000f875a, 0x0017de1f, //4.5
    0x000cc93c, 0xffe1d5d2, 0xfff91f44, 0x000f4e52, 0x0018f35d, //5.0
    0x000d7a03, 0xffe02cef, 0xfff92f47, 0x000f14ba, 0x001a150d, //5.5
    0x000e3406, 0xffde6e84, 0xfff93f29, 0x000eda94, 0x001b43b9, //6.0
    0x000ef7b9, 0xffdc998d, 0xfff94ee7, 0x000e9fe1, 0x001c7ff2, //6.5
    0x000fc594, 0xffdaacfe, 0xfff95e80, 0x000e64a1, 0x001dca4d, //7.0
    0x00109e17, 0xffd8a7bd, 0xfff96df3, 0x000e28d4, 0x001f2365, //7.5
    0x001181c5, 0xffd688a4, 0xfff97d3e, 0x000dec7d, 0x00208bdc, //8.0
    0x00127129, 0xffd44e83, 0xfff98c5f, 0x000daf9b, 0x0022045a, //8.5
    0x00136cd2, 0xffd1f81b, 0xfff99b55, 0x000d7230, 0x00238d8e, //9.0
    0x00147558, 0xffcf8421, 0xfff9aa1d, 0x000d343d, 0x0025282e, //9.5
    0x00158b56, 0xffccf13a, 0xfff9b8b6, 0x000cf5c3, 0x0026d4f6, //10.0
    0x0016af72, 0xffca3e01, 0xfff9c71f, 0x000cb6c3, 0x002894ac, //10.5
    0x0017e254, 0xffc768fd, 0xfff9d555, 0x000c773e, 0x002a681b, //11.0
    0x001924b1, 0xffc470aa, 0xfff9e358, 0x000c3737, 0x002c5016, //11.5
    0x001a7740, 0xffc15371, 0xfff9f125, 0x000bf6ae, 0x002e4d7c, //12.0
    0x001bdac5, 0xffbe0fad, 0xfff9febb, 0x000bb5a5, 0x0030612f, //12.5
    0x001d5008, 0xffbaa3a6, 0xfffa0c17, 0x000b741d, 0x00328c1e, //13.0
    0x001ed7db, 0xffb70d94, 0xfffa1939, 0x000b3219, 0x0034cf3f, //13.5
    0x00207319, 0xffb34b9b, 0xfffa261f, 0x000aef9a, 0x00372b92, //14.0
};
#endif
#endif

#ifdef AUDIO_CHL_BASS_TREBLE_COEF_TBL_DEFAULT //20100524
#ifdef CC_AUD_3_5K_TREBLE
// 200Hz/3.5kHz
// -14dB ~ +14dB, 1dB/step
static const UINT32 _aau4MtkAudChlBassTrebleCoefTbl[(57*2)*5] =
{
    // 48000.0 Hz
    // Bass Band
    0x003c8374, 0xff84d9b4, 0xffc4cb42, 0x007b1ca9, 0x003ea7a7, //-14.0
    0x003c87f9, 0xff84c890, 0xffc4ba62, 0x007b2e35, 0x003eb46b, //-13.5
    0x003c8c50, 0xff84b7a9, 0xffc4a9bb, 0x007b3f83, 0x003ec121, //-13.0
    0x003c907a, 0xff84a6fc, 0xffc4994d, 0x007b5093, 0x003ecdc9, //-12.5
    0x003c9479, 0xff84968b, 0xffc48916, 0x007b6168, 0x003eda64, //-12.0
    0x003c984b, 0xff848653, 0xffc47916, 0x007b7201, 0x003ee6f4, //-11.5
    0x003c9bf0, 0xff847654, 0xffc4694c, 0x007b8260, 0x003ef377, //-11.0
    0x003c9f6a, 0xff84668d, 0xffc459b9, 0x007b9285, 0x003efff0, //-10.5
    0x003ca2b8, 0xff8456fe, 0xffc44a5a, 0x007ba271, 0x003f0c5e, //-10.0
    0x003ca5da, 0xff8447a7, 0xffc43b2f, 0x007bb224, 0x003f18c2, //-9.5
    0x003ca8d0, 0xff843885, 0xffc42c39, 0x007bc1a0, 0x003f251d, //-9.0
    0x003cab9b, 0xff842999, 0xffc41d75, 0x007bd0e6, 0x003f316f, //-8.5
    0x003cae3a, 0xff841ae2, 0xffc40ee4, 0x007bdff5, 0x003f3db9, //-8.0
    0x003cb0ae, 0xff840c5f, 0xffc40085, 0x007beecf, 0x003f49fb, //-7.5
    0x003cb2f6, 0xff83fe11, 0xffc3f257, 0x007bfd74, 0x003f5637, //-7.0
    0x003cb513, 0xff83eff5, 0xffc3e459, 0x007c0be5, 0x003f626d, //-6.5
    0x003cb706, 0xff83e20b, 0xffc3d68c, 0x007c1a23, 0x003f6e9d, //-6.0
    0x003cb8cd, 0xff83d454, 0xffc3c8ee, 0x007c282f, 0x003f7ac8, //-5.5
    0x003cba69, 0xff83c6cd, 0xffc3bb7f, 0x007c3608, 0x003f86ee, //-5.0
    0x003cbbda, 0xff83b977, 0xffc3ae3e, 0x007c43b1, 0x003f9311, //-4.5
    0x003cbd20, 0xff83ac51, 0xffc3a12b, 0x007c5129, 0x003f9f30, //-4.0
    0x003cbe3b, 0xff839f5b, 0xffc39444, 0x007c5e71, 0x003fab4d, //-3.5
    0x003cbf2b, 0xff839293, 0xffc3878b, 0x007c6b8a, 0x003fb767, //-3.0
    0x003cbff0, 0xff8385fa, 0xffc37afd, 0x007c7874, 0x003fc381, //-2.5
    0x003cc08b, 0xff83798e, 0xffc36e9a, 0x007c8531, 0x003fcf99, //-2.0
    0x003cc0fb, 0xff836d50, 0xffc36263, 0x007c91c0, 0x003fdbb2, //-1.5
    0x003cc13f, 0xff83613e, 0xffc35656, 0x007c9e22, 0x003fe7cb, //-1.0
    0x003cc159, 0xff835558, 0xffc34a72, 0x007caa58, 0x003ff3e4, //-0.5
    0x003cc148, 0xff83499d, 0xffc33eb8, 0x007cb663, 0x00400000, //0.0
    0x003cc10c, 0xff833e0e, 0xffc33326, 0x007cc243, 0x00400c1e, //0.5
    0x003cc0a5, 0xff8332a9, 0xffc327bd, 0x007ccdf8, 0x0040183f, //1.0
    0x003cc013, 0xff83276e, 0xffc31c7b, 0x007cd984, 0x00402463, //1.5
    0x003cbf57, 0xff831c5c, 0xffc31160, 0x007ce4e6, 0x0040308b, //2.0
    0x003cbe6e, 0xff831174, 0xffc3066c, 0x007cf020, 0x00403cb9, //2.5
    0x003cbd5b, 0xff8306b4, 0xffc2fb9e, 0x007cfb31, 0x004048eb, //3.0
    0x003cbc1d, 0xff82fc1c, 0xffc2f0f6, 0x007d061b, 0x00405524, //3.5
    0x003cbab3, 0xff82f1ab, 0xffc2e673, 0x007d10df, 0x00406163, //4.0
    0x003cb91e, 0xff82e761, 0xffc2dc15, 0x007d1b7b, 0x00406daa, //4.5
    0x003cb75d, 0xff82dd3f, 0xffc2d1db, 0x007d25f2, 0x004079f9, //5.0
    0x003cb571, 0xff82d342, 0xffc2c7c4, 0x007d3043, 0x00408650, //5.5
    0x003cb358, 0xff82c96b, 0xffc2bdd1, 0x007d3a6f, 0x004092b1, //6.0
    0x003cb115, 0xff82bfb9, 0xffc2b401, 0x007d4477, 0x00409f1b, //6.5
    0x003caea5, 0xff82b62c, 0xffc2aa53, 0x007d4e5b, 0x0040ab90, //7.0
    0x003cac09, 0xff82acc4, 0xffc2a0c7, 0x007d581c, 0x0040b810, //7.5
    0x003ca940, 0xff82a37f, 0xffc2975d, 0x007d61ba, 0x0040c49c, //8.0
    0x003ca64c, 0xff829a5f, 0xffc28e13, 0x007d6b35, 0x0040d135, //8.5
    0x003ca32a, 0xff829161, 0xffc284ea, 0x007d748e, 0x0040ddda, //9.0
    0x003c9fdd, 0xff828886, 0xffc27be2, 0x007d7dc6, 0x0040ea8e, //9.5
    0x003c9c62, 0xff827fce, 0xffc272f9, 0x007d86dc, 0x0040f750, //10.0
    0x003c98ba, 0xff827738, 0xffc26a2f, 0x007d8fd2, 0x00410421, //10.5
    0x003c94e5, 0xff826ec3, 0xffc26184, 0x007d98a8, 0x00411102, //11.0
    0x003c90e2, 0xff826670, 0xffc258f8, 0x007da15e, 0x00411df4, //11.5
    0x003c8cb2, 0xff825e3e, 0xffc2508a, 0x007da9f5, 0x00412af7, //12.0
    0x003c8853, 0xff82562c, 0xffc2483a, 0x007db26d, 0x0041380c, //12.5
    0x003c83c7, 0xff824e3b, 0xffc24007, 0x007dbac6, 0x00414534, //13.0
    0x003c7f0c, 0xff82466a, 0xffc237f1, 0x007dc302, 0x0041526f, //13.5
    0x003c7a23, 0xff823eb8, 0xffc22ff7, 0x007dcb20, 0x00415fbe, //14.0
    // Treble Band
    0x0001861d, 0xfffb5073, 0xfff5bc95, 0x001956bf, 0x0004161b, //-14.0
    0x00019f2a, 0xfffb09a7, 0xfff5cd62, 0x00193fc4, 0x00044a09, //-13.5
    0x0001b9c1, 0xfffabed9, 0xfff5de51, 0x00192882, 0x00048093, //-13.0
    0x0001d5fa, 0xfffa6fd1, 0xfff5ef61, 0x001910f6, 0x0004b9de, //-12.5
    0x0001f3ef, 0xfffa1c54, 0xfff60092, 0x0018f921, 0x0004f60b, //-12.0
    0x000213b8, 0xfff9c423, 0xfff611e4, 0x0018e101, 0x00053540, //-11.5
    0x00023571, 0xfff966fc, 0xfff62358, 0x0018c896, 0x000577a5, //-11.0
    0x00025938, 0xfff9049b, 0xfff634eb, 0x0018afe0, 0x0005bd62, //-10.5
    0x00027f2a, 0xfff89cb6, 0xfff646a0, 0x001896de, 0x000606a3, //-10.0
    0x0002a769, 0xfff82f01, 0xfff65874, 0x00187d8e, 0x00065394, //-9.5
    0x0002d215, 0xfff7bb2b, 0xfff66a68, 0x001863f1, 0x0006a467, //-9.0
    0x0002ff54, 0xfff740df, 0xfff67c7c, 0x00184a05, 0x0006f94c, //-8.5
    0x00032f4b, 0xfff6bfc4, 0xfff68eaf, 0x00182fcb, 0x00075278, //-8.0
    0x00036222, 0xfff6377c, 0xfff6a100, 0x00181540, 0x0007b022, //-7.5
    0x00039803, 0xfff5a7a2, 0xfff6b371, 0x0017fa66, 0x00081284, //-7.0
    0x0003d11b, 0xfff50fd1, 0xfff6c600, 0x0017df3a, 0x000879db, //-6.5
    0x00040d99, 0xfff46f98, 0xfff6d8ac, 0x0017c3bd, 0x0008e665, //-6.0
    0x00044daf, 0xfff3c686, 0xfff6eb76, 0x0017a7ee, 0x00095867, //-5.5
    0x00049190, 0xfff31422, 0xfff6fe5d, 0x00178bcb, 0x0009d026, //-5.0
    0x0004d975, 0xfff257ea, 0xfff71161, 0x00176f55, 0x000a4deb, //-4.5
    0x00052596, 0xfff1915a, 0xfff72481, 0x0017528b, 0x000ad204, //-4.0
    0x00057632, 0xfff0bfe4, 0xfff737bc, 0x0017356c, 0x000b5cc2, //-3.5
    0x0005cb88, 0xffefe2f4, 0xfff74b13, 0x001717f8, 0x000bee7a, //-3.0
    0x000625dd, 0xffeef9ed, 0xfff75e84, 0x0016fa2d, 0x000c8785, //-2.5
    0x00068578, 0xffee042d, 0xfff7720f, 0x0016dc0c, 0x000d2840, //-2.0
    0x0006eaa6, 0xffed0106, 0xfff785b5, 0x0016bd93, 0x000dd10d, //-1.5
    0x000755b4, 0xffebefc3, 0xfff79973, 0x00169ec3, 0x000e8253, //-1.0
    0x0007c6f8, 0xffeacfa7, 0xfff7ad49, 0x00167f9a, 0x000f3c7f, //-0.5
    0x00083ec8, 0xffe99fe8, 0xfff7c138, 0x00166018, 0x00100000, //0.0
    0x0008bd83, 0xffe85fb5, 0xfff7d53d, 0x0016403c, 0x0010cd4e, //0.5
    0x0009438a, 0xffe70e32, 0xfff7e959, 0x00162006, 0x0011a4e5, //1.0
    0x0009d143, 0xffe5aa75, 0xfff7fd8b, 0x0015ff76, 0x00128747, //1.5
    0x000a671a, 0xffe4338c, 0xfff811d2, 0x0015de8a, 0x001374fe, //2.0
    0x000b0583, 0xffe2a876, 0xfff8262d, 0x0015bd42, 0x00146e97, //2.5
    0x000bacf4, 0xffe10828, 0xfff83a9c, 0x00159b9e, 0x001574aa, //3.0
    0x000c5deb, 0xffdf5186, 0xfff84f1e, 0x0015799d, 0x001687d3, //3.5
    0x000d18ee, 0xffdd8369, 0xfff863b2, 0x0015573f, 0x0017a8b8, //4.0
    0x000dde87, 0xffdb9c99, 0xfff87858, 0x00153483, 0x0018d805, //4.5
    0x000eaf4a, 0xffd99bd1, 0xfff88d0d, 0x00151169, 0x001a1670, //5.0
    0x000f8bd0, 0xffd77fb9, 0xfff8a1d3, 0x0014edef, 0x001b64b5, //5.5
    0x001074bb, 0xffd546eb, 0xfff8b6a7, 0x0014ca17, 0x001cc39c, //6.0
    0x00116ab7, 0xffd2efed, 0xfff8cb88, 0x0014a5df, 0x001e33f5, //6.5
    0x00126e76, 0xffd07933, 0xfff8e077, 0x00148147, 0x001fb69a, //7.0
    0x001380b3, 0xffcde11e, 0xfff8f571, 0x00145c4e, 0x00214c6f, //7.5
    0x0014a236, 0xffcb25fc, 0xfff90a77, 0x001436f5, 0x0022f663, //8.0
    0x0015d3cd, 0xffc84602, 0xfff91f86, 0x0014113a, 0x0024b571, //8.5
    0x00171652, 0xffc53f53, 0xfff9349e, 0x0013eb1e, 0x00268a9f, //9.0
    0x00186aac, 0xffc20ff8, 0xfff949be, 0x0013c4a0, 0x002876ff, //9.5
    0x0019d1c9, 0xffbeb5e3, 0xfff95ee5, 0x00139dc0, 0x002a7bb0, //10.0
    0x001b4ca7, 0xffbb2eeb, 0xfff97411, 0x0013767d, 0x002c99e0, //10.5
    0x001cdc50, 0xffb778cf, 0xfff98942, 0x00134ed8, 0x002ed2c8, //11.0
    0x001e81d8, 0xffb39130, 0xfff99e76, 0x001326cf, 0x003127b3, //11.5
    0x00203e64, 0xffaf7594, 0xfff9b3ac, 0x0012fe63, 0x003399f8, //12.0
    0x00221327, 0xffab2360, 0xfff9c8e4, 0x0012d594, 0x00362b01, //12.5
    0x00240162, 0xffa697db, 0xfff9de1b, 0x0012ac61, 0x0038dc47, //13.0
    0x00260a66, 0xffa1d02b, 0xfff9f351, 0x001282ca, 0x003baf54, //13.5
    0x00282f94, 0xff9cc954, 0xfffa0884, 0x001258d0, 0x003ea5c5, //14.0
};
#else
#ifdef CC_SONY_2K14_FLASH_AQ
static const UINT32 _aau4MtkAudChlBassTrebleCoefTbl_100_5k[(29*2)*5] =
{
        // 48000.0 Hz  
        // Bass Band
        0x003eb8b0, 0xff81c682, 0xffc1c2c9, 0x007e3703, 0x003f820c, //-14.0
        0x003ebc1f, 0xff81b9c1, 0xffc1b62b, 0x007e43f9, 0x003f8b71, //-13.0
        0x003ebf49, 0xff81ad5d, 0xffc1a9e7, 0x007e5091, 0x003f94be, //-12.0
        0x003ec231, 0xff81a152, 0xffc19df9, 0x007e5cce, 0x003f9df6, //-11.0
        0x003ec4d6, 0xff81959f, 0xffc1925f, 0x007e68b1, 0x003fa71b, //-10.0
        0x003ec739, 0xff818a41, 0xffc18718, 0x007e743f, 0x003fb02f, //-9.0
        0x003ec95a, 0xff817f35, 0xffc17c21, 0x007e7f78, 0x003fb932, //-8.0
        0x003ecb3a, 0xff817479, 0xffc17177, 0x007e8a60, 0x003fc228, //-7.0
        0x003eccd9, 0xff816a0c, 0xffc1671a, 0x007e94f9, 0x003fcb13, //-6.0
        0x003ece38, 0xff815feb, 0xffc15d06, 0x007e9f45, 0x003fd3f3, //-5.0
        0x003ecf57, 0xff815614, 0xffc15339, 0x007ea947, 0x003fdccb, //-4.0
        0x003ed035, 0xff814c85, 0xffc149b2, 0x007eb2ff, 0x003fe59d, //-3.0
        0x003ed0d4, 0xff81433d, 0xffc1406f, 0x007ebc71, 0x003fee6b, //-2.0
        0x003ed133, 0xff813a38, 0xffc1376e, 0x007ec59f, 0x003ff736, //-1.0
        0x003ed153, 0xff813176, 0xffc12ead, 0x007ece8a, 0x00400000, //0.0
        0x003ed133, 0xff8128f5, 0xffc1262b, 0x007ed734, 0x004008cc, //1.0
        0x003ed0d3, 0xff8120b3, 0xffc11de5, 0x007edf9f, 0x0040119a, //2.0
        0x003ed034, 0xff8118ae, 0xffc115da, 0x007ee7cd, 0x00401a6e, //3.0
        0x003ecf54, 0xff8110e6, 0xffc10e09, 0x007eefc0, 0x00402348, //4.0
        0x003ece35, 0xff810957, 0xffc1066f, 0x007ef779, 0x00402c2c, //5.0
        0x003eccd6, 0xff810201, 0xffc0ff0c, 0x007efefa, 0x00403519, //6.0
        0x003ecb36, 0xff80fae3, 0xffc0f7de, 0x007f0645, 0x00403e14, //7.0
        0x003ec955, 0xff80f3fa, 0xffc0f0e3, 0x007f0d5a, 0x0040471c, //8.0
        0x003ec733, 0xff80ed46, 0xffc0ea1a, 0x007f143c, 0x00405036, //9.0
        0x003ec4d0, 0xff80e6c6, 0xffc0e381, 0x007f1aec, 0x00405961, //10.0
        0x003ec22a, 0xff80e077, 0xffc0dd18, 0x007f216c, 0x004062a1, //11.0
        0x003ebf42, 0xff80da59, 0xffc0d6dd, 0x007f27bc, 0x00406bf7, //12.0
        0x003ebc16, 0xff80d46b, 0xffc0d0ce, 0x007f2ddf, 0x00407565, //13.0
        0x003eb8a7, 0xff80ceab, 0xffc0caeb, 0x007f33d5, 0x00407eee, //14.0
        // Treble Band
        0x00013dbf, 0xfffc8db2, 0xfff785ef, 0x00161498, 0x00049a08, //-14.0
        0x00016557, 0xfffc17de, 0xfff7ac55, 0x0015cfb3, 0x000506c3, //-13.0
        0x000191e1, 0xfffb942f, 0xfff7d300, 0x0015892e, 0x00057dc2, //-12.0
        0x0001c3f5, 0xfffb0121, 0xfff7f9eb, 0x00154103, 0x0005fffb, //-11.0
        0x0001fc3b, 0xfffa5d09, 0xfff82110, 0x0014f72d, 0x00068e80, //-10.0
        0x00023b6d, 0xfff9a60f, 0xfff84865, 0x0014aba7, 0x00072a77, //-9.0
        0x00028259, 0xfff8da2e, 0xfff86fe5, 0x00145e6d, 0x0007d527, //-8.0
        0x0002d1e5, 0xfff7f72a, 0xfff89787, 0x00140f7a, 0x00088ff0, //-7.0
        0x00032b0f, 0xfff6fa90, 0xfff8bf42, 0x0013beca, 0x00095c55, //-6.0
        0x00038ef0, 0xfff5e1ad, 0xfff8e70e, 0x00136c59, 0x000a3bfd, //-5.0
        0x0003febf, 0xfff4a98b, 0xfff90ee0, 0x00131824, 0x000b30b2, //-4.0
        0x00047bd3, 0xfff34ee8, 0xfff936b1, 0x0012c229, 0x000c3c6b, //-3.0
        0x000507a9, 0xfff1ce33, 0xfff95e75, 0x00126a65, 0x000d614a, //-2.0
        0x0005a3e4, 0xfff02381, 0xfff98622, 0x001210d5, 0x000ea1a3, //-1.0
        0x00065253, 0xffee4a87, 0xfff9adad, 0x0011b579, 0x00100000, //0.0
        0x000714f1, 0xffec3e91, 0xfff9d50c, 0x0011584f, 0x00117f22, //1.0
        0x0007edf1, 0xffe9fa79, 0xfff9fc33, 0x0010f958, 0x0013220b, //2.0
        0x0008dfbc, 0xffe7789d, 0xfffa2316, 0x00109892, 0x0014ec00, //3.0
        0x0009ecf8, 0xffe4b2d4, 0xfffa49a8, 0x001035ff, 0x0016e08c, //4.0
        0x000b188e, 0xffe1a265, 0xfffa6fdf, 0x000fd1a1, 0x0019038d, //5.0
        0x000c65b0, 0xffde3ff6, 0xfffa95ac, 0x000f6b7a, 0x001b5934, //6.0
        0x000dd7e0, 0xffda8381, 0xfffabb04, 0x000f038b, 0x001de60f, //7.0
        0x000f72f4, 0xffd6644a, 0xfffadfd9, 0x000e99da, 0x0020af0f, //8.0
        0x00113b22, 0xffd1d8c8, 0xfffb041e, 0x000e2e69, 0x0023b98f, //9.0
        0x00133502, 0xffccd69b, 0xfffb27c6, 0x000dc13e, 0x00270b5f, //10.0
        0x0015659d, 0xffc75276, 0xfffb4ac3, 0x000d525e, 0x002aaacc, //11.0
        0x0017d271, 0xffc14011, 0xfffb6d08, 0x000ce1d0, 0x002e9ea6, //12.0
        0x001a817d, 0xffba9212, 0xfffb8e87, 0x000c6f9c, 0x0032ee4e, //13.0
        0x001d794c, 0xffb339f6, 0xfffbaf33, 0x000bfbc8, 0x0037a1c2, //14.0
    };
static const UINT32 _aau4MtkAudChlBassTrebleCoefTbl_100_6k[(29*2)*5] =
    {
        // 48000.0 Hz  
        // Bass Band
        0x003eb8b0, 0xff81c682, 0xffc1c2c9, 0x007e3703, 0x003f820c, //-14.0
        0x003ebc1f, 0xff81b9c1, 0xffc1b62b, 0x007e43f9, 0x003f8b71, //-13.0
        0x003ebf49, 0xff81ad5d, 0xffc1a9e7, 0x007e5091, 0x003f94be, //-12.0
        0x003ec231, 0xff81a152, 0xffc19df9, 0x007e5cce, 0x003f9df6, //-11.0
        0x003ec4d6, 0xff81959f, 0xffc1925f, 0x007e68b1, 0x003fa71b, //-10.0
        0x003ec739, 0xff818a41, 0xffc18718, 0x007e743f, 0x003fb02f, //-9.0
        0x003ec95a, 0xff817f35, 0xffc17c21, 0x007e7f78, 0x003fb932, //-8.0
        0x003ecb3a, 0xff817479, 0xffc17177, 0x007e8a60, 0x003fc228, //-7.0
        0x003eccd9, 0xff816a0c, 0xffc1671a, 0x007e94f9, 0x003fcb13, //-6.0
        0x003ece38, 0xff815feb, 0xffc15d06, 0x007e9f45, 0x003fd3f3, //-5.0
        0x003ecf57, 0xff815614, 0xffc15339, 0x007ea947, 0x003fdccb, //-4.0
        0x003ed035, 0xff814c85, 0xffc149b2, 0x007eb2ff, 0x003fe59d, //-3.0
        0x003ed0d4, 0xff81433d, 0xffc1406f, 0x007ebc71, 0x003fee6b, //-2.0
        0x003ed133, 0xff813a38, 0xffc1376e, 0x007ec59f, 0x003ff736, //-1.0
        0x003ed153, 0xff813176, 0xffc12ead, 0x007ece8a, 0x00400000, //0.0
        0x003ed133, 0xff8128f5, 0xffc1262b, 0x007ed734, 0x004008cc, //1.0
        0x003ed0d3, 0xff8120b3, 0xffc11de5, 0x007edf9f, 0x0040119a, //2.0
        0x003ed034, 0xff8118ae, 0xffc115da, 0x007ee7cd, 0x00401a6e, //3.0
        0x003ecf54, 0xff8110e6, 0xffc10e09, 0x007eefc0, 0x00402348, //4.0
        0x003ece35, 0xff810957, 0xffc1066f, 0x007ef779, 0x00402c2c, //5.0
        0x003eccd6, 0xff810201, 0xffc0ff0c, 0x007efefa, 0x00403519, //6.0
        0x003ecb36, 0xff80fae3, 0xffc0f7de, 0x007f0645, 0x00403e14, //7.0
        0x003ec955, 0xff80f3fa, 0xffc0f0e3, 0x007f0d5a, 0x0040471c, //8.0
        0x003ec733, 0xff80ed46, 0xffc0ea1a, 0x007f143c, 0x00405036, //9.0
        0x003ec4d0, 0xff80e6c6, 0xffc0e381, 0x007f1aec, 0x00405961, //10.0
        0x003ec22a, 0xff80e077, 0xffc0dd18, 0x007f216c, 0x004062a1, //11.0
        0x003ebf42, 0xff80da59, 0xffc0d6dd, 0x007f27bc, 0x00406bf7, //12.0
        0x003ebc16, 0xff80d46b, 0xffc0d0ce, 0x007f2ddf, 0x00407565, //13.0
        0x003eb8a7, 0xff80ceab, 0xffc0caeb, 0x007f33d5, 0x00407eee, //14.0
        // Treble Band
        0x0001167d, 0xfffd53a4, 0xfff8942c, 0x00141638, 0x0004eb7b, //-14.0
        0x0001374b, 0xfffcedee, 0xfff8bbe5, 0x0013c5ad, 0x00055935, //-13.0
        0x00015c2d, 0xfffc7c07, 0xfff8e3b0, 0x00137363, 0x0005d0b9, //-12.0
        0x000185a2, 0xfffbfca0, 0xfff90b82, 0x00131f55, 0x000652e7, //-11.0
        0x0001b433, 0xfffb6e48, 0xfff93353, 0x0012c980, 0x0006e0b2, //-10.0
        0x0001e879, 0xfffacf68, 0xfff95b19, 0x001271e2, 0x00077b24, //-9.0
        0x0002231e, 0xfffa1e44, 0xfff982c8, 0x0012187a, 0x0008235c, //-8.0
        0x000264de, 0xfff958f3, 0xfff9aa57, 0x0011bd45, 0x0008da94, //-7.0
        0x0002ae89, 0xfff87d5d, 0xfff9d1ba, 0x00116042, 0x0009a21e, //-6.0
        0x00030105, 0xfff78939, 0xfff9f8e6, 0x00110171, 0x000a7b6c, //-5.0
        0x00035d4f, 0xfff67a02, 0xfffa1fcf, 0x0010a0d3, 0x000b680e, //-4.0
        0x0003c47f, 0xfff54cfb, 0xfffa4669, 0x00103e67, 0x000c69b6, //-3.0
        0x000437ca, 0xfff3ff24, 0xfffa6ca8, 0x000fda30, 0x000d823b, //-2.0
        0x0004b883, 0xfff28d35, 0xfffa927e, 0x000f742f, 0x000eb39b, //-1.0
        0x0005481f, 0xfff0f39a, 0xfffab7e1, 0x000f0c66, 0x00100000, //0.0
        0x0005e839, 0xffef2e6b, 0xfffadcc1, 0x000ea2db, 0x001169c0, //1.0
        0x00069a94, 0xffed3966, 0xfffb0113, 0x000e3790, 0x0012f363, //2.0
        0x0007611d, 0xffeb0fe9, 0xfffb24c9, 0x000dca8a, 0x00149fa8, //3.0
        0x00083df3, 0xffe8ace5, 0xfffb47d5, 0x000d5bcf, 0x00167184, //4.0
        0x00093368, 0xffe60add, 0xfffb6a2a, 0x000ceb65, 0x00186c2c, //5.0
        0x000a4404, 0xffe323d7, 0xfffb8bba, 0x000c7954, 0x001a9317, //6.0
        0x000b728d, 0xffdff155, 0xfffbac78, 0x000c05a3, 0x001cea02, //7.0
        0x000cc20c, 0xffdc6c4b, 0xfffbcc57, 0x000b905c, 0x001f74f6, //8.0
        0x000e35cd, 0xffd88d14, 0xfffbeb48, 0x000b1987, 0x0022384f, //9.0
        0x000fd16d, 0xffd44b65, 0xfffc0940, 0x000aa130, 0x002538bf, //10.0
        0x001198d7, 0xffcf9e43, 0xfffc262f, 0x000a2761, 0x00287b56, //11.0
        0x00139053, 0xffca7bf3, 0xfffc420b, 0x0009ac26, 0x002c058a, //12.0
        0x0015bc86, 0xffc4d9ee, 0xfffc5cc5, 0x00092f8d, 0x002fdd3a, //13.0
        0x0018227d, 0xffbeacd4, 0xfffc7652, 0x0008b1a3, 0x003408ba, //14.0
    };
static const UINT32 _aau4MtkAudChlBassTrebleCoefTbl_100_7k[(29*2)*5] =
    {
        // 48000.0 Hz  
        // Bass Band
        0x003eb8b0, 0xff81c682, 0xffc1c2c9, 0x007e3703, 0x003f820c, //-14.0
        0x003ebc1f, 0xff81b9c1, 0xffc1b62b, 0x007e43f9, 0x003f8b71, //-13.0
        0x003ebf49, 0xff81ad5d, 0xffc1a9e7, 0x007e5091, 0x003f94be, //-12.0
        0x003ec231, 0xff81a152, 0xffc19df9, 0x007e5cce, 0x003f9df6, //-11.0
        0x003ec4d6, 0xff81959f, 0xffc1925f, 0x007e68b1, 0x003fa71b, //-10.0
        0x003ec739, 0xff818a41, 0xffc18718, 0x007e743f, 0x003fb02f, //-9.0
        0x003ec95a, 0xff817f35, 0xffc17c21, 0x007e7f78, 0x003fb932, //-8.0
        0x003ecb3a, 0xff817479, 0xffc17177, 0x007e8a60, 0x003fc228, //-7.0
        0x003eccd9, 0xff816a0c, 0xffc1671a, 0x007e94f9, 0x003fcb13, //-6.0
        0x003ece38, 0xff815feb, 0xffc15d06, 0x007e9f45, 0x003fd3f3, //-5.0
        0x003ecf57, 0xff815614, 0xffc15339, 0x007ea947, 0x003fdccb, //-4.0
        0x003ed035, 0xff814c85, 0xffc149b2, 0x007eb2ff, 0x003fe59d, //-3.0
        0x003ed0d4, 0xff81433d, 0xffc1406f, 0x007ebc71, 0x003fee6b, //-2.0
        0x003ed133, 0xff813a38, 0xffc1376e, 0x007ec59f, 0x003ff736, //-1.0
        0x003ed153, 0xff813176, 0xffc12ead, 0x007ece8a, 0x00400000, //0.0
        0x003ed133, 0xff8128f5, 0xffc1262b, 0x007ed734, 0x004008cc, //1.0
        0x003ed0d3, 0xff8120b3, 0xffc11de5, 0x007edf9f, 0x0040119a, //2.0
        0x003ed034, 0xff8118ae, 0xffc115da, 0x007ee7cd, 0x00401a6e, //3.0
        0x003ecf54, 0xff8110e6, 0xffc10e09, 0x007eefc0, 0x00402348, //4.0
        0x003ece35, 0xff810957, 0xffc1066f, 0x007ef779, 0x00402c2c, //5.0
        0x003eccd6, 0xff810201, 0xffc0ff0c, 0x007efefa, 0x00403519, //6.0
        0x003ecb36, 0xff80fae3, 0xffc0f7de, 0x007f0645, 0x00403e14, //7.0
        0x003ec955, 0xff80f3fa, 0xffc0f0e3, 0x007f0d5a, 0x0040471c, //8.0
        0x003ec733, 0xff80ed46, 0xffc0ea1a, 0x007f143c, 0x00405036, //9.0
        0x003ec4d0, 0xff80e6c6, 0xffc0e381, 0x007f1aec, 0x00405961, //10.0
        0x003ec22a, 0xff80e077, 0xffc0dd18, 0x007f216c, 0x004062a1, //11.0
        0x003ebf42, 0xff80da59, 0xffc0d6dd, 0x007f27bc, 0x00406bf7, //12.0
        0x003ebc16, 0xff80d46b, 0xffc0d0ce, 0x007f2ddf, 0x00407565, //13.0
        0x003eb8a7, 0xff80ceab, 0xffc0caeb, 0x007f33d5, 0x00407eee, //14.0
        // Treble Band
        0x0000ff7e, 0xfffe282b, 0xfff98529, 0x0012130d, 0x00054022, //-14.0
        0x00011ab0, 0xfffdd252, 0xfff9acb6, 0x0011b7bc, 0x0005ae8c, //-13.0
        0x00013939, 0xfffd71d2, 0xfff9d416, 0x00115a9d, 0x00062641, //-12.0
        0x00015b7f, 0xfffd0589, 0xfff9fb3e, 0x0010fbb1, 0x0006a809, //-11.0
        0x000181f3, 0xfffc8c37, 0xfffa2223, 0x00109af6, 0x000734bd, //-10.0
        0x0001ad12, 0xfffc0481, 0xfffa48b7, 0x0010386f, 0x0007cd47, //-9.0
        0x0001dd66, 0xfffb6ce7, 0xfffa6ef0, 0x000fd41c, 0x000872a6, //-8.0
        0x0002138b, 0xfffac3c9, 0xfffa94c1, 0x000f6e00, 0x000925eb, //-7.0
        0x00025028, 0xfffa0760, 0xfffaba1b, 0x000f061d, 0x0009e840, //-6.0
        0x000293f9, 0xfff935b9, 0xfffadef4, 0x000e9c76, 0x000abae5, //-5.0
        0x0002dfcc, 0xfff84cb5, 0xfffb033d, 0x000e3110, 0x000b9f33, //-4.0
        0x00033484, 0xfff74a04, 0xfffb26e9, 0x000dc3ef, 0x000c96a0, //-3.0
        0x0003931b, 0xfff62b22, 0xfffb49ea, 0x000d551a, 0x000da2bf, //-2.0
        0x0003fca3, 0xfff4ed50, 0xfffb6c34, 0x000ce497, 0x000ec543, //-1.0
        0x00047248, 0xfff38d93, 0xfffb8db8, 0x000c726d, 0x00100000, //0.0
        0x0004f556, 0xfff208ae, 0xfffbae69, 0x000bfea4, 0x001154f0, //1.0
        0x00058735, 0xfff05b1a, 0xfffbce3a, 0x000b8944, 0x0012c633, //2.0
        0x00062972, 0xffee8107, 0xfffbed1c, 0x000b1258, 0x00145613, //3.0
        0x0006ddbd, 0xffec764f, 0xfffc0b04, 0x000a99ea, 0x00160707, //4.0
        0x0007a5f0, 0xffea3673, 0xfffc27e3, 0x000a2004, 0x0017dbb5, //5.0
        0x0008840e, 0xffe7bc99, 0xfffc43ae, 0x0009a4b4, 0x0019d6f8, //6.0
        0x00097a49, 0xffe5037a, 0xfffc5e56, 0x00092807, 0x001bfbe0, //7.0
        0x000a8b07, 0xffe20567, 0xfffc77d1, 0x0008aa08, 0x001e4db8, //8.0
        0x000bb8e3, 0xffdebc39, 0xfffc9012, 0x00082ac8, 0x0020d00a, //9.0
        0x000d06b2, 0xffdb2149, 0xfffca70d, 0x0007aa55, 0x002386a3, //10.0
        0x000e7787, 0xffd72d6d, 0xfffcbcb8, 0x000728bf, 0x00267595, //11.0
        0x00100eba, 0xffd2d8e7, 0xfffcd108, 0x0006a617, 0x0029a13f, //12.0
        0x0011cfea, 0xffce1b63, 0xfffce3f3, 0x0006226e, 0x002d0e52, //13.0
        0x0013bf03, 0xffc8ebe3, 0xfffcf570, 0x00059dd6, 0x0030c1d4, //14.0
    };

static const UINT32 _aau4MtkAudChlBassTrebleCoefTbl_150_5k[(29*2)*5] =
    {
        // 48000.0 Hz  
        // Bass Band
        0x003e1783, 0xff82a7cd, 0xffc29f7e, 0x007d52a8, 0x003f4374, //-14.0
        0x003e1c9b, 0xff8294d6, 0xffc28cd4, 0x007d6616, 0x003f517e, //-13.0
        0x003e214e, 0xff828268, 0xffc27aac, 0x007d78f8, 0x003f5f65, //-12.0
        0x003e259e, 0xff82707f, 0xffc26903, 0x007d8b50, 0x003f6d2e, //-11.0
        0x003e298c, 0xff825f17, 0xffc257d5, 0x007d9d24, 0x003f7adb, //-10.0
        0x003e2d17, 0xff824e2e, 0xffc2471f, 0x007dae76, 0x003f886e, //-9.0
        0x003e3040, 0xff823dbf, 0xffc236de, 0x007dbf4b, 0x003f95ec, //-8.0
        0x003e3309, 0xff822dc9, 0xffc2270f, 0x007dcfa5, 0x003fa355, //-7.0
        0x003e3572, 0xff821e47, 0xffc217af, 0x007ddf89, 0x003fb0ae, //-6.0
        0x003e377b, 0xff820f36, 0xffc208bb, 0x007deefa, 0x003fbdf9, //-5.0
        0x003e3925, 0xff820094, 0xffc1fa30, 0x007dfdfa, 0x003fcb39, //-4.0
        0x003e3a6f, 0xff81f25d, 0xffc1ec0c, 0x007e0c8e, 0x003fd871, //-3.0
        0x003e3b5b, 0xff81e490, 0xffc1de4b, 0x007e1ab8, 0x003fe5a2, //-2.0
        0x003e3be8, 0xff81d729, 0xffc1d0eb, 0x007e287c, 0x003ff2d1, //-1.0
        0x003e3c17, 0xff81ca25, 0xffc1c3e9, 0x007e35db, 0x00400000, //0.0
        0x003e3be7, 0xff81bd83, 0xffc1b744, 0x007e42d9, 0x00400d32, //1.0
        0x003e3b58, 0xff81b13f, 0xffc1aaf7, 0x007e4f79, 0x00401a69, //2.0
        0x003e3a6b, 0xff81a557, 0xffc19f02, 0x007e5bbe, 0x004027a8, //3.0
        0x003e391f, 0xff8199ca, 0xffc19361, 0x007e67a9, 0x004034f2, //4.0
        0x003e3774, 0xff818e94, 0xffc18813, 0x007e733e, 0x0040424b, //5.0
        0x003e356a, 0xff8183b4, 0xffc17d15, 0x007e7e7f, 0x00404fb4, //6.0
        0x003e3300, 0xff817928, 0xffc17264, 0x007e896e, 0x00405d32, //7.0
        0x003e3036, 0xff816eed, 0xffc16800, 0x007e940e, 0x00406ac5, //8.0
        0x003e2d0a, 0xff816502, 0xffc15de5, 0x007e9e61, 0x00407873, //9.0
        0x003e297e, 0xff815b65, 0xffc15413, 0x007ea868, 0x0040863c, //10.0
        0x003e258f, 0xff815213, 0xffc14a86, 0x007eb227, 0x00409426, //11.0
        0x003e213d, 0xff81490d, 0xffc1413d, 0x007ebba0, 0x0040a232, //12.0
        0x003e1c88, 0xff81404f, 0xffc13836, 0x007ec4d3, 0x0040b063, //13.0
        0x003e176e, 0xff8137d8, 0xffc12f70, 0x007ecdc4, 0x0040bebe, //14.0
        // Treble Band
        0x00013dbf, 0xfffc8db2, 0xfff785ef, 0x00161498, 0x00049a08, //-14.0
        0x00016557, 0xfffc17de, 0xfff7ac55, 0x0015cfb3, 0x000506c3, //-13.0
        0x000191e1, 0xfffb942f, 0xfff7d300, 0x0015892e, 0x00057dc2, //-12.0
        0x0001c3f5, 0xfffb0121, 0xfff7f9eb, 0x00154103, 0x0005fffb, //-11.0
        0x0001fc3b, 0xfffa5d09, 0xfff82110, 0x0014f72d, 0x00068e80, //-10.0
        0x00023b6d, 0xfff9a60f, 0xfff84865, 0x0014aba7, 0x00072a77, //-9.0
        0x00028259, 0xfff8da2e, 0xfff86fe5, 0x00145e6d, 0x0007d527, //-8.0
        0x0002d1e5, 0xfff7f72a, 0xfff89787, 0x00140f7a, 0x00088ff0, //-7.0
        0x00032b0f, 0xfff6fa90, 0xfff8bf42, 0x0013beca, 0x00095c55, //-6.0
        0x00038ef0, 0xfff5e1ad, 0xfff8e70e, 0x00136c59, 0x000a3bfd, //-5.0
        0x0003febf, 0xfff4a98b, 0xfff90ee0, 0x00131824, 0x000b30b2, //-4.0
        0x00047bd3, 0xfff34ee8, 0xfff936b1, 0x0012c229, 0x000c3c6b, //-3.0
        0x000507a9, 0xfff1ce33, 0xfff95e75, 0x00126a65, 0x000d614a, //-2.0
        0x0005a3e4, 0xfff02381, 0xfff98622, 0x001210d5, 0x000ea1a3, //-1.0
        0x00065253, 0xffee4a87, 0xfff9adad, 0x0011b579, 0x00100000, //0.0
        0x000714f1, 0xffec3e91, 0xfff9d50c, 0x0011584f, 0x00117f22, //1.0
        0x0007edf1, 0xffe9fa79, 0xfff9fc33, 0x0010f958, 0x0013220b, //2.0
        0x0008dfbc, 0xffe7789d, 0xfffa2316, 0x00109892, 0x0014ec00, //3.0
        0x0009ecf8, 0xffe4b2d4, 0xfffa49a8, 0x001035ff, 0x0016e08c, //4.0
        0x000b188e, 0xffe1a265, 0xfffa6fdf, 0x000fd1a1, 0x0019038d, //5.0
        0x000c65b0, 0xffde3ff6, 0xfffa95ac, 0x000f6b7a, 0x001b5934, //6.0
        0x000dd7e0, 0xffda8381, 0xfffabb04, 0x000f038b, 0x001de60f, //7.0
        0x000f72f4, 0xffd6644a, 0xfffadfd9, 0x000e99da, 0x0020af0f, //8.0
        0x00113b22, 0xffd1d8c8, 0xfffb041e, 0x000e2e69, 0x0023b98f, //9.0
        0x00133502, 0xffccd69b, 0xfffb27c6, 0x000dc13e, 0x00270b5f, //10.0
        0x0015659d, 0xffc75276, 0xfffb4ac3, 0x000d525e, 0x002aaacc, //11.0
        0x0017d271, 0xffc14011, 0xfffb6d08, 0x000ce1d0, 0x002e9ea6, //12.0
        0x001a817d, 0xffba9212, 0xfffb8e87, 0x000c6f9c, 0x0032ee4e, //13.0
        0x001d794c, 0xffb339f6, 0xfffbaf33, 0x000bfbc8, 0x0037a1c2, //14.0
    };

static const UINT32 _aau4MtkAudChlBassTrebleCoefTbl_150_6k[(29*2)*5] =

    {
        // 48000.0 Hz  
        // Bass Band
        0x003e1783, 0xff82a7cd, 0xffc29f7e, 0x007d52a8, 0x003f4374, //-14.0
        0x003e1c9b, 0xff8294d6, 0xffc28cd4, 0x007d6616, 0x003f517e, //-13.0
        0x003e214e, 0xff828268, 0xffc27aac, 0x007d78f8, 0x003f5f65, //-12.0
        0x003e259e, 0xff82707f, 0xffc26903, 0x007d8b50, 0x003f6d2e, //-11.0
        0x003e298c, 0xff825f17, 0xffc257d5, 0x007d9d24, 0x003f7adb, //-10.0
        0x003e2d17, 0xff824e2e, 0xffc2471f, 0x007dae76, 0x003f886e, //-9.0
        0x003e3040, 0xff823dbf, 0xffc236de, 0x007dbf4b, 0x003f95ec, //-8.0
        0x003e3309, 0xff822dc9, 0xffc2270f, 0x007dcfa5, 0x003fa355, //-7.0
        0x003e3572, 0xff821e47, 0xffc217af, 0x007ddf89, 0x003fb0ae, //-6.0
        0x003e377b, 0xff820f36, 0xffc208bb, 0x007deefa, 0x003fbdf9, //-5.0
        0x003e3925, 0xff820094, 0xffc1fa30, 0x007dfdfa, 0x003fcb39, //-4.0
        0x003e3a6f, 0xff81f25d, 0xffc1ec0c, 0x007e0c8e, 0x003fd871, //-3.0
        0x003e3b5b, 0xff81e490, 0xffc1de4b, 0x007e1ab8, 0x003fe5a2, //-2.0
        0x003e3be8, 0xff81d729, 0xffc1d0eb, 0x007e287c, 0x003ff2d1, //-1.0
        0x003e3c17, 0xff81ca25, 0xffc1c3e9, 0x007e35db, 0x00400000, //0.0
        0x003e3be7, 0xff81bd83, 0xffc1b744, 0x007e42d9, 0x00400d32, //1.0
        0x003e3b58, 0xff81b13f, 0xffc1aaf7, 0x007e4f79, 0x00401a69, //2.0
        0x003e3a6b, 0xff81a557, 0xffc19f02, 0x007e5bbe, 0x004027a8, //3.0
        0x003e391f, 0xff8199ca, 0xffc19361, 0x007e67a9, 0x004034f2, //4.0
        0x003e3774, 0xff818e94, 0xffc18813, 0x007e733e, 0x0040424b, //5.0
        0x003e356a, 0xff8183b4, 0xffc17d15, 0x007e7e7f, 0x00404fb4, //6.0
        0x003e3300, 0xff817928, 0xffc17264, 0x007e896e, 0x00405d32, //7.0
        0x003e3036, 0xff816eed, 0xffc16800, 0x007e940e, 0x00406ac5, //8.0
        0x003e2d0a, 0xff816502, 0xffc15de5, 0x007e9e61, 0x00407873, //9.0
        0x003e297e, 0xff815b65, 0xffc15413, 0x007ea868, 0x0040863c, //10.0
        0x003e258f, 0xff815213, 0xffc14a86, 0x007eb227, 0x00409426, //11.0
        0x003e213d, 0xff81490d, 0xffc1413d, 0x007ebba0, 0x0040a232, //12.0
        0x003e1c88, 0xff81404f, 0xffc13836, 0x007ec4d3, 0x0040b063, //13.0
        0x003e176e, 0xff8137d8, 0xffc12f70, 0x007ecdc4, 0x0040bebe, //14.0
        // Treble Band
        0x0001167d, 0xfffd53a4, 0xfff8942c, 0x00141638, 0x0004eb7b, //-14.0
        0x0001374b, 0xfffcedee, 0xfff8bbe5, 0x0013c5ad, 0x00055935, //-13.0
        0x00015c2d, 0xfffc7c07, 0xfff8e3b0, 0x00137363, 0x0005d0b9, //-12.0
        0x000185a2, 0xfffbfca0, 0xfff90b82, 0x00131f55, 0x000652e7, //-11.0
        0x0001b433, 0xfffb6e48, 0xfff93353, 0x0012c980, 0x0006e0b2, //-10.0
        0x0001e879, 0xfffacf68, 0xfff95b19, 0x001271e2, 0x00077b24, //-9.0
        0x0002231e, 0xfffa1e44, 0xfff982c8, 0x0012187a, 0x0008235c, //-8.0
        0x000264de, 0xfff958f3, 0xfff9aa57, 0x0011bd45, 0x0008da94, //-7.0
        0x0002ae89, 0xfff87d5d, 0xfff9d1ba, 0x00116042, 0x0009a21e, //-6.0
        0x00030105, 0xfff78939, 0xfff9f8e6, 0x00110171, 0x000a7b6c, //-5.0
        0x00035d4f, 0xfff67a02, 0xfffa1fcf, 0x0010a0d3, 0x000b680e, //-4.0
        0x0003c47f, 0xfff54cfb, 0xfffa4669, 0x00103e67, 0x000c69b6, //-3.0
        0x000437ca, 0xfff3ff24, 0xfffa6ca8, 0x000fda30, 0x000d823b, //-2.0
        0x0004b883, 0xfff28d35, 0xfffa927e, 0x000f742f, 0x000eb39b, //-1.0
        0x0005481f, 0xfff0f39a, 0xfffab7e1, 0x000f0c66, 0x00100000, //0.0
        0x0005e839, 0xffef2e6b, 0xfffadcc1, 0x000ea2db, 0x001169c0, //1.0
        0x00069a94, 0xffed3966, 0xfffb0113, 0x000e3790, 0x0012f363, //2.0
        0x0007611d, 0xffeb0fe9, 0xfffb24c9, 0x000dca8a, 0x00149fa8, //3.0
        0x00083df3, 0xffe8ace5, 0xfffb47d5, 0x000d5bcf, 0x00167184, //4.0
        0x00093368, 0xffe60add, 0xfffb6a2a, 0x000ceb65, 0x00186c2c, //5.0
        0x000a4404, 0xffe323d7, 0xfffb8bba, 0x000c7954, 0x001a9317, //6.0
        0x000b728d, 0xffdff155, 0xfffbac78, 0x000c05a3, 0x001cea02, //7.0
        0x000cc20c, 0xffdc6c4b, 0xfffbcc57, 0x000b905c, 0x001f74f6, //8.0
        0x000e35cd, 0xffd88d14, 0xfffbeb48, 0x000b1987, 0x0022384f, //9.0
        0x000fd16d, 0xffd44b65, 0xfffc0940, 0x000aa130, 0x002538bf, //10.0
        0x001198d7, 0xffcf9e43, 0xfffc262f, 0x000a2761, 0x00287b56, //11.0
        0x00139053, 0xffca7bf3, 0xfffc420b, 0x0009ac26, 0x002c058a, //12.0
        0x0015bc86, 0xffc4d9ee, 0xfffc5cc5, 0x00092f8d, 0x002fdd3a, //13.0
        0x0018227d, 0xffbeacd4, 0xfffc7652, 0x0008b1a3, 0x003408ba, //14.0
    };

static const UINT32 _aau4MtkAudChlBassTrebleCoefTbl_150_7k[(29*2)*5] =

    {
        // 48000.0 Hz  
        // Bass Band
        0x003e1783, 0xff82a7cd, 0xffc29f7e, 0x007d52a8, 0x003f4374, //-14.0
        0x003e1c9b, 0xff8294d6, 0xffc28cd4, 0x007d6616, 0x003f517e, //-13.0
        0x003e214e, 0xff828268, 0xffc27aac, 0x007d78f8, 0x003f5f65, //-12.0
        0x003e259e, 0xff82707f, 0xffc26903, 0x007d8b50, 0x003f6d2e, //-11.0
        0x003e298c, 0xff825f17, 0xffc257d5, 0x007d9d24, 0x003f7adb, //-10.0
        0x003e2d17, 0xff824e2e, 0xffc2471f, 0x007dae76, 0x003f886e, //-9.0
        0x003e3040, 0xff823dbf, 0xffc236de, 0x007dbf4b, 0x003f95ec, //-8.0
        0x003e3309, 0xff822dc9, 0xffc2270f, 0x007dcfa5, 0x003fa355, //-7.0
        0x003e3572, 0xff821e47, 0xffc217af, 0x007ddf89, 0x003fb0ae, //-6.0
        0x003e377b, 0xff820f36, 0xffc208bb, 0x007deefa, 0x003fbdf9, //-5.0
        0x003e3925, 0xff820094, 0xffc1fa30, 0x007dfdfa, 0x003fcb39, //-4.0
        0x003e3a6f, 0xff81f25d, 0xffc1ec0c, 0x007e0c8e, 0x003fd871, //-3.0
        0x003e3b5b, 0xff81e490, 0xffc1de4b, 0x007e1ab8, 0x003fe5a2, //-2.0
        0x003e3be8, 0xff81d729, 0xffc1d0eb, 0x007e287c, 0x003ff2d1, //-1.0
        0x003e3c17, 0xff81ca25, 0xffc1c3e9, 0x007e35db, 0x00400000, //0.0
        0x003e3be7, 0xff81bd83, 0xffc1b744, 0x007e42d9, 0x00400d32, //1.0
        0x003e3b58, 0xff81b13f, 0xffc1aaf7, 0x007e4f79, 0x00401a69, //2.0
        0x003e3a6b, 0xff81a557, 0xffc19f02, 0x007e5bbe, 0x004027a8, //3.0
        0x003e391f, 0xff8199ca, 0xffc19361, 0x007e67a9, 0x004034f2, //4.0
        0x003e3774, 0xff818e94, 0xffc18813, 0x007e733e, 0x0040424b, //5.0
        0x003e356a, 0xff8183b4, 0xffc17d15, 0x007e7e7f, 0x00404fb4, //6.0
        0x003e3300, 0xff817928, 0xffc17264, 0x007e896e, 0x00405d32, //7.0
        0x003e3036, 0xff816eed, 0xffc16800, 0x007e940e, 0x00406ac5, //8.0
        0x003e2d0a, 0xff816502, 0xffc15de5, 0x007e9e61, 0x00407873, //9.0
        0x003e297e, 0xff815b65, 0xffc15413, 0x007ea868, 0x0040863c, //10.0
        0x003e258f, 0xff815213, 0xffc14a86, 0x007eb227, 0x00409426, //11.0
        0x003e213d, 0xff81490d, 0xffc1413d, 0x007ebba0, 0x0040a232, //12.0
        0x003e1c88, 0xff81404f, 0xffc13836, 0x007ec4d3, 0x0040b063, //13.0
        0x003e176e, 0xff8137d8, 0xffc12f70, 0x007ecdc4, 0x0040bebe, //14.0
        // Treble Band
        0x0000ff7e, 0xfffe282b, 0xfff98529, 0x0012130d, 0x00054022, //-14.0
        0x00011ab0, 0xfffdd252, 0xfff9acb6, 0x0011b7bc, 0x0005ae8c, //-13.0
        0x00013939, 0xfffd71d2, 0xfff9d416, 0x00115a9d, 0x00062641, //-12.0
        0x00015b7f, 0xfffd0589, 0xfff9fb3e, 0x0010fbb1, 0x0006a809, //-11.0
        0x000181f3, 0xfffc8c37, 0xfffa2223, 0x00109af6, 0x000734bd, //-10.0
        0x0001ad12, 0xfffc0481, 0xfffa48b7, 0x0010386f, 0x0007cd47, //-9.0
        0x0001dd66, 0xfffb6ce7, 0xfffa6ef0, 0x000fd41c, 0x000872a6, //-8.0
        0x0002138b, 0xfffac3c9, 0xfffa94c1, 0x000f6e00, 0x000925eb, //-7.0
        0x00025028, 0xfffa0760, 0xfffaba1b, 0x000f061d, 0x0009e840, //-6.0
        0x000293f9, 0xfff935b9, 0xfffadef4, 0x000e9c76, 0x000abae5, //-5.0
        0x0002dfcc, 0xfff84cb5, 0xfffb033d, 0x000e3110, 0x000b9f33, //-4.0
        0x00033484, 0xfff74a04, 0xfffb26e9, 0x000dc3ef, 0x000c96a0, //-3.0
        0x0003931b, 0xfff62b22, 0xfffb49ea, 0x000d551a, 0x000da2bf, //-2.0
        0x0003fca3, 0xfff4ed50, 0xfffb6c34, 0x000ce497, 0x000ec543, //-1.0
        0x00047248, 0xfff38d93, 0xfffb8db8, 0x000c726d, 0x00100000, //0.0
        0x0004f556, 0xfff208ae, 0xfffbae69, 0x000bfea4, 0x001154f0, //1.0
        0x00058735, 0xfff05b1a, 0xfffbce3a, 0x000b8944, 0x0012c633, //2.0
        0x00062972, 0xffee8107, 0xfffbed1c, 0x000b1258, 0x00145613, //3.0
        0x0006ddbd, 0xffec764f, 0xfffc0b04, 0x000a99ea, 0x00160707, //4.0
        0x0007a5f0, 0xffea3673, 0xfffc27e3, 0x000a2004, 0x0017dbb5, //5.0
        0x0008840e, 0xffe7bc99, 0xfffc43ae, 0x0009a4b4, 0x0019d6f8, //6.0
        0x00097a49, 0xffe5037a, 0xfffc5e56, 0x00092807, 0x001bfbe0, //7.0
        0x000a8b07, 0xffe20567, 0xfffc77d1, 0x0008aa08, 0x001e4db8, //8.0
        0x000bb8e3, 0xffdebc39, 0xfffc9012, 0x00082ac8, 0x0020d00a, //9.0
        0x000d06b2, 0xffdb2149, 0xfffca70d, 0x0007aa55, 0x002386a3, //10.0
        0x000e7787, 0xffd72d6d, 0xfffcbcb8, 0x000728bf, 0x00267595, //11.0
        0x00100eba, 0xffd2d8e7, 0xfffcd108, 0x0006a617, 0x0029a13f, //12.0
        0x0011cfea, 0xffce1b63, 0xfffce3f3, 0x0006226e, 0x002d0e52, //13.0
        0x0013bf03, 0xffc8ebe3, 0xfffcf570, 0x00059dd6, 0x0030c1d4, //14.0
    };

static const UINT32 _aau4MtkAudChlBassTrebleCoefTbl_200_5k[(29*2)*5] =

   {
        // 48000.0 Hz  
        // Bass Band
        0x003d77f7, 0xff8387cb, 0xffc37920, 0x007c6e6c, 0x003f0520, //-14.0
        0x003d7eb0, 0xff836eb9, 0xffc36095, 0x007c8850, 0x003f17c4, //-13.0
        0x003d84e4, 0xff83565b, 0xffc348b3, 0x007ca179, 0x003f2a3d, //-12.0
        0x003d8a95, 0xff833ead, 0xffc33175, 0x007cb9eb, 0x003f3c8f, //-11.0
        0x003d8fc4, 0xff8327aa, 0xffc31ad7, 0x007cd1ad, 0x003f4ebc, //-10.0
        0x003d9471, 0xff83114e, 0xffc304d5, 0x007ce8c2, 0x003f60ca, //-9.0
        0x003d989e, 0xff82fb94, 0xffc2ef6c, 0x007cff30, 0x003f72bb, //-8.0
        0x003d9c4b, 0xff82e679, 0xffc2da96, 0x007d14fc, 0x003f8493, //-7.0
        0x003d9f79, 0xff82d1f8, 0xffc2c652, 0x007d2a29, 0x003f9657, //-6.0
        0x003da229, 0xff82be0e, 0xffc2b299, 0x007d3ebd, 0x003fa809, //-5.0
        0x003da45a, 0xff82aab6, 0xffc29f6a, 0x007d52bc, 0x003fb9ad, //-4.0
        0x003da60e, 0xff8297ed, 0xffc28cc1, 0x007d662a, 0x003fcb48, //-3.0
        0x003da746, 0xff8285b0, 0xffc27a99, 0x007d790b, 0x003fdcdc, //-2.0
        0x003da800, 0xff8273fb, 0xffc268f1, 0x007d8b63, 0x003fee6d, //-1.0
        0x003da83d, 0xff8262ca, 0xffc257c3, 0x007d9d36, 0x00400000, //0.0
        0x003da7fd, 0xff82521b, 0xffc2470e, 0x007dae88, 0x00401197, //1.0
        0x003da741, 0xff8241ea, 0xffc236ce, 0x007dbf5c, 0x00402338, //2.0
        0x003da608, 0xff823235, 0xffc226ff, 0x007dcfb6, 0x004034e4, //3.0
        0x003da451, 0xff8222f8, 0xffc217a0, 0x007ddf99, 0x004046a0, //4.0
        0x003da21d, 0xff821430, 0xffc208ac, 0x007def09, 0x00405871, //5.0
        0x003d9f6b, 0xff8205db, 0xffc1fa22, 0x007dfe0a, 0x00406a59, //6.0
        0x003d9c3a, 0xff81f7f7, 0xffc1ebfd, 0x007e0c9d, 0x00407c5c, //7.0
        0x003d988b, 0xff81ea80, 0xffc1de3d, 0x007e1ac7, 0x00408e80, //8.0
        0x003d945b, 0xff81dd75, 0xffc1d0dd, 0x007e288a, 0x0040a0c6, //9.0
        0x003d8fab, 0xff81d0d3, 0xffc1c3dc, 0x007e35e9, 0x0040b334, //10.0
        0x003d8a7a, 0xff81c498, 0xffc1b737, 0x007e42e6, 0x0040c5cd, //11.0
        0x003d84c7, 0xff81b8c1, 0xffc1aaeb, 0x007e4f86, 0x0040d896, //12.0
        0x003d7e8f, 0xff81ad4e, 0xffc19ef6, 0x007e5bca, 0x0040eb93, //13.0
        0x003d77d4, 0xff81a23b, 0xffc19355, 0x007e67b5, 0x0040fec7, //14.0
        // Treble Band
        0x00013dbf, 0xfffc8db2, 0xfff785ef, 0x00161498, 0x00049a08, //-14.0
        0x00016557, 0xfffc17de, 0xfff7ac55, 0x0015cfb3, 0x000506c3, //-13.0
        0x000191e1, 0xfffb942f, 0xfff7d300, 0x0015892e, 0x00057dc2, //-12.0
        0x0001c3f5, 0xfffb0121, 0xfff7f9eb, 0x00154103, 0x0005fffb, //-11.0
        0x0001fc3b, 0xfffa5d09, 0xfff82110, 0x0014f72d, 0x00068e80, //-10.0
        0x00023b6d, 0xfff9a60f, 0xfff84865, 0x0014aba7, 0x00072a77, //-9.0
        0x00028259, 0xfff8da2e, 0xfff86fe5, 0x00145e6d, 0x0007d527, //-8.0
        0x0002d1e5, 0xfff7f72a, 0xfff89787, 0x00140f7a, 0x00088ff0, //-7.0
        0x00032b0f, 0xfff6fa90, 0xfff8bf42, 0x0013beca, 0x00095c55, //-6.0
        0x00038ef0, 0xfff5e1ad, 0xfff8e70e, 0x00136c59, 0x000a3bfd, //-5.0
        0x0003febf, 0xfff4a98b, 0xfff90ee0, 0x00131824, 0x000b30b2, //-4.0
        0x00047bd3, 0xfff34ee8, 0xfff936b1, 0x0012c229, 0x000c3c6b, //-3.0
        0x000507a9, 0xfff1ce33, 0xfff95e75, 0x00126a65, 0x000d614a, //-2.0
        0x0005a3e4, 0xfff02381, 0xfff98622, 0x001210d5, 0x000ea1a3, //-1.0
        0x00065253, 0xffee4a87, 0xfff9adad, 0x0011b579, 0x00100000, //0.0
        0x000714f1, 0xffec3e91, 0xfff9d50c, 0x0011584f, 0x00117f22, //1.0
        0x0007edf1, 0xffe9fa79, 0xfff9fc33, 0x0010f958, 0x0013220b, //2.0
        0x0008dfbc, 0xffe7789d, 0xfffa2316, 0x00109892, 0x0014ec00, //3.0
        0x0009ecf8, 0xffe4b2d4, 0xfffa49a8, 0x001035ff, 0x0016e08c, //4.0
        0x000b188e, 0xffe1a265, 0xfffa6fdf, 0x000fd1a1, 0x0019038d, //5.0
        0x000c65b0, 0xffde3ff6, 0xfffa95ac, 0x000f6b7a, 0x001b5934, //6.0
        0x000dd7e0, 0xffda8381, 0xfffabb04, 0x000f038b, 0x001de60f, //7.0
        0x000f72f4, 0xffd6644a, 0xfffadfd9, 0x000e99da, 0x0020af0f, //8.0
        0x00113b22, 0xffd1d8c8, 0xfffb041e, 0x000e2e69, 0x0023b98f, //9.0
        0x00133502, 0xffccd69b, 0xfffb27c6, 0x000dc13e, 0x00270b5f, //10.0
        0x0015659d, 0xffc75276, 0xfffb4ac3, 0x000d525e, 0x002aaacc, //11.0
        0x0017d271, 0xffc14011, 0xfffb6d08, 0x000ce1d0, 0x002e9ea6, //12.0
        0x001a817d, 0xffba9212, 0xfffb8e87, 0x000c6f9c, 0x0032ee4e, //13.0
        0x001d794c, 0xffb339f6, 0xfffbaf33, 0x000bfbc8, 0x0037a1c2, //14.0
    };

static const UINT32 _aau4MtkAudChlBassTrebleCoefTbl_200_6k[(29*2)*5] =

   {
        // 48000.0 Hz  
        // Bass Band
        0x003d77f7, 0xff8387cb, 0xffc37920, 0x007c6e6c, 0x003f0520, //-14.0
        0x003d7eb0, 0xff836eb9, 0xffc36095, 0x007c8850, 0x003f17c4, //-13.0
        0x003d84e4, 0xff83565b, 0xffc348b3, 0x007ca179, 0x003f2a3d, //-12.0
        0x003d8a95, 0xff833ead, 0xffc33175, 0x007cb9eb, 0x003f3c8f, //-11.0
        0x003d8fc4, 0xff8327aa, 0xffc31ad7, 0x007cd1ad, 0x003f4ebc, //-10.0
        0x003d9471, 0xff83114e, 0xffc304d5, 0x007ce8c2, 0x003f60ca, //-9.0
        0x003d989e, 0xff82fb94, 0xffc2ef6c, 0x007cff30, 0x003f72bb, //-8.0
        0x003d9c4b, 0xff82e679, 0xffc2da96, 0x007d14fc, 0x003f8493, //-7.0
        0x003d9f79, 0xff82d1f8, 0xffc2c652, 0x007d2a29, 0x003f9657, //-6.0
        0x003da229, 0xff82be0e, 0xffc2b299, 0x007d3ebd, 0x003fa809, //-5.0
        0x003da45a, 0xff82aab6, 0xffc29f6a, 0x007d52bc, 0x003fb9ad, //-4.0
        0x003da60e, 0xff8297ed, 0xffc28cc1, 0x007d662a, 0x003fcb48, //-3.0
        0x003da746, 0xff8285b0, 0xffc27a99, 0x007d790b, 0x003fdcdc, //-2.0
        0x003da800, 0xff8273fb, 0xffc268f1, 0x007d8b63, 0x003fee6d, //-1.0
        0x003da83d, 0xff8262ca, 0xffc257c3, 0x007d9d36, 0x00400000, //0.0
        0x003da7fd, 0xff82521b, 0xffc2470e, 0x007dae88, 0x00401197, //1.0
        0x003da741, 0xff8241ea, 0xffc236ce, 0x007dbf5c, 0x00402338, //2.0
        0x003da608, 0xff823235, 0xffc226ff, 0x007dcfb6, 0x004034e4, //3.0
        0x003da451, 0xff8222f8, 0xffc217a0, 0x007ddf99, 0x004046a0, //4.0
        0x003da21d, 0xff821430, 0xffc208ac, 0x007def09, 0x00405871, //5.0
        0x003d9f6b, 0xff8205db, 0xffc1fa22, 0x007dfe0a, 0x00406a59, //6.0
        0x003d9c3a, 0xff81f7f7, 0xffc1ebfd, 0x007e0c9d, 0x00407c5c, //7.0
        0x003d988b, 0xff81ea80, 0xffc1de3d, 0x007e1ac7, 0x00408e80, //8.0
        0x003d945b, 0xff81dd75, 0xffc1d0dd, 0x007e288a, 0x0040a0c6, //9.0
        0x003d8fab, 0xff81d0d3, 0xffc1c3dc, 0x007e35e9, 0x0040b334, //10.0
        0x003d8a7a, 0xff81c498, 0xffc1b737, 0x007e42e6, 0x0040c5cd, //11.0
        0x003d84c7, 0xff81b8c1, 0xffc1aaeb, 0x007e4f86, 0x0040d896, //12.0
        0x003d7e8f, 0xff81ad4e, 0xffc19ef6, 0x007e5bca, 0x0040eb93, //13.0
        0x003d77d4, 0xff81a23b, 0xffc19355, 0x007e67b5, 0x0040fec7, //14.0
        // Treble Band
        0x0001167d, 0xfffd53a4, 0xfff8942c, 0x00141638, 0x0004eb7b, //-14.0
        0x0001374b, 0xfffcedee, 0xfff8bbe5, 0x0013c5ad, 0x00055935, //-13.0
        0x00015c2d, 0xfffc7c07, 0xfff8e3b0, 0x00137363, 0x0005d0b9, //-12.0
        0x000185a2, 0xfffbfca0, 0xfff90b82, 0x00131f55, 0x000652e7, //-11.0
        0x0001b433, 0xfffb6e48, 0xfff93353, 0x0012c980, 0x0006e0b2, //-10.0
        0x0001e879, 0xfffacf68, 0xfff95b19, 0x001271e2, 0x00077b24, //-9.0
        0x0002231e, 0xfffa1e44, 0xfff982c8, 0x0012187a, 0x0008235c, //-8.0
        0x000264de, 0xfff958f3, 0xfff9aa57, 0x0011bd45, 0x0008da94, //-7.0
        0x0002ae89, 0xfff87d5d, 0xfff9d1ba, 0x00116042, 0x0009a21e, //-6.0
        0x00030105, 0xfff78939, 0xfff9f8e6, 0x00110171, 0x000a7b6c, //-5.0
        0x00035d4f, 0xfff67a02, 0xfffa1fcf, 0x0010a0d3, 0x000b680e, //-4.0
        0x0003c47f, 0xfff54cfb, 0xfffa4669, 0x00103e67, 0x000c69b6, //-3.0
        0x000437ca, 0xfff3ff24, 0xfffa6ca8, 0x000fda30, 0x000d823b, //-2.0
        0x0004b883, 0xfff28d35, 0xfffa927e, 0x000f742f, 0x000eb39b, //-1.0
        0x0005481f, 0xfff0f39a, 0xfffab7e1, 0x000f0c66, 0x00100000, //0.0
        0x0005e839, 0xffef2e6b, 0xfffadcc1, 0x000ea2db, 0x001169c0, //1.0
        0x00069a94, 0xffed3966, 0xfffb0113, 0x000e3790, 0x0012f363, //2.0
        0x0007611d, 0xffeb0fe9, 0xfffb24c9, 0x000dca8a, 0x00149fa8, //3.0
        0x00083df3, 0xffe8ace5, 0xfffb47d5, 0x000d5bcf, 0x00167184, //4.0
        0x00093368, 0xffe60add, 0xfffb6a2a, 0x000ceb65, 0x00186c2c, //5.0
        0x000a4404, 0xffe323d7, 0xfffb8bba, 0x000c7954, 0x001a9317, //6.0
        0x000b728d, 0xffdff155, 0xfffbac78, 0x000c05a3, 0x001cea02, //7.0
        0x000cc20c, 0xffdc6c4b, 0xfffbcc57, 0x000b905c, 0x001f74f6, //8.0
        0x000e35cd, 0xffd88d14, 0xfffbeb48, 0x000b1987, 0x0022384f, //9.0
        0x000fd16d, 0xffd44b65, 0xfffc0940, 0x000aa130, 0x002538bf, //10.0
        0x001198d7, 0xffcf9e43, 0xfffc262f, 0x000a2761, 0x00287b56, //11.0
        0x00139053, 0xffca7bf3, 0xfffc420b, 0x0009ac26, 0x002c058a, //12.0
        0x0015bc86, 0xffc4d9ee, 0xfffc5cc5, 0x00092f8d, 0x002fdd3a, //13.0
        0x0018227d, 0xffbeacd4, 0xfffc7652, 0x0008b1a3, 0x003408ba, //14.0
    };

static const UINT32 _aau4MtkAudChlBassTrebleCoefTbl_200_7k[(29*2)*5] =

   {
        // 48000.0 Hz  
        // Bass Band
        0x003d77f7, 0xff8387cb, 0xffc37920, 0x007c6e6c, 0x003f0520, //-14.0
        0x003d7eb0, 0xff836eb9, 0xffc36095, 0x007c8850, 0x003f17c4, //-13.0
        0x003d84e4, 0xff83565b, 0xffc348b3, 0x007ca179, 0x003f2a3d, //-12.0
        0x003d8a95, 0xff833ead, 0xffc33175, 0x007cb9eb, 0x003f3c8f, //-11.0
        0x003d8fc4, 0xff8327aa, 0xffc31ad7, 0x007cd1ad, 0x003f4ebc, //-10.0
        0x003d9471, 0xff83114e, 0xffc304d5, 0x007ce8c2, 0x003f60ca, //-9.0
        0x003d989e, 0xff82fb94, 0xffc2ef6c, 0x007cff30, 0x003f72bb, //-8.0
        0x003d9c4b, 0xff82e679, 0xffc2da96, 0x007d14fc, 0x003f8493, //-7.0
        0x003d9f79, 0xff82d1f8, 0xffc2c652, 0x007d2a29, 0x003f9657, //-6.0
        0x003da229, 0xff82be0e, 0xffc2b299, 0x007d3ebd, 0x003fa809, //-5.0
        0x003da45a, 0xff82aab6, 0xffc29f6a, 0x007d52bc, 0x003fb9ad, //-4.0
        0x003da60e, 0xff8297ed, 0xffc28cc1, 0x007d662a, 0x003fcb48, //-3.0
        0x003da746, 0xff8285b0, 0xffc27a99, 0x007d790b, 0x003fdcdc, //-2.0
        0x003da800, 0xff8273fb, 0xffc268f1, 0x007d8b63, 0x003fee6d, //-1.0
        0x003da83d, 0xff8262ca, 0xffc257c3, 0x007d9d36, 0x00400000, //0.0
        0x003da7fd, 0xff82521b, 0xffc2470e, 0x007dae88, 0x00401197, //1.0
        0x003da741, 0xff8241ea, 0xffc236ce, 0x007dbf5c, 0x00402338, //2.0
        0x003da608, 0xff823235, 0xffc226ff, 0x007dcfb6, 0x004034e4, //3.0
        0x003da451, 0xff8222f8, 0xffc217a0, 0x007ddf99, 0x004046a0, //4.0
        0x003da21d, 0xff821430, 0xffc208ac, 0x007def09, 0x00405871, //5.0
        0x003d9f6b, 0xff8205db, 0xffc1fa22, 0x007dfe0a, 0x00406a59, //6.0
        0x003d9c3a, 0xff81f7f7, 0xffc1ebfd, 0x007e0c9d, 0x00407c5c, //7.0
        0x003d988b, 0xff81ea80, 0xffc1de3d, 0x007e1ac7, 0x00408e80, //8.0
        0x003d945b, 0xff81dd75, 0xffc1d0dd, 0x007e288a, 0x0040a0c6, //9.0
        0x003d8fab, 0xff81d0d3, 0xffc1c3dc, 0x007e35e9, 0x0040b334, //10.0
        0x003d8a7a, 0xff81c498, 0xffc1b737, 0x007e42e6, 0x0040c5cd, //11.0
        0x003d84c7, 0xff81b8c1, 0xffc1aaeb, 0x007e4f86, 0x0040d896, //12.0
        0x003d7e8f, 0xff81ad4e, 0xffc19ef6, 0x007e5bca, 0x0040eb93, //13.0
        0x003d77d4, 0xff81a23b, 0xffc19355, 0x007e67b5, 0x0040fec7, //14.0
        // Treble Band
        0x0000ff7e, 0xfffe282b, 0xfff98529, 0x0012130d, 0x00054022, //-14.0
        0x00011ab0, 0xfffdd252, 0xfff9acb6, 0x0011b7bc, 0x0005ae8c, //-13.0
        0x00013939, 0xfffd71d2, 0xfff9d416, 0x00115a9d, 0x00062641, //-12.0
        0x00015b7f, 0xfffd0589, 0xfff9fb3e, 0x0010fbb1, 0x0006a809, //-11.0
        0x000181f3, 0xfffc8c37, 0xfffa2223, 0x00109af6, 0x000734bd, //-10.0
        0x0001ad12, 0xfffc0481, 0xfffa48b7, 0x0010386f, 0x0007cd47, //-9.0
        0x0001dd66, 0xfffb6ce7, 0xfffa6ef0, 0x000fd41c, 0x000872a6, //-8.0
        0x0002138b, 0xfffac3c9, 0xfffa94c1, 0x000f6e00, 0x000925eb, //-7.0
        0x00025028, 0xfffa0760, 0xfffaba1b, 0x000f061d, 0x0009e840, //-6.0
        0x000293f9, 0xfff935b9, 0xfffadef4, 0x000e9c76, 0x000abae5, //-5.0
        0x0002dfcc, 0xfff84cb5, 0xfffb033d, 0x000e3110, 0x000b9f33, //-4.0
        0x00033484, 0xfff74a04, 0xfffb26e9, 0x000dc3ef, 0x000c96a0, //-3.0
        0x0003931b, 0xfff62b22, 0xfffb49ea, 0x000d551a, 0x000da2bf, //-2.0
        0x0003fca3, 0xfff4ed50, 0xfffb6c34, 0x000ce497, 0x000ec543, //-1.0
        0x00047248, 0xfff38d93, 0xfffb8db8, 0x000c726d, 0x00100000, //0.0
        0x0004f556, 0xfff208ae, 0xfffbae69, 0x000bfea4, 0x001154f0, //1.0
        0x00058735, 0xfff05b1a, 0xfffbce3a, 0x000b8944, 0x0012c633, //2.0
        0x00062972, 0xffee8107, 0xfffbed1c, 0x000b1258, 0x00145613, //3.0
        0x0006ddbd, 0xffec764f, 0xfffc0b04, 0x000a99ea, 0x00160707, //4.0
        0x0007a5f0, 0xffea3673, 0xfffc27e3, 0x000a2004, 0x0017dbb5, //5.0
        0x0008840e, 0xffe7bc99, 0xfffc43ae, 0x0009a4b4, 0x0019d6f8, //6.0
        0x00097a49, 0xffe5037a, 0xfffc5e56, 0x00092807, 0x001bfbe0, //7.0
        0x000a8b07, 0xffe20567, 0xfffc77d1, 0x0008aa08, 0x001e4db8, //8.0
        0x000bb8e3, 0xffdebc39, 0xfffc9012, 0x00082ac8, 0x0020d00a, //9.0
        0x000d06b2, 0xffdb2149, 0xfffca70d, 0x0007aa55, 0x002386a3, //10.0
        0x000e7787, 0xffd72d6d, 0xfffcbcb8, 0x000728bf, 0x00267595, //11.0
        0x00100eba, 0xffd2d8e7, 0xfffcd108, 0x0006a617, 0x0029a13f, //12.0
        0x0011cfea, 0xffce1b63, 0xfffce3f3, 0x0006226e, 0x002d0e52, //13.0
        0x0013bf03, 0xffc8ebe3, 0xfffcf570, 0x00059dd6, 0x0030c1d4, //14.0
    };

#else
static const UINT32 _aau4MtkAudChlBassTrebleCoefTbl[(29*2)*5] =
{
    // 48000.0 Hz
    // Bass Band
    0x003c8374, 0xff84d9b4, 0xffc4cb42, 0x007b1ca9, 0x003ea7a7, //-14.0
    0x003c8c50, 0xff84b7a9, 0xffc4a9bb, 0x007b3f83, 0x003ec121, //-13.0
    0x003c9479, 0xff84968b, 0xffc48916, 0x007b6168, 0x003eda64, //-12.0
    0x003c9bf0, 0xff847654, 0xffc4694c, 0x007b8260, 0x003ef377, //-11.0
    0x003ca2b8, 0xff8456fe, 0xffc44a5a, 0x007ba271, 0x003f0c5e, //-10.0
    0x003ca8d0, 0xff843885, 0xffc42c39, 0x007bc1a0, 0x003f251d, //-9.0
    0x003cae3a, 0xff841ae2, 0xffc40ee4, 0x007bdff5, 0x003f3db9, //-8.0
    0x003cb2f6, 0xff83fe11, 0xffc3f257, 0x007bfd74, 0x003f5637, //-7.0
    0x003cb706, 0xff83e20b, 0xffc3d68c, 0x007c1a23, 0x003f6e9d, //-6.0
    0x003cba69, 0xff83c6cd, 0xffc3bb7f, 0x007c3608, 0x003f86ee, //-5.0
    0x003cbd20, 0xff83ac51, 0xffc3a12b, 0x007c5129, 0x003f9f30, //-4.0
    0x003cbf2b, 0xff839293, 0xffc3878b, 0x007c6b8a, 0x003fb767, //-3.0
    0x003cc08b, 0xff83798e, 0xffc36e9a, 0x007c8531, 0x003fcf99, //-2.0
    0x003cc13f, 0xff83613e, 0xffc35656, 0x007c9e22, 0x003fe7cb, //-1.0
    0x003cc148, 0xff83499d, 0xffc33eb8, 0x007cb663, 0x00400000, //0.0
    0x003cc0a5, 0xff8332a9, 0xffc327bd, 0x007ccdf8, 0x0040183f, //1.0
    0x003cbf57, 0xff831c5c, 0xffc31160, 0x007ce4e6, 0x0040308b, //2.0
    0x003cbd5b, 0xff8306b4, 0xffc2fb9e, 0x007cfb31, 0x004048eb, //3.0
    0x003cbab3, 0xff82f1ab, 0xffc2e673, 0x007d10df, 0x00406163, //4.0
    0x003cb75d, 0xff82dd3f, 0xffc2d1db, 0x007d25f2, 0x004079f9, //5.0
    0x003cb358, 0xff82c96b, 0xffc2bdd1, 0x007d3a6f, 0x004092b1, //6.0
    0x003caea5, 0xff82b62c, 0xffc2aa53, 0x007d4e5b, 0x0040ab90, //7.0
    0x003ca940, 0xff82a37f, 0xffc2975d, 0x007d61ba, 0x0040c49c, //8.0
    0x003ca32a, 0xff829161, 0xffc284ea, 0x007d748e, 0x0040ddda, //9.0
    0x003c9c62, 0xff827fce, 0xffc272f9, 0x007d86dc, 0x0040f750, //10.0
    0x003c94e5, 0xff826ec3, 0xffc26184, 0x007d98a8, 0x00411102, //11.0
    0x003c8cb2, 0xff825e3e, 0xffc2508a, 0x007da9f5, 0x00412af7, //12.0
    0x003c83c7, 0xff824e3b, 0xffc24007, 0x007dbac6, 0x00414534, //13.0
    0x003c7a23, 0xff823eb8, 0xffc22ff7, 0x007dcb20, 0x00415fbe, //14.0
    // Treble Band
    0x0001861d, 0xfffb5073, 0xfff5bc95, 0x001956bf, 0x0004161b, //-14.0
    0x0001b9c1, 0xfffabed9, 0xfff5de51, 0x00192882, 0x00048093, //-13.0
    0x0001f3ef, 0xfffa1c54, 0xfff60092, 0x0018f921, 0x0004f60b, //-12.0
    0x00023571, 0xfff966fc, 0xfff62358, 0x0018c896, 0x000577a5, //-11.0
    0x00027f2a, 0xfff89cb6, 0xfff646a0, 0x001896de, 0x000606a3, //-10.0
    0x0002d215, 0xfff7bb2b, 0xfff66a68, 0x001863f1, 0x0006a467, //-9.0
    0x00032f4b, 0xfff6bfc4, 0xfff68eaf, 0x00182fcb, 0x00075278, //-8.0
    0x00039803, 0xfff5a7a2, 0xfff6b371, 0x0017fa66, 0x00081284, //-7.0
    0x00040d99, 0xfff46f98, 0xfff6d8ac, 0x0017c3bd, 0x0008e665, //-6.0
    0x00049190, 0xfff31422, 0xfff6fe5d, 0x00178bcb, 0x0009d026, //-5.0
    0x00052596, 0xfff1915a, 0xfff72481, 0x0017528b, 0x000ad204, //-4.0
    0x0005cb88, 0xffefe2f4, 0xfff74b13, 0x001717f8, 0x000bee7a, //-3.0
    0x00068578, 0xffee042d, 0xfff7720f, 0x0016dc0c, 0x000d2840, //-2.0
    0x000755b4, 0xffebefc3, 0xfff79973, 0x00169ec3, 0x000e8253, //-1.0
    0x00083ec8, 0xffe99fe8, 0xfff7c138, 0x00166018, 0x00100000, //0.0
    0x0009438a, 0xffe70e32, 0xfff7e959, 0x00162006, 0x0011a4e5, //1.0
    0x000a671a, 0xffe4338c, 0xfff811d2, 0x0015de8a, 0x001374fe, //2.0
    0x000bacf4, 0xffe10828, 0xfff83a9c, 0x00159b9e, 0x001574aa, //3.0
    0x000d18ee, 0xffdd8369, 0xfff863b2, 0x0015573f, 0x0017a8b8, //4.0
    0x000eaf4a, 0xffd99bd1, 0xfff88d0d, 0x00151169, 0x001a1670, //5.0
    0x001074bb, 0xffd546eb, 0xfff8b6a7, 0x0014ca17, 0x001cc39c, //6.0
    0x00126e76, 0xffd07933, 0xfff8e077, 0x00148147, 0x001fb69a, //7.0
    0x0014a236, 0xffcb25fc, 0xfff90a77, 0x001436f5, 0x0022f663, //8.0
    0x00171652, 0xffc53f53, 0xfff9349e, 0x0013eb1e, 0x00268a9f, //9.0
    0x0019d1c9, 0xffbeb5e3, 0xfff95ee5, 0x00139dc0, 0x002a7bb0, //10.0
    0x001cdc50, 0xffb778cf, 0xfff98942, 0x00134ed8, 0x002ed2c8, //11.0
    0x00203e64, 0xffaf7594, 0xfff9b3ac, 0x0012fe63, 0x003399f8, //12.0
    0x00240162, 0xffa697db, 0xfff9de1b, 0x0012ac61, 0x0038dc47, //13.0
    0x00282f94, 0xff9cc954, 0xfffa0884, 0x001258d0, 0x003ea5c5, //14.0
};
#endif
#endif
#endif

#ifdef CC_AUD_FY12_LOUDNESS
#ifdef AUDIO_CHL_BASS_TREBLE_LOUD_COEF_TBL_DEFAULT //20100909
static const UINT32 _aau4MtkAudChlBassTrebleLoudnessCoefTbl[(57*2)*5] =
{
    // 48000.0 Hz
    // Bass Band
    0x003c8374, 0xff84d9b4, 0xffc4cb42, 0x007b1ca9, 0x003ea7a7, //-14.0
    0x003c87f9, 0xff84c890, 0xffc4ba62, 0x007b2e35, 0x003eb46b, //-13.5
    0x003c8c50, 0xff84b7a9, 0xffc4a9bb, 0x007b3f83, 0x003ec121, //-13.0
    0x003c907a, 0xff84a6fc, 0xffc4994d, 0x007b5093, 0x003ecdc9, //-12.5
    0x003c9479, 0xff84968b, 0xffc48916, 0x007b6168, 0x003eda64, //-12.0
    0x003c984b, 0xff848653, 0xffc47916, 0x007b7201, 0x003ee6f4, //-11.5
    0x003c9bf0, 0xff847654, 0xffc4694c, 0x007b8260, 0x003ef377, //-11.0
    0x003c9f6a, 0xff84668d, 0xffc459b9, 0x007b9285, 0x003efff0, //-10.5
    0x003ca2b8, 0xff8456fe, 0xffc44a5a, 0x007ba271, 0x003f0c5e, //-10.0
    0x003ca5da, 0xff8447a7, 0xffc43b2f, 0x007bb224, 0x003f18c2, //-9.5
    0x003ca8d0, 0xff843885, 0xffc42c39, 0x007bc1a0, 0x003f251d, //-9.0
    0x003cab9b, 0xff842999, 0xffc41d75, 0x007bd0e6, 0x003f316f, //-8.5
    0x003cae3a, 0xff841ae2, 0xffc40ee4, 0x007bdff5, 0x003f3db9, //-8.0
    0x003cb0ae, 0xff840c5f, 0xffc40085, 0x007beecf, 0x003f49fb, //-7.5
    0x003cb2f6, 0xff83fe11, 0xffc3f257, 0x007bfd74, 0x003f5637, //-7.0
    0x003cb513, 0xff83eff5, 0xffc3e459, 0x007c0be5, 0x003f626d, //-6.5
    0x003cb706, 0xff83e20b, 0xffc3d68c, 0x007c1a23, 0x003f6e9d, //-6.0
    0x003cb8cd, 0xff83d454, 0xffc3c8ee, 0x007c282f, 0x003f7ac8, //-5.5
    0x003cba69, 0xff83c6cd, 0xffc3bb7f, 0x007c3608, 0x003f86ee, //-5.0
    0x003cbbda, 0xff83b977, 0xffc3ae3e, 0x007c43b1, 0x003f9311, //-4.5
    0x003cbd20, 0xff83ac51, 0xffc3a12b, 0x007c5129, 0x003f9f30, //-4.0
    0x003cbe3b, 0xff839f5b, 0xffc39444, 0x007c5e71, 0x003fab4d, //-3.5
    0x003cbf2b, 0xff839293, 0xffc3878b, 0x007c6b8a, 0x003fb767, //-3.0
    0x003cbff0, 0xff8385fa, 0xffc37afd, 0x007c7874, 0x003fc381, //-2.5
    0x003cc08b, 0xff83798e, 0xffc36e9a, 0x007c8531, 0x003fcf99, //-2.0
    0x003cc0fb, 0xff836d50, 0xffc36263, 0x007c91c0, 0x003fdbb2, //-1.5
    0x003cc13f, 0xff83613e, 0xffc35656, 0x007c9e22, 0x003fe7cb, //-1.0
    0x003cc159, 0xff835558, 0xffc34a72, 0x007caa58, 0x003ff3e4, //-0.5
    0x003cc148, 0xff83499d, 0xffc33eb8, 0x007cb663, 0x00400000, //0.0
    0x003cc10c, 0xff833e0e, 0xffc33326, 0x007cc243, 0x00400c1e, //0.5
    0x003cc0a5, 0xff8332a9, 0xffc327bd, 0x007ccdf8, 0x0040183f, //1.0
    0x003cc013, 0xff83276e, 0xffc31c7b, 0x007cd984, 0x00402463, //1.5
    0x003cbf57, 0xff831c5c, 0xffc31160, 0x007ce4e6, 0x0040308b, //2.0
    0x003cbe6e, 0xff831174, 0xffc3066c, 0x007cf020, 0x00403cb9, //2.5
    0x003cbd5b, 0xff8306b4, 0xffc2fb9e, 0x007cfb31, 0x004048eb, //3.0
    0x003cbc1d, 0xff82fc1c, 0xffc2f0f6, 0x007d061b, 0x00405524, //3.5
    0x003cbab3, 0xff82f1ab, 0xffc2e673, 0x007d10df, 0x00406163, //4.0
    0x003cb91e, 0xff82e761, 0xffc2dc15, 0x007d1b7b, 0x00406daa, //4.5
    0x003cb75d, 0xff82dd3f, 0xffc2d1db, 0x007d25f2, 0x004079f9, //5.0
    0x003cb571, 0xff82d342, 0xffc2c7c4, 0x007d3043, 0x00408650, //5.5
    0x003cb358, 0xff82c96b, 0xffc2bdd1, 0x007d3a6f, 0x004092b1, //6.0
    0x003cb115, 0xff82bfb9, 0xffc2b401, 0x007d4477, 0x00409f1b, //6.5
    0x003caea5, 0xff82b62c, 0xffc2aa53, 0x007d4e5b, 0x0040ab90, //7.0
    0x003cac09, 0xff82acc4, 0xffc2a0c7, 0x007d581c, 0x0040b810, //7.5
    0x003ca940, 0xff82a37f, 0xffc2975d, 0x007d61ba, 0x0040c49c, //8.0
    0x003ca64c, 0xff829a5f, 0xffc28e13, 0x007d6b35, 0x0040d135, //8.5
    0x003ca32a, 0xff829161, 0xffc284ea, 0x007d748e, 0x0040ddda, //9.0
    0x003c9fdd, 0xff828886, 0xffc27be2, 0x007d7dc6, 0x0040ea8e, //9.5
    0x003c9c62, 0xff827fce, 0xffc272f9, 0x007d86dc, 0x0040f750, //10.0
    0x003c98ba, 0xff827738, 0xffc26a2f, 0x007d8fd2, 0x00410421, //10.5
    0x003c94e5, 0xff826ec3, 0xffc26184, 0x007d98a8, 0x00411102, //11.0
    0x003c90e2, 0xff826670, 0xffc258f8, 0x007da15e, 0x00411df4, //11.5
    0x003c8cb2, 0xff825e3e, 0xffc2508a, 0x007da9f5, 0x00412af7, //12.0
    0x003c8853, 0xff82562c, 0xffc2483a, 0x007db26d, 0x0041380c, //12.5
    0x003c83c7, 0xff824e3b, 0xffc24007, 0x007dbac6, 0x00414534, //13.0
    0x003c7f0c, 0xff82466a, 0xffc237f1, 0x007dc302, 0x0041526f, //13.5
    0x003c7a23, 0xff823eb8, 0xffc22ff7, 0x007dcb20, 0x00415fbe, //14.0
    // Treble Band
    0x0001861d, 0xfffb5073, 0xfff5bc95, 0x001956bf, 0x0004161b, //-14.0
    0x00019f2a, 0xfffb09a7, 0xfff5cd62, 0x00193fc4, 0x00044a09, //-13.5
    0x0001b9c1, 0xfffabed9, 0xfff5de51, 0x00192882, 0x00048093, //-13.0
    0x0001d5fa, 0xfffa6fd1, 0xfff5ef61, 0x001910f6, 0x0004b9de, //-12.5
    0x0001f3ef, 0xfffa1c54, 0xfff60092, 0x0018f921, 0x0004f60b, //-12.0
    0x000213b8, 0xfff9c423, 0xfff611e4, 0x0018e101, 0x00053540, //-11.5
    0x00023571, 0xfff966fc, 0xfff62358, 0x0018c896, 0x000577a5, //-11.0
    0x00025938, 0xfff9049b, 0xfff634eb, 0x0018afe0, 0x0005bd62, //-10.5
    0x00027f2a, 0xfff89cb6, 0xfff646a0, 0x001896de, 0x000606a3, //-10.0
    0x0002a769, 0xfff82f01, 0xfff65874, 0x00187d8e, 0x00065394, //-9.5
    0x0002d215, 0xfff7bb2b, 0xfff66a68, 0x001863f1, 0x0006a467, //-9.0
    0x0002ff54, 0xfff740df, 0xfff67c7c, 0x00184a05, 0x0006f94c, //-8.5
    0x00032f4b, 0xfff6bfc4, 0xfff68eaf, 0x00182fcb, 0x00075278, //-8.0
    0x00036222, 0xfff6377c, 0xfff6a100, 0x00181540, 0x0007b022, //-7.5
    0x00039803, 0xfff5a7a2, 0xfff6b371, 0x0017fa66, 0x00081284, //-7.0
    0x0003d11b, 0xfff50fd1, 0xfff6c600, 0x0017df3a, 0x000879db, //-6.5
    0x00040d99, 0xfff46f98, 0xfff6d8ac, 0x0017c3bd, 0x0008e665, //-6.0
    0x00044daf, 0xfff3c686, 0xfff6eb76, 0x0017a7ee, 0x00095867, //-5.5
    0x00049190, 0xfff31422, 0xfff6fe5d, 0x00178bcb, 0x0009d026, //-5.0
    0x0004d975, 0xfff257ea, 0xfff71161, 0x00176f55, 0x000a4deb, //-4.5
    0x00052596, 0xfff1915a, 0xfff72481, 0x0017528b, 0x000ad204, //-4.0
    0x00057632, 0xfff0bfe4, 0xfff737bc, 0x0017356c, 0x000b5cc2, //-3.5
    0x0005cb88, 0xffefe2f4, 0xfff74b13, 0x001717f8, 0x000bee7a, //-3.0
    0x000625dd, 0xffeef9ed, 0xfff75e84, 0x0016fa2d, 0x000c8785, //-2.5
    0x00068578, 0xffee042d, 0xfff7720f, 0x0016dc0c, 0x000d2840, //-2.0
    0x0006eaa6, 0xffed0106, 0xfff785b5, 0x0016bd93, 0x000dd10d, //-1.5
    0x000755b4, 0xffebefc3, 0xfff79973, 0x00169ec3, 0x000e8253, //-1.0
    0x0007c6f8, 0xffeacfa7, 0xfff7ad49, 0x00167f9a, 0x000f3c7f, //-0.5
    0x00083ec8, 0xffe99fe8, 0xfff7c138, 0x00166018, 0x00100000, //0.0
    0x0008bd83, 0xffe85fb5, 0xfff7d53d, 0x0016403c, 0x0010cd4e, //0.5
    0x0009438a, 0xffe70e32, 0xfff7e959, 0x00162006, 0x0011a4e5, //1.0
    0x0009d143, 0xffe5aa75, 0xfff7fd8b, 0x0015ff76, 0x00128747, //1.5
    0x000a671a, 0xffe4338c, 0xfff811d2, 0x0015de8a, 0x001374fe, //2.0
    0x000b0583, 0xffe2a876, 0xfff8262d, 0x0015bd42, 0x00146e97, //2.5
    0x000bacf4, 0xffe10828, 0xfff83a9c, 0x00159b9e, 0x001574aa, //3.0
    0x000c5deb, 0xffdf5186, 0xfff84f1e, 0x0015799d, 0x001687d3, //3.5
    0x000d18ee, 0xffdd8369, 0xfff863b2, 0x0015573f, 0x0017a8b8, //4.0
    0x000dde87, 0xffdb9c99, 0xfff87858, 0x00153483, 0x0018d805, //4.5
    0x000eaf4a, 0xffd99bd1, 0xfff88d0d, 0x00151169, 0x001a1670, //5.0
    0x000f8bd0, 0xffd77fb9, 0xfff8a1d3, 0x0014edef, 0x001b64b5, //5.5
    0x001074bb, 0xffd546eb, 0xfff8b6a7, 0x0014ca17, 0x001cc39c, //6.0
    0x00116ab7, 0xffd2efed, 0xfff8cb88, 0x0014a5df, 0x001e33f5, //6.5
    0x00126e76, 0xffd07933, 0xfff8e077, 0x00148147, 0x001fb69a, //7.0
    0x001380b3, 0xffcde11e, 0xfff8f571, 0x00145c4e, 0x00214c6f, //7.5
    0x0014a236, 0xffcb25fc, 0xfff90a77, 0x001436f5, 0x0022f663, //8.0
    0x0015d3cd, 0xffc84602, 0xfff91f86, 0x0014113a, 0x0024b571, //8.5
    0x00171652, 0xffc53f53, 0xfff9349e, 0x0013eb1e, 0x00268a9f, //9.0
    0x00186aac, 0xffc20ff8, 0xfff949be, 0x0013c4a0, 0x002876ff, //9.5
    0x0019d1c9, 0xffbeb5e3, 0xfff95ee5, 0x00139dc0, 0x002a7bb0, //10.0
    0x001b4ca7, 0xffbb2eeb, 0xfff97411, 0x0013767d, 0x002c99e0, //10.5
    0x001cdc50, 0xffb778cf, 0xfff98942, 0x00134ed8, 0x002ed2c8, //11.0
    0x001e81d8, 0xffb39130, 0xfff99e76, 0x001326cf, 0x003127b3, //11.5
    0x00203e64, 0xffaf7594, 0xfff9b3ac, 0x0012fe63, 0x003399f8, //12.0
    0x00221327, 0xffab2360, 0xfff9c8e4, 0x0012d594, 0x00362b01, //12.5
    0x00240162, 0xffa697db, 0xfff9de1b, 0x0012ac61, 0x0038dc47, //13.0
    0x00260a66, 0xffa1d02b, 0xfff9f351, 0x001282ca, 0x003baf54, //13.5
    0x00282f94, 0xff9cc954, 0xfffa0884, 0x001258d0, 0x003ea5c5, //14.0
};
static const UINT32 _aau4MtkAudChlBassTrebleLoudnessCoefTbl_200_5K[(57*2)*5] =
{
    // 48000.0 Hz  
    // Bass Band
    0x003d77f7, 0xff8387cb, 0xffc37920, 0x007c6e6c, 0x003f0520, //-14.0
    0x003d7b64, 0xff837b2b, 0xffc36cc5, 0x007c7b76, 0x003f0e77, //-13.5
    0x003d7eb0, 0xff836eb9, 0xffc36095, 0x007c8850, 0x003f17c4, //-13.0
    0x003d81db, 0xff836274, 0xffc3548f, 0x007c94fc, 0x003f2106, //-12.5
    0x003d84e4, 0xff83565b, 0xffc348b3, 0x007ca179, 0x003f2a3d, //-12.0
    0x003d87cd, 0xff834a6e, 0xffc33cff, 0x007cadc9, 0x003f336b, //-11.5
    0x003d8a95, 0xff833ead, 0xffc33175, 0x007cb9eb, 0x003f3c8f, //-11.0
    0x003d8d3d, 0xff833316, 0xffc32612, 0x007cc5e2, 0x003f45aa, //-10.5
    0x003d8fc4, 0xff8327aa, 0xffc31ad7, 0x007cd1ad, 0x003f4ebc, //-10.0
    0x003d922a, 0xff831c67, 0xffc30fc3, 0x007cdd4d, 0x003f57c7, //-9.5
    0x003d9471, 0xff83114e, 0xffc304d5, 0x007ce8c2, 0x003f60ca, //-9.0
    0x003d9697, 0xff83065d, 0xffc2fa0e, 0x007cf40e, 0x003f69c6, //-8.5
    0x003d989e, 0xff82fb94, 0xffc2ef6c, 0x007cff30, 0x003f72bb, //-8.0
    0x003d9a84, 0xff82f0f3, 0xffc2e4ef, 0x007d0a2a, 0x003f7baa, //-7.5
    0x003d9c4b, 0xff82e679, 0xffc2da96, 0x007d14fc, 0x003f8493, //-7.0
    0x003d9df2, 0xff82dc25, 0xffc2d062, 0x007d1fa6, 0x003f8d78, //-6.5
    0x003d9f79, 0xff82d1f8, 0xffc2c652, 0x007d2a29, 0x003f9657, //-6.0
    0x003da0e0, 0xff82c7f0, 0xffc2bc64, 0x007d3486, 0x003f9f32, //-5.5
    0x003da229, 0xff82be0e, 0xffc2b299, 0x007d3ebd, 0x003fa809, //-5.0
    0x003da351, 0xff82b450, 0xffc2a8f1, 0x007d48cf, 0x003fb0dd, //-4.5
    0x003da45a, 0xff82aab6, 0xffc29f6a, 0x007d52bc, 0x003fb9ad, //-4.0
    0x003da544, 0xff82a140, 0xffc29605, 0x007d5c85, 0x003fc27c, //-3.5
    0x003da60e, 0xff8297ed, 0xffc28cc1, 0x007d662a, 0x003fcb48, //-3.0
    0x003da6ba, 0xff828ebd, 0xffc2839d, 0x007d6fac, 0x003fd412, //-2.5
    0x003da746, 0xff8285b0, 0xffc27a99, 0x007d790b, 0x003fdcdc, //-2.0
    0x003da7b2, 0xff827cc5, 0xffc271b5, 0x007d8248, 0x003fe5a5, //-1.5
    0x003da800, 0xff8273fb, 0xffc268f1, 0x007d8b63, 0x003fee6d, //-1.0
    0x003da82e, 0xff826b52, 0xffc2604b, 0x007d945d, 0x003ff736, //-0.5
    0x003da83d, 0xff8262ca, 0xffc257c3, 0x007d9d36, 0x00400000, //0.0
    0x003da82d, 0xff825a63, 0xffc24f5a, 0x007da5ef, 0x004008cb, //0.5
    0x003da7fd, 0xff82521b, 0xffc2470e, 0x007dae88, 0x00401197, //1.0
    0x003da7af, 0xff8249f3, 0xffc23edf, 0x007db701, 0x00401a66, //1.5
    0x003da741, 0xff8241ea, 0xffc236ce, 0x007dbf5c, 0x00402338, //2.0
    0x003da6b4, 0xff823a00, 0xffc22ed8, 0x007dc798, 0x00402c0c, //2.5
    0x003da608, 0xff823235, 0xffc226ff, 0x007dcfb6, 0x004034e4, //3.0
    0x003da53c, 0xff822a87, 0xffc21f42, 0x007dd7b6, 0x00403dc0, //3.5
    0x003da451, 0xff8222f8, 0xffc217a0, 0x007ddf99, 0x004046a0, //4.0
    0x003da347, 0xff821b85, 0xffc21018, 0x007de760, 0x00404f86, //4.5
    0x003da21d, 0xff821430, 0xffc208ac, 0x007def09, 0x00405871, //5.0
    0x003da0d4, 0xff820cf8, 0xffc2015a, 0x007df697, 0x00406161, //5.5
    0x003d9f6b, 0xff8205db, 0xffc1fa22, 0x007dfe0a, 0x00406a59, //6.0
    0x003d9de2, 0xff81fedb, 0xffc1f303, 0x007e0561, 0x00407357, //6.5
    0x003d9c3a, 0xff81f7f7, 0xffc1ebfd, 0x007e0c9d, 0x00407c5c, //7.0
    0x003d9a72, 0xff81f12e, 0xffc1e511, 0x007e13bf, 0x0040856a, //7.5
    0x003d988b, 0xff81ea80, 0xffc1de3d, 0x007e1ac7, 0x00408e80, //8.0
    0x003d9683, 0xff81e3ee, 0xffc1d781, 0x007e21b5, 0x0040979e, //8.5
    0x003d945b, 0xff81dd75, 0xffc1d0dd, 0x007e288a, 0x0040a0c6, //9.0
    0x003d9214, 0xff81d717, 0xffc1ca51, 0x007e2f45, 0x0040a9f8, //9.5
    0x003d8fab, 0xff81d0d3, 0xffc1c3dc, 0x007e35e9, 0x0040b334, //10.0
    0x003d8d23, 0xff81caa9, 0xffc1bd7e, 0x007e3c73, 0x0040bc7b, //10.5
    0x003d8a7a, 0xff81c498, 0xffc1b737, 0x007e42e6, 0x0040c5cd, //11.0
    0x003d87b1, 0xff81bea0, 0xffc1b106, 0x007e4942, 0x0040cf2c, //11.5
    0x003d84c7, 0xff81b8c1, 0xffc1aaeb, 0x007e4f86, 0x0040d896, //12.0
    0x003d81bb, 0xff81b2fb, 0xffc1a4e6, 0x007e55b3, 0x0040e20e, //12.5
    0x003d7e8f, 0xff81ad4e, 0xffc19ef6, 0x007e5bca, 0x0040eb93, //13.0
    0x003d7b42, 0xff81a7b8, 0xffc1991b, 0x007e61cb, 0x0040f526, //13.5
    0x003d77d4, 0xff81a23b, 0xffc19355, 0x007e67b5, 0x0040fec7, //14.0
    // Treble Band
    0x00013dbf, 0xfffc8db2, 0xfff785ef, 0x00161498, 0x00049a08, //-14.0
    0x000150f5, 0xfffc546d, 0xfff79919, 0x0015f259, 0x0004cf2c, //-13.5
    0x00016557, 0xfffc17de, 0xfff7ac55, 0x0015cfb3, 0x000506c3, //-13.0
    0x00017af4, 0xfffbd7da, 0xfff7bfa2, 0x0015aca5, 0x000540eb, //-12.5
    0x000191e1, 0xfffb942f, 0xfff7d300, 0x0015892e, 0x00057dc2, //-12.0
    0x0001aa30, 0xfffb4cae, 0xfff7e66e, 0x0015654d, 0x0005bd67, //-11.5
    0x0001c3f5, 0xfffb0121, 0xfff7f9eb, 0x00154103, 0x0005fffb, //-11.0
    0x0001df47, 0xfffab153, 0xfff80d77, 0x00151c4d, 0x000645a2, //-10.5
    0x0001fc3b, 0xfffa5d09, 0xfff82110, 0x0014f72d, 0x00068e80, //-10.0
    0x00021aea, 0xfffa0407, 0xfff834b5, 0x0014d1a0, 0x0006dab9, //-9.5
    0x00023b6d, 0xfff9a60f, 0xfff84865, 0x0014aba7, 0x00072a77, //-9.0
    0x00025dde, 0xfff942de, 0xfff85c21, 0x00148541, 0x00077de3, //-8.5
    0x00028259, 0xfff8da2e, 0xfff86fe5, 0x00145e6d, 0x0007d527, //-8.0
    0x0002a8fc, 0xfff86bb6, 0xfff883b2, 0x0014372a, 0x00083071, //-7.5
    0x0002d1e5, 0xfff7f72a, 0xfff89787, 0x00140f7a, 0x00088ff0, //-7.0
    0x0002fd36, 0xfff77c39, 0xfff8ab62, 0x0013e759, 0x0008f3d6, //-6.5
    0x00032b0f, 0xfff6fa90, 0xfff8bf42, 0x0013beca, 0x00095c55, //-6.0
    0x00035b96, 0xfff671d5, 0xfff8d326, 0x001395ca, 0x0009c9a5, //-5.5
    0x00038ef0, 0xfff5e1ad, 0xfff8e70e, 0x00136c59, 0x000a3bfd, //-5.0
    0x0003c545, 0xfff549b6, 0xfff8faf7, 0x00134277, 0x000ab397, //-4.5
    0x0003febf, 0xfff4a98b, 0xfff90ee0, 0x00131824, 0x000b30b2, //-4.0
    0x00043b89, 0xfff400c0, 0xfff922ca, 0x0012ed60, 0x000bb38d, //-3.5
    0x00047bd3, 0xfff34ee8, 0xfff936b1, 0x0012c229, 0x000c3c6b, //-3.0
    0x0004bfcd, 0xfff2938c, 0xfff94a95, 0x00129680, 0x000ccb91, //-2.5
    0x000507a9, 0xfff1ce33, 0xfff95e75, 0x00126a65, 0x000d614a, //-2.0
    0x0005539f, 0xfff0fe5c, 0xfff9724f, 0x00123dd7, 0x000dfde0, //-1.5
    0x0005a3e4, 0xfff02381, 0xfff98622, 0x001210d5, 0x000ea1a3, //-1.0
    0x0005f8b6, 0xffef3d16, 0xfff999ed, 0x0011e361, 0x000f4ce6, //-0.5
    0x00065253, 0xffee4a87, 0xfff9adad, 0x0011b579, 0x00100000, //0.0
    0x0006b0fa, 0xffed4b3b, 0xfff9c163, 0x0011871e, 0x0010bb4a, //0.5
    0x000714f1, 0xffec3e91, 0xfff9d50c, 0x0011584f, 0x00117f22, //1.0
    0x00077e80, 0xffeb23e0, 0xfff9e8a7, 0x0011290d, 0x00124bec, //1.5
    0x0007edf1, 0xffe9fa79, 0xfff9fc33, 0x0010f958, 0x0013220b, //2.0
    0x00086394, 0xffe8c1a3, 0xfffa0fad, 0x0010c92e, 0x001401ed, //2.5
    0x0008dfbc, 0xffe7789d, 0xfffa2316, 0x00109892, 0x0014ec00, //3.0
    0x000962bf, 0xffe61e9e, 0xfffa366a, 0x00106782, 0x0015e0b7, //3.5
    0x0009ecf8, 0xffe4b2d4, 0xfffa49a8, 0x001035ff, 0x0016e08c, //4.0
    0x000a7ec6, 0xffe33463, 0xfffa5cd0, 0x0010040a, 0x0017ebfd, //4.5
    0x000b188e, 0xffe1a265, 0xfffa6fdf, 0x000fd1a1, 0x0019038d, //5.0
    0x000bbab7, 0xffdffbe9, 0xfffa82d3, 0x000f9ec7, 0x001a27c5, //5.5
    0x000c65b0, 0xffde3ff6, 0xfffa95ac, 0x000f6b7a, 0x001b5934, //6.0
    0x000d19eb, 0xffdc6d84, 0xfffaa868, 0x000f37bb, 0x001c986e, //6.5
    0x000dd7e0, 0xffda8381, 0xfffabb04, 0x000f038b, 0x001de60f, //7.0
    0x000ea00d, 0xffd880d2, 0xfffacd80, 0x000eceeb, 0x001f42b7, //7.5
    0x000f72f4, 0xffd6644a, 0xfffadfd9, 0x000e99da, 0x0020af0f, //8.0
    0x00105121, 0xffd42cb3, 0xfffaf20f, 0x000e6459, 0x00222bc5, //8.5
    0x00113b22, 0xffd1d8c8, 0xfffb041e, 0x000e2e69, 0x0023b98f, //9.0
    0x0012318e, 0xffcf6736, 0xfffb1607, 0x000df80a, 0x0025592b, //9.5
    0x00133502, 0xffccd69b, 0xfffb27c6, 0x000dc13e, 0x00270b5f, //10.0
    0x00144623, 0xffca2586, 0xfffb395b, 0x000d8a04, 0x0028d0f8, //10.5
    0x0015659d, 0xffc75276, 0xfffb4ac3, 0x000d525e, 0x002aaacc, //11.0
    0x00169423, 0xffc45bdb, 0xfffb5bfe, 0x000d1a4c, 0x002c99b8, //11.5
    0x0017d271, 0xffc14011, 0xfffb6d08, 0x000ce1d0, 0x002e9ea6, //12.0
    0x0019214b, 0xffbdfd66, 0xfffb7de1, 0x000ca8ea, 0x0030ba84, //12.5
    0x001a817d, 0xffba9212, 0xfffb8e87, 0x000c6f9c, 0x0032ee4e, //13.0
    0x001bf3de, 0xffb6fc3c, 0xfffb9ef8, 0x000c35e5, 0x00353b09, //13.5
    0x001d794c, 0xffb339f6, 0xfffbaf33, 0x000bfbc8, 0x0037a1c2, //14.0
};
static const UINT32 _aau4MtkAudChlBassTrebleLoudnessCoefTbl_200_7K[(57*2)*5] =
{
    // 48000.0 Hz  
    // Bass Band
    0x003d77f7, 0xff8387cb, 0xffc37920, 0x007c6e6c, 0x003f0520, //-14.0
    0x003d7b64, 0xff837b2b, 0xffc36cc5, 0x007c7b76, 0x003f0e77, //-13.5
    0x003d7eb0, 0xff836eb9, 0xffc36095, 0x007c8850, 0x003f17c4, //-13.0
    0x003d81db, 0xff836274, 0xffc3548f, 0x007c94fc, 0x003f2106, //-12.5
    0x003d84e4, 0xff83565b, 0xffc348b3, 0x007ca179, 0x003f2a3d, //-12.0
    0x003d87cd, 0xff834a6e, 0xffc33cff, 0x007cadc9, 0x003f336b, //-11.5
    0x003d8a95, 0xff833ead, 0xffc33175, 0x007cb9eb, 0x003f3c8f, //-11.0
    0x003d8d3d, 0xff833316, 0xffc32612, 0x007cc5e2, 0x003f45aa, //-10.5
    0x003d8fc4, 0xff8327aa, 0xffc31ad7, 0x007cd1ad, 0x003f4ebc, //-10.0
    0x003d922a, 0xff831c67, 0xffc30fc3, 0x007cdd4d, 0x003f57c7, //-9.5
    0x003d9471, 0xff83114e, 0xffc304d5, 0x007ce8c2, 0x003f60ca, //-9.0
    0x003d9697, 0xff83065d, 0xffc2fa0e, 0x007cf40e, 0x003f69c6, //-8.5
    0x003d989e, 0xff82fb94, 0xffc2ef6c, 0x007cff30, 0x003f72bb, //-8.0
    0x003d9a84, 0xff82f0f3, 0xffc2e4ef, 0x007d0a2a, 0x003f7baa, //-7.5
    0x003d9c4b, 0xff82e679, 0xffc2da96, 0x007d14fc, 0x003f8493, //-7.0
    0x003d9df2, 0xff82dc25, 0xffc2d062, 0x007d1fa6, 0x003f8d78, //-6.5
    0x003d9f79, 0xff82d1f8, 0xffc2c652, 0x007d2a29, 0x003f9657, //-6.0
    0x003da0e0, 0xff82c7f0, 0xffc2bc64, 0x007d3486, 0x003f9f32, //-5.5
    0x003da229, 0xff82be0e, 0xffc2b299, 0x007d3ebd, 0x003fa809, //-5.0
    0x003da351, 0xff82b450, 0xffc2a8f1, 0x007d48cf, 0x003fb0dd, //-4.5
    0x003da45a, 0xff82aab6, 0xffc29f6a, 0x007d52bc, 0x003fb9ad, //-4.0
    0x003da544, 0xff82a140, 0xffc29605, 0x007d5c85, 0x003fc27c, //-3.5
    0x003da60e, 0xff8297ed, 0xffc28cc1, 0x007d662a, 0x003fcb48, //-3.0
    0x003da6ba, 0xff828ebd, 0xffc2839d, 0x007d6fac, 0x003fd412, //-2.5
    0x003da746, 0xff8285b0, 0xffc27a99, 0x007d790b, 0x003fdcdc, //-2.0
    0x003da7b2, 0xff827cc5, 0xffc271b5, 0x007d8248, 0x003fe5a5, //-1.5
    0x003da800, 0xff8273fb, 0xffc268f1, 0x007d8b63, 0x003fee6d, //-1.0
    0x003da82e, 0xff826b52, 0xffc2604b, 0x007d945d, 0x003ff736, //-0.5
    0x003da83d, 0xff8262ca, 0xffc257c3, 0x007d9d36, 0x00400000, //0.0
    0x003da82d, 0xff825a63, 0xffc24f5a, 0x007da5ef, 0x004008cb, //0.5
    0x003da7fd, 0xff82521b, 0xffc2470e, 0x007dae88, 0x00401197, //1.0
    0x003da7af, 0xff8249f3, 0xffc23edf, 0x007db701, 0x00401a66, //1.5
    0x003da741, 0xff8241ea, 0xffc236ce, 0x007dbf5c, 0x00402338, //2.0
    0x003da6b4, 0xff823a00, 0xffc22ed8, 0x007dc798, 0x00402c0c, //2.5
    0x003da608, 0xff823235, 0xffc226ff, 0x007dcfb6, 0x004034e4, //3.0
    0x003da53c, 0xff822a87, 0xffc21f42, 0x007dd7b6, 0x00403dc0, //3.5
    0x003da451, 0xff8222f8, 0xffc217a0, 0x007ddf99, 0x004046a0, //4.0
    0x003da347, 0xff821b85, 0xffc21018, 0x007de760, 0x00404f86, //4.5
    0x003da21d, 0xff821430, 0xffc208ac, 0x007def09, 0x00405871, //5.0
    0x003da0d4, 0xff820cf8, 0xffc2015a, 0x007df697, 0x00406161, //5.5
    0x003d9f6b, 0xff8205db, 0xffc1fa22, 0x007dfe0a, 0x00406a59, //6.0
    0x003d9de2, 0xff81fedb, 0xffc1f303, 0x007e0561, 0x00407357, //6.5
    0x003d9c3a, 0xff81f7f7, 0xffc1ebfd, 0x007e0c9d, 0x00407c5c, //7.0
    0x003d9a72, 0xff81f12e, 0xffc1e511, 0x007e13bf, 0x0040856a, //7.5
    0x003d988b, 0xff81ea80, 0xffc1de3d, 0x007e1ac7, 0x00408e80, //8.0
    0x003d9683, 0xff81e3ee, 0xffc1d781, 0x007e21b5, 0x0040979e, //8.5
    0x003d945b, 0xff81dd75, 0xffc1d0dd, 0x007e288a, 0x0040a0c6, //9.0
    0x003d9214, 0xff81d717, 0xffc1ca51, 0x007e2f45, 0x0040a9f8, //9.5
    0x003d8fab, 0xff81d0d3, 0xffc1c3dc, 0x007e35e9, 0x0040b334, //10.0
    0x003d8d23, 0xff81caa9, 0xffc1bd7e, 0x007e3c73, 0x0040bc7b, //10.5
    0x003d8a7a, 0xff81c498, 0xffc1b737, 0x007e42e6, 0x0040c5cd, //11.0
    0x003d87b1, 0xff81bea0, 0xffc1b106, 0x007e4942, 0x0040cf2c, //11.5
    0x003d84c7, 0xff81b8c1, 0xffc1aaeb, 0x007e4f86, 0x0040d896, //12.0
    0x003d81bb, 0xff81b2fb, 0xffc1a4e6, 0x007e55b3, 0x0040e20e, //12.5
    0x003d7e8f, 0xff81ad4e, 0xffc19ef6, 0x007e5bca, 0x0040eb93, //13.0
    0x003d7b42, 0xff81a7b8, 0xffc1991b, 0x007e61cb, 0x0040f526, //13.5
    0x003d77d4, 0xff81a23b, 0xffc19355, 0x007e67b5, 0x0040fec7, //14.0
    // Treble Band
    0x0000ff7e, 0xfffe282b, 0xfff98529, 0x0012130d, 0x00054022, //-14.0
    0x00010cb2, 0xfffdfe82, 0xfff998f5, 0x0011e59e, 0x00057639, //-13.5
    0x00011ab0, 0xfffdd252, 0xfff9acb6, 0x0011b7bc, 0x0005ae8c, //-13.0
    0x00012984, 0xfffda379, 0xfff9c06c, 0x00118966, 0x0005e931, //-12.5
    0x00013939, 0xfffd71d2, 0xfff9d416, 0x00115a9d, 0x00062641, //-12.0
    0x000149de, 0xfffd3d3a, 0xfff9e7b2, 0x00112b61, 0x000665d6, //-11.5
    0x00015b7f, 0xfffd0589, 0xfff9fb3e, 0x0010fbb1, 0x0006a809, //-11.0
    0x00016e2c, 0xfffcca96, 0xfffa0eba, 0x0010cb8d, 0x0006ecf7, //-10.5
    0x000181f3, 0xfffc8c37, 0xfffa2223, 0x00109af6, 0x000734bd, //-10.0
    0x000196e4, 0xfffc4a40, 0xfffa3578, 0x001069ec, 0x00077f78, //-9.5
    0x0001ad12, 0xfffc0481, 0xfffa48b7, 0x0010386f, 0x0007cd47, //-9.0
    0x0001c48c, 0xfffbbac9, 0xfffa5be0, 0x0010067f, 0x00081e4b, //-8.5
    0x0001dd66, 0xfffb6ce7, 0xfffa6ef0, 0x000fd41c, 0x000872a6, //-8.0
    0x0001f7b4, 0xfffb1aa4, 0xfffa81e6, 0x000fa147, 0x0008ca7a, //-7.5
    0x0002138b, 0xfffac3c9, 0xfffa94c1, 0x000f6e00, 0x000925eb, //-7.0
    0x000230ff, 0xfffa681c, 0xfffaa77d, 0x000f3a47, 0x00098520, //-6.5
    0x00025028, 0xfffa0760, 0xfffaba1b, 0x000f061d, 0x0009e840, //-6.0
    0x0002711e, 0xfff9a155, 0xfffacc99, 0x000ed181, 0x000a4f73, //-5.5
    0x000293f9, 0xfff935b9, 0xfffadef4, 0x000e9c76, 0x000abae5, //-5.0
    0x0002b8d5, 0xfff8c446, 0xfffaf12b, 0x000e66fa, 0x000b2ac0, //-4.5
    0x0002dfcc, 0xfff84cb5, 0xfffb033d, 0x000e3110, 0x000b9f33, //-4.0
    0x000308fd, 0xfff7ceb9, 0xfffb1527, 0x000dfab7, 0x000c186d, //-3.5
    0x00033484, 0xfff74a04, 0xfffb26e9, 0x000dc3ef, 0x000c96a0, //-3.0
    0x00036283, 0xfff6be43, 0xfffb387f, 0x000d8cbb, 0x000d19ff, //-2.5
    0x0003931b, 0xfff62b22, 0xfffb49ea, 0x000d551a, 0x000da2bf, //-2.0
    0x0003c66f, 0xfff59045, 0xfffb5b27, 0x000d1d0e, 0x000e3118, //-1.5
    0x0003fca3, 0xfff4ed50, 0xfffb6c34, 0x000ce497, 0x000ec543, //-1.0
    0x000435de, 0xfff441e1, 0xfffb7d0f, 0x000cabb6, 0x000f5f7b, //-0.5
    0x00047248, 0xfff38d93, 0xfffb8db8, 0x000c726d, 0x00100000, //0.0
    0x0004b20c, 0xfff2cffc, 0xfffb9e2b, 0x000c38bc, 0x0010a711, //0.5
    0x0004f556, 0xfff208ae, 0xfffbae69, 0x000bfea4, 0x001154f0, //1.0
    0x00053c53, 0xfff13735, 0xfffbbe6e, 0x000bc426, 0x001209e4, //1.5
    0x00058735, 0xfff05b1a, 0xfffbce3a, 0x000b8944, 0x0012c633, //2.0
    0x0005d62e, 0xffef73e1, 0xfffbddc9, 0x000b4dff, 0x00138a29, //2.5
    0x00062972, 0xffee8107, 0xfffbed1c, 0x000b1258, 0x00145613, //3.0
    0x00068139, 0xffed8205, 0xfffbfc30, 0x000ad650, 0x00152a41, //3.5
    0x0006ddbd, 0xffec764f, 0xfffc0b04, 0x000a99ea, 0x00160707, //4.0
    0x00073f3a, 0xffeb5d51, 0xfffc1996, 0x000a5d25, 0x0016ecba, //4.5
    0x0007a5f0, 0xffea3673, 0xfffc27e3, 0x000a2004, 0x0017dbb5, //5.0
    0x0008121f, 0xffe90118, 0xfffc35ec, 0x0009e289, 0x0018d454, //5.5
    0x0008840e, 0xffe7bc99, 0xfffc43ae, 0x0009a4b4, 0x0019d6f8, //6.0
    0x0008fc03, 0xffe6684a, 0xfffc5127, 0x00096688, 0x001ae404, //6.5
    0x00097a49, 0xffe5037a, 0xfffc5e56, 0x00092807, 0x001bfbe0, //7.0
    0x0009ff30, 0xffe38d6f, 0xfffc6b3a, 0x0008e931, 0x001d1ef7, //7.5
    0x000a8b07, 0xffe20567, 0xfffc77d1, 0x0008aa08, 0x001e4db8, //8.0
    0x000b1e26, 0xffe06a9b, 0xfffc8419, 0x00086a8f, 0x001f8897, //8.5
    0x000bb8e3, 0xffdebc39, 0xfffc9012, 0x00082ac8, 0x0020d00a, //9.0
    0x000c5b9d, 0xffdcf968, 0xfffc9bb9, 0x0007eab4, 0x0022248e, //9.5
    0x000d06b2, 0xffdb2149, 0xfffca70d, 0x0007aa55, 0x002386a3, //10.0
    0x000dba88, 0xffd932f1, 0xfffcb20e, 0x000769ad, 0x0024f6cc, //10.5
    0x000e7787, 0xffd72d6d, 0xfffcbcb8, 0x000728bf, 0x00267595, //11.0
    0x000f3e1d, 0xffd50fc1, 0xfffcc70c, 0x0006e78c, 0x0028038a, //11.5
    0x00100eba, 0xffd2d8e7, 0xfffcd108, 0x0006a617, 0x0029a13f, //12.0
    0x0010e9d5, 0xffd087d1, 0xfffcdaab, 0x00066462, 0x002b4f4d, //12.5
    0x0011cfea, 0xffce1b63, 0xfffce3f3, 0x0006226e, 0x002d0e52, //13.0
    0x0012c177, 0xffcb9279, 0xfffcece0, 0x0005e03f, 0x002edef1, //13.5
    0x0013bf03, 0xffc8ebe3, 0xfffcf570, 0x00059dd6, 0x0030c1d4, //14.0
};
static const UINT32 _aau4MtkAudChlBassTrebleLoudnessCoefTbl_200_5k_Sony_2k15[(281*2)*5] =
{
    // 48000.0 Hz  
    // Bass Band
    0x003d77f7, 0xff8387cb, 0xffc37920, 0x007c6e6c, 0x003f0520, //-14.0
    0x003d78a9, 0xff838541, 0xffc376a4, 0x007c710b, 0x003f06ff, //-13.9
    0x003d795a, 0xff8382b9, 0xffc3742a, 0x007c73a9, 0x003f08de, //-13.8
    0x003d7a09, 0xff838032, 0xffc371b1, 0x007c7644, 0x003f0abc, //-13.7
    0x003d7ab8, 0xff837dae, 0xffc36f3a, 0x007c78de, 0x003f0c9a, //-13.6
    0x003d7b64, 0xff837b2b, 0xffc36cc5, 0x007c7b76, 0x003f0e77, //-13.5
    0x003d7c10, 0xff8378aa, 0xffc36a52, 0x007c7e0b, 0x003f1054, //-13.4
    0x003d7cba, 0xff83762b, 0xffc367e0, 0x007c809f, 0x003f1231, //-13.3
    0x003d7d62, 0xff8373ae, 0xffc36570, 0x007c8332, 0x003f140d, //-13.2
    0x003d7e0a, 0xff837133, 0xffc36302, 0x007c85c2, 0x003f15e9, //-13.1
    0x003d7eb0, 0xff836eb9, 0xffc36095, 0x007c8850, 0x003f17c4, //-13.0
    0x003d7f55, 0xff836c41, 0xffc35e2a, 0x007c8adc, 0x003f199f, //-12.9
    0x003d7ff8, 0xff8369cb, 0xffc35bc1, 0x007c8d67, 0x003f1b79, //-12.8
    0x003d809a, 0xff836757, 0xffc35959, 0x007c8ff0, 0x003f1d53, //-12.7
    0x003d813b, 0xff8364e4, 0xffc356f3, 0x007c9277, 0x003f1f2d, //-12.6
    0x003d81db, 0xff836274, 0xffc3548f, 0x007c94fc, 0x003f2106, //-12.5
    0x003d8279, 0xff836005, 0xffc3522c, 0x007c977f, 0x003f22de, //-12.4
    0x003d8316, 0xff835d98, 0xffc34fcc, 0x007c9a00, 0x003f24b7, //-12.3
    0x003d83b1, 0xff835b2d, 0xffc34d6c, 0x007c9c7f, 0x003f268f, //-12.2
    0x003d844b, 0xff8358c3, 0xffc34b0f, 0x007c9efd, 0x003f2866, //-12.1
    0x003d84e4, 0xff83565b, 0xffc348b3, 0x007ca179, 0x003f2a3d, //-12.0
    0x003d857c, 0xff8353f5, 0xffc34658, 0x007ca3f3, 0x003f2c14, //-11.9
    0x003d8612, 0xff835191, 0xffc34400, 0x007ca66b, 0x003f2dea, //-11.8
    0x003d86a7, 0xff834f2e, 0xffc341a9, 0x007ca8e1, 0x003f2fc0, //-11.7
    0x003d873b, 0xff834ccd, 0xffc33f53, 0x007cab56, 0x003f3195, //-11.6
    0x003d87cd, 0xff834a6e, 0xffc33cff, 0x007cadc9, 0x003f336b, //-11.5
    0x003d885e, 0xff834811, 0xffc33aad, 0x007cb03a, 0x003f353f, //-11.4
    0x003d88ee, 0xff8345b5, 0xffc3385d, 0x007cb2a9, 0x003f3714, //-11.3
    0x003d897c, 0xff83435c, 0xffc3360e, 0x007cb516, 0x003f38e8, //-11.2
    0x003d8a09, 0xff834103, 0xffc333c0, 0x007cb782, 0x003f3abb, //-11.1
    0x003d8a95, 0xff833ead, 0xffc33175, 0x007cb9eb, 0x003f3c8f, //-11.0
    0x003d8b20, 0xff833c58, 0xffc32f2b, 0x007cbc53, 0x003f3e62, //-10.9
    0x003d8ba9, 0xff833a05, 0xffc32ce2, 0x007cbeba, 0x003f4034, //-10.8
    0x003d8c31, 0xff8337b4, 0xffc32a9b, 0x007cc11e, 0x003f4206, //-10.7
    0x003d8cb7, 0xff833564, 0xffc32856, 0x007cc381, 0x003f43d8, //-10.6
    0x003d8d3d, 0xff833316, 0xffc32612, 0x007cc5e2, 0x003f45aa, //-10.5
    0x003d8dc1, 0xff8330ca, 0xffc323d0, 0x007cc841, 0x003f477b, //-10.4
    0x003d8e43, 0xff832e80, 0xffc3218f, 0x007cca9f, 0x003f494c, //-10.3
    0x003d8ec5, 0xff832c37, 0xffc31f50, 0x007cccfb, 0x003f4b1c, //-10.2
    0x003d8f45, 0xff8329f0, 0xffc31d13, 0x007ccf55, 0x003f4cec, //-10.1
    0x003d8fc4, 0xff8327aa, 0xffc31ad7, 0x007cd1ad, 0x003f4ebc, //-10.0
    0x003d9041, 0xff832566, 0xffc3189d, 0x007cd404, 0x003f508c, //-9.9
    0x003d90bd, 0xff832324, 0xffc31664, 0x007cd658, 0x003f525b, //-9.8
    0x003d9138, 0xff8320e3, 0xffc3142d, 0x007cd8ac, 0x003f542a, //-9.7
    0x003d91b2, 0xff831ea5, 0xffc311f7, 0x007cdafd, 0x003f55f9, //-9.6
    0x003d922a, 0xff831c67, 0xffc30fc3, 0x007cdd4d, 0x003f57c7, //-9.5
    0x003d92a1, 0xff831a2c, 0xffc30d90, 0x007cdf9b, 0x003f5995, //-9.4
    0x003d9317, 0xff8317f2, 0xffc30b5f, 0x007ce1e7, 0x003f5b63, //-9.3
    0x003d938c, 0xff8315ba, 0xffc30930, 0x007ce432, 0x003f5d30, //-9.2
    0x003d93ff, 0xff831383, 0xffc30702, 0x007ce67b, 0x003f5efd, //-9.1
    0x003d9471, 0xff83114e, 0xffc304d5, 0x007ce8c2, 0x003f60ca, //-9.0
    0x003d94e2, 0xff830f1a, 0xffc302aa, 0x007ceb08, 0x003f6296, //-8.9
    0x003d9551, 0xff830ce9, 0xffc30081, 0x007ced4c, 0x003f6463, //-8.8
    0x003d95bf, 0xff830ab9, 0xffc2fe59, 0x007cef8e, 0x003f662f, //-8.7
    0x003d962c, 0xff83088a, 0xffc2fc33, 0x007cf1cf, 0x003f67fa, //-8.6
    0x003d9697, 0xff83065d, 0xffc2fa0e, 0x007cf40e, 0x003f69c6, //-8.5
    0x003d9702, 0xff830432, 0xffc2f7ea, 0x007cf64b, 0x003f6b91, //-8.4
    0x003d976b, 0xff830208, 0xffc2f5c8, 0x007cf887, 0x003f6d5c, //-8.3
    0x003d97d2, 0xff82ffe0, 0xffc2f3a8, 0x007cfac1, 0x003f6f26, //-8.2
    0x003d9839, 0xff82fdb9, 0xffc2f189, 0x007cfcf9, 0x003f70f1, //-8.1
    0x003d989e, 0xff82fb94, 0xffc2ef6c, 0x007cff30, 0x003f72bb, //-8.0
    0x003d9902, 0xff82f971, 0xffc2ed50, 0x007d0165, 0x003f7485, //-7.9
    0x003d9964, 0xff82f74f, 0xffc2eb35, 0x007d0399, 0x003f764f, //-7.8
    0x003d99c5, 0xff82f52f, 0xffc2e91c, 0x007d05cb, 0x003f7818, //-7.7
    0x003d9a25, 0xff82f310, 0xffc2e705, 0x007d07fb, 0x003f79e1, //-7.6
    0x003d9a84, 0xff82f0f3, 0xffc2e4ef, 0x007d0a2a, 0x003f7baa, //-7.5
    0x003d9ae2, 0xff82eed8, 0xffc2e2da, 0x007d0c57, 0x003f7d73, //-7.4
    0x003d9b3e, 0xff82ecbe, 0xffc2e0c7, 0x007d0e83, 0x003f7f3b, //-7.3
    0x003d9b99, 0xff82eaa5, 0xffc2deb5, 0x007d10ad, 0x003f8104, //-7.2
    0x003d9bf2, 0xff82e88e, 0xffc2dca5, 0x007d12d5, 0x003f82cc, //-7.1
    0x003d9c4b, 0xff82e679, 0xffc2da96, 0x007d14fc, 0x003f8493, //-7.0
    0x003d9ca2, 0xff82e465, 0xffc2d889, 0x007d1721, 0x003f865b, //-6.9
    0x003d9cf8, 0xff82e253, 0xffc2d67d, 0x007d1945, 0x003f8823, //-6.8
    0x003d9d4c, 0xff82e042, 0xffc2d473, 0x007d1b67, 0x003f89ea, //-6.7
    0x003d9da0, 0xff82de33, 0xffc2d26a, 0x007d1d87, 0x003f8bb1, //-6.6
    0x003d9df2, 0xff82dc25, 0xffc2d062, 0x007d1fa6, 0x003f8d78, //-6.5
    0x003d9e42, 0xff82da19, 0xffc2ce5c, 0x007d21c3, 0x003f8f3e, //-6.4
    0x003d9e92, 0xff82d80f, 0xffc2cc57, 0x007d23df, 0x003f9105, //-6.3
    0x003d9ee0, 0xff82d606, 0xffc2ca54, 0x007d25f9, 0x003f92cb, //-6.2
    0x003d9f2d, 0xff82d3fe, 0xffc2c852, 0x007d2812, 0x003f9491, //-6.1
    0x003d9f79, 0xff82d1f8, 0xffc2c652, 0x007d2a29, 0x003f9657, //-6.0
    0x003d9fc3, 0xff82cff4, 0xffc2c453, 0x007d2c3f, 0x003f981d, //-5.9
    0x003da00c, 0xff82cdf0, 0xffc2c255, 0x007d2e53, 0x003f99e2, //-5.8
    0x003da054, 0xff82cbef, 0xffc2c059, 0x007d3066, 0x003f9ba8, //-5.7
    0x003da09b, 0xff82c9ef, 0xffc2be5e, 0x007d3277, 0x003f9d6d, //-5.6
    0x003da0e0, 0xff82c7f0, 0xffc2bc64, 0x007d3486, 0x003f9f32, //-5.5
    0x003da125, 0xff82c5f3, 0xffc2ba6c, 0x007d3694, 0x003fa0f7, //-5.4
    0x003da167, 0xff82c3f8, 0xffc2b875, 0x007d38a1, 0x003fa2bb, //-5.3
    0x003da1a9, 0xff82c1fd, 0xffc2b680, 0x007d3aac, 0x003fa480, //-5.2
    0x003da1e9, 0xff82c005, 0xffc2b48c, 0x007d3cb5, 0x003fa645, //-5.1
    0x003da229, 0xff82be0e, 0xffc2b299, 0x007d3ebd, 0x003fa809, //-5.0
    0x003da266, 0xff82bc18, 0xffc2b0a8, 0x007d40c4, 0x003fa9cd, //-4.9
    0x003da2a3, 0xff82ba24, 0xffc2aeb8, 0x007d42c9, 0x003fab91, //-4.8
    0x003da2de, 0xff82b831, 0xffc2acca, 0x007d44cc, 0x003fad55, //-4.7
    0x003da318, 0xff82b640, 0xffc2aadd, 0x007d46ce, 0x003faf19, //-4.6
    0x003da351, 0xff82b450, 0xffc2a8f1, 0x007d48cf, 0x003fb0dd, //-4.5
    0x003da389, 0xff82b261, 0xffc2a707, 0x007d4ace, 0x003fb2a0, //-4.4
    0x003da3bf, 0xff82b074, 0xffc2a51e, 0x007d4ccc, 0x003fb464, //-4.3
    0x003da3f4, 0xff82ae89, 0xffc2a336, 0x007d4ec8, 0x003fb627, //-4.2
    0x003da428, 0xff82ac9f, 0xffc2a14f, 0x007d50c3, 0x003fb7ea, //-4.1
    0x003da45a, 0xff82aab6, 0xffc29f6a, 0x007d52bc, 0x003fb9ad, //-4.0
    0x003da48c, 0xff82a8cf, 0xffc29d87, 0x007d54b4, 0x003fbb70, //-3.9
    0x003da4bc, 0xff82a6e9, 0xffc29ba4, 0x007d56aa, 0x003fbd33, //-3.8
    0x003da4ea, 0xff82a504, 0xffc299c3, 0x007d589f, 0x003fbef6, //-3.7
    0x003da518, 0xff82a321, 0xffc297e4, 0x007d5a93, 0x003fc0b9, //-3.6
    0x003da544, 0xff82a140, 0xffc29605, 0x007d5c85, 0x003fc27c, //-3.5
    0x003da56f, 0xff829f60, 0xffc29428, 0x007d5e75, 0x003fc43e, //-3.4
    0x003da599, 0xff829d81, 0xffc2924c, 0x007d6065, 0x003fc601, //-3.3
    0x003da5c1, 0xff829ba4, 0xffc29072, 0x007d6252, 0x003fc7c3, //-3.2
    0x003da5e8, 0xff8299c8, 0xffc28e99, 0x007d643f, 0x003fc985, //-3.1
    0x003da60e, 0xff8297ed, 0xffc28cc1, 0x007d662a, 0x003fcb48, //-3.0
    0x003da633, 0xff829614, 0xffc28aea, 0x007d6813, 0x003fcd0a, //-2.9
    0x003da657, 0xff82943c, 0xffc28915, 0x007d69fc, 0x003fcecc, //-2.8
    0x003da679, 0xff829266, 0xffc28741, 0x007d6be2, 0x003fd08e, //-2.7
    0x003da69a, 0xff829091, 0xffc2856e, 0x007d6dc8, 0x003fd250, //-2.6
    0x003da6ba, 0xff828ebd, 0xffc2839d, 0x007d6fac, 0x003fd412, //-2.5
    0x003da6d8, 0xff828ceb, 0xffc281cd, 0x007d718e, 0x003fd5d4, //-2.4
    0x003da6f5, 0xff828b1a, 0xffc27ffe, 0x007d736f, 0x003fd796, //-2.3
    0x003da711, 0xff82894b, 0xffc27e31, 0x007d754f, 0x003fd958, //-2.2
    0x003da72c, 0xff82877d, 0xffc27c64, 0x007d772e, 0x003fdb1a, //-2.1
    0x003da746, 0xff8285b0, 0xffc27a99, 0x007d790b, 0x003fdcdc, //-2.0
    0x003da75e, 0xff8283e5, 0xffc278d0, 0x007d7ae7, 0x003fde9e, //-1.9
    0x003da775, 0xff82821b, 0xffc27707, 0x007d7cc1, 0x003fe05f, //-1.8
    0x003da78a, 0xff828052, 0xffc27540, 0x007d7e9a, 0x003fe221, //-1.7
    0x003da79f, 0xff827e8b, 0xffc2737a, 0x007d8071, 0x003fe3e3, //-1.6
    0x003da7b2, 0xff827cc5, 0xffc271b5, 0x007d8248, 0x003fe5a5, //-1.5
    0x003da7c4, 0xff827b00, 0xffc26ff2, 0x007d841d, 0x003fe766, //-1.4
    0x003da7d5, 0xff82793d, 0xffc26e30, 0x007d85f0, 0x003fe928, //-1.3
    0x003da7e4, 0xff82777b, 0xffc26c6f, 0x007d87c2, 0x003feaea, //-1.2
    0x003da7f3, 0xff8275ba, 0xffc26aaf, 0x007d8993, 0x003fecac, //-1.1
    0x003da800, 0xff8273fb, 0xffc268f1, 0x007d8b63, 0x003fee6d, //-1.0
    0x003da80b, 0xff82723d, 0xffc26733, 0x007d8d31, 0x003ff02f, //-0.9
    0x003da816, 0xff827080, 0xffc26577, 0x007d8efe, 0x003ff1f1, //-0.8
    0x003da81f, 0xff826ec5, 0xffc263bd, 0x007d90ca, 0x003ff3b3, //-0.7
    0x003da827, 0xff826d0b, 0xffc26203, 0x007d9294, 0x003ff574, //-0.6
    0x003da82e, 0xff826b52, 0xffc2604b, 0x007d945d, 0x003ff736, //-0.5
    0x003da833, 0xff82699b, 0xffc25e94, 0x007d9624, 0x003ff8f8, //-0.4
    0x003da838, 0xff8267e5, 0xffc25cde, 0x007d97eb, 0x003ffaba, //-0.3
    0x003da83b, 0xff826630, 0xffc25b29, 0x007d99b0, 0x003ffc7c, //-0.2
    0x003da83c, 0xff82647c, 0xffc25975, 0x007d9b73, 0x003ffe3e, //-0.1
    0x003da83d, 0xff8262ca, 0xffc257c3, 0x007d9d36, 0x00400000, //-0.0
    0x003da83c, 0xff826119, 0xffc25612, 0x007d9ef7, 0x004001c2, //0.1
    0x003da83a, 0xff825f6a, 0xffc25462, 0x007da0b7, 0x00400384, //0.2
    0x003da837, 0xff825dbb, 0xffc252b3, 0x007da275, 0x00400546, //0.3
    0x003da832, 0xff825c0e, 0xffc25106, 0x007da433, 0x00400709, //0.4
    0x003da82d, 0xff825a63, 0xffc24f5a, 0x007da5ef, 0x004008cb, //0.5
    0x003da826, 0xff8258b8, 0xffc24daf, 0x007da7a9, 0x00400a8d, //0.6
    0x003da81d, 0xff82570f, 0xffc24c05, 0x007da963, 0x00400c50, //0.7
    0x003da814, 0xff825567, 0xffc24a5c, 0x007dab1b, 0x00400e12, //0.8
    0x003da809, 0xff8253c0, 0xffc248b4, 0x007dacd2, 0x00400fd5, //0.9
    0x003da7fd, 0xff82521b, 0xffc2470e, 0x007dae88, 0x00401197, //1.0
    0x003da7f0, 0xff825077, 0xffc24569, 0x007db03c, 0x0040135a, //1.1
    0x003da7e2, 0xff824ed4, 0xffc243c5, 0x007db1ef, 0x0040151d, //1.2
    0x003da7d2, 0xff824d32, 0xffc24222, 0x007db3a1, 0x004016e0, //1.3
    0x003da7c1, 0xff824b92, 0xffc24080, 0x007db552, 0x004018a3, //1.4
    0x003da7af, 0xff8249f3, 0xffc23edf, 0x007db701, 0x00401a66, //1.5
    0x003da79b, 0xff824855, 0xffc23d40, 0x007db8af, 0x00401c29, //1.6
    0x003da787, 0xff8246b9, 0xffc23ba2, 0x007dba5c, 0x00401ded, //1.7
    0x003da771, 0xff82451d, 0xffc23a04, 0x007dbc08, 0x00401fb0, //1.8
    0x003da759, 0xff824383, 0xffc23868, 0x007dbdb3, 0x00402174, //1.9
    0x003da741, 0xff8241ea, 0xffc236ce, 0x007dbf5c, 0x00402338, //2.0
    0x003da727, 0xff824053, 0xffc23534, 0x007dc104, 0x004024fb, //2.1
    0x003da70c, 0xff823ebc, 0xffc2339b, 0x007dc2ab, 0x004026bf, //2.2
    0x003da6f0, 0xff823d27, 0xffc23204, 0x007dc450, 0x00402883, //2.3
    0x003da6d3, 0xff823b93, 0xffc2306d, 0x007dc5f5, 0x00402a48, //2.4
    0x003da6b4, 0xff823a00, 0xffc22ed8, 0x007dc798, 0x00402c0c, //2.5
    0x003da694, 0xff82386f, 0xffc22d44, 0x007dc93a, 0x00402dd0, //2.6
    0x003da673, 0xff8236de, 0xffc22bb1, 0x007dcadb, 0x00402f95, //2.7
    0x003da650, 0xff82354f, 0xffc22a1f, 0x007dcc7a, 0x0040315a, //2.8
    0x003da62d, 0xff8233c1, 0xffc2288f, 0x007dce19, 0x0040331f, //2.9
    0x003da608, 0xff823235, 0xffc226ff, 0x007dcfb6, 0x004034e4, //3.0
    0x003da5e1, 0xff8230a9, 0xffc22571, 0x007dd152, 0x004036a9, //3.1
    0x003da5ba, 0xff822f1f, 0xffc223e3, 0x007dd2ed, 0x0040386f, //3.2
    0x003da591, 0xff822d96, 0xffc22257, 0x007dd486, 0x00403a34, //3.3
    0x003da567, 0xff822c0e, 0xffc220cc, 0x007dd61f, 0x00403bfa, //3.4
    0x003da53c, 0xff822a87, 0xffc21f42, 0x007dd7b6, 0x00403dc0, //3.5
    0x003da50f, 0xff822902, 0xffc21db9, 0x007dd94c, 0x00403f86, //3.6
    0x003da4e2, 0xff82277d, 0xffc21c31, 0x007ddae1, 0x0040414c, //3.7
    0x003da4b3, 0xff8225fa, 0xffc21aaa, 0x007ddc75, 0x00404313, //3.8
    0x003da482, 0xff822478, 0xffc21924, 0x007dde08, 0x004044d9, //3.9
    0x003da451, 0xff8222f8, 0xffc217a0, 0x007ddf99, 0x004046a0, //4.0
    0x003da41e, 0xff822178, 0xffc2161c, 0x007de12a, 0x00404867, //4.1
    0x003da3ea, 0xff821ffa, 0xffc2149a, 0x007de2b9, 0x00404a2f, //4.2
    0x003da3b5, 0xff821e7c, 0xffc21318, 0x007de447, 0x00404bf6, //4.3
    0x003da37e, 0xff821d00, 0xffc21198, 0x007de5d4, 0x00404dbe, //4.4
    0x003da347, 0xff821b85, 0xffc21018, 0x007de760, 0x00404f86, //4.5
    0x003da30e, 0xff821a0c, 0xffc20e9a, 0x007de8ea, 0x0040514e, //4.6
    0x003da2d3, 0xff821893, 0xffc20d1d, 0x007dea74, 0x00405316, //4.7
    0x003da298, 0xff82171b, 0xffc20ba1, 0x007debfc, 0x004054df, //4.8
    0x003da25b, 0xff8215a5, 0xffc20a26, 0x007ded83, 0x004056a8, //4.9
    0x003da21d, 0xff821430, 0xffc208ac, 0x007def09, 0x00405871, //5.0
    0x003da1de, 0xff8212bc, 0xffc20733, 0x007df08f, 0x00405a3a, //5.1
    0x003da19d, 0xff821149, 0xffc205bb, 0x007df212, 0x00405c03, //5.2
    0x003da15b, 0xff820fd8, 0xffc20444, 0x007df395, 0x00405dcd, //5.3
    0x003da118, 0xff820e67, 0xffc202cf, 0x007df517, 0x00405f97, //5.4
    0x003da0d4, 0xff820cf8, 0xffc2015a, 0x007df697, 0x00406161, //5.5
    0x003da08e, 0xff820b89, 0xffc1ffe6, 0x007df817, 0x0040632c, //5.6
    0x003da047, 0xff820a1c, 0xffc1fe73, 0x007df995, 0x004064f7, //5.7
    0x003d9fff, 0xff8208b0, 0xffc1fd02, 0x007dfb12, 0x004066c2, //5.8
    0x003d9fb5, 0xff820745, 0xffc1fb91, 0x007dfc8f, 0x0040688d, //5.9
    0x003d9f6b, 0xff8205db, 0xffc1fa22, 0x007dfe0a, 0x00406a59, //6.0
    0x003d9f1f, 0xff820473, 0xffc1f8b3, 0x007dff84, 0x00406c25, //6.1
    0x003d9ed2, 0xff82030b, 0xffc1f745, 0x007e00fd, 0x00406df1, //6.2
    0x003d9e83, 0xff8201a5, 0xffc1f5d9, 0x007e0274, 0x00406fbd, //6.3
    0x003d9e33, 0xff820040, 0xffc1f46d, 0x007e03eb, 0x0040718a, //6.4
    0x003d9de2, 0xff81fedb, 0xffc1f303, 0x007e0561, 0x00407357, //6.5
    0x003d9d90, 0xff81fd78, 0xffc1f199, 0x007e06d5, 0x00407524, //6.6
    0x003d9d3d, 0xff81fc16, 0xffc1f031, 0x007e0849, 0x004076f2, //6.7
    0x003d9ce8, 0xff81fab5, 0xffc1eec9, 0x007e09bb, 0x004078c0, //6.8
    0x003d9c92, 0xff81f956, 0xffc1ed63, 0x007e0b2d, 0x00407a8e, //6.9
    0x003d9c3a, 0xff81f7f7, 0xffc1ebfd, 0x007e0c9d, 0x00407c5c, //7.0
    0x003d9be2, 0xff81f69a, 0xffc1ea99, 0x007e0e0c, 0x00407e2b, //7.1
    0x003d9b88, 0xff81f53d, 0xffc1e935, 0x007e0f7b, 0x00407ffa, //7.2
    0x003d9b2d, 0xff81f3e2, 0xffc1e7d3, 0x007e10e8, 0x004081ca, //7.3
    0x003d9ad0, 0xff81f287, 0xffc1e671, 0x007e1254, 0x0040839a, //7.4
    0x003d9a72, 0xff81f12e, 0xffc1e511, 0x007e13bf, 0x0040856a, //7.5
    0x003d9a13, 0xff81efd6, 0xffc1e3b1, 0x007e1529, 0x0040873a, //7.6
    0x003d99b3, 0xff81ee7f, 0xffc1e253, 0x007e1692, 0x0040890b, //7.7
    0x003d9952, 0xff81ed29, 0xffc1e0f5, 0x007e17fa, 0x00408adc, //7.8
    0x003d98ef, 0xff81ebd4, 0xffc1df99, 0x007e1961, 0x00408cae, //7.9
    0x003d988b, 0xff81ea80, 0xffc1de3d, 0x007e1ac7, 0x00408e80, //8.0
    0x003d9825, 0xff81e92e, 0xffc1dce2, 0x007e1c2c, 0x00409052, //8.1
    0x003d97bf, 0xff81e7dc, 0xffc1db89, 0x007e1d8f, 0x00409224, //8.2
    0x003d9757, 0xff81e68c, 0xffc1da30, 0x007e1ef2, 0x004093f7, //8.3
    0x003d96ee, 0xff81e53c, 0xffc1d8d8, 0x007e2054, 0x004095ca, //8.4
    0x003d9683, 0xff81e3ee, 0xffc1d781, 0x007e21b5, 0x0040979e, //8.5
    0x003d9617, 0xff81e2a0, 0xffc1d62b, 0x007e2315, 0x00409972, //8.6
    0x003d95aa, 0xff81e154, 0xffc1d4d6, 0x007e2473, 0x00409b47, //8.7
    0x003d953c, 0xff81e009, 0xffc1d382, 0x007e25d1, 0x00409d1b, //8.8
    0x003d94cc, 0xff81debe, 0xffc1d22f, 0x007e272e, 0x00409ef1, //8.9
    0x003d945b, 0xff81dd75, 0xffc1d0dd, 0x007e288a, 0x0040a0c6, //9.0
    0x003d93e9, 0xff81dc2d, 0xffc1cf8c, 0x007e29e4, 0x0040a29c, //9.1
    0x003d9376, 0xff81dae6, 0xffc1ce3c, 0x007e2b3e, 0x0040a472, //9.2
    0x003d9301, 0xff81d9a0, 0xffc1cced, 0x007e2c97, 0x0040a649, //9.3
    0x003d928b, 0xff81d85b, 0xffc1cb9f, 0x007e2def, 0x0040a820, //9.4
    0x003d9214, 0xff81d717, 0xffc1ca51, 0x007e2f45, 0x0040a9f8, //9.5
    0x003d919b, 0xff81d5d4, 0xffc1c905, 0x007e309b, 0x0040abd0, //9.6
    0x003d9121, 0xff81d493, 0xffc1c7b9, 0x007e31f0, 0x0040ada8, //9.7
    0x003d90a6, 0xff81d352, 0xffc1c66f, 0x007e3344, 0x0040af81, //9.8
    0x003d9029, 0xff81d212, 0xffc1c525, 0x007e3497, 0x0040b15a, //9.9
    0x003d8fab, 0xff81d0d3, 0xffc1c3dc, 0x007e35e9, 0x0040b334, //10.0
    0x003d8f2c, 0xff81cf95, 0xffc1c294, 0x007e3739, 0x0040b50e, //10.1
    0x003d8eac, 0xff81ce59, 0xffc1c14d, 0x007e3889, 0x0040b6e9, //10.2
    0x003d8e2a, 0xff81cd1d, 0xffc1c007, 0x007e39d8, 0x0040b8c4, //10.3
    0x003d8da7, 0xff81cbe2, 0xffc1bec2, 0x007e3b26, 0x0040ba9f, //10.4
    0x003d8d23, 0xff81caa9, 0xffc1bd7e, 0x007e3c73, 0x0040bc7b, //10.5
    0x003d8c9d, 0xff81c970, 0xffc1bc3b, 0x007e3dc0, 0x0040be57, //10.6
    0x003d8c17, 0xff81c839, 0xffc1baf9, 0x007e3f0b, 0x0040c034, //10.7
    0x003d8b8e, 0xff81c702, 0xffc1b9b7, 0x007e4055, 0x0040c211, //10.8
    0x003d8b05, 0xff81c5cc, 0xffc1b876, 0x007e419e, 0x0040c3ef, //10.9
    0x003d8a7a, 0xff81c498, 0xffc1b737, 0x007e42e6, 0x0040c5cd, //11.0
    0x003d89ee, 0xff81c364, 0xffc1b5f8, 0x007e442e, 0x0040c7ac, //11.1
    0x003d8961, 0xff81c232, 0xffc1b4ba, 0x007e4574, 0x0040c98b, //11.2
    0x003d88d2, 0xff81c100, 0xffc1b37d, 0x007e46ba, 0x0040cb6b, //11.3
    0x003d8842, 0xff81bfd0, 0xffc1b241, 0x007e47fe, 0x0040cd4b, //11.4
    0x003d87b1, 0xff81bea0, 0xffc1b106, 0x007e4942, 0x0040cf2c, //11.5
    0x003d871e, 0xff81bd72, 0xffc1afcb, 0x007e4a85, 0x0040d10d, //11.6
    0x003d868a, 0xff81bc44, 0xffc1ae92, 0x007e4bc6, 0x0040d2ee, //11.7
    0x003d85f5, 0xff81bb18, 0xffc1ad59, 0x007e4d07, 0x0040d4d1, //11.8
    0x003d855e, 0xff81b9ec, 0xffc1ac22, 0x007e4e47, 0x0040d6b3, //11.9
    0x003d84c7, 0xff81b8c1, 0xffc1aaeb, 0x007e4f86, 0x0040d896, //12.0
    0x003d842d, 0xff81b798, 0xffc1a9b5, 0x007e50c4, 0x0040da7a, //12.1
    0x003d8393, 0xff81b66f, 0xffc1a880, 0x007e5201, 0x0040dc5e, //12.2
    0x003d82f7, 0xff81b548, 0xffc1a74b, 0x007e533e, 0x0040de43, //12.3
    0x003d825a, 0xff81b421, 0xffc1a618, 0x007e5479, 0x0040e028, //12.4
    0x003d81bb, 0xff81b2fb, 0xffc1a4e6, 0x007e55b3, 0x0040e20e, //12.5
    0x003d811c, 0xff81b1d7, 0xffc1a3b4, 0x007e56ed, 0x0040e3f4, //12.6
    0x003d807b, 0xff81b0b3, 0xffc1a283, 0x007e5826, 0x0040e5db, //12.7
    0x003d7fd8, 0xff81af90, 0xffc1a153, 0x007e595d, 0x0040e7c2, //12.8
    0x003d7f34, 0xff81ae6f, 0xffc1a024, 0x007e5a94, 0x0040e9aa, //12.9
    0x003d7e8f, 0xff81ad4e, 0xffc19ef6, 0x007e5bca, 0x0040eb93, //13.0
    0x003d7de9, 0xff81ac2e, 0xffc19dc8, 0x007e5cff, 0x0040ed7c, //13.1
    0x003d7d41, 0xff81ab0f, 0xffc19c9c, 0x007e5e33, 0x0040ef65, //13.2
    0x003d7c98, 0xff81a9f1, 0xffc19b70, 0x007e5f67, 0x0040f150, //13.3
    0x003d7bee, 0xff81a8d4, 0xffc19a45, 0x007e6099, 0x0040f33a, //13.4
    0x003d7b42, 0xff81a7b8, 0xffc1991b, 0x007e61cb, 0x0040f526, //13.5
    0x003d7a95, 0xff81a69d, 0xffc197f2, 0x007e62fb, 0x0040f712, //13.6
    0x003d79e7, 0xff81a583, 0xffc196ca, 0x007e642b, 0x0040f8fe, //13.7
    0x003d7937, 0xff81a46a, 0xffc195a2, 0x007e655a, 0x0040faeb, //13.8
    0x003d7886, 0xff81a352, 0xffc1947b, 0x007e6688, 0x0040fcd9, //13.9
    0x003d77d4, 0xff81a23b, 0xffc19355, 0x007e67b5, 0x0040fec7, //14.0
    // Treble Band
    0x0000ff7e, 0xfffe282b, 0xfff98529, 0x0012130d, 0x00054022, //-14.0
    0x00010212, 0xfffe2008, 0xfff98920, 0x00120a00, 0x00054ac7, //-13.9
    0x000104ae, 0xfffe17cc, 0xfff98d15, 0x001200ee, 0x00055582, //-13.8
    0x00010752, 0xfffe0f78, 0xfff9910b, 0x0011f7d8, 0x00056053, //-13.7
    0x000109fe, 0xfffe070a, 0xfff99500, 0x0011eebd, 0x00056b3b, //-13.6
    0x00010cb2, 0xfffdfe82, 0xfff998f5, 0x0011e59e, 0x00057639, //-13.5
    0x00010f6e, 0xfffdf5e1, 0xfff99ce9, 0x0011dc7a, 0x0005814f, //-13.4
    0x00011232, 0xfffded25, 0xfff9a0dd, 0x0011d351, 0x00058c7b, //-13.3
    0x000114fe, 0xfffde44f, 0xfff9a4d0, 0x0011ca24, 0x000597bf, //-13.2
    0x000117d3, 0xfffddb5e, 0xfff9a8c3, 0x0011c0f2, 0x0005a31a, //-13.1
    0x00011ab0, 0xfffdd252, 0xfff9acb6, 0x0011b7bc, 0x0005ae8c, //-13.0
    0x00011d96, 0xfffdc92b, 0xfff9b0a8, 0x0011ae81, 0x0005ba16, //-12.9
    0x00012084, 0xfffdbfe8, 0xfff9b49a, 0x0011a541, 0x0005c5b9, //-12.8
    0x0001237b, 0xfffdb68a, 0xfff9b88b, 0x00119bfd, 0x0005d173, //-12.7
    0x0001267b, 0xfffdad10, 0xfff9bc7c, 0x001192b4, 0x0005dd46, //-12.6
    0x00012984, 0xfffda379, 0xfff9c06c, 0x00118966, 0x0005e931, //-12.5
    0x00012c96, 0xfffd99c5, 0xfff9c45c, 0x00118014, 0x0005f535, //-12.4
    0x00012fb1, 0xfffd8ff5, 0xfff9c84b, 0x001176bd, 0x00060152, //-12.3
    0x000132d5, 0xfffd8607, 0xfff9cc3a, 0x00116d62, 0x00060d88, //-12.2
    0x00013602, 0xfffd7bfc, 0xfff9d028, 0x00116402, 0x000619d8, //-12.1
    0x00013939, 0xfffd71d2, 0xfff9d416, 0x00115a9d, 0x00062641, //-12.0
    0x00013c7a, 0xfffd678b, 0xfff9d803, 0x00115134, 0x000632c4, //-11.9
    0x00013fc4, 0xfffd5d25, 0xfff9dbf0, 0x001147c6, 0x00063f61, //-11.8
    0x00014318, 0xfffd52a1, 0xfff9dfdc, 0x00113e54, 0x00064c18, //-11.7
    0x00014676, 0xfffd47fd, 0xfff9e3c7, 0x001134dc, 0x000658e9, //-11.6
    0x000149de, 0xfffd3d3a, 0xfff9e7b2, 0x00112b61, 0x000665d6, //-11.5
    0x00014d50, 0xfffd3257, 0xfff9eb9c, 0x001121e0, 0x000672dc, //-11.4
    0x000150cc, 0xfffd2755, 0xfff9ef85, 0x0011185b, 0x00067ffe, //-11.3
    0x00015453, 0xfffd1c32, 0xfff9f36e, 0x00110ed2, 0x00068d3c, //-11.2
    0x000157e4, 0xfffd10ee, 0xfff9f757, 0x00110544, 0x00069a95, //-11.1
    0x00015b7f, 0xfffd0589, 0xfff9fb3e, 0x0010fbb1, 0x0006a809, //-11.0
    0x00015f25, 0xfffcfa03, 0xfff9ff25, 0x0010f219, 0x0006b599, //-10.9
    0x000162d6, 0xfffcee5b, 0xfffa030b, 0x0010e87d, 0x0006c346, //-10.8
    0x00016692, 0xfffce291, 0xfffa06f1, 0x0010dedd, 0x0006d10f, //-10.7
    0x00016a59, 0xfffcd6a5, 0xfffa0ad5, 0x0010d537, 0x0006def5, //-10.6
    0x00016e2c, 0xfffcca96, 0xfffa0eba, 0x0010cb8d, 0x0006ecf7, //-10.5
    0x00017209, 0xfffcbe64, 0xfffa129d, 0x0010c1df, 0x0006fb17, //-10.4
    0x000175f2, 0xfffcb20f, 0xfffa167f, 0x0010b82c, 0x00070954, //-10.3
    0x000179e7, 0xfffca596, 0xfffa1a61, 0x0010ae74, 0x000717ae, //-10.2
    0x00017de7, 0xfffc98f9, 0xfffa1e42, 0x0010a4b7, 0x00072627, //-10.1
    0x000181f3, 0xfffc8c37, 0xfffa2223, 0x00109af6, 0x000734bd, //-10.0
    0x0001860b, 0xfffc7f51, 0xfffa2602, 0x00109131, 0x00074371, //-9.9
    0x00018a2f, 0xfffc7245, 0xfffa29e1, 0x00108767, 0x00075245, //-9.8
    0x00018e5f, 0xfffc6514, 0xfffa2dbf, 0x00107d98, 0x00076137, //-9.7
    0x0001929b, 0xfffc57bd, 0xfffa319c, 0x001073c4, 0x00077048, //-9.6
    0x000196e4, 0xfffc4a40, 0xfffa3578, 0x001069ec, 0x00077f78, //-9.5
    0x00019b3a, 0xfffc3c9b, 0xfffa3953, 0x00106010, 0x00078ec8, //-9.4
    0x00019f9c, 0xfffc2ed0, 0xfffa3d2e, 0x0010562f, 0x00079e37, //-9.3
    0x0001a40c, 0xfffc20de, 0xfffa4107, 0x00104c49, 0x0007adc7, //-9.2
    0x0001a888, 0xfffc12c3, 0xfffa44e0, 0x0010425e, 0x0007bd77, //-9.1
    0x0001ad12, 0xfffc0481, 0xfffa48b7, 0x0010386f, 0x0007cd47, //-9.0
    0x0001b1a8, 0xfffbf615, 0xfffa4c8e, 0x00102e7c, 0x0007dd39, //-8.9
    0x0001b64d, 0xfffbe781, 0xfffa5064, 0x00102483, 0x0007ed4b, //-8.8
    0x0001baff, 0xfffbd8c3, 0xfffa5439, 0x00101a87, 0x0007fd7f, //-8.7
    0x0001bfbe, 0xfffbc9db, 0xfffa580d, 0x00101085, 0x00080dd4, //-8.6
    0x0001c48c, 0xfffbbac9, 0xfffa5be0, 0x0010067f, 0x00081e4b, //-8.5
    0x0001c968, 0xfffbab8d, 0xfffa5fb2, 0x000ffc75, 0x00082ee5, //-8.4
    0x0001ce52, 0xfffb9c25, 0xfffa6383, 0x000ff265, 0x00083fa1, //-8.3
    0x0001d34a, 0xfffb8c92, 0xfffa6753, 0x000fe852, 0x0008507f, //-8.2
    0x0001d851, 0xfffb7cd3, 0xfffa6b22, 0x000fde39, 0x00086181, //-8.1
    0x0001dd66, 0xfffb6ce7, 0xfffa6ef0, 0x000fd41c, 0x000872a6, //-8.0
    0x0001e28b, 0xfffb5ccf, 0xfffa72bd, 0x000fc9fb, 0x000883ee, //-7.9
    0x0001e7be, 0xfffb4c89, 0xfffa7689, 0x000fbfd5, 0x0008955b, //-7.8
    0x0001ed01, 0xfffb3c16, 0xfffa7a54, 0x000fb5aa, 0x0008a6eb, //-7.7
    0x0001f253, 0xfffb2b74, 0xfffa7e1e, 0x000fab7b, 0x0008b8a0, //-7.6
    0x0001f7b4, 0xfffb1aa4, 0xfffa81e6, 0x000fa147, 0x0008ca7a, //-7.5
    0x0001fd26, 0xfffb09a5, 0xfffa85ae, 0x000f970f, 0x0008dc79, //-7.4
    0x000202a7, 0xfffaf877, 0xfffa8974, 0x000f8cd2, 0x0008ee9d, //-7.3
    0x00020838, 0xfffae718, 0xfffa8d3a, 0x000f8290, 0x000900e6, //-7.2
    0x00020dd9, 0xfffad589, 0xfffa90fe, 0x000f784a, 0x00091356, //-7.1
    0x0002138b, 0xfffac3c9, 0xfffa94c1, 0x000f6e00, 0x000925eb, //-7.0
    0x0002194d, 0xfffab1d8, 0xfffa9882, 0x000f63b1, 0x000938a8, //-6.9
    0x00021f20, 0xfffa9fb5, 0xfffa9c43, 0x000f595d, 0x00094b8b, //-6.8
    0x00022504, 0xfffa8d60, 0xfffaa002, 0x000f4f05, 0x00095e95, //-6.7
    0x00022af9, 0xfffa7ad8, 0xfffaa3c1, 0x000f44a8, 0x000971c7, //-6.6
    0x000230ff, 0xfffa681c, 0xfffaa77d, 0x000f3a47, 0x00098520, //-6.5
    0x00023717, 0xfffa552d, 0xfffaab39, 0x000f2fe1, 0x000998a2, //-6.4
    0x00023d40, 0xfffa4209, 0xfffaaef4, 0x000f2577, 0x0009ac4c, //-6.3
    0x0002437b, 0xfffa2eb1, 0xfffab2ad, 0x000f1b08, 0x0009c01f, //-6.2
    0x000249c8, 0xfffa1b23, 0xfffab665, 0x000f1094, 0x0009d41b, //-6.1
    0x00025028, 0xfffa0760, 0xfffaba1b, 0x000f061d, 0x0009e840, //-6.0
    0x0002569a, 0xfff9f366, 0xfffabdd1, 0x000efba0, 0x0009fc8f, //-5.9
    0x00025d1e, 0xfff9df35, 0xfffac185, 0x000ef11f, 0x000a1108, //-5.8
    0x000263b6, 0xfff9cacd, 0xfffac537, 0x000ee69a, 0x000a25ac, //-5.7
    0x00026a60, 0xfff9b62d, 0xfffac8e9, 0x000edc10, 0x000a3a7a, //-5.6
    0x0002711e, 0xfff9a155, 0xfffacc99, 0x000ed181, 0x000a4f73, //-5.5
    0x000277ef, 0xfff98c43, 0xfffad047, 0x000ec6ee, 0x000a6498, //-5.4
    0x00027ed3, 0xfff976f8, 0xfffad3f5, 0x000ebc57, 0x000a79e9, //-5.3
    0x000285cc, 0xfff96173, 0xfffad7a0, 0x000eb1bb, 0x000a8f65, //-5.2
    0x00028cd8, 0xfff94bb4, 0xfffadb4b, 0x000ea71b, 0x000aa50f, //-5.1
    0x000293f9, 0xfff935b9, 0xfffadef4, 0x000e9c76, 0x000abae5, //-5.0
    0x00029b2e, 0xfff91f82, 0xfffae29b, 0x000e91cc, 0x000ad0e8, //-4.9
    0x0002a278, 0xfff9090f, 0xfffae642, 0x000e871f, 0x000ae719, //-4.8
    0x0002a9d7, 0xfff8f25f, 0xfffae9e6, 0x000e7c6c, 0x000afd77, //-4.7
    0x0002b14b, 0xfff8db72, 0xfffaed89, 0x000e71b6, 0x000b1404, //-4.6
    0x0002b8d5, 0xfff8c446, 0xfffaf12b, 0x000e66fa, 0x000b2ac0, //-4.5
    0x0002c074, 0xfff8acdc, 0xfffaf4cb, 0x000e5c3b, 0x000b41aa, //-4.4
    0x0002c829, 0xfff89532, 0xfffaf86a, 0x000e5177, 0x000b58c4, //-4.3
    0x0002cff3, 0xfff87d49, 0xfffafc07, 0x000e46ae, 0x000b700e, //-4.2
    0x0002d7d5, 0xfff8651f, 0xfffaffa3, 0x000e3be1, 0x000b8788, //-4.1
    0x0002dfcc, 0xfff84cb5, 0xfffb033d, 0x000e3110, 0x000b9f33, //-4.0
    0x0002e7db, 0xfff83408, 0xfffb06d5, 0x000e263a, 0x000bb70e, //-3.9
    0x0002f000, 0xfff81b19, 0xfffb0a6c, 0x000e1b60, 0x000bcf1b, //-3.8
    0x0002f83d, 0xfff801e8, 0xfffb0e01, 0x000e1081, 0x000be759, //-3.7
    0x00030091, 0xfff7e872, 0xfffb1195, 0x000e059e, 0x000bffca, //-3.6
    0x000308fd, 0xfff7ceb9, 0xfffb1527, 0x000dfab7, 0x000c186d, //-3.5
    0x00031181, 0xfff7b4bb, 0xfffb18b7, 0x000defcb, 0x000c3143, //-3.4
    0x00031a1d, 0xfff79a77, 0xfffb1c46, 0x000de4db, 0x000c4a4c, //-3.3
    0x000322d1, 0xfff77fed, 0xfffb1fd3, 0x000dd9e6, 0x000c6389, //-3.2
    0x00032b9e, 0xfff7651c, 0xfffb235f, 0x000dceed, 0x000c7cfa, //-3.1
    0x00033484, 0xfff74a04, 0xfffb26e9, 0x000dc3ef, 0x000c96a0, //-3.0
    0x00033d84, 0xfff72ea4, 0xfffb2a71, 0x000db8ee, 0x000cb07a, //-2.9
    0x0003469d, 0xfff712fa, 0xfffb2df7, 0x000dade8, 0x000cca8a, //-2.8
    0x00034fd0, 0xfff6f708, 0xfffb317b, 0x000da2dd, 0x000ce4d0, //-2.7
    0x0003591c, 0xfff6dacb, 0xfffb34fe, 0x000d97ce, 0x000cff4c, //-2.6
    0x00036283, 0xfff6be43, 0xfffb387f, 0x000d8cbb, 0x000d19ff, //-2.5
    0x00036c05, 0xfff6a170, 0xfffb3bff, 0x000d81a4, 0x000d34e8, //-2.4
    0x000375a2, 0xfff68451, 0xfffb3f7c, 0x000d7688, 0x000d5009, //-2.3
    0x00037f59, 0xfff666e4, 0xfffb42f8, 0x000d6b68, 0x000d6b63, //-2.2
    0x0003892c, 0xfff6492a, 0xfffb4672, 0x000d6043, 0x000d86f4, //-2.1
    0x0003931b, 0xfff62b22, 0xfffb49ea, 0x000d551a, 0x000da2bf, //-2.0
    0x00039d26, 0xfff60cca, 0xfffb4d60, 0x000d49ed, 0x000dbec2, //-1.9
    0x0003a74d, 0xfff5ee22, 0xfffb50d5, 0x000d3ebc, 0x000ddb00, //-1.8
    0x0003b191, 0xfff5cf2a, 0xfffb5447, 0x000d3386, 0x000df778, //-1.7
    0x0003bbf1, 0xfff5afe1, 0xfffb57b8, 0x000d284c, 0x000e142a, //-1.6
    0x0003c66f, 0xfff59045, 0xfffb5b27, 0x000d1d0e, 0x000e3118, //-1.5
    0x0003d10a, 0xfff57056, 0xfffb5e93, 0x000d11cc, 0x000e4e41, //-1.4
    0x0003dbc3, 0xfff55014, 0xfffb61fe, 0x000d0685, 0x000e6ba6, //-1.3
    0x0003e69a, 0xfff52f7d, 0xfffb6567, 0x000cfb3a, 0x000e8948, //-1.2
    0x0003f18f, 0xfff50e92, 0xfffb68ce, 0x000cefeb, 0x000ea726, //-1.1
    0x0003fca3, 0xfff4ed50, 0xfffb6c34, 0x000ce497, 0x000ec543, //-1.0
    0x000407d6, 0xfff4cbb7, 0xfffb6f97, 0x000cd93f, 0x000ee39d, //-0.9
    0x00041328, 0xfff4a9c7, 0xfffb72f8, 0x000ccde4, 0x000f0236, //-0.8
    0x00041e9a, 0xfff4877f, 0xfffb7657, 0x000cc283, 0x000f210d, //-0.7
    0x00042a2c, 0xfff464dd, 0xfffb79b4, 0x000cb71f, 0x000f4024, //-0.6
    0x000435de, 0xfff441e1, 0xfffb7d0f, 0x000cabb6, 0x000f5f7b, //-0.5
    0x000441b1, 0xfff41e8a, 0xfffb8068, 0x000ca04a, 0x000f7f13, //-0.4
    0x00044da4, 0xfff3fad8, 0xfffb83bf, 0x000c94d9, 0x000f9eeb, //-0.3
    0x000459b9, 0xfff3d6ca, 0xfffb8714, 0x000c8964, 0x000fbf05, //-0.2
    0x000465f0, 0xfff3b25d, 0xfffb8a67, 0x000c7dea, 0x000fdf61, //-0.1
    0x00047248, 0xfff38d93, 0xfffb8db8, 0x000c726d, 0x00100000, //-0.0
    0x00047ec3, 0xfff3686a, 0xfffb9106, 0x000c66eb, 0x001020e2, //0.1
    0x00048b61, 0xfff342e0, 0xfffb9453, 0x000c5b66, 0x00104207, //0.2
    0x00049821, 0xfff31cf6, 0xfffb979d, 0x000c4fdc, 0x00106370, //0.3
    0x0004a505, 0xfff2f6aa, 0xfffb9ae5, 0x000c444e, 0x0010851e, //0.4
    0x0004b20c, 0xfff2cffc, 0xfffb9e2b, 0x000c38bc, 0x0010a711, //0.5
    0x0004bf38, 0xfff2a8ea, 0xfffba16f, 0x000c2d25, 0x0010c949, //0.6
    0x0004cc88, 0xfff28174, 0xfffba4b1, 0x000c218b, 0x0010ebc8, //0.7
    0x0004d9fc, 0xfff25998, 0xfffba7f1, 0x000c15ed, 0x00110e8e, //0.8
    0x0004e796, 0xfff23157, 0xfffbab2e, 0x000c0a4a, 0x0011319b, //0.9
    0x0004f556, 0xfff208ae, 0xfffbae69, 0x000bfea4, 0x001154f0, //1.0
    0x0005033b, 0xfff1df9d, 0xfffbb1a2, 0x000bf2f9, 0x0011788e, //1.1
    0x00051147, 0xfff1b623, 0xfffbb4d8, 0x000be74a, 0x00119c74, //1.2
    0x00051f79, 0xfff18c3f, 0xfffbb80c, 0x000bdb98, 0x0011c0a4, //1.3
    0x00052dd3, 0xfff161f0, 0xfffbbb3e, 0x000bcfe1, 0x0011e51e, //1.4
    0x00053c53, 0xfff13735, 0xfffbbe6e, 0x000bc426, 0x001209e4, //1.5
    0x00054afc, 0xfff10c0d, 0xfffbc19b, 0x000bb867, 0x00122ef4, //1.6
    0x000559cd, 0xfff0e078, 0xfffbc4c6, 0x000baca4, 0x00125450, //1.7
    0x000568c6, 0xfff0b474, 0xfffbc7ef, 0x000ba0de, 0x001279f9, //1.8
    0x000577e9, 0xfff087ff, 0xfffbcb16, 0x000b9513, 0x00129fef, //1.9
    0x00058735, 0xfff05b1a, 0xfffbce3a, 0x000b8944, 0x0012c633, //2.0
    0x000596ab, 0xfff02dc4, 0xfffbd15b, 0x000b7d71, 0x0012ecc5, //2.1
    0x0005a64b, 0xffeffffa, 0xfffbd47a, 0x000b719b, 0x001313a6, //2.2
    0x0005b616, 0xffefd1bc, 0xfffbd797, 0x000b65c0, 0x00133ad7, //2.3
    0x0005c60c, 0xffefa30a, 0xfffbdab2, 0x000b59e1, 0x00136257, //2.4
    0x0005d62e, 0xffef73e1, 0xfffbddc9, 0x000b4dff, 0x00138a29, //2.5
    0x0005e67b, 0xffef4441, 0xfffbe0df, 0x000b4218, 0x0013b24c, //2.6
    0x0005f6f5, 0xffef142a, 0xfffbe3f2, 0x000b362e, 0x0013dac1, //2.7
    0x0006079c, 0xffeee399, 0xfffbe703, 0x000b2a40, 0x00140389, //2.8
    0x00061870, 0xffeeb28d, 0xfffbea11, 0x000b1e4e, 0x00142ca4, //2.9
    0x00062972, 0xffee8107, 0xfffbed1c, 0x000b1258, 0x00145613, //3.0
    0x00063aa2, 0xffee4f04, 0xfffbf025, 0x000b065e, 0x00147fd7, //3.1
    0x00064c01, 0xffee1c83, 0xfffbf32c, 0x000afa60, 0x0014a9f0, //3.2
    0x00065d8e, 0xffede984, 0xfffbf630, 0x000aee5f, 0x0014d45f, //3.3
    0x00066f4c, 0xffedb605, 0xfffbf931, 0x000ae259, 0x0014ff24, //3.4
    0x00068139, 0xffed8205, 0xfffbfc30, 0x000ad650, 0x00152a41, //3.5
    0x00069357, 0xffed4d83, 0xfffbff2d, 0x000aca43, 0x001555b6, //3.6
    0x0006a5a6, 0xffed187e, 0xfffc0226, 0x000abe33, 0x00158183, //3.7
    0x0006b826, 0xffece2f4, 0xfffc051e, 0x000ab21e, 0x0015adaa, //3.8
    0x0006cad9, 0xffecace5, 0xfffc0812, 0x000aa606, 0x0015da2b, //3.9
    0x0006ddbd, 0xffec764f, 0xfffc0b04, 0x000a99ea, 0x00160707, //4.0
    0x0006f0d5, 0xffec3f31, 0xfffc0df3, 0x000a8dca, 0x0016343e, //4.1
    0x00070420, 0xffec0789, 0xfffc10e0, 0x000a81a6, 0x001661d1, //4.2
    0x0007179f, 0xffebcf58, 0xfffc13ca, 0x000a757f, 0x00168fc1, //4.3
    0x00072b52, 0xffeb969b, 0xfffc16b1, 0x000a6954, 0x0016be0e, //4.4
    0x00073f3a, 0xffeb5d51, 0xfffc1996, 0x000a5d25, 0x0016ecba, //4.5
    0x00075358, 0xffeb2379, 0xfffc1c77, 0x000a50f3, 0x00171bc5, //4.6
    0x000767ac, 0xffeae912, 0xfffc1f57, 0x000a44bd, 0x00174b2f, //4.7
    0x00077c36, 0xffeaae1a, 0xfffc2233, 0x000a3883, 0x00177afa, //4.8
    0x000790f7, 0xffea7290, 0xfffc250d, 0x000a2c45, 0x0017ab27, //4.9
    0x0007a5f0, 0xffea3673, 0xfffc27e3, 0x000a2004, 0x0017dbb5, //5.0
    0x0007bb21, 0xffe9f9c2, 0xfffc2ab8, 0x000a13c0, 0x00180ca6, //5.1
    0x0007d08a, 0xffe9bc7c, 0xfffc2d89, 0x000a0777, 0x00183dfa, //5.2
    0x0007e62c, 0xffe97e9e, 0xfffc3057, 0x0009fb2c, 0x00186fb3, //5.3
    0x0007fc09, 0xffe94028, 0xfffc3323, 0x0009eedc, 0x0018a1d0, //5.4
    0x0008121f, 0xffe90118, 0xfffc35ec, 0x0009e289, 0x0018d454, //5.5
    0x00082871, 0xffe8c16d, 0xfffc38b2, 0x0009d632, 0x0019073e, //5.6
    0x00083efd, 0xffe88126, 0xfffc3b75, 0x0009c9d8, 0x00193a8f, //5.7
    0x000855c6, 0xffe84041, 0xfffc3e36, 0x0009bd7a, 0x00196e49, //5.8
    0x00086ccb, 0xffe7febd, 0xfffc40f3, 0x0009b119, 0x0019a26b, //5.9
    0x0008840e, 0xffe7bc99, 0xfffc43ae, 0x0009a4b4, 0x0019d6f8, //6.0
    0x00089b8e, 0xffe779d2, 0xfffc4665, 0x0009984c, 0x001a0bee, //6.1
    0x0008b34c, 0xffe73669, 0xfffc491a, 0x00098be0, 0x001a4151, //6.2
    0x0008cb49, 0xffe6f25b, 0xfffc4bcc, 0x00097f71, 0x001a771f, //6.3
    0x0008e386, 0xffe6ada6, 0xfffc4e7b, 0x000972ff, 0x001aad5a, //6.4
    0x0008fc03, 0xffe6684a, 0xfffc5127, 0x00096688, 0x001ae404, //6.5
    0x000914c0, 0xffe62245, 0xfffc53d0, 0x00095a0f, 0x001b1b1c, //6.6
    0x00092dbf, 0xffe5db96, 0xfffc5676, 0x00094d92, 0x001b52a3, //6.7
    0x000946ff, 0xffe5943b, 0xfffc5919, 0x00094111, 0x001b8a9b, //6.8
    0x00096083, 0xffe54c32, 0xfffc5bb9, 0x0009348e, 0x001bc304, //6.9
    0x00097a49, 0xffe5037a, 0xfffc5e56, 0x00092807, 0x001bfbe0, //7.0
    0x00099453, 0xffe4ba12, 0xfffc60f0, 0x00091b7c, 0x001c352e, //7.1
    0x0009aea2, 0xffe46ff8, 0xfffc6388, 0x00090eee, 0x001c6ef0, //7.2
    0x0009c936, 0xffe4252b, 0xfffc661b, 0x0009025d, 0x001ca927, //7.3
    0x0009e410, 0xffe3d9a8, 0xfffc68ac, 0x0008f5c8, 0x001ce3d3, //7.4
    0x0009ff30, 0xffe38d6f, 0xfffc6b3a, 0x0008e931, 0x001d1ef7, //7.5
    0x000a1a97, 0xffe3407e, 0xfffc6dc5, 0x0008dc95, 0x001d5a91, //7.6
    0x000a3646, 0xffe2f2d3, 0xfffc704d, 0x0008cff7, 0x001d96a4, //7.7
    0x000a523d, 0xffe2a46c, 0xfffc72d1, 0x0008c355, 0x001dd330, //7.8
    0x000a6e7d, 0xffe25549, 0xfffc7553, 0x0008b6b0, 0x001e1036, //7.9
    0x000a8b07, 0xffe20567, 0xfffc77d1, 0x0008aa08, 0x001e4db8, //8.0
    0x000aa7dc, 0xffe1b4c5, 0xfffc7a4c, 0x00089d5d, 0x001e8bb5, //8.1
    0x000ac4fc, 0xffe16362, 0xfffc7cc4, 0x000890ae, 0x001eca30, //8.2
    0x000ae268, 0xffe1113a, 0xfffc7f39, 0x000883fc, 0x001f0928, //8.3
    0x000b0020, 0xffe0be4e, 0xfffc81ab, 0x00087748, 0x001f489f, //8.4
    0x000b1e26, 0xffe06a9b, 0xfffc8419, 0x00086a8f, 0x001f8897, //8.5
    0x000b3c79, 0xffe0161f, 0xfffc8685, 0x00085dd4, 0x001fc90e, //8.6
    0x000b5b1c, 0xffdfc0d9, 0xfffc88ed, 0x00085116, 0x00200a08, //8.7
    0x000b7a0e, 0xffdf6ac7, 0xfffc8b52, 0x00084454, 0x00204b85, //8.8
    0x000b9950, 0xffdf13e8, 0xfffc8db3, 0x00083790, 0x00208d85, //8.9
    0x000bb8e3, 0xffdebc39, 0xfffc9012, 0x00082ac8, 0x0020d00a, //9.0
    0x000bd8c8, 0xffde63b9, 0xfffc926d, 0x00081dfd, 0x00211315, //9.1
    0x000bf900, 0xffde0a65, 0xfffc94c5, 0x0008112f, 0x002156a6, //9.2
    0x000c198a, 0xffddb03e, 0xfffc971a, 0x0008045f, 0x00219ac0, //9.3
    0x000c3a69, 0xffdd553f, 0xfffc996b, 0x0007f78b, 0x0021df62, //9.4
    0x000c5b9d, 0xffdcf968, 0xfffc9bb9, 0x0007eab4, 0x0022248e, //9.5
    0x000c7d26, 0xffdc9cb8, 0xfffc9e04, 0x0007ddda, 0x00226a45, //9.6
    0x000c9f05, 0xffdc3f2b, 0xfffca04b, 0x0007d0fd, 0x0022b088, //9.7
    0x000cc13c, 0xffdbe0c0, 0xfffca28f, 0x0007c41d, 0x0022f758, //9.8
    0x000ce3cb, 0xffdb8175, 0xfffca4d0, 0x0007b73b, 0x00233eb6, //9.9
    0x000d06b2, 0xffdb2149, 0xfffca70d, 0x0007aa55, 0x002386a3, //10.0
    0x000d29f3, 0xffdac039, 0xfffca947, 0x00079d6c, 0x0023cf20, //10.1
    0x000d4d8f, 0xffda5e44, 0xfffcab7e, 0x00079081, 0x0024182e, //10.2
    0x000d7185, 0xffd9fb68, 0xfffcadb1, 0x00078393, 0x002461cf, //10.3
    0x000d95d8, 0xffd997a2, 0xfffcafe1, 0x000776a2, 0x0024ac03, //10.4
    0x000dba88, 0xffd932f1, 0xfffcb20e, 0x000769ad, 0x0024f6cc, //10.5
    0x000ddf96, 0xffd8cd52, 0xfffcb437, 0x00075cb7, 0x0025422b, //10.6
    0x000e0502, 0xffd866c5, 0xfffcb65c, 0x00074fbd, 0x00258e20, //10.7
    0x000e2ace, 0xffd7ff46, 0xfffcb87e, 0x000742c0, 0x0025daae, //10.8
    0x000e50fa, 0xffd796d4, 0xfffcba9d, 0x000735c1, 0x002627d4, //10.9
    0x000e7787, 0xffd72d6d, 0xfffcbcb8, 0x000728bf, 0x00267595, //11.0
    0x000e9e77, 0xffd6c30e, 0xfffcbed0, 0x00071bba, 0x0026c3f1, //11.1
    0x000ec5c9, 0xffd657b6, 0xfffcc0e4, 0x00070eb3, 0x002712e9, //11.2
    0x000eed80, 0xffd5eb63, 0xfffcc2f5, 0x000701a9, 0x0027627f, //11.3
    0x000f159c, 0xffd57e12, 0xfffcc502, 0x0006f49c, 0x0027b2b5, //11.4
    0x000f3e1d, 0xffd50fc1, 0xfffcc70c, 0x0006e78c, 0x0028038a, //11.5
    0x000f6705, 0xffd4a06e, 0xfffcc913, 0x0006da7a, 0x00285500, //11.6
    0x000f9054, 0xffd43018, 0xfffccb15, 0x0006cd65, 0x0028a719, //11.7
    0x000fba0c, 0xffd3bebb, 0xfffccd15, 0x0006c04e, 0x0028f9d6, //11.8
    0x000fe42e, 0xffd34c57, 0xfffccf10, 0x0006b334, 0x00294d37, //11.9
    0x00100eba, 0xffd2d8e7, 0xfffcd108, 0x0006a617, 0x0029a13f, //12.0
    0x001039b2, 0xffd2646b, 0xfffcd2fd, 0x000698f8, 0x0029f5ee, //12.1
    0x00106516, 0xffd1eee1, 0xfffcd4ee, 0x00068bd6, 0x002a4b46, //12.2
    0x001090e7, 0xffd17845, 0xfffcd6db, 0x00067eb2, 0x002aa148, //12.3
    0x0010bd26, 0xffd10096, 0xfffcd8c5, 0x0006718b, 0x002af7f4, //12.4
    0x0010e9d5, 0xffd087d1, 0xfffcdaab, 0x00066462, 0x002b4f4d, //12.5
    0x001116f5, 0xffd00df4, 0xfffcdc8d, 0x00065736, 0x002ba754, //12.6
    0x00114485, 0xffcf92fd, 0xfffcde6c, 0x00064a07, 0x002c000a, //12.7
    0x00117289, 0xffcf16e9, 0xfffce048, 0x00063cd7, 0x002c5970, //12.8
    0x0011a0ff, 0xffce99b6, 0xfffce21f, 0x00062fa4, 0x002cb388, //12.9
    0x0011cfea, 0xffce1b63, 0xfffce3f3, 0x0006226e, 0x002d0e52, //13.0
    0x0011ff4a, 0xffcd9beb, 0xfffce5c3, 0x00061536, 0x002d69d1, //13.1
    0x00122f21, 0xffcd1b4e, 0xfffce790, 0x000607fc, 0x002dc606, //13.2
    0x00125f70, 0xffcc9988, 0xfffce959, 0x0005fabf, 0x002e22f1, //13.3
    0x00129037, 0xffcc1697, 0xfffceb1e, 0x0005ed80, 0x002e8094, //13.4
    0x0012c177, 0xffcb9279, 0xfffcece0, 0x0005e03f, 0x002edef1, //13.5
    0x0012f333, 0xffcb0d2b, 0xfffcee9e, 0x0005d2fb, 0x002f3e0a, //13.6
    0x0013256a, 0xffca86ab, 0xfffcf058, 0x0005c5b5, 0x002f9dde, //13.7
    0x0013581f, 0xffc9fef6, 0xfffcf20e, 0x0005b86d, 0x002ffe70, //13.8
    0x00138b52, 0xffc97609, 0xfffcf3c1, 0x0005ab22, 0x00305fc2, //13.9
    0x0013bf03, 0xffc8ebe3, 0xfffcf570, 0x00059dd6, 0x0030c1d4, //14.0
};
static const UINT32 _aau4MtkAudChlBassTrebleLoudnessCoefTbl_250_4500_Sony_2k15[(281*2)*5] =
{
    // 48000.0 Hz  
    // Bass Band
    0x003cda0a, 0xff84667b, 0xffc44fb9, 0x007b8a55, 0x003ec70e, //-14.0
    0x003cdae6, 0xff846356, 0xffc44ca9, 0x007b8d9c, 0x003ec962, //-13.9
    0x003cdbc1, 0xff846032, 0xffc4499b, 0x007b90e0, 0x003ecbb7, //-13.8
    0x003cdc9a, 0xff845d11, 0xffc4468f, 0x007b9422, 0x003ece0a, //-13.7
    0x003cdd71, 0xff8459f3, 0xffc44386, 0x007b9761, 0x003ed05d, //-13.6
    0x003cde47, 0xff8456d6, 0xffc4407e, 0x007b9a9f, 0x003ed2b0, //-13.5
    0x003cdf1b, 0xff8453bc, 0xffc43d79, 0x007b9dd9, 0x003ed502, //-13.4
    0x003cdfed, 0xff8450a4, 0xffc43a75, 0x007ba112, 0x003ed753, //-13.3
    0x003ce0be, 0xff844d8e, 0xffc43774, 0x007ba448, 0x003ed9a4, //-13.2
    0x003ce18d, 0xff844a7b, 0xffc43475, 0x007ba77b, 0x003edbf4, //-13.1
    0x003ce25a, 0xff84476a, 0xffc43178, 0x007baaad, 0x003ede44, //-13.0
    0x003ce326, 0xff84445a, 0xffc42e7d, 0x007baddc, 0x003ee093, //-12.9
    0x003ce3f0, 0xff84414e, 0xffc42b83, 0x007bb108, 0x003ee2e2, //-12.8
    0x003ce4b9, 0xff843e43, 0xffc4288c, 0x007bb432, 0x003ee530, //-12.7
    0x003ce580, 0xff843b3b, 0xffc42597, 0x007bb75a, 0x003ee77e, //-12.6
    0x003ce645, 0xff843835, 0xffc422a4, 0x007bba80, 0x003ee9cb, //-12.5
    0x003ce709, 0xff843531, 0xffc41fb3, 0x007bbda3, 0x003eec18, //-12.4
    0x003ce7cb, 0xff84322f, 0xffc41cc4, 0x007bc0c5, 0x003eee64, //-12.3
    0x003ce88b, 0xff842f2f, 0xffc419d7, 0x007bc3e3, 0x003ef0b0, //-12.2
    0x003ce94a, 0xff842c32, 0xffc416ec, 0x007bc700, 0x003ef2fb, //-12.1
    0x003cea07, 0xff842937, 0xffc41403, 0x007bca1a, 0x003ef546, //-12.0
    0x003ceac3, 0xff84263e, 0xffc4111c, 0x007bcd32, 0x003ef790, //-11.9
    0x003ceb7c, 0xff842347, 0xffc40e38, 0x007bd048, 0x003ef9da, //-11.8
    0x003cec35, 0xff842052, 0xffc40b55, 0x007bd35b, 0x003efc24, //-11.7
    0x003ceceb, 0xff841d5f, 0xffc40874, 0x007bd66c, 0x003efe6d, //-11.6
    0x003ceda0, 0xff841a6f, 0xffc40595, 0x007bd97b, 0x003f00b5, //-11.5
    0x003cee54, 0xff841781, 0xffc402b8, 0x007bdc88, 0x003f02fd, //-11.4
    0x003cef06, 0xff841495, 0xffc3ffdc, 0x007bdf92, 0x003f0545, //-11.3
    0x003cefb6, 0xff8411ab, 0xffc3fd03, 0x007be29a, 0x003f078c, //-11.2
    0x003cf064, 0xff840ec3, 0xffc3fa2c, 0x007be5a0, 0x003f09d2, //-11.1
    0x003cf111, 0xff840bdd, 0xffc3f757, 0x007be8a4, 0x003f0c19, //-11.0
    0x003cf1bd, 0xff8408f9, 0xffc3f484, 0x007beba5, 0x003f0e5e, //-10.9
    0x003cf266, 0xff840618, 0xffc3f1b2, 0x007beea5, 0x003f10a4, //-10.8
    0x003cf30f, 0xff840338, 0xffc3eee3, 0x007bf1a2, 0x003f12e9, //-10.7
    0x003cf3b5, 0xff84005b, 0xffc3ec16, 0x007bf49d, 0x003f152d, //-10.6
    0x003cf45a, 0xff83fd80, 0xffc3e94a, 0x007bf796, 0x003f1771, //-10.5
    0x003cf4fd, 0xff83faa7, 0xffc3e681, 0x007bfa8c, 0x003f19b5, //-10.4
    0x003cf59f, 0xff83f7d0, 0xffc3e3b9, 0x007bfd81, 0x003f1bf8, //-10.3
    0x003cf63f, 0xff83f4fb, 0xffc3e0f3, 0x007c0073, 0x003f1e3b, //-10.2
    0x003cf6de, 0xff83f228, 0xffc3de2f, 0x007c0363, 0x003f207e, //-10.1
    0x003cf77b, 0xff83ef57, 0xffc3db6d, 0x007c0651, 0x003f22c0, //-10.0
    0x003cf816, 0xff83ec89, 0xffc3d8ad, 0x007c093d, 0x003f2502, //-9.9
    0x003cf8b0, 0xff83e9bc, 0xffc3d5ef, 0x007c0c26, 0x003f2743, //-9.8
    0x003cf948, 0xff83e6f1, 0xffc3d333, 0x007c0f0e, 0x003f2984, //-9.7
    0x003cf9de, 0xff83e429, 0xffc3d079, 0x007c11f3, 0x003f2bc5, //-9.6
    0x003cfa73, 0xff83e162, 0xffc3cdc0, 0x007c14d6, 0x003f2e05, //-9.5
    0x003cfb07, 0xff83de9e, 0xffc3cb0a, 0x007c17b8, 0x003f3045, //-9.4
    0x003cfb98, 0xff83dbdb, 0xffc3c855, 0x007c1a97, 0x003f3285, //-9.3
    0x003cfc28, 0xff83d91b, 0xffc3c5a2, 0x007c1d74, 0x003f34c4, //-9.2
    0x003cfcb7, 0xff83d65d, 0xffc3c2f1, 0x007c204e, 0x003f3703, //-9.1
    0x003cfd44, 0xff83d3a0, 0xffc3c042, 0x007c2327, 0x003f3941, //-9.0
    0x003cfdcf, 0xff83d0e6, 0xffc3bd95, 0x007c25fe, 0x003f3b7f, //-8.9
    0x003cfe59, 0xff83ce2e, 0xffc3bae9, 0x007c28d2, 0x003f3dbd, //-8.8
    0x003cfee1, 0xff83cb77, 0xffc3b840, 0x007c2ba5, 0x003f3ffb, //-8.7
    0x003cff68, 0xff83c8c3, 0xffc3b598, 0x007c2e75, 0x003f4238, //-8.6
    0x003cffed, 0xff83c611, 0xffc3b2f2, 0x007c3144, 0x003f4475, //-8.5
    0x003d0070, 0xff83c360, 0xffc3b04e, 0x007c3410, 0x003f46b1, //-8.4
    0x003d00f2, 0xff83c0b2, 0xffc3adac, 0x007c36da, 0x003f48ee, //-8.3
    0x003d0173, 0xff83be05, 0xffc3ab0b, 0x007c39a2, 0x003f4b2a, //-8.2
    0x003d01f1, 0xff83bb5b, 0xffc3a86d, 0x007c3c68, 0x003f4d65, //-8.1
    0x003d026e, 0xff83b8b3, 0xffc3a5d0, 0x007c3f2d, 0x003f4fa1, //-8.0
    0x003d02ea, 0xff83b60c, 0xffc3a335, 0x007c41ef, 0x003f51dc, //-7.9
    0x003d0364, 0xff83b368, 0xffc3a09c, 0x007c44af, 0x003f5416, //-7.8
    0x003d03dc, 0xff83b0c5, 0xffc39e05, 0x007c476d, 0x003f5651, //-7.7
    0x003d0453, 0xff83ae24, 0xffc39b6f, 0x007c4a29, 0x003f588b, //-7.6
    0x003d04c8, 0xff83ab86, 0xffc398db, 0x007c4ce3, 0x003f5ac5, //-7.5
    0x003d053c, 0xff83a8e9, 0xffc39649, 0x007c4f9b, 0x003f5cff, //-7.4
    0x003d05ae, 0xff83a64e, 0xffc393b9, 0x007c5251, 0x003f5f38, //-7.3
    0x003d061f, 0xff83a3b5, 0xffc3912a, 0x007c5505, 0x003f6171, //-7.2
    0x003d068e, 0xff83a11e, 0xffc38e9e, 0x007c57b7, 0x003f63aa, //-7.1
    0x003d06fb, 0xff839e89, 0xffc38c13, 0x007c5a67, 0x003f65e3, //-7.0
    0x003d0767, 0xff839bf6, 0xffc3898a, 0x007c5d15, 0x003f681b, //-6.9
    0x003d07d1, 0xff839965, 0xffc38702, 0x007c5fc1, 0x003f6a53, //-6.8
    0x003d083a, 0xff8396d6, 0xffc3847d, 0x007c626c, 0x003f6c8b, //-6.7
    0x003d08a1, 0xff839449, 0xffc381f9, 0x007c6514, 0x003f6ec3, //-6.6
    0x003d0906, 0xff8391bd, 0xffc37f77, 0x007c67ba, 0x003f70fa, //-6.5
    0x003d096a, 0xff838f34, 0xffc37cf6, 0x007c6a5e, 0x003f7332, //-6.4
    0x003d09cd, 0xff838cac, 0xffc37a78, 0x007c6d01, 0x003f7569, //-6.3
    0x003d0a2d, 0xff838a26, 0xffc377fb, 0x007c6fa1, 0x003f779f, //-6.2
    0x003d0a8d, 0xff8387a2, 0xffc3757f, 0x007c7240, 0x003f79d6, //-6.1
    0x003d0aea, 0xff838520, 0xffc37306, 0x007c74dc, 0x003f7c0c, //-6.0
    0x003d0b46, 0xff8382a0, 0xffc3708e, 0x007c7777, 0x003f7e42, //-5.9
    0x003d0ba1, 0xff838022, 0xffc36e18, 0x007c7a10, 0x003f8078, //-5.8
    0x003d0bfa, 0xff837da5, 0xffc36ba4, 0x007c7ca7, 0x003f82ae, //-5.7
    0x003d0c51, 0xff837b2b, 0xffc36931, 0x007c7f3c, 0x003f84e4, //-5.6
    0x003d0ca7, 0xff8378b2, 0xffc366c0, 0x007c81cf, 0x003f8719, //-5.5
    0x003d0cfc, 0xff83763b, 0xffc36451, 0x007c8460, 0x003f894e, //-5.4
    0x003d0d4e, 0xff8373c6, 0xffc361e3, 0x007c86ef, 0x003f8b83, //-5.3
    0x003d0da0, 0xff837153, 0xffc35f78, 0x007c897d, 0x003f8db8, //-5.2
    0x003d0def, 0xff836ee1, 0xffc35d0d, 0x007c8c08, 0x003f8fed, //-5.1
    0x003d0e3d, 0xff836c72, 0xffc35aa5, 0x007c8e92, 0x003f9222, //-5.0
    0x003d0e8a, 0xff836a04, 0xffc3583e, 0x007c911a, 0x003f9456, //-4.9
    0x003d0ed5, 0xff836798, 0xffc355d9, 0x007c93a0, 0x003f968a, //-4.8
    0x003d0f1e, 0xff83652e, 0xffc35375, 0x007c9624, 0x003f98be, //-4.7
    0x003d0f66, 0xff8362c6, 0xffc35114, 0x007c98a6, 0x003f9af2, //-4.6
    0x003d0fac, 0xff83605f, 0xffc34eb4, 0x007c9b27, 0x003f9d26, //-4.5
    0x003d0ff1, 0xff835dfa, 0xffc34c55, 0x007c9da6, 0x003f9f5a, //-4.4
    0x003d1034, 0xff835b98, 0xffc349f8, 0x007ca022, 0x003fa18e, //-4.3
    0x003d1076, 0xff835936, 0xffc3479d, 0x007ca29d, 0x003fa3c1, //-4.2
    0x003d10b6, 0xff8356d7, 0xffc34543, 0x007ca516, 0x003fa5f4, //-4.1
    0x003d10f4, 0xff83547a, 0xffc342eb, 0x007ca78e, 0x003fa828, //-4.0
    0x003d1131, 0xff83521e, 0xffc34095, 0x007caa03, 0x003faa5b, //-3.9
    0x003d116d, 0xff834fc4, 0xffc33e40, 0x007cac77, 0x003fac8e, //-3.8
    0x003d11a7, 0xff834d6c, 0xffc33bed, 0x007caee9, 0x003faec1, //-3.7
    0x003d11df, 0xff834b15, 0xffc3399c, 0x007cb159, 0x003fb0f3, //-3.6
    0x003d1216, 0xff8348c1, 0xffc3374c, 0x007cb3c7, 0x003fb326, //-3.5
    0x003d124b, 0xff83466e, 0xffc334fe, 0x007cb634, 0x003fb559, //-3.4
    0x003d127e, 0xff83441d, 0xffc332b1, 0x007cb89f, 0x003fb78b, //-3.3
    0x003d12b0, 0xff8341cd, 0xffc33066, 0x007cbb08, 0x003fb9be, //-3.2
    0x003d12e1, 0xff833f80, 0xffc32e1d, 0x007cbd6f, 0x003fbbf0, //-3.1
    0x003d1310, 0xff833d34, 0xffc32bd5, 0x007cbfd4, 0x003fbe23, //-3.0
    0x003d133d, 0xff833ae9, 0xffc3298f, 0x007cc238, 0x003fc055, //-2.9
    0x003d1369, 0xff8338a1, 0xffc3274a, 0x007cc49a, 0x003fc287, //-2.8
    0x003d1394, 0xff83365a, 0xffc32507, 0x007cc6fa, 0x003fc4b9, //-2.7
    0x003d13bc, 0xff833415, 0xffc322c6, 0x007cc959, 0x003fc6eb, //-2.6
    0x003d13e4, 0xff8331d2, 0xffc32086, 0x007ccbb5, 0x003fc91d, //-2.5
    0x003d1409, 0xff832f91, 0xffc31e48, 0x007cce10, 0x003fcb4f, //-2.4
    0x003d142e, 0xff832d51, 0xffc31c0b, 0x007cd069, 0x003fcd81, //-2.3
    0x003d1450, 0xff832b13, 0xffc319d0, 0x007cd2c1, 0x003fcfb3, //-2.2
    0x003d1471, 0xff8328d6, 0xffc31796, 0x007cd517, 0x003fd1e5, //-2.1
    0x003d1491, 0xff83269b, 0xffc3155e, 0x007cd76b, 0x003fd417, //-2.0
    0x003d14af, 0xff832462, 0xffc31328, 0x007cd9bd, 0x003fd649, //-1.9
    0x003d14cb, 0xff83222b, 0xffc310f3, 0x007cdc0e, 0x003fd87b, //-1.8
    0x003d14e6, 0xff831ff5, 0xffc30ebf, 0x007cde5d, 0x003fdaad, //-1.7
    0x003d14ff, 0xff831dc1, 0xffc30c8e, 0x007ce0aa, 0x003fdcdf, //-1.6
    0x003d1517, 0xff831b8f, 0xffc30a5d, 0x007ce2f6, 0x003fdf11, //-1.5
    0x003d152d, 0xff83195f, 0xffc3082e, 0x007ce540, 0x003fe142, //-1.4
    0x003d1542, 0xff831730, 0xffc30601, 0x007ce788, 0x003fe374, //-1.3
    0x003d1555, 0xff831502, 0xffc303d5, 0x007ce9ce, 0x003fe5a6, //-1.2
    0x003d1567, 0xff8312d7, 0xffc301ab, 0x007cec13, 0x003fe7d8, //-1.1
    0x003d1577, 0xff8310ad, 0xffc2ff82, 0x007cee57, 0x003fea0a, //-1.0
    0x003d1585, 0xff830e85, 0xffc2fd5b, 0x007cf098, 0x003fec3c, //-0.9
    0x003d1592, 0xff830c5e, 0xffc2fb36, 0x007cf2d8, 0x003fee6e, //-0.8
    0x003d159e, 0xff830a39, 0xffc2f911, 0x007cf516, 0x003ff0a0, //-0.7
    0x003d15a8, 0xff830816, 0xffc2f6ef, 0x007cf753, 0x003ff2d2, //-0.6
    0x003d15b0, 0xff8305f4, 0xffc2f4cd, 0x007cf98e, 0x003ff504, //-0.5
    0x003d15b7, 0xff8303d4, 0xffc2f2ae, 0x007cfbc7, 0x003ff737, //-0.4
    0x003d15bc, 0xff8301b5, 0xffc2f090, 0x007cfdff, 0x003ff969, //-0.3
    0x003d15c0, 0xff82ff99, 0xffc2ee73, 0x007d0035, 0x003ffb9b, //-0.2
    0x003d15c2, 0xff82fd7d, 0xffc2ec58, 0x007d0269, 0x003ffdce, //-0.1
    0x003d15c2, 0xff82fb64, 0xffc2ea3e, 0x007d049c, 0x00400000, //-0.0
    0x003d15c1, 0xff82f94c, 0xffc2e825, 0x007d06cd, 0x00400233, //0.1
    0x003d15bf, 0xff82f736, 0xffc2e60f, 0x007d08fd, 0x00400465, //0.2
    0x003d15bb, 0xff82f521, 0xffc2e3f9, 0x007d0b2b, 0x00400698, //0.3
    0x003d15b5, 0xff82f30e, 0xffc2e1e5, 0x007d0d57, 0x004008cb, //0.4
    0x003d15ae, 0xff82f0fc, 0xffc2dfd3, 0x007d0f82, 0x00400afd, //0.5
    0x003d15a5, 0xff82eeec, 0xffc2ddc2, 0x007d11ab, 0x00400d30, //0.6
    0x003d159b, 0xff82ecde, 0xffc2dbb2, 0x007d13d3, 0x00400f63, //0.7
    0x003d158f, 0xff82ead1, 0xffc2d9a4, 0x007d15f9, 0x00401197, //0.8
    0x003d1582, 0xff82e8c6, 0xffc2d798, 0x007d181d, 0x004013ca, //0.9
    0x003d1573, 0xff82e6bd, 0xffc2d58c, 0x007d1a40, 0x004015fd, //1.0
    0x003d1563, 0xff82e4b5, 0xffc2d383, 0x007d1c62, 0x00401831, //1.1
    0x003d1551, 0xff82e2ae, 0xffc2d17a, 0x007d1e81, 0x00401a65, //1.2
    0x003d153d, 0xff82e0a9, 0xffc2cf73, 0x007d20a0, 0x00401c98, //1.3
    0x003d1528, 0xff82dea6, 0xffc2cd6e, 0x007d22bc, 0x00401ecc, //1.4
    0x003d1512, 0xff82dca4, 0xffc2cb6a, 0x007d24d7, 0x00402100, //1.5
    0x003d14fa, 0xff82daa4, 0xffc2c967, 0x007d26f1, 0x00402335, //1.6
    0x003d14e0, 0xff82d8a6, 0xffc2c766, 0x007d2909, 0x00402569, //1.7
    0x003d14c5, 0xff82d6a9, 0xffc2c566, 0x007d2b1f, 0x0040279d, //1.8
    0x003d14a8, 0xff82d4ad, 0xffc2c367, 0x007d2d34, 0x004029d2, //1.9
    0x003d148a, 0xff82d2b3, 0xffc2c16a, 0x007d2f48, 0x00402c07, //2.0
    0x003d146a, 0xff82d0bb, 0xffc2bf6f, 0x007d315a, 0x00402e3c, //2.1
    0x003d1448, 0xff82cec4, 0xffc2bd75, 0x007d336a, 0x00403071, //2.2
    0x003d1425, 0xff82cccf, 0xffc2bb7c, 0x007d3579, 0x004032a7, //2.3
    0x003d1401, 0xff82cadb, 0xffc2b984, 0x007d3786, 0x004034dc, //2.4
    0x003d13db, 0xff82c8e9, 0xffc2b78e, 0x007d3992, 0x00403712, //2.5
    0x003d13b3, 0xff82c6f8, 0xffc2b599, 0x007d3b9c, 0x00403948, //2.6
    0x003d138a, 0xff82c509, 0xffc2b3a6, 0x007d3da5, 0x00403b7e, //2.7
    0x003d135f, 0xff82c31b, 0xffc2b1b4, 0x007d3fac, 0x00403db4, //2.8
    0x003d1333, 0xff82c12f, 0xffc2afc4, 0x007d41b2, 0x00403feb, //2.9
    0x003d1305, 0xff82bf45, 0xffc2add4, 0x007d43b7, 0x00404221, //3.0
    0x003d12d6, 0xff82bd5c, 0xffc2abe7, 0x007d45b9, 0x00404458, //3.1
    0x003d12a5, 0xff82bb74, 0xffc2a9fa, 0x007d47bb, 0x00404690, //3.2
    0x003d1273, 0xff82b98e, 0xffc2a80f, 0x007d49bb, 0x004048c7, //3.3
    0x003d123f, 0xff82b7a9, 0xffc2a625, 0x007d4bb9, 0x00404aff, //3.4
    0x003d1209, 0xff82b5c6, 0xffc2a43d, 0x007d4db6, 0x00404d37, //3.5
    0x003d11d2, 0xff82b3e4, 0xffc2a256, 0x007d4fb2, 0x00404f6f, //3.6
    0x003d1199, 0xff82b204, 0xffc2a070, 0x007d51ac, 0x004051a7, //3.7
    0x003d115f, 0xff82b026, 0xffc29e8b, 0x007d53a4, 0x004053e0, //3.8
    0x003d1123, 0xff82ae49, 0xffc29ca8, 0x007d559c, 0x00405619, //3.9
    0x003d10e6, 0xff82ac6d, 0xffc29ac6, 0x007d5791, 0x00405852, //4.0
    0x003d10a7, 0xff82aa93, 0xffc298e6, 0x007d5986, 0x00405a8b, //4.1
    0x003d1067, 0xff82a8ba, 0xffc29707, 0x007d5b78, 0x00405cc5, //4.2
    0x003d1025, 0xff82a6e3, 0xffc29529, 0x007d5d6a, 0x00405eff, //4.3
    0x003d0fe1, 0xff82a50d, 0xffc2934d, 0x007d5f5a, 0x00406139, //4.4
    0x003d0f9c, 0xff82a339, 0xffc29172, 0x007d6148, 0x00406373, //4.5
    0x003d0f55, 0xff82a166, 0xffc28f98, 0x007d6336, 0x004065ae, //4.6
    0x003d0f0d, 0xff829f94, 0xffc28dbf, 0x007d6521, 0x004067e9, //4.7
    0x003d0ec4, 0xff829dc4, 0xffc28be8, 0x007d670c, 0x00406a25, //4.8
    0x003d0e78, 0xff829bf6, 0xffc28a12, 0x007d68f5, 0x00406c60, //4.9
    0x003d0e2b, 0xff829a29, 0xffc2883d, 0x007d6adc, 0x00406e9c, //5.0
    0x003d0ddd, 0xff82985d, 0xffc2866a, 0x007d6cc2, 0x004070d9, //5.1
    0x003d0d8d, 0xff829693, 0xffc28498, 0x007d6ea7, 0x00407315, //5.2
    0x003d0d3b, 0xff8294ca, 0xffc282c7, 0x007d708a, 0x00407552, //5.3
    0x003d0ce8, 0xff829303, 0xffc280f8, 0x007d726c, 0x0040778f, //5.4
    0x003d0c94, 0xff82913d, 0xffc27f29, 0x007d744d, 0x004079cd, //5.5
    0x003d0c3d, 0xff828f79, 0xffc27d5c, 0x007d762c, 0x00407c0b, //5.6
    0x003d0be5, 0xff828db6, 0xffc27b91, 0x007d780a, 0x00407e49, //5.7
    0x003d0b8c, 0xff828bf4, 0xffc279c6, 0x007d79e6, 0x00408088, //5.8
    0x003d0b31, 0xff828a34, 0xffc277fd, 0x007d7bc1, 0x004082c7, //5.9
    0x003d0ad5, 0xff828875, 0xffc27635, 0x007d7d9b, 0x00408506, //6.0
    0x003d0a77, 0xff8286b8, 0xffc2746f, 0x007d7f73, 0x00408746, //6.1
    0x003d0a17, 0xff8284fc, 0xffc272a9, 0x007d814a, 0x00408986, //6.2
    0x003d09b6, 0xff828341, 0xffc270e5, 0x007d8320, 0x00408bc6, //6.3
    0x003d0953, 0xff828188, 0xffc26f22, 0x007d84f4, 0x00408e07, //6.4
    0x003d08ef, 0xff827fd0, 0xffc26d61, 0x007d86c7, 0x00409048, //6.5
    0x003d0889, 0xff827e1a, 0xffc26ba0, 0x007d8899, 0x0040928a, //6.6
    0x003d0821, 0xff827c65, 0xffc269e1, 0x007d8a69, 0x004094cc, //6.7
    0x003d07b8, 0xff827ab2, 0xffc26823, 0x007d8c38, 0x0040970e, //6.8
    0x003d074e, 0xff8278ff, 0xffc26667, 0x007d8e06, 0x00409951, //6.9
    0x003d06e2, 0xff82774f, 0xffc264ab, 0x007d8fd2, 0x00409b94, //7.0
    0x003d0674, 0xff82759f, 0xffc262f1, 0x007d919d, 0x00409dd7, //7.1
    0x003d0605, 0xff8273f1, 0xffc26138, 0x007d9367, 0x0040a01b, //7.2
    0x003d0594, 0xff827245, 0xffc25f80, 0x007d952f, 0x0040a260, //7.3
    0x003d0521, 0xff827099, 0xffc25dca, 0x007d96f6, 0x0040a4a5, //7.4
    0x003d04ad, 0xff826ef0, 0xffc25c14, 0x007d98bc, 0x0040a6ea, //7.5
    0x003d0437, 0xff826d47, 0xffc25a60, 0x007d9a80, 0x0040a930, //7.6
    0x003d03c0, 0xff826ba0, 0xffc258ad, 0x007d9c43, 0x0040ab76, //7.7
    0x003d0348, 0xff8269fa, 0xffc256fb, 0x007d9e05, 0x0040adbc, //7.8
    0x003d02cd, 0xff826856, 0xffc2554b, 0x007d9fc6, 0x0040b003, //7.9
    0x003d0251, 0xff8266b3, 0xffc2539c, 0x007da185, 0x0040b24b, //8.0
    0x003d01d4, 0xff826511, 0xffc251ed, 0x007da343, 0x0040b493, //8.1
    0x003d0155, 0xff826371, 0xffc25040, 0x007da4ff, 0x0040b6db, //8.2
    0x003d00d4, 0xff8261d2, 0xffc24e95, 0x007da6bb, 0x0040b924, //8.3
    0x003d0052, 0xff826034, 0xffc24cea, 0x007da875, 0x0040bb6d, //8.4
    0x003cffce, 0xff825e98, 0xffc24b41, 0x007daa2e, 0x0040bdb7, //8.5
    0x003cff48, 0xff825cfd, 0xffc24999, 0x007dabe5, 0x0040c001, //8.6
    0x003cfec1, 0xff825b63, 0xffc247f1, 0x007dad9c, 0x0040c24c, //8.7
    0x003cfe39, 0xff8259cb, 0xffc2464c, 0x007daf51, 0x0040c497, //8.8
    0x003cfdaf, 0xff825834, 0xffc244a7, 0x007db105, 0x0040c6e3, //8.9
    0x003cfd23, 0xff82569e, 0xffc24303, 0x007db2b7, 0x0040c92f, //9.0
    0x003cfc95, 0xff82550a, 0xffc24161, 0x007db469, 0x0040cb7c, //9.1
    0x003cfc07, 0xff825377, 0xffc23fc0, 0x007db619, 0x0040cdca, //9.2
    0x003cfb76, 0xff8251e5, 0xffc23e20, 0x007db7c8, 0x0040d017, //9.3
    0x003cfae4, 0xff825055, 0xffc23c81, 0x007db975, 0x0040d266, //9.4
    0x003cfa50, 0xff824ec6, 0xffc23ae3, 0x007dbb22, 0x0040d4b5, //9.5
    0x003cf9bb, 0xff824d39, 0xffc23946, 0x007dbccd, 0x0040d704, //9.6
    0x003cf924, 0xff824bac, 0xffc237ab, 0x007dbe77, 0x0040d954, //9.7
    0x003cf88b, 0xff824a21, 0xffc23611, 0x007dc01f, 0x0040dba5, //9.8
    0x003cf7f1, 0xff824897, 0xffc23477, 0x007dc1c7, 0x0040ddf6, //9.9
    0x003cf755, 0xff82470f, 0xffc232df, 0x007dc36d, 0x0040e047, //10.0
    0x003cf6b8, 0xff824588, 0xffc23148, 0x007dc512, 0x0040e299, //10.1
    0x003cf619, 0xff824402, 0xffc22fb3, 0x007dc6b6, 0x0040e4ec, //10.2
    0x003cf579, 0xff82427d, 0xffc22e1e, 0x007dc859, 0x0040e73f, //10.3
    0x003cf4d7, 0xff8240fa, 0xffc22c8a, 0x007dc9fa, 0x0040e993, //10.4
    0x003cf433, 0xff823f78, 0xffc22af8, 0x007dcb9a, 0x0040ebe8, //10.5
    0x003cf38e, 0xff823df8, 0xffc22967, 0x007dcd39, 0x0040ee3d, //10.6
    0x003cf2e7, 0xff823c78, 0xffc227d6, 0x007dced7, 0x0040f092, //10.7
    0x003cf23e, 0xff823afa, 0xffc22647, 0x007dd074, 0x0040f2e9, //10.8
    0x003cf194, 0xff82397d, 0xffc224b9, 0x007dd20f, 0x0040f540, //10.9
    0x003cf0e8, 0xff823802, 0xffc2232c, 0x007dd3aa, 0x0040f797, //11.0
    0x003cf03b, 0xff823688, 0xffc221a1, 0x007dd543, 0x0040f9ef, //11.1
    0x003cef8c, 0xff82350f, 0xffc22016, 0x007dd6db, 0x0040fc48, //11.2
    0x003ceedb, 0xff823397, 0xffc21e8c, 0x007dd872, 0x0040fea1, //11.3
    0x003cee29, 0xff823221, 0xffc21d04, 0x007dda07, 0x004100fb, //11.4
    0x003ced75, 0xff8230ab, 0xffc21b7d, 0x007ddb9c, 0x00410355, //11.5
    0x003cecc0, 0xff822f38, 0xffc219f6, 0x007ddd2f, 0x004105b1, //11.6
    0x003cec08, 0xff822dc5, 0xffc21871, 0x007ddec1, 0x0041080d, //11.7
    0x003ceb50, 0xff822c54, 0xffc216ed, 0x007de052, 0x00410a69, //11.8
    0x003cea95, 0xff822ae4, 0xffc2156a, 0x007de1e2, 0x00410cc6, //11.9
    0x003ce9d9, 0xff822975, 0xffc213e8, 0x007de370, 0x00410f24, //12.0
    0x003ce91c, 0xff822807, 0xffc21267, 0x007de4fe, 0x00411182, //12.1
    0x003ce85d, 0xff82269b, 0xffc210e7, 0x007de68a, 0x004113e2, //12.2
    0x003ce79c, 0xff822530, 0xffc20f68, 0x007de816, 0x00411641, //12.3
    0x003ce6d9, 0xff8223c6, 0xffc20deb, 0x007de9a0, 0x004118a2, //12.4
    0x003ce615, 0xff82225d, 0xffc20c6e, 0x007deb29, 0x00411b03, //12.5
    0x003ce550, 0xff8220f6, 0xffc20af2, 0x007decb1, 0x00411d65, //12.6
    0x003ce488, 0xff821f90, 0xffc20978, 0x007dee37, 0x00411fc7, //12.7
    0x003ce3bf, 0xff821e2b, 0xffc207fe, 0x007defbd, 0x0041222b, //12.8
    0x003ce2f5, 0xff821cc8, 0xffc20686, 0x007df141, 0x0041248f, //12.9
    0x003ce228, 0xff821b65, 0xffc2050e, 0x007df2c5, 0x004126f3, //13.0
    0x003ce15b, 0xff821a04, 0xffc20398, 0x007df447, 0x00412959, //13.1
    0x003ce08b, 0xff8218a4, 0xffc20223, 0x007df5c8, 0x00412bbf, //13.2
    0x003cdfba, 0xff821746, 0xffc200ae, 0x007df748, 0x00412e26, //13.3
    0x003cdee7, 0xff8215e8, 0xffc1ff3b, 0x007df8c7, 0x0041308d, //13.4
    0x003cde13, 0xff82148c, 0xffc1fdc9, 0x007dfa45, 0x004132f6, //13.5
    0x003cdd3c, 0xff821331, 0xffc1fc58, 0x007dfbc2, 0x0041355f, //13.6
    0x003cdc65, 0xff8211d7, 0xffc1fae8, 0x007dfd3d, 0x004137c8, //13.7
    0x003cdb8b, 0xff82107f, 0xffc1f979, 0x007dfeb8, 0x00413a33, //13.8
    0x003cdab0, 0xff820f27, 0xffc1f80a, 0x007e0031, 0x00413c9e, //13.9
    0x003cd9d4, 0xff820dd1, 0xffc1f69d, 0x007e01aa, 0x00413f0a, //14.0
    // Treble Band
    0x0001e22e, 0xfffb5ad1, 0xfff4d933, 0x0019dd34, 0x00040c9a, //-14.0
    0x0001e7d2, 0xfffb4cc1, 0xfff4dc17, 0x0019d898, 0x000416be, //-13.9
    0x0001ed87, 0xfffb3e89, 0xfff4defc, 0x0019d3f8, 0x000420fc, //-13.8
    0x0001f34d, 0xfffb3028, 0xfff4e1e2, 0x0019cf55, 0x00042b54, //-13.7
    0x0001f924, 0xfffb219d, 0xfff4e4ca, 0x0019caaf, 0x000435c6, //-13.6
    0x0001ff0c, 0xfffb12e9, 0xfff4e7b2, 0x0019c606, 0x00044053, //-13.5
    0x00020506, 0xfffb040a, 0xfff4ea9c, 0x0019c159, 0x00044afb, //-13.4
    0x00020b11, 0xfffaf501, 0xfff4ed87, 0x0019bca9, 0x000455be, //-13.3
    0x0002112f, 0xfffae5cd, 0xfff4f073, 0x0019b7f5, 0x0004609c, //-13.2
    0x0002175e, 0xfffad66d, 0xfff4f361, 0x0019b33e, 0x00046b96, //-13.1
    0x00021da0, 0xfffac6e1, 0xfff4f64f, 0x0019ae83, 0x000476ad, //-13.0
    0x000223f4, 0xfffab728, 0xfff4f93f, 0x0019a9c5, 0x000481df, //-12.9
    0x00022a5b, 0xfffaa743, 0xfff4fc30, 0x0019a504, 0x00048d2e, //-12.8
    0x000230d6, 0xfffa9730, 0xfff4ff22, 0x0019a03f, 0x0004989a, //-12.7
    0x00023763, 0xfffa86ef, 0xfff50216, 0x00199b76, 0x0004a423, //-12.6
    0x00023e03, 0xfffa767f, 0xfff5050a, 0x001996aa, 0x0004afc9, //-12.5
    0x000244b7, 0xfffa65e0, 0xfff50800, 0x001991db, 0x0004bb8d, //-12.4
    0x00024b7f, 0xfffa5512, 0xfff50af7, 0x00198d08, 0x0004c76f, //-12.3
    0x0002525b, 0xfffa4414, 0xfff50def, 0x00198832, 0x0004d370, //-12.2
    0x0002594c, 0xfffa32e5, 0xfff510e8, 0x00198358, 0x0004df8f, //-12.1
    0x00026050, 0xfffa2185, 0xfff513e3, 0x00197e7b, 0x0004ebcd, //-12.0
    0x0002676a, 0xfffa0ff3, 0xfff516de, 0x0019799a, 0x0004f82a, //-11.9
    0x00026e98, 0xfff9fe30, 0xfff519db, 0x001974b6, 0x000504a7, //-11.8
    0x000275dc, 0xfff9ec39, 0xfff51cd9, 0x00196fce, 0x00051144, //-11.7
    0x00027d35, 0xfff9da10, 0xfff51fd8, 0x00196ae2, 0x00051e00, //-11.6
    0x000284a4, 0xfff9c7b3, 0xfff522d9, 0x001965f3, 0x00052ade, //-11.5
    0x00028c28, 0xfff9b521, 0xfff525da, 0x00196100, 0x000537dc, //-11.4
    0x000293c3, 0xfff9a25a, 0xfff528dd, 0x00195c0a, 0x000544fb, //-11.3
    0x00029b74, 0xfff98f5e, 0xfff52be1, 0x00195711, 0x0005523c, //-11.2
    0x0002a33c, 0xfff97c2c, 0xfff52ee6, 0x00195213, 0x00055f9f, //-11.1
    0x0002ab1b, 0xfff968c3, 0xfff531ec, 0x00194d12, 0x00056d24, //-11.0
    0x0002b310, 0xfff95523, 0xfff534f3, 0x0019480e, 0x00057acb, //-10.9
    0x0002bb1e, 0xfff9414c, 0xfff537fc, 0x00194305, 0x00058895, //-10.8
    0x0002c343, 0xfff92d3b, 0xfff53b06, 0x00193dfa, 0x00059682, //-10.7
    0x0002cb80, 0xfff918f2, 0xfff53e11, 0x001938ea, 0x0005a493, //-10.6
    0x0002d3d5, 0xfff90470, 0xfff5411d, 0x001933d7, 0x0005b2c8, //-10.5
    0x0002dc42, 0xfff8efb2, 0xfff5442a, 0x00192ec0, 0x0005c121, //-10.4
    0x0002e4c9, 0xfff8dabb, 0xfff54738, 0x001929a6, 0x0005cf9f, //-10.3
    0x0002ed68, 0xfff8c587, 0xfff54a47, 0x00192488, 0x0005de41, //-10.2
    0x0002f621, 0xfff8b018, 0xfff54d58, 0x00191f66, 0x0005ed09, //-10.1
    0x0002fef3, 0xfff89a6b, 0xfff5506a, 0x00191a41, 0x0005fbf7, //-10.0
    0x000307df, 0xfff88482, 0xfff5537d, 0x00191518, 0x00060b0b, //-9.9
    0x000310e5, 0xfff86e5a, 0xfff55691, 0x00190feb, 0x00061a45, //-9.8
    0x00031a06, 0xfff857f3, 0xfff559a6, 0x00190aba, 0x000629a6, //-9.7
    0x00032341, 0xfff8414d, 0xfff55cbc, 0x00190586, 0x0006392f, //-9.6
    0x00032c98, 0xfff82a67, 0xfff55fd4, 0x0019004e, 0x000648df, //-9.5
    0x0003360a, 0xfff81340, 0xfff562ec, 0x0018fb12, 0x000658b7, //-9.4
    0x00033f97, 0xfff7fbd8, 0xfff56606, 0x0018f5d3, 0x000668b7, //-9.3
    0x00034941, 0xfff7e42e, 0xfff56921, 0x0018f090, 0x000678e1, //-9.2
    0x00035307, 0xfff7cc40, 0xfff56c3d, 0x0018eb49, 0x00068933, //-9.1
    0x00035ce9, 0xfff7b40f, 0xfff56f5a, 0x0018e5fe, 0x000699b0, //-9.0
    0x000366e8, 0xfff79b9a, 0xfff57278, 0x0018e0af, 0x0006aa56, //-8.9
    0x00037105, 0xfff782e0, 0xfff57598, 0x0018db5d, 0x0006bb27, //-8.8
    0x00037b3f, 0xfff769e0, 0xfff578b8, 0x0018d607, 0x0006cc22, //-8.7
    0x00038597, 0xfff75099, 0xfff57bda, 0x0018d0ad, 0x0006dd49, //-8.6
    0x0003900d, 0xfff7370b, 0xfff57efc, 0x0018cb4f, 0x0006ee9c, //-8.5
    0x00039aa1, 0xfff71d35, 0xfff58220, 0x0018c5ee, 0x0007001b, //-8.4
    0x0003a555, 0xfff70317, 0xfff58545, 0x0018c088, 0x000711c7, //-8.3
    0x0003b028, 0xfff6e8af, 0xfff5886b, 0x0018bb1f, 0x000723a0, //-8.2
    0x0003bb1a, 0xfff6cdfc, 0xfff58b92, 0x0018b5b2, 0x000735a6, //-8.1
    0x0003c62c, 0xfff6b2fe, 0xfff58ebb, 0x0018b041, 0x000747da, //-8.0
    0x0003d15e, 0xfff697b5, 0xfff591e4, 0x0018aacc, 0x00075a3d, //-7.9
    0x0003dcb1, 0xfff67c1e, 0xfff5950e, 0x0018a554, 0x00076ccf, //-7.8
    0x0003e825, 0xfff6603a, 0xfff5983a, 0x00189fd7, 0x00077f90, //-7.7
    0x0003f3bb, 0xfff64408, 0xfff59b66, 0x00189a56, 0x00079281, //-7.6
    0x0003ff72, 0xfff62786, 0xfff59e94, 0x001894d2, 0x0007a5a2, //-7.5
    0x00040b4b, 0xfff60ab5, 0xfff5a1c3, 0x00188f4a, 0x0007b8f4, //-7.4
    0x00041747, 0xfff5ed92, 0xfff5a4f3, 0x001889be, 0x0007cc77, //-7.3
    0x00042365, 0xfff5d01e, 0xfff5a824, 0x0018842d, 0x0007e02c, //-7.2
    0x00042fa7, 0xfff5b257, 0xfff5ab56, 0x00187e99, 0x0007f413, //-7.1
    0x00043c0c, 0xfff5943c, 0xfff5ae89, 0x00187901, 0x0008082d, //-7.0
    0x00044895, 0xfff575ce, 0xfff5b1bd, 0x00187365, 0x00081c7b, //-6.9
    0x00045543, 0xfff55709, 0xfff5b4f2, 0x00186dc6, 0x000830fc, //-6.8
    0x00046216, 0xfff537ef, 0xfff5b829, 0x00186822, 0x000845b1, //-6.7
    0x00046f0d, 0xfff5187e, 0xfff5bb60, 0x0018627a, 0x00085a9b, //-6.6
    0x00047c2b, 0xfff4f8b4, 0xfff5be98, 0x00185cce, 0x00086fbb, //-6.5
    0x0004896e, 0xfff4d892, 0xfff5c1d2, 0x0018571e, 0x00088510, //-6.4
    0x000496d8, 0xfff4b816, 0xfff5c50c, 0x0018516a, 0x00089a9c, //-6.3
    0x0004a468, 0xfff4973f, 0xfff5c848, 0x00184bb2, 0x0008b05f, //-6.2
    0x0004b220, 0xfff4760c, 0xfff5cb85, 0x001845f6, 0x0008c659, //-6.1
    0x0004c000, 0xfff4547c, 0xfff5cec2, 0x00184036, 0x0008dc8b, //-6.0
    0x0004ce07, 0xfff4328f, 0xfff5d201, 0x00183a72, 0x0008f2f6, //-5.9
    0x0004dc38, 0xfff41043, 0xfff5d541, 0x001834aa, 0x0009099a, //-5.8
    0x0004ea91, 0xfff3ed97, 0xfff5d882, 0x00182ede, 0x00092078, //-5.7
    0x0004f914, 0xfff3ca8b, 0xfff5dbc3, 0x0018290e, 0x00093790, //-5.6
    0x000507c1, 0xfff3a71d, 0xfff5df06, 0x0018233a, 0x00094ee2, //-5.5
    0x00051698, 0xfff3834b, 0xfff5e24a, 0x00181d62, 0x00096671, //-5.4
    0x0005259a, 0xfff35f17, 0xfff5e58f, 0x00181785, 0x00097e3b, //-5.3
    0x000534c8, 0xfff33a7d, 0xfff5e8d5, 0x001811a5, 0x00099642, //-5.2
    0x00054421, 0xfff3157d, 0xfff5ec1c, 0x00180bc0, 0x0009ae86, //-5.1
    0x000553a6, 0xfff2f017, 0xfff5ef64, 0x001805d7, 0x0009c708, //-5.0
    0x00056359, 0xfff2ca48, 0xfff5f2ad, 0x0017ffea, 0x0009dfc8, //-4.9
    0x00057338, 0xfff2a410, 0xfff5f5f7, 0x0017f9f9, 0x0009f8c8, //-4.8
    0x00058345, 0xfff27d6e, 0xfff5f942, 0x0017f404, 0x000a1207, //-4.7
    0x00059381, 0xfff25660, 0xfff5fc8e, 0x0017ee0b, 0x000a2b86, //-4.6
    0x0005a3eb, 0xfff22ee6, 0xfff5ffdb, 0x0017e80e, 0x000a4547, //-4.5
    0x0005b485, 0xfff206fe, 0xfff60328, 0x0017e20c, 0x000a5f49, //-4.4
    0x0005c54e, 0xfff1dea8, 0xfff60677, 0x0017dc06, 0x000a798d, //-4.3
    0x0005d647, 0xfff1b5e1, 0xfff609c7, 0x0017d5fc, 0x000a9414, //-4.2
    0x0005e772, 0xfff18ca9, 0xfff60d18, 0x0017cfee, 0x000aaedf, //-4.1
    0x0005f8cd, 0xfff162ff, 0xfff6106a, 0x0017c9dc, 0x000ac9ee, //-4.0
    0x00060a5b, 0xfff138e2, 0xfff613bd, 0x0017c3c5, 0x000ae542, //-3.9
    0x00061c1b, 0xfff10e4f, 0xfff61711, 0x0017bdaa, 0x000b00db, //-3.8
    0x00062e0e, 0xfff0e347, 0xfff61a65, 0x0017b78b, 0x000b1cba, //-3.7
    0x00064035, 0xfff0b7c8, 0xfff61dbb, 0x0017b168, 0x000b38e1, //-3.6
    0x0006528f, 0xfff08bd0, 0xfff62112, 0x0017ab40, 0x000b554f, //-3.5
    0x0006651e, 0xfff05f5e, 0xfff62469, 0x0017a514, 0x000b7206, //-3.4
    0x000677e3, 0xfff03271, 0xfff627c2, 0x00179ee4, 0x000b8f05, //-3.3
    0x00068add, 0xfff00509, 0xfff62b1b, 0x001798b0, 0x000bac4f, //-3.2
    0x00069e0e, 0xffefd722, 0xfff62e76, 0x00179277, 0x000bc9e3, //-3.1
    0x0006b175, 0xffefa8bd, 0xfff631d1, 0x00178c3a, 0x000be7c2, //-3.0
    0x0006c514, 0xffef79d8, 0xfff6352e, 0x001785f9, 0x000c05ed, //-2.9
    0x0006d8ec, 0xffef4a71, 0xfff6388b, 0x00177fb4, 0x000c2465, //-2.8
    0x0006ecfc, 0xffef1a87, 0xfff63be9, 0x0017796a, 0x000c432a, //-2.7
    0x00070145, 0xffeeea19, 0xfff63f48, 0x0017731c, 0x000c623e, //-2.6
    0x000715c9, 0xffeeb925, 0xfff642a8, 0x00176cc9, 0x000c81a1, //-2.5
    0x00072a87, 0xffee87ab, 0xfff64609, 0x00176672, 0x000ca153, //-2.4
    0x00073f80, 0xffee55a8, 0xfff6496b, 0x00176017, 0x000cc156, //-2.3
    0x000754b5, 0xffee231b, 0xfff64ccd, 0x001759b8, 0x000ce1aa, //-2.2
    0x00076a27, 0xffedf003, 0xfff65031, 0x00175354, 0x000d0251, //-2.1
    0x00077fd6, 0xffedbc5e, 0xfff65395, 0x00174cec, 0x000d234b, //-2.0
    0x000795c3, 0xffed882b, 0xfff656fb, 0x0017467f, 0x000d4498, //-1.9
    0x0007abee, 0xffed5369, 0xfff65a61, 0x0017400e, 0x000d663a, //-1.8
    0x0007c259, 0xffed1e15, 0xfff65dc8, 0x00173998, 0x000d8832, //-1.7
    0x0007d903, 0xffece82f, 0xfff66130, 0x0017331e, 0x000daa7f, //-1.6
    0x0007efee, 0xffecb1b5, 0xfff66499, 0x00172ca0, 0x000dcd24, //-1.5
    0x0008071a, 0xffec7aa5, 0xfff66803, 0x0017261d, 0x000df021, //-1.4
    0x00081e88, 0xffec42fd, 0xfff66b6d, 0x00171f96, 0x000e1377, //-1.3
    0x00083639, 0xffec0abd, 0xfff66ed9, 0x0017190b, 0x000e3726, //-1.2
    0x00084e2d, 0xffebd1e3, 0xfff67245, 0x0017127b, 0x000e5b30, //-1.1
    0x00086665, 0xffeb986c, 0xfff675b2, 0x00170be6, 0x000e7f96, //-1.0
    0x00087ee2, 0xffeb5e58, 0xfff67920, 0x0017054d, 0x000ea458, //-0.9
    0x000897a5, 0xffeb23a5, 0xfff67c8f, 0x0016feb0, 0x000ec977, //-0.8
    0x0008b0ae, 0xffeae851, 0xfff67fff, 0x0016f80e, 0x000eeef5, //-0.7
    0x0008c9fe, 0xffeaac5a, 0xfff6836f, 0x0016f167, 0x000f14d1, //-0.6
    0x0008e396, 0xffea6fbf, 0xfff686e0, 0x0016eabd, 0x000f3b0e, //-0.5
    0x0008fd76, 0xffea327e, 0xfff68a53, 0x0016e40d, 0x000f61ac, //-0.4
    0x000917a0, 0xffe9f496, 0xfff68dc6, 0x0016dd59, 0x000f88ac, //-0.3
    0x00093214, 0xffe9b604, 0xfff69139, 0x0016d6a1, 0x000fb00e, //-0.2
    0x00094cd2, 0xffe976c7, 0xfff694ae, 0x0016cfe4, 0x000fd7d5, //-0.1
    0x000967dd, 0xffe936de, 0xfff69823, 0x0016c922, 0x00100000, //-0.0
    0x00098334, 0xffe8f645, 0xfff69b99, 0x0016c25c, 0x00102891, //0.1
    0x00099ed8, 0xffe8b4fd, 0xfff69f10, 0x0016bb91, 0x00105189, //0.2
    0x0009bacb, 0xffe87302, 0xfff6a288, 0x0016b4c2, 0x00107ae9, //0.3
    0x0009d70d, 0xffe83053, 0xfff6a600, 0x0016adef, 0x0010a4b2, //0.4
    0x0009f39e, 0xffe7ecee, 0xfff6a979, 0x0016a716, 0x0010cee4, //0.5
    0x000a1080, 0xffe7a8d1, 0xfff6acf3, 0x0016a039, 0x0010f982, //0.6
    0x000a2db4, 0xffe763fb, 0xfff6b06e, 0x00169958, 0x0011248c, //0.7
    0x000a4b3a, 0xffe71e69, 0xfff6b3e9, 0x00169271, 0x00115002, //0.8
    0x000a6914, 0xffe6d819, 0xfff6b766, 0x00168b87, 0x00117be7, //0.9
    0x000a8742, 0xffe6910a, 0xfff6bae3, 0x00168497, 0x0011a83a, //1.0
    0x000aa5c4, 0xffe6493a, 0xfff6be60, 0x00167da3, 0x0011d4fe, //1.1
    0x000ac49d, 0xffe600a6, 0xfff6c1df, 0x001676ab, 0x00120234, //1.2
    0x000ae3cd, 0xffe5b74d, 0xfff6c55e, 0x00166fad, 0x00122fdc, //1.3
    0x000b0354, 0xffe56d2c, 0xfff6c8de, 0x001668ab, 0x00125df7, //1.4
    0x000b2334, 0xffe52242, 0xfff6cc5e, 0x001661a5, 0x00128c87, //1.5
    0x000b436e, 0xffe4d68c, 0xfff6cfdf, 0x00165a99, 0x0012bb8d, //1.6
    0x000b6403, 0xffe48a09, 0xfff6d361, 0x00165389, 0x0012eb09, //1.7
    0x000b84f3, 0xffe43cb6, 0xfff6d6e4, 0x00164c75, 0x00131afe, //1.8
    0x000ba640, 0xffe3ee91, 0xfff6da67, 0x0016455b, 0x00134b6c, //1.9
    0x000bc7ea, 0xffe39f98, 0xfff6ddeb, 0x00163e3d, 0x00137c55, //2.0
    0x000be9f3, 0xffe34fc9, 0xfff6e170, 0x0016371b, 0x0013adb9, //2.1
    0x000c0c5b, 0xffe2ff22, 0xfff6e4f5, 0x00162ff3, 0x0013df9a, //2.2
    0x000c2f24, 0xffe2ada0, 0xfff6e87b, 0x001628c7, 0x001411fa, //2.3
    0x000c524f, 0xffe25b41, 0xfff6ec02, 0x00162196, 0x001444d8, //2.4
    0x000c75dc, 0xffe20804, 0xfff6ef89, 0x00161a60, 0x00147837, //2.5
    0x000c99cc, 0xffe1b3e5, 0xfff6f311, 0x00161326, 0x0014ac18, //2.6
    0x000cbe22, 0xffe15ee2, 0xfff6f69a, 0x00160be7, 0x0014e07c, //2.7
    0x000ce2dd, 0xffe108f9, 0xfff6fa23, 0x001604a3, 0x00151564, //2.8
    0x000d07ff, 0xffe0b229, 0xfff6fdad, 0x0015fd5a, 0x00154ad2, //2.9
    0x000d2d88, 0xffe05a6d, 0xfff70137, 0x0015f60d, 0x001580c6, //3.0
    0x000d537b, 0xffe001c5, 0xfff704c3, 0x0015eeba, 0x0015b743, //3.1
    0x000d79d8, 0xffdfa82d, 0xfff7084e, 0x0015e763, 0x0015ee49, //3.2
    0x000da0a0, 0xffdf4da4, 0xfff70bdb, 0x0015e008, 0x001625db, //3.3
    0x000dc7d4, 0xffdef226, 0xfff70f67, 0x0015d8a7, 0x00165df8, //3.4
    0x000def76, 0xffde95b1, 0xfff712f5, 0x0015d141, 0x001696a3, //3.5
    0x000e1786, 0xffde3843, 0xfff71683, 0x0015c9d7, 0x0016cfdd, //3.6
    0x000e4006, 0xffddd9d9, 0xfff71a12, 0x0015c268, 0x001709a7, //3.7
    0x000e68f8, 0xffdd7a71, 0xfff71da1, 0x0015baf4, 0x00174402, //3.8
    0x000e925b, 0xffdd1a08, 0xfff72130, 0x0015b37b, 0x00177ef1, //3.9
    0x000ebc31, 0xffdcb89c, 0xfff724c1, 0x0015abfe, 0x0017ba75, //4.0
    0x000ee67c, 0xffdc5629, 0xfff72852, 0x0015a47b, 0x0017f68e, //4.1
    0x000f113d, 0xffdbf2ad, 0xfff72be3, 0x00159cf4, 0x0018333f, //4.2
    0x000f3c75, 0xffdb8e26, 0xfff72f75, 0x00159567, 0x00187089, //4.3
    0x000f6825, 0xffdb2891, 0xfff73307, 0x00158dd6, 0x0018ae6d, //4.4
    0x000f944e, 0xffdac1eb, 0xfff7369a, 0x00158640, 0x0018eced, //4.5
    0x000fc0f2, 0xffda5a31, 0xfff73a2e, 0x00157ea5, 0x00192c0a, //4.6
    0x000fee12, 0xffd9f161, 0xfff73dc2, 0x00157705, 0x00196bc6, //4.7
    0x00101bb0, 0xffd98777, 0xfff74156, 0x00156f61, 0x0019ac22, //4.8
    0x001049cc, 0xffd91c71, 0xfff744eb, 0x001567b7, 0x0019ed21, //4.9
    0x00107868, 0xffd8b04d, 0xfff74881, 0x00156008, 0x001a2ec2, //5.0
    0x0010a785, 0xffd84306, 0xfff74c16, 0x00155855, 0x001a7109, //5.1
    0x0010d725, 0xffd7d49b, 0xfff74fad, 0x0015509c, 0x001ab3f7, //5.2
    0x00110749, 0xffd76508, 0xfff75344, 0x001548df, 0x001af78d, //5.3
    0x001137f2, 0xffd6f44a, 0xfff756db, 0x0015411d, 0x001b3bcc, //5.4
    0x00116922, 0xffd6825f, 0xfff75a73, 0x00153955, 0x001b80b8, //5.5
    0x00119ad9, 0xffd60f42, 0xfff75e0b, 0x00153189, 0x001bc650, //5.6
    0x0011cd1b, 0xffd59af2, 0xfff761a3, 0x001529b8, 0x001c0c97, //5.7
    0x0011ffe7, 0xffd5256b, 0xfff7653d, 0x001521e2, 0x001c538f, //5.8
    0x00123340, 0xffd4aeaa, 0xfff768d6, 0x00151a07, 0x001c9b39, //5.9
    0x00126727, 0xffd436ac, 0xfff76c70, 0x00151226, 0x001ce397, //6.0
    0x00129b9d, 0xffd3bd6e, 0xfff7700a, 0x00150a41, 0x001d2caa, //6.1
    0x0012d0a3, 0xffd342ec, 0xfff773a5, 0x00150257, 0x001d7675, //6.2
    0x0013063c, 0xffd2c723, 0xfff77740, 0x0014fa68, 0x001dc0f9, //6.3
    0x00133c69, 0xffd24a10, 0xfff77adb, 0x0014f274, 0x001e0c38, //6.4
    0x0013732b, 0xffd1cbb0, 0xfff77e77, 0x0014ea7a, 0x001e5834, //6.5
    0x0013aa84, 0xffd14bff, 0xfff78213, 0x0014e27c, 0x001ea4ee, //6.6
    0x0013e276, 0xffd0cafa, 0xfff785af, 0x0014da79, 0x001ef268, //6.7
    0x00141b01, 0xffd0489d, 0xfff7894c, 0x0014d270, 0x001f40a5, //6.8
    0x00145428, 0xffcfc4e6, 0xfff78ce9, 0x0014ca63, 0x001f8fa6, //6.9
    0x00148dec, 0xffcf3fd0, 0xfff79087, 0x0014c251, 0x001fdf6c, //7.0
    0x0014c84f, 0xffceb958, 0xfff79425, 0x0014ba39, 0x00202ffb, //7.1
    0x00150352, 0xffce317b, 0xfff797c3, 0x0014b21c, 0x00208153, //7.2
    0x00153ef8, 0xffcda835, 0xfff79b61, 0x0014a9fb, 0x0020d377, //7.3
    0x00157b41, 0xffcd1d83, 0xfff79f00, 0x0014a1d4, 0x00212668, //7.4
    0x0015b830, 0xffcc9160, 0xfff7a29f, 0x001499a8, 0x00217a29, //7.5
    0x0015f5c6, 0xffcc03c9, 0xfff7a63e, 0x00149177, 0x0021cebc, //7.6
    0x00163404, 0xffcb74bb, 0xfff7a9de, 0x00148941, 0x00222422, //7.7
    0x001672ee, 0xffcae431, 0xfff7ad7e, 0x00148106, 0x00227a5d, //7.8
    0x0016b283, 0xffca5229, 0xfff7b11e, 0x001478c6, 0x0022d170, //7.9
    0x0016f2c7, 0xffc9be9d, 0xfff7b4be, 0x00147081, 0x0023295d, //8.0
    0x001733ba, 0xffc9298b, 0xfff7b85f, 0x00146836, 0x00238226, //8.1
    0x00177560, 0xffc892ee, 0xfff7bbff, 0x00145fe7, 0x0023dbcc, //8.2
    0x0017b7b8, 0xffc7fac3, 0xfff7bfa0, 0x00145792, 0x00243652, //8.3
    0x0017fac6, 0xffc76105, 0xfff7c342, 0x00144f38, 0x002491ba, //8.4
    0x00183e8c, 0xffc6c5b1, 0xfff7c6e3, 0x001446d9, 0x0024ee07, //8.5
    0x0018830a, 0xffc628c3, 0xfff7ca85, 0x00143e75, 0x00254b3a, //8.6
    0x0018c843, 0xffc58a36, 0xfff7ce27, 0x0014360b, 0x0025a955, //8.7
    0x00190e39, 0xffc4ea06, 0xfff7d1c9, 0x00142d9d, 0x0026085b, //8.8
    0x001954ee, 0xffc4482f, 0xfff7d56b, 0x00142529, 0x0026684f, //8.9
    0x00199c64, 0xffc3a4ae, 0xfff7d90d, 0x00141cb0, 0x0026c931, //9.0
    0x0019e49c, 0xffc2ff7d, 0xfff7dcaf, 0x00141432, 0x00272b05, //9.1
    0x001a2d99, 0xffc25899, 0xfff7e052, 0x00140baf, 0x00278dcd, //9.2
    0x001a775c, 0xffc1affd, 0xfff7e3f5, 0x00140327, 0x0027f18b, //9.3
    0x001ac1e9, 0xffc105a5, 0xfff7e798, 0x0013fa99, 0x00285641, //9.4
    0x001b0d40, 0xffc0598d, 0xfff7eb3b, 0x0013f206, 0x0028bbf3, //9.5
    0x001b5963, 0xffbfabaf, 0xfff7eede, 0x0013e96f, 0x002922a1, //9.6
    0x001ba656, 0xffbefc09, 0xfff7f281, 0x0013e0d1, 0x00298a4f, //9.7
    0x001bf41a, 0xffbe4a94, 0xfff7f624, 0x0013d82f, 0x0029f2ff, //9.8
    0x001c42b0, 0xffbd974d, 0xfff7f9c7, 0x0013cf87, 0x002a5cb4, //9.9
    0x001c921c, 0xffbce230, 0xfff7fd6b, 0x0013c6da, 0x002ac76f, //10.0
    0x001ce25f, 0xffbc2b36, 0xfff8010e, 0x0013be28, 0x002b3334, //10.1
    0x001d337c, 0xffbb725d, 0xfff804b2, 0x0013b571, 0x002ba004, //10.2
    0x001d8575, 0xffbab79e, 0xfff80855, 0x0013acb5, 0x002c0de4, //10.3
    0x001dd84b, 0xffb9faf5, 0xfff80bf9, 0x0013a3f3, 0x002c7cd4, //10.4
    0x001e2c02, 0xffb93c5f, 0xfff80f9d, 0x00139b2c, 0x002cecd7, //10.5
    0x001e809b, 0xffb87bd4, 0xfff81340, 0x0013925f, 0x002d5df1, //10.6
    0x001ed619, 0xffb7b951, 0xfff816e4, 0x0013898e, 0x002dd024, //10.7
    0x001f2c7e, 0xffb6f4d2, 0xfff81a87, 0x001380b7, 0x002e4372, //10.8
    0x001f83cc, 0xffb62e4f, 0xfff81e2b, 0x001377db, 0x002eb7de, //10.9
    0x001fdc06, 0xffb565c6, 0xfff821cf, 0x00136efa, 0x002f2d6b, //11.0
    0x0020352f, 0xffb49b30, 0xfff82572, 0x00136613, 0x002fa41c, //11.1
    0x00208f47, 0xffb3ce89, 0xfff82916, 0x00135d27, 0x00301bf3, //11.2
    0x0020ea53, 0xffb2ffcb, 0xfff82cb9, 0x00135436, 0x003094f2, //11.3
    0x00214654, 0xffb22ef2, 0xfff8305c, 0x00134b3f, 0x00310f1e, //11.4
    0x0021a34d, 0xffb15bf7, 0xfff83400, 0x00134244, 0x00318a78, //11.5
    0x00220141, 0xffb086d6, 0xfff837a3, 0x00133943, 0x00320704, //11.6
    0x00226031, 0xffafaf89, 0xfff83b46, 0x0013303c, 0x003284c4, //11.7
    0x0022c020, 0xffaed60b, 0xfff83ee9, 0x00132731, 0x003303bc, //11.8
    0x00232112, 0xffadfa56, 0xfff8428c, 0x00131e20, 0x003383ed, //11.9
    0x00238308, 0xffad1c65, 0xfff8462f, 0x00131509, 0x0034055c, //12.0
    0x0023e605, 0xffac3c32, 0xfff849d1, 0x00130bee, 0x0034880b, //12.1
    0x00244a0b, 0xffab59b8, 0xfff84d74, 0x001302cd, 0x00350bfc, //12.2
    0x0024af1f, 0xffaa74f0, 0xfff85116, 0x0012f9a7, 0x00359134, //12.3
    0x00251541, 0xffa98dd6, 0xfff854b8, 0x0012f07b, 0x003617b5, //12.4
    0x00257c75, 0xffa8a464, 0xfff8585a, 0x0012e74a, 0x00369f83, //12.5
    0x0025e4be, 0xffa7b893, 0xfff85bfc, 0x0012de14, 0x003728a0, //12.6
    0x00264e1e, 0xffa6ca5e, 0xfff85f9e, 0x0012d4d8, 0x0037b30f, //12.7
    0x0026b898, 0xffa5d9be, 0xfff8633f, 0x0012cb97, 0x00383ed4, //12.8
    0x0027242f, 0xffa4e6af, 0xfff866e0, 0x0012c251, 0x0038cbf1, //12.9
    0x002790e6, 0xffa3f129, 0xfff86a81, 0x0012b905, 0x00395a6b, //13.0
    0x0027febf, 0xffa2f927, 0xfff86e22, 0x0012afb4, 0x0039ea44, //13.1
    0x00286dbe, 0xffa1fea2, 0xfff871c2, 0x0012a65e, 0x003a7b80, //13.2
    0x0028dde5, 0xffa10195, 0xfff87562, 0x00129d02, 0x003b0e21, //13.3
    0x00294f37, 0xffa001f9, 0xfff87902, 0x001293a1, 0x003ba22c, //13.4
    0x0029c1b8, 0xff9effc8, 0xfff87ca2, 0x00128a3b, 0x003c37a3, //13.5
    0x002a356a, 0xff9dfafb, 0xfff88041, 0x001280cf, 0x003cce8b, //13.6
    0x002aaa50, 0xff9cf38c, 0xfff883e0, 0x0012775e, 0x003d66e5, //13.7
    0x002b206e, 0xff9be974, 0xfff8877f, 0x00126de8, 0x003e00b7, //13.8
    0x002b97c6, 0xff9adcad, 0xfff88b1e, 0x0012646c, 0x003e9c03, //13.9
    0x002c105c, 0xff99cd31, 0xfff88ebc, 0x00125aeb, 0x003f38cd, //14.0
};
#endif
#endif

//-----------------------------------------------------------------------------
// Audio channel delay
//-----------------------------------------------------------------------------
#ifdef AUDIO_CHANNEL_DELAY_DEFAULT
static const UINT8 _au1MtkAudChDelay[AUD_STREAM_FROM_NUM] =
{
    0x0,        // OTHERS
    0x0,        // DIGITAL_TUNER
    0x0,        // ANALOG_TUNER
    0x0,        // SPDIF
    0x0,        // LINE_IN
    0x0,        // HDMI
    0x0,        // MEMORY
    0x0,        // BUF_AGT
    0x0,        // FEEDER
    0x0,        // MULTI_MEDIA
};
#endif

//-----------------------------------------------------------------------------
// IEC Configuration
//-----------------------------------------------------------------------------
#ifdef AUDIO_IEC_COPYRIGHT_DEFAULT
static const UINT8 _au1MtkAudIecCopyright[AUD_STREAM_FROM_NUM] =
{
    IEC_COPY_NEVER,                     // DVI
    IEC_COPY_FREELY,            // DIGITAL_TUNER
    IEC_COPY_FREELY,                    // ANALOG_TUNER
    IEC_COPY_FREELY,                    // SPDIF
    IEC_COPY_FREELY,                    // LINE_IN
    IEC_COPY_NEVER,                     // HDMI
    IEC_COPY_FREELY,                    // MEMORY
    IEC_COPY_FREELY,                    // BUF_AGT
    IEC_COPY_FREELY,                    // FEEDER
    IEC_COPY_FREELY,                    // MULTI_MEDIA
};
#endif
#ifdef AUDIO_IEC_CATEGORY_DEFAULT
static const UINT8 _au1MtkAudIecCategory[AUD_STREAM_FROM_NUM] =
{
    IEC_NON_ORIGINAL_BROAD_CAST,        // DVI
    IEC_NON_ORIGINAL_BROAD_CAST,        // DIGITAL_TUNER
    IEC_ORIGINAL_GENERAL,               // ANALOG_TUNER
    IEC_ORIGINAL_GENERAL,               // SPDIF
    IEC_ORIGINAL_GENERAL,               // LINE_IN
    IEC_NON_ORIGINAL_BROAD_CAST,        // HDMI
    IEC_ORIGINAL_GENERAL,               // MEMORY
    IEC_ORIGINAL_GENERAL,               // BUF_AGT
    IEC_ORIGINAL_GENERAL,               // FEEDER
    IEC_NON_ORIGINAL_BROAD_CAST,               // MULTI_MEDIA
};
#endif
#ifdef AUDIO_IEC_WORD_LENGTH_DEFAULT
static const UINT8 _au1MtkAudIecWordLength[AUD_STREAM_FROM_NUM] =
{
    IEC_WORD_LENGTH_16BIT,              // DVI
    IEC_WORD_LENGTH_16BIT,              // DIGITAL_TUNER
    IEC_WORD_LENGTH_16BIT,              // ANALOG_TUNER
    IEC_WORD_LENGTH_16BIT,              // SPDIF
    IEC_WORD_LENGTH_16BIT,              // LINE_IN
    IEC_WORD_LENGTH_16BIT,              // HDMI
    IEC_WORD_LENGTH_16BIT,              // MEMORY
    IEC_WORD_LENGTH_16BIT,              // BUF_AGT
    IEC_WORD_LENGTH_16BIT,              // FEEDER
    IEC_WORD_LENGTH_16BIT,              // MULTI_MEDIA
};
#endif

#ifdef AUDIO_IEC_CHANNEL_STATUS_BYSOURCE_DEFAULT
static const UINT8 _au1MtkAudIecChannelStatusBySource[AUD_STREAM_FROM_NUM] =
{
    IEC_CHANNEL_STATUS_BY_SETUP,                     // DVI
    IEC_CHANNEL_STATUS_BY_SOURCE,                    // DIGITAL_TUNER
    IEC_CHANNEL_STATUS_BY_SETUP,                    // ANALOG_TUNER
    IEC_CHANNEL_STATUS_BY_SETUP,                    // SPDIF
    IEC_CHANNEL_STATUS_BY_SETUP,                    // LINE_IN
    IEC_CHANNEL_STATUS_BY_SETUP,                     // HDMI
    IEC_CHANNEL_STATUS_BY_SETUP,                    // MEMORY
    IEC_CHANNEL_STATUS_BY_SETUP,                    // BUF_AGT
    IEC_CHANNEL_STATUS_BY_SETUP,                    // FEEDER
    IEC_CHANNEL_STATUS_BY_SETUP,                    // MULTI_MEDIA
};
#endif

//-----------------------------------------------------------------------------
// Unused table
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Audio DSP table
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// DAC config
//-----------------------------------------------------------------------------
#ifdef AUDIO_ADAC_USAGE_DEFAULT
static const AUD_ADAC_USAGE_T _arMtkAdacUsage =
{
    AUD_ADAC_NULL,
    AUD_ADAC_NULL,
    AUD_ADAC_NULL,
    AUD_ADAC_NULL,
    AUD_CODEC_MT5398,
    AUD_CODEC_NULL,
    AUD_AMP_AD82581,
    AUD_AMP_NULL
};
#endif

// Define the usage of audio I2S data
#ifdef AUDIO_Digital_Data_TABLE_DEFAULT
static const AUD_DIGITAL_DATA_T _afgMtkAudDigitalDataUsage =
{
    TRUE,   //MCLK,BCK,LRCK
    TRUE,   //AOSDATA0
    TRUE,   //AOSDATA1
    FALSE,   //AOSDATA2
    FALSE,   //AOSDATA3
    FALSE   //AOSDATA4
};
#endif

//-----------------------------------------------------------------------------
// AOUT PAD config
//-----------------------------------------------------------------------------
#ifdef AUDIO_AOUT_PAD_CFG_DEFAULT
static const AUD_AOUT_PAD_CFG_T _arMtkAoutPadTable =
{
    AUD_CH_FRONT_LEFT,
    AUD_CH_REAR_LEFT,
    AUD_CH_CENTER,
    AUD_CH_DMX_LEFT,
    AUD_CH_FRONT_LEFT,
    AUD_CH_AUX_FRONT_LEFT,
};
#endif

//-----------------------------------------------------------------------------
// Internal DAC channel config
//-----------------------------------------------------------------------------
#ifdef AUDIO_INTER_DAC_USAGE_DEFAULT
static const AUD_INTER_DAC_CFG_T _arMtkInterDacUsage =
{
#ifndef CC_AUDIO_EU_PWM_OUTPUT_AUXDEC
    AUD_CHL_DOWNMIX,    // 5880 M1V2, AL0/AR0 Headphone
    AUD_CHL_AUX,    // 5880 M1V2, AL1/AR1 SCART1/YPbPr0, not used as output
    //DQA used as monitor scart
    //AUD_CHL_LS_RS,        // 5880 M1V2, AL2/AR2 SCART2 (Monitor Bypass)
    //Alpha site used as TV scart
    AUD_CHL_AUX, 
    AUD_CHL_L_R,        // No Use, Viper only has ALR0~ALR2
#else
    AUD_CHL_L_R,            ///AR0, AL0
    AUD_CHL_L_R,            ///AR2, AL2
    AUD_CHL_LS_RS,         ///AR3, AL3
    AUD_CHL_AUX,            ///AR1, AL1 AUDIO_AUX_OUT_AT_AL2AR2 = TRUE at Drv_default.h
#endif
};
#endif

//-----------------------------------------------------------------------------
// ATV FActory Mode
//-----------------------------------------------------------------------------
#ifdef AUDIO_TV_SYS_FINE_TUNE_VOL_DEFAULT
static const UINT8 _au1MtkTVFineTuneVol[SV_AUD_SYS_NUM] =
{
    0,//SV_NONE_DETECTED
    20,//SV_MTS
    20,//SV_FM_FM
    20,//SV_NTSC_M
    20,//SV_A2_BG
    20,//SV_A2_DK1
    20,//SV_A2_DK2
    20,//SV_A2_DK3
    20,//SV_PAL_I
    20,//SV_PAL_BG
    20,//SV_PAL_DK
    20,//SV_SECAM_L
    20,//SV_SECAM_L_PLUM
    20,//SV_SECAM_BG
    20//SV_SECAM_DK
};
#endif

#ifdef AUDIO_MTS_FACTORY_MODE_DEFAULT
static const AUD_MTS_FAC_T _arMtsFactory =
{
    50,                                // numers of check
    //****** stereo detection  **********************//
    35,                                // numers of pilot
    155,                               // higher threshold of pilot detection
    112,                               // lower threshold of pilot detection
    //****** SAP detection  *************************//
    30,                                // numers of SAP
    144,                               // higher threshold of SAP detection
    106,                               // lower threshold of SAP detection
    //****** high deviation mode  *******************//
    FALSE,                             // enable/disable of high deviation mode
    //****** carrier shift mode  ********************//
    TRUE,                             // enable/disable of carrier shift mode
    //****** FM saturation mute mode  ***************//
    FALSE,                             // enable/disable of saturation mute mode
    69,                                // higher threshold of saturation mute
    16,                                // lower threshold of saturation mute
    //****** FM carrier mute mode  ******************//
    FALSE,                             // enable/disable of FM carrier mute mode
    180,                               // higher threshold of FM carrier mute
    120,                                // lower threshold of FM carrier mute
    //****** prescale  ******************************//
    20,                                //mono and stereo prescale
    20,                                //SAP prescale
    //****** pilot offset calibration mode  *********//
    FALSE,                             // enable/disable of pilot calibration mode
    //****** SAP noise mute  ************************//
    4,                               //  (higher threshold - lower threshold )of SAP noise mute
    12                                 // lower threshold of SAP noise mute
};
#endif

static const AUD_A2_FAC_T _arA2Factory =
{
    //******  detection  ****************************//
    10,                                // numers of check
    10,                                // numers of double check
    1,                                 // mono weight
    1,                                 // stereo weight
    1,                                 // dual weight
    //****** high deviation mode  *******************//
    FALSE,                             // enable/disable of high deviation mode
    //****** carrier shift mode  ********************//
    FALSE,                             // enable/disable of carrier shift mode
    //****** FM carrier mute mode  ******************//
    FALSE,                             // enable/disable of FM carrier mute mode
    34,                                // higher threshold of FM carrier mute
    32,                                // lower threshold of FM carrier mute
    //****** prescale  ******************************//
    20,                                //A2 prescale
    //****** FM saturation mute mode  ***************//
    FALSE,                             // enable/disable of saturation mute mode
    //****** non-EU mode  ***************************//
    FALSE,                               // enable/disable of non-EU mode
    //****** stereo/dual detection threshold  *******************//
    128,                             // mono 2 stereo threshold for EU model
    64,                             // stereo 2 mono threshold for EU model
    112,                             // mono 2 stereo threshold for Korea model
    80,                             // stereo 2 mono threshold for Korea model
    656,                             // mono 2 stereo threshold for EU model
    896                             // stereo 2 mono threshold for EU model
};

#ifdef AUDIO_PAL_FACTORY_MODE_DEFAULT
static const AUD_PAL_FAC_T _arPalFactory =
{
    //******  detection  ****************************//
    6,                                 // correction threshold
    63,                                // total sync loop
    8,                                 // error threshold
    1056,                                // parity error threshold
    512,                               // every number frames
    //****** high deviation mode  *******************//
    TRUE,                              // enable/disable of high deviation mode
    //****** AM mute mode  ******************//
    FALSE,                             // enable/disable of AM mute mode
    53,                                // higher threshold of AM mute
    37,                                // lower threshold of AM mute
    //****** carrier shift mode  ********************//
    FALSE,                             // enable/disable of carrier shift mode
    //****** FM carrier mute mode  ******************//
    FALSE,                             // enable/disable of FM carrier mute mode
    32,                                // higher threshold of FM carrier mute
    16,                                // lower threshold of FM carrier mute
    //****** prescale  ******************************//
    20,                                //PAL prescale
    20,                                //AM prescale
    20,                                //NICAM prescale
    //****** FM saturation mute mode  ***************//
    FALSE,                             // enable/disable of saturation mute mode
    //****** non-EU mode  ***************************//
    FALSE,                       // enable/disable of non-EU mode
     //****** not to boost NICAM I ? ********************//
    FALSE                              // False :to boost nicam I by 4dB, True: not to boost NICAM I for 4dB
};
#endif

#ifdef CC_AUD_DSP_SUPPORT_AUDYSSEY
#ifdef AUDIO_AEQ_5BAND_TABLE_DEFAULT
//Only 48KHz is available
//B2,B1,A2,A1,B0 (A1,A2 need to apply minus), range need to 1~-1
static const UINT32 _aau4MtkAeq5BandTable[(1+1+1+1+1)*5] =
{
    //48000.0 Hz
    //Band 1
    0xFFD7AE97, 0xFFF946B1, 0x0006055D, 0x0006B94F, 0x00424C0B,
    //Band 2
    0x001FBFAB, 0xFFC061E0, 0xFFE05FDE, 0x003F9E20, 0x001FE077,
    //Band 3
    0x0019742B, 0xFFC8AC7F, 0xFFE79704, 0x00375381, 0x001EF4D1,
    //Band 4
    0x001E4E47, 0xFFC22E0E, 0xFFE1F816, 0x003DD1F2, 0x001FB9A2,
    //Band 5
    0x00009E93, 0xFFE890EC, 0xFFFD7A3E, 0x00176F14, 0x0021E72F,
};
#endif
#endif

#if 0 //CC_AUD_QUERY_VDO_INFO
static INT16 arMTKAudVdoCustTblDtv[AUD_SRM_VDO_HEIGHT_NUM][AUD_SRM_VDO_IP_NUM][AUD_SRM_VDO_RATE_NUM]=
{
    { // 480
     {15,15}, // P 50, 60
     {15,15}, // I 50, 60
    },
    { // 576
     {0,0}, // P 50, 60
     {0,0}, // I 50, 60
    },
    { // 720
     {15,15}, // P 50, 60
     {0,0}, // I 50, 60
    },
    { // 1080
     {20,20}, // P 50, 60
     {30,30}, // I 50, 60
    },
};
#endif

#endif /* MTK_AUD_H */

